/* BatchImport.c generated by valac, the Vala compiler
 * generated from BatchImport.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/* A BatchImportJob describes a unit of work the BatchImport object should perform.  It returns*/
/* a file to be imported.  If the file is a directory, it is automatically recursed by BatchImport*/
/* to find all files that need to be imported into the library.*/
/**/
/* NOTE: Both methods may be called from the context of a background thread or the main GTK thread.*/
/* Implementations should be able to handle either situation.  The prepare method will always be*/
/* called by the same thread context.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <time.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BATCH_IMPORT_JOB (batch_import_job_get_type ())
#define BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJob))
#define BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))
#define IS_BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_JOB))
#define IS_BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_JOB))
#define BATCH_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))

typedef struct _BatchImportJob BatchImportJob;
typedef struct _BatchImportJobClass BatchImportJobClass;
typedef struct _BatchImportJobPrivate BatchImportJobPrivate;
typedef struct _ParamSpecBatchImportJob ParamSpecBatchImportJob;

#define TYPE_BATCH_IMPORT_RESULT (batch_import_result_get_type ())
#define BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResult))
#define BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))
#define IS_BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_RESULT))
#define IS_BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_RESULT))
#define BATCH_IMPORT_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))

typedef struct _BatchImportResult BatchImportResult;
typedef struct _BatchImportResultClass BatchImportResultClass;
typedef struct _BatchImportResultPrivate BatchImportResultPrivate;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
#define _batch_import_job_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_job_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_IMPORT_MANIFEST (import_manifest_get_type ())
#define IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMPORT_MANIFEST, ImportManifest))
#define IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMPORT_MANIFEST, ImportManifestClass))
#define IS_IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMPORT_MANIFEST))
#define IS_IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMPORT_MANIFEST))
#define IMPORT_MANIFEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMPORT_MANIFEST, ImportManifestClass))

typedef struct _ImportManifest ImportManifest;
typedef struct _ImportManifestClass ImportManifestClass;
typedef struct _ImportManifestPrivate ImportManifestPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_TRANSFORMABLE_PHOTO (transformable_photo_get_type ())
#define TRANSFORMABLE_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSFORMABLE_PHOTO, TransformablePhoto))
#define TRANSFORMABLE_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSFORMABLE_PHOTO, TransformablePhotoClass))
#define IS_TRANSFORMABLE_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSFORMABLE_PHOTO))
#define IS_TRANSFORMABLE_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSFORMABLE_PHOTO))
#define TRANSFORMABLE_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSFORMABLE_PHOTO, TransformablePhotoClass))

typedef struct _TransformablePhoto TransformablePhoto;
typedef struct _TransformablePhotoClass TransformablePhotoClass;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_BATCH_IMPORT (batch_import_get_type ())
#define BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT, BatchImport))
#define BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT, BatchImportClass))
#define IS_BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT))
#define IS_BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT))
#define BATCH_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT, BatchImportClass))

typedef struct _BatchImport BatchImport;
typedef struct _BatchImportClass BatchImportClass;
typedef struct _BatchImportPrivate BatchImportPrivate;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())

#define TYPE_BACKGROUND_IMPORT_JOB (background_import_job_get_type ())
#define BACKGROUND_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob))
#define BACKGROUND_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJobClass))
#define IS_BACKGROUND_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_IMPORT_JOB))
#define IS_BACKGROUND_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_IMPORT_JOB))
#define BACKGROUND_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJobClass))

typedef struct _BackgroundImportJob BackgroundImportJob;
typedef struct _BackgroundImportJobClass BackgroundImportJobClass;
typedef struct _BackgroundImportJobPrivate BackgroundImportJobPrivate;

#define TYPE_WORK_SNIFFER (work_sniffer_get_type ())
#define WORK_SNIFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORK_SNIFFER, WorkSniffer))
#define WORK_SNIFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORK_SNIFFER, WorkSnifferClass))
#define IS_WORK_SNIFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORK_SNIFFER))
#define IS_WORK_SNIFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORK_SNIFFER))
#define WORK_SNIFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORK_SNIFFER, WorkSnifferClass))

typedef struct _WorkSniffer WorkSniffer;
typedef struct _WorkSnifferClass WorkSnifferClass;
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _WorkSnifferPrivate WorkSnifferPrivate;

#define TYPE_FILE_TO_PREPARE (file_to_prepare_get_type ())
#define FILE_TO_PREPARE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_TO_PREPARE, FileToPrepare))
#define FILE_TO_PREPARE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_TO_PREPARE, FileToPrepareClass))
#define IS_FILE_TO_PREPARE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_TO_PREPARE))
#define IS_FILE_TO_PREPARE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_TO_PREPARE))
#define FILE_TO_PREPARE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_TO_PREPARE, FileToPrepareClass))

typedef struct _FileToPrepare FileToPrepare;
typedef struct _FileToPrepareClass FileToPrepareClass;

#define TYPE_NOTIFICATION_OBJECT (notification_object_get_type ())
#define NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_OBJECT, NotificationObject))
#define NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_OBJECT, NotificationObjectClass))
#define IS_NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_OBJECT))
#define IS_NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_OBJECT))
#define NOTIFICATION_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_OBJECT, NotificationObjectClass))

typedef struct _NotificationObject NotificationObject;
typedef struct _NotificationObjectClass NotificationObjectClass;

#define TYPE_PREPARE_FILES_JOB (prepare_files_job_get_type ())
#define PREPARE_FILES_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREPARE_FILES_JOB, PrepareFilesJob))
#define PREPARE_FILES_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREPARE_FILES_JOB, PrepareFilesJobClass))
#define IS_PREPARE_FILES_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREPARE_FILES_JOB))
#define IS_PREPARE_FILES_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREPARE_FILES_JOB))
#define PREPARE_FILES_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREPARE_FILES_JOB, PrepareFilesJobClass))

typedef struct _PrepareFilesJob PrepareFilesJob;
typedef struct _PrepareFilesJobClass PrepareFilesJobClass;

#define TYPE_PREPARED_FILE (prepared_file_get_type ())
#define PREPARED_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREPARED_FILE, PreparedFile))
#define PREPARED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREPARED_FILE, PreparedFileClass))
#define IS_PREPARED_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREPARED_FILE))
#define IS_PREPARED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREPARED_FILE))
#define PREPARED_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREPARED_FILE, PreparedFileClass))

typedef struct _PreparedFile PreparedFile;
typedef struct _PreparedFileClass PreparedFileClass;
typedef struct _NotificationObjectPrivate NotificationObjectPrivate;
typedef struct _PreparedFilePrivate PreparedFilePrivate;
#define _notification_object_unref0(var) ((var == NULL) ? NULL : (var = (notification_object_unref (var), NULL)))

#define TYPE_FILE_IMPORT_JOB (file_import_job_get_type ())
#define FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_IMPORT_JOB, FileImportJob))
#define FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_IMPORT_JOB, FileImportJobClass))
#define IS_FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_IMPORT_JOB))
#define IS_FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_IMPORT_JOB))
#define FILE_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_IMPORT_JOB, FileImportJobClass))

typedef struct _FileImportJob FileImportJob;
typedef struct _FileImportJobClass FileImportJobClass;
typedef struct _PrepareFilesJobPrivate PrepareFilesJobPrivate;
typedef struct _FileImportJobPrivate FileImportJobPrivate;

#define TYPE_PHOTO_ROW (photo_row_get_type ())

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;
typedef struct _PhotoRow PhotoRow;

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;
typedef struct _FileToPreparePrivate FileToPreparePrivate;
typedef struct _ParamSpecFileToPrepare ParamSpecFileToPrepare;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _file_to_prepare_unref0(var) ((var == NULL) ? NULL : (var = (file_to_prepare_unref (var), NULL)))

#define TYPE_PHOTO_EXIF (photo_exif_get_type ())
#define PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_EXIF, PhotoExif))
#define PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_EXIF, PhotoExifClass))
#define IS_PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_EXIF))
#define IS_PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_EXIF))
#define PHOTO_EXIF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_EXIF, PhotoExifClass))

typedef struct _PhotoExif PhotoExif;
typedef struct _PhotoExifClass PhotoExifClass;
#define _photo_exif_unref0(var) ((var == NULL) ? NULL : (var = (photo_exif_unref (var), NULL)))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))

#define PHOTO_FILE_INTERROGATOR_TYPE_OPTIONS (photo_file_interrogator_options_get_type ())

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

struct _BatchImportJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BatchImportJobPrivate * priv;
};

struct _BatchImportJobClass {
	GTypeClass parent_class;
	void (*finalize) (BatchImportJob *self);
	char* (*get_identifier) (BatchImportJob* self);
	gboolean (*is_directory) (BatchImportJob* self);
	gboolean (*prepare) (BatchImportJob* self, GFile** file_to_import, gboolean* copy_to_library, GError** error);
};

struct _ParamSpecBatchImportJob {
	GParamSpec parent_instance;
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR
} ImportResult;

struct _BatchImportResult {
	GObject parent_instance;
	BatchImportResultPrivate * priv;
	BatchImportJob* job;
	GFile* file;
	char* identifier;
	ImportResult result;
	char* errmsg;
};

struct _BatchImportResultClass {
	GObjectClass parent_class;
};

struct _ImportID {
	gint64 id;
};

struct _ImportManifest {
	GObject parent_instance;
	ImportManifestPrivate * priv;
	ImportID import_id;
	guint64 total_imported_bytes;
	GeeList* imported;
	GeeList* success;
	GeeList* camera_failed;
	GeeList* failed;
	GeeList* skipped_photos;
	GeeList* skipped_files;
	GeeList* aborted;
	GeeList* already_imported;
	GeeList* all;
};

struct _ImportManifestClass {
	GObjectClass parent_class;
};

struct _BatchImport {
	GObject parent_instance;
	BatchImportPrivate * priv;
};

struct _BatchImportClass {
	GObjectClass parent_class;
};

typedef void (*BatchImportImportReporter) (ImportManifest* manifest, void* user_data);
struct _BatchImportPrivate {
	GeeIterable* jobs;
	char* name;
	guint64 total_bytes;
	BatchImportImportReporter reporter;
	gpointer reporter_target;
	GDestroyNotify reporter_target_destroy_notify;
	ImportManifest* manifest;
	gboolean scheduled;
	gboolean completed;
	gint file_imports_to_perform;
	gint file_imports_completed;
	GCancellable* cancellable;
};

typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _BackgroundImportJob {
	BackgroundJob parent_instance;
	BackgroundImportJobPrivate * priv;
	ImportResult abort_flag;
	GeeList* failed;
};

struct _BackgroundImportJobClass {
	BackgroundJobClass parent_class;
};

typedef void (*CompletionCallback) (BackgroundJob* job, void* user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, void* user_data);
struct _WorkSniffer {
	BackgroundImportJob parent_instance;
	WorkSnifferPrivate * priv;
	GeeList* files_to_prepare;
};

struct _WorkSnifferClass {
	BackgroundImportJobClass parent_class;
};

typedef void (*NotificationCallback) (BackgroundJob* job, NotificationObject* user, void* user_data);
struct _NotificationObject {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NotificationObjectPrivate * priv;
};

struct _NotificationObjectClass {
	GTypeClass parent_class;
	void (*finalize) (NotificationObject *self);
};

struct _PreparedFile {
	NotificationObject parent_instance;
	PreparedFilePrivate * priv;
	BatchImportJob* job;
	ImportResult result;
	GFile* file;
	char* id;
	gboolean copy_to_library;
	char* exif_md5;
	char* thumbnail_md5;
	char* full_md5;
};

struct _PreparedFileClass {
	NotificationObjectClass parent_class;
};

struct _PrepareFilesJob {
	BackgroundImportJob parent_instance;
	PrepareFilesJobPrivate * priv;
	gint prepared_files;
};

struct _PrepareFilesJobClass {
	BackgroundImportJobClass parent_class;
};

struct _PhotoID {
	gint64 id;
};

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _EventID {
	gint64 id;
};

struct _PhotoRow {
	PhotoID photo_id;
	char* filepath;
	Dimensions dim;
	gint64 filesize;
	time_t timestamp;
	time_t exposure_time;
	Orientation orientation;
	Orientation original_orientation;
	ImportID import_id;
	EventID event_id;
	GeeHashMap* transformations;
	char* md5;
	char* thumbnail_md5;
	char* exif_md5;
	time_t time_created;
	guint64 flags;
};

struct _FileImportJob {
	BackgroundJob parent_instance;
	FileImportJobPrivate * priv;
	BatchImportResult* batch_result;
	PhotoRow photo_row;
	GdkPixbuf* pixbuf;
	Thumbnails* thumbnails;
};

struct _FileImportJobClass {
	BackgroundJobClass parent_class;
};

struct _FileToPrepare {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FileToPreparePrivate * priv;
	BatchImportJob* job;
	GFile* file;
	gboolean copy_to_library;
};

struct _FileToPrepareClass {
	GTypeClass parent_class;
	void (*finalize) (FileToPrepare *self);
};

struct _ParamSpecFileToPrepare {
	GParamSpec parent_instance;
};

struct _WorkSnifferPrivate {
	GeeIterable* jobs;
};

struct _PrepareFilesJobPrivate {
	GeeList* files_to_prepare;
	NotificationCallback notification;
	gpointer notification_target;
	GDestroyNotify notification_target_destroy_notify;
	GFile* library_dir;
	gint import_file_count;
	gint fail_every;
	gint skip_every;
};

typedef enum  {
	EXIF_ERROR_FILE_FORMAT
} ExifError;
#define EXIF_ERROR exif_error_quark ()
struct _FileImportJobPrivate {
	PreparedFile* prepared_file;
	ImportID import_id;
	GFile* final_file;
};

typedef enum  {
	PHOTO_FILE_INTERROGATOR_OPTIONS_GET_ALL,
	PHOTO_FILE_INTERROGATOR_OPTIONS_NO_MD5,
	PHOTO_FILE_INTERROGATOR_OPTIONS_NO_PIXBUF
} PhotoFileInterrogatorOptions;

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};


static gpointer batch_import_job_parent_class = NULL;
static gpointer batch_import_result_parent_class = NULL;
static gpointer import_manifest_parent_class = NULL;
static Workers* batch_import_workers;
static Workers* batch_import_workers = NULL;
static gpointer batch_import_parent_class = NULL;
static gpointer background_import_job_parent_class = NULL;
static gpointer file_to_prepare_parent_class = NULL;
static gpointer work_sniffer_parent_class = NULL;
static gpointer prepared_file_parent_class = NULL;
static gpointer prepare_files_job_parent_class = NULL;
static gpointer file_import_job_parent_class = NULL;

gpointer batch_import_job_ref (gpointer instance);
void batch_import_job_unref (gpointer instance);
GParamSpec* param_spec_batch_import_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_batch_import_job (GValue* value, gpointer v_object);
void value_take_batch_import_job (GValue* value, gpointer v_object);
gpointer value_get_batch_import_job (const GValue* value);
GType batch_import_job_get_type (void);
enum  {
	BATCH_IMPORT_JOB_DUMMY_PROPERTY
};
char* batch_import_job_get_identifier (BatchImportJob* self);
static char* batch_import_job_real_get_identifier (BatchImportJob* self);
gboolean batch_import_job_is_directory (BatchImportJob* self);
static gboolean batch_import_job_real_is_directory (BatchImportJob* self);
gboolean batch_import_job_prepare (BatchImportJob* self, GFile** file_to_import, gboolean* copy_to_library, GError** error);
static gboolean batch_import_job_real_prepare (BatchImportJob* self, GFile** file_to_import, gboolean* copy_to_library, GError** error);
BatchImportJob* batch_import_job_construct (GType object_type);
static void batch_import_job_finalize (BatchImportJob* obj);
GType batch_import_result_get_type (void);
GType import_result_get_type (void);
enum  {
	BATCH_IMPORT_RESULT_DUMMY_PROPERTY
};
BatchImportResult* batch_import_result_new (BatchImportJob* job, GFile* file, const char* identifier, ImportResult _result_);
BatchImportResult* batch_import_result_construct (GType object_type, BatchImportJob* job, GFile* file, const char* identifier, ImportResult _result_);
ImportResult import_result_convert_error (GError* err, ImportResult default_result);
BatchImportResult* batch_import_result_new_from_error (BatchImportJob* job, GFile* file, const char* identifier, GError* err, ImportResult default_result);
BatchImportResult* batch_import_result_construct_from_error (GType object_type, BatchImportJob* job, GFile* file, const char* identifier, GError* err, ImportResult default_result);
static void batch_import_result_finalize (GObject* obj);
GType import_manifest_get_type (void);
GType import_id_get_type (void);
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType data_object_get_type (void);
GType data_source_get_type (void);
GType thumbnail_source_get_type (void);
GType photo_source_get_type (void);
GType transformable_photo_get_type (void);
GType library_photo_get_type (void);
enum  {
	IMPORT_MANIFEST_DUMMY_PROPERTY
};
#define IMPORT_ID_INVALID ((gint64) (-1))
void import_id_init (ImportID *self, gint64 id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void);
GType photo_table_get_type (void);
PhotoTable* photo_table_get_instance (void);
void photo_table_generate_import_id (PhotoTable* self, ImportID* result);
void import_manifest_add_result (ImportManifest* self, BatchImportResult* batch_result);
ImportManifest* import_manifest_new (GeeList* prefailed, GeeList* pre_already_imported);
ImportManifest* import_manifest_construct (GType object_type, GeeList* prefailed, GeeList* pre_already_imported);
gboolean query_is_directory (GFile* file);
static void import_manifest_finalize (GObject* obj);
GType batch_import_get_type (void);
#define BATCH_IMPORT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BATCH_IMPORT, BatchImportPrivate))
enum  {
	BATCH_IMPORT_DUMMY_PROPERTY
};
Workers* workers_new (gint max_threads, gboolean exclusive);
Workers* workers_construct (GType object_type, gint max_threads, gboolean exclusive);
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void);
void batch_import_user_halt (BatchImport* self);
GType page_window_get_type (void);
GType app_window_get_type (void);
static void _batch_import_user_halt_app_window_user_quit (AppWindow* _sender, gpointer self);
AppWindow* app_window_get_instance (void);
BatchImport* batch_import_new (GeeIterable* jobs, const char* name, BatchImportImportReporter reporter, void* reporter_target, guint64 total_bytes, GeeArrayList* prefailed, GeeArrayList* pre_already_imported, GCancellable* cancellable);
BatchImport* batch_import_construct (GType object_type, GeeIterable* jobs, const char* name, BatchImportImportReporter reporter, void* reporter_target, guint64 total_bytes, GeeArrayList* prefailed, GeeArrayList* pre_already_imported, GCancellable* cancellable);
char* batch_import_get_name (BatchImport* self);
guint64 batch_import_get_total_bytes (BatchImport* self);
static void batch_import_log_status (BatchImport* self, const char* where);
gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_background_job (GValue* value, gpointer v_object);
void value_take_background_job (GValue* value, gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void);
GType background_job_job_priority_get_type (void);
GType background_import_job_get_type (void);
gboolean import_result_is_nonuser_abort (ImportResult self);
static gboolean batch_import_report_failures (BatchImport* self, BackgroundImportJob* background_job);
static void batch_import_report_completed (BatchImport* self, const char* where);
void workers_enqueue (Workers* self, BackgroundJob* background_job);
static void batch_import_on_work_sniffed_out (BatchImport* self, BackgroundJob* j);
static void _batch_import_on_work_sniffed_out_completion_callback (BackgroundJob* job, gpointer self);
static void batch_import_on_sniffer_cancelled (BatchImport* self, BackgroundJob* j);
static void _batch_import_on_sniffer_cancelled_cancellation_callback (BackgroundJob* job, gpointer self);
WorkSniffer* work_sniffer_new (BatchImport* owner, GeeIterable* jobs, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
WorkSniffer* work_sniffer_construct (GType object_type, BatchImport* owner, GeeIterable* jobs, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
GType work_sniffer_get_type (void);
void batch_import_schedule (BatchImport* self);
gpointer file_to_prepare_ref (gpointer instance);
void file_to_prepare_unref (gpointer instance);
GParamSpec* param_spec_file_to_prepare (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_file_to_prepare (GValue* value, gpointer v_object);
void value_take_file_to_prepare (GValue* value, gpointer v_object);
gpointer value_get_file_to_prepare (const GValue* value);
GType file_to_prepare_get_type (void);
gpointer notification_object_ref (gpointer instance);
void notification_object_unref (gpointer instance);
GParamSpec* param_spec_notification_object (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_notification_object (GValue* value, gpointer v_object);
void value_take_notification_object (GValue* value, gpointer v_object);
gpointer value_get_notification_object (const GValue* value);
GType notification_object_get_type (void);
static void batch_import_on_file_prepared (BatchImport* self, BackgroundJob* j, NotificationObject* user);
static void _batch_import_on_file_prepared_notification_callback (BackgroundJob* job, NotificationObject* user, gpointer self);
static void batch_import_on_files_prepared (BatchImport* self, BackgroundJob* j);
static void _batch_import_on_files_prepared_completion_callback (BackgroundJob* job, gpointer self);
static void batch_import_on_file_prepare_cancelled (BatchImport* self, BackgroundJob* j);
static void _batch_import_on_file_prepare_cancelled_cancellation_callback (BackgroundJob* job, gpointer self);
PrepareFilesJob* prepare_files_job_new (BatchImport* owner, GeeList* files_to_prepare, NotificationCallback notification, void* notification_target, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
PrepareFilesJob* prepare_files_job_construct (GType object_type, BatchImport* owner, GeeList* files_to_prepare, NotificationCallback notification, void* notification_target, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
GType prepare_files_job_get_type (void);
GType prepared_file_get_type (void);
gboolean transformable_photo_is_duplicate (GFile* file, const char* exif_md5, const char* thumbnail_md5, const char* full_md5);
static void batch_import_on_import_file_completed (BatchImport* self, BackgroundJob* j);
static void _batch_import_on_import_file_completed_completion_callback (BackgroundJob* job, gpointer self);
static void batch_import_on_import_file_cancelled (BatchImport* self, BackgroundJob* j);
static void _batch_import_on_import_file_cancelled_cancellation_callback (BackgroundJob* job, gpointer self);
FileImportJob* file_import_job_new (BatchImport* owner, PreparedFile* prepared_file, ImportID* import_id, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
FileImportJob* file_import_job_construct (GType object_type, BatchImport* owner, PreparedFile* prepared_file, ImportID* import_id, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
GType file_import_job_get_type (void);
char* file_import_job_get_filename (FileImportJob* self);
GType photo_row_get_type (void);
GType photo_id_get_type (void);
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType orientation_get_type (void);
GType event_id_get_type (void);
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_key_value_map (GValue* value, gpointer v_object);
void value_take_key_value_map (GValue* value, gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void);
PhotoRow* photo_row_dup (const PhotoRow* self);
void photo_row_free (PhotoRow* self);
void photo_row_copy (const PhotoRow* self, PhotoRow* dest);
void photo_row_destroy (PhotoRow* self);
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_thumbnails (GValue* value, gpointer v_object);
void value_take_thumbnails (GValue* value, gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void);
ImportResult library_photo_import (PhotoRow* photo_row, Thumbnails* thumbnails, LibraryPhoto** photo);
char* import_result_to_string (ImportResult self);
BatchImportResult* file_import_job_abort (FileImportJob* self);
static void batch_import_finalize (GObject* obj);
enum  {
	BACKGROUND_IMPORT_JOB_DUMMY_PROPERTY
};
BackgroundJob* background_job_construct (GType object_type, GObject* owner, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
BackgroundImportJob* background_import_job_construct (GType object_type, BatchImport* owner, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
gboolean background_job_is_cancelled (BackgroundJob* self);
ImportResult background_import_job_abort_check (BackgroundImportJob* self);
void background_import_job_abort (BackgroundImportJob* self, ImportResult _result_);
gboolean import_result_is_abort (ImportResult self);
void background_import_job_report_failure (BackgroundImportJob* self, BatchImportJob* job, GFile* file, const char* identifier, ImportResult _result_);
void background_import_job_report_error (BackgroundImportJob* self, BatchImportJob* job, GFile* file, const char* identifier, GError* err, ImportResult default_result);
static void background_import_job_finalize (BackgroundJob* obj);
enum  {
	FILE_TO_PREPARE_DUMMY_PROPERTY
};
FileToPrepare* file_to_prepare_new (BatchImportJob* job, GFile* file, gboolean copy_to_library);
FileToPrepare* file_to_prepare_construct (GType object_type, BatchImportJob* job, GFile* file, gboolean copy_to_library);
static void file_to_prepare_finalize (FileToPrepare* obj);
#define WORK_SNIFFER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_WORK_SNIFFER, WorkSnifferPrivate))
enum  {
	WORK_SNIFFER_DUMMY_PROPERTY
};
static void work_sniffer_sniff_job (WorkSniffer* self, BatchImportJob* job, GError** error);
static void work_sniffer_real_execute (BackgroundJob* base);
void work_sniffer_search_dir (WorkSniffer* self, BatchImportJob* job, GFile* dir, gboolean copy_to_library, GError** error);
static void work_sniffer_finalize (BackgroundJob* obj);
enum  {
	PREPARED_FILE_DUMMY_PROPERTY
};
NotificationObject* notification_object_construct (GType object_type);
PreparedFile* prepared_file_new (BatchImportJob* job, GFile* file, const char* id, gboolean copy_to_library, const char* exif_md5, const char* thumbnail_md5, const char* full_md5);
PreparedFile* prepared_file_construct (GType object_type, BatchImportJob* job, GFile* file, const char* id, gboolean copy_to_library, const char* exif_md5, const char* thumbnail_md5, const char* full_md5);
static void prepared_file_finalize (NotificationObject* obj);
#define PREPARE_FILES_JOB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PREPARE_FILES_JOB, PrepareFilesJobPrivate))
enum  {
	PREPARE_FILES_JOB_DUMMY_PROPERTY
};
GFile* app_dirs_get_photos_dir (void);
static gint prepare_files_job_get_test_variable (const char* name);
static ImportResult prepare_files_job_prepare_file (PrepareFilesJob* self, BatchImportJob* job, GFile* file, gboolean copy_to_library, GError** error);
static void prepare_files_job_real_execute (BackgroundJob* base);
gboolean transformable_photo_is_file_image (GFile* file);
gboolean transformable_photo_is_file_supported (GFile* file);
PhotoExif* photo_exif_new (GFile* file);
PhotoExif* photo_exif_construct (GType object_type, GFile* file);
gpointer photo_exif_ref (gpointer instance);
void photo_exif_unref (gpointer instance);
GParamSpec* param_spec_photo_exif (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_exif (GValue* value, gpointer v_object);
void value_take_photo_exif (GValue* value, gpointer v_object);
gpointer value_get_photo_exif (const GValue* value);
GType photo_exif_get_type (void);
GQuark exif_error_quark (void);
void photo_exif_load (PhotoExif* self, GError** error);
char* photo_exif_get_md5 (PhotoExif* self);
char* photo_exif_get_thumbnail_md5 (PhotoExif* self);
char* md5_file (GFile* file, GError** error);
void background_job_notify (BackgroundJob* self, NotificationCallback callback, void* callback_target, NotificationObject* user);
static void prepare_files_job_finalize (BackgroundJob* obj);
#define FILE_IMPORT_JOB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_FILE_IMPORT_JOB, FileImportJobPrivate))
enum  {
	FILE_IMPORT_JOB_DUMMY_PROPERTY
};
void photo_row_init (PhotoRow *self);
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, GError** error);
GType photo_file_interrogator_options_get_type (void);
GType scaling_get_type (void);
GType scale_constraint_get_type (void);
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result);
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file, PhotoFileInterrogatorOptions options, Scaling* scaling);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type, GFile* file, PhotoFileInterrogatorOptions options, Scaling* scaling);
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value, gpointer v_object);
void value_take_photo_file_interrogator (GValue* value, gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void);
Thumbnails* thumbnails_new (void);
Thumbnails* thumbnails_construct (GType object_type);
ImportResult transformable_photo_prepare_for_import (GFile* file, ImportID* import_id, PhotoFileInterrogator* interrogator, PhotoRow* photo_row, GdkPixbuf** pixbuf, Thumbnails* thumbnails);
static void file_import_job_real_execute (BackgroundJob* base);
static void file_import_job_finalize (BackgroundJob* obj);


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 15 "BatchImport.vala"
static char* batch_import_job_real_get_identifier (BatchImportJob* self) {
#line 930 "BatchImport.c"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_get_identifier'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 15 "BatchImport.vala"
char* batch_import_job_get_identifier (BatchImportJob* self) {
#line 15 "BatchImport.vala"
	return BATCH_IMPORT_JOB_GET_CLASS (self)->get_identifier (self);
#line 941 "BatchImport.c"
}


#line 17 "BatchImport.vala"
static gboolean batch_import_job_real_is_directory (BatchImportJob* self) {
#line 947 "BatchImport.c"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), FALSE);
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_is_directory'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


#line 17 "BatchImport.vala"
gboolean batch_import_job_is_directory (BatchImportJob* self) {
#line 17 "BatchImport.vala"
	return BATCH_IMPORT_JOB_GET_CLASS (self)->is_directory (self);
#line 958 "BatchImport.c"
}


#line 19 "BatchImport.vala"
static gboolean batch_import_job_real_prepare (BatchImportJob* self, GFile** file_to_import, gboolean* copy_to_library, GError** error) {
#line 964 "BatchImport.c"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), FALSE);
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_prepare'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


#line 19 "BatchImport.vala"
gboolean batch_import_job_prepare (BatchImportJob* self, GFile** file_to_import, gboolean* copy_to_library, GError** error) {
#line 19 "BatchImport.vala"
	return BATCH_IMPORT_JOB_GET_CLASS (self)->prepare (self, file_to_import, copy_to_library, error);
#line 975 "BatchImport.c"
}


#line 14 "BatchImport.vala"
BatchImportJob* batch_import_job_construct (GType object_type) {
#line 981 "BatchImport.c"
	BatchImportJob* self;
	self = (BatchImportJob*) g_type_create_instance (object_type);
	return self;
}


static void value_batch_import_job_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_batch_import_job_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		batch_import_job_unref (value->data[0].v_pointer);
	}
}


static void value_batch_import_job_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = batch_import_job_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_batch_import_job_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_batch_import_job_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		BatchImportJob* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = batch_import_job_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_batch_import_job_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	BatchImportJob** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = batch_import_job_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_batch_import_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecBatchImportJob* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BATCH_IMPORT_JOB), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_batch_import_job (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_JOB), NULL);
	return value->data[0].v_pointer;
}


void value_set_batch_import_job (GValue* value, gpointer v_object) {
	BatchImportJob* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_JOB));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATCH_IMPORT_JOB));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		batch_import_job_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		batch_import_job_unref (old);
	}
}


void value_take_batch_import_job (GValue* value, gpointer v_object) {
	BatchImportJob* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_JOB));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATCH_IMPORT_JOB));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		batch_import_job_unref (old);
	}
}


static void batch_import_job_class_init (BatchImportJobClass * klass) {
	batch_import_job_parent_class = g_type_class_peek_parent (klass);
	BATCH_IMPORT_JOB_CLASS (klass)->finalize = batch_import_job_finalize;
	BATCH_IMPORT_JOB_CLASS (klass)->get_identifier = batch_import_job_real_get_identifier;
	BATCH_IMPORT_JOB_CLASS (klass)->is_directory = batch_import_job_real_is_directory;
	BATCH_IMPORT_JOB_CLASS (klass)->prepare = batch_import_job_real_prepare;
}


static void batch_import_job_instance_init (BatchImportJob * self) {
	self->ref_count = 1;
}


static void batch_import_job_finalize (BatchImportJob* obj) {
	BatchImportJob * self;
	self = BATCH_IMPORT_JOB (obj);
}


GType batch_import_job_get_type (void) {
	static volatile gsize batch_import_job_type_id__volatile = 0;
	if (g_once_init_enter (&batch_import_job_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_batch_import_job_init, value_batch_import_job_free_value, value_batch_import_job_copy_value, value_batch_import_job_peek_pointer, "p", value_batch_import_job_collect_value, "p", value_batch_import_job_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BatchImportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) batch_import_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatchImportJob), 0, (GInstanceInitFunc) batch_import_job_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType batch_import_job_type_id;
		batch_import_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BatchImportJob", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&batch_import_job_type_id__volatile, batch_import_job_type_id);
	}
	return batch_import_job_type_id__volatile;
}


gpointer batch_import_job_ref (gpointer instance) {
	BatchImportJob* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void batch_import_job_unref (gpointer instance) {
	BatchImportJob* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		BATCH_IMPORT_JOB_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static gpointer _batch_import_job_ref0 (gpointer self) {
	return self ? batch_import_job_ref (self) : NULL;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 35 "BatchImport.vala"
BatchImportResult* batch_import_result_construct (GType object_type, BatchImportJob* job, GFile* file, const char* identifier, ImportResult _result_) {
#line 1162 "BatchImport.c"
	BatchImportResult * self;
	BatchImportJob* _tmp0_;
	GFile* _tmp1_;
	char* _tmp2_;
#line 35 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), NULL);
#line 35 "BatchImport.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 35 "BatchImport.vala"
	g_return_val_if_fail (identifier != NULL, NULL);
#line 35 "BatchImport.vala"
	self = (BatchImportResult*) g_object_new (object_type, NULL);
#line 36 "BatchImport.vala"
	self->job = (_tmp0_ = _batch_import_job_ref0 (job), _batch_import_job_unref0 (self->job), _tmp0_);
#line 37 "BatchImport.vala"
	self->file = (_tmp1_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp1_);
#line 38 "BatchImport.vala"
	self->identifier = (_tmp2_ = g_strdup (identifier), _g_free0 (self->identifier), _tmp2_);
#line 39 "BatchImport.vala"
	self->result = _result_;
#line 1183 "BatchImport.c"
	return self;
}


#line 35 "BatchImport.vala"
BatchImportResult* batch_import_result_new (BatchImportJob* job, GFile* file, const char* identifier, ImportResult _result_) {
#line 35 "BatchImport.vala"
	return batch_import_result_construct (TYPE_BATCH_IMPORT_RESULT, job, file, identifier, _result_);
#line 1192 "BatchImport.c"
}


#line 42 "BatchImport.vala"
BatchImportResult* batch_import_result_construct_from_error (GType object_type, BatchImportJob* job, GFile* file, const char* identifier, GError* err, ImportResult default_result) {
#line 1198 "BatchImport.c"
	BatchImportResult * self;
	BatchImportJob* _tmp0_;
	GFile* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
#line 42 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), NULL);
#line 42 "BatchImport.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 42 "BatchImport.vala"
	g_return_val_if_fail (identifier != NULL, NULL);
#line 42 "BatchImport.vala"
	self = (BatchImportResult*) g_object_new (object_type, NULL);
#line 44 "BatchImport.vala"
	self->job = (_tmp0_ = _batch_import_job_ref0 (job), _batch_import_job_unref0 (self->job), _tmp0_);
#line 45 "BatchImport.vala"
	self->file = (_tmp1_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp1_);
#line 46 "BatchImport.vala"
	self->identifier = (_tmp2_ = g_strdup (identifier), _g_free0 (self->identifier), _tmp2_);
#line 47 "BatchImport.vala"
	self->result = import_result_convert_error (err, default_result);
#line 48 "BatchImport.vala"
	self->errmsg = (_tmp3_ = g_strdup (err->message), _g_free0 (self->errmsg), _tmp3_);
#line 1222 "BatchImport.c"
	return self;
}


#line 42 "BatchImport.vala"
BatchImportResult* batch_import_result_new_from_error (BatchImportJob* job, GFile* file, const char* identifier, GError* err, ImportResult default_result) {
#line 42 "BatchImport.vala"
	return batch_import_result_construct_from_error (TYPE_BATCH_IMPORT_RESULT, job, file, identifier, err, default_result);
#line 1231 "BatchImport.c"
}


static void batch_import_result_class_init (BatchImportResultClass * klass) {
	batch_import_result_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = batch_import_result_finalize;
}


static void batch_import_result_instance_init (BatchImportResult * self) {
	self->errmsg = NULL;
}


static void batch_import_result_finalize (GObject* obj) {
	BatchImportResult * self;
	self = BATCH_IMPORT_RESULT (obj);
	_batch_import_job_unref0 (self->job);
	_g_object_unref0 (self->file);
	_g_free0 (self->identifier);
	_g_free0 (self->errmsg);
	G_OBJECT_CLASS (batch_import_result_parent_class)->finalize (obj);
}


GType batch_import_result_get_type (void) {
	static volatile gsize batch_import_result_type_id__volatile = 0;
	if (g_once_init_enter (&batch_import_result_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BatchImportResultClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) batch_import_result_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatchImportResult), 0, (GInstanceInitFunc) batch_import_result_instance_init, NULL };
		GType batch_import_result_type_id;
		batch_import_result_type_id = g_type_register_static (G_TYPE_OBJECT, "BatchImportResult", &g_define_type_info, 0);
		g_once_init_leave (&batch_import_result_type_id__volatile, batch_import_result_type_id);
	}
	return batch_import_result_type_id__volatile;
}


#line 65 "BatchImport.vala"
ImportManifest* import_manifest_construct (GType object_type, GeeList* prefailed, GeeList* pre_already_imported) {
#line 1271 "BatchImport.c"
	ImportManifest * self;
	ImportID _tmp1_ = {0};
	PhotoTable* _tmp0_;
#line 65 "BatchImport.vala"
	g_return_val_if_fail ((prefailed == NULL) || GEE_IS_LIST (prefailed), NULL);
#line 65 "BatchImport.vala"
	g_return_val_if_fail ((pre_already_imported == NULL) || GEE_IS_LIST (pre_already_imported), NULL);
#line 65 "BatchImport.vala"
	self = (ImportManifest*) g_object_new (object_type, NULL);
#line 66 "BatchImport.vala"
	self->import_id = (photo_table_generate_import_id (_tmp0_ = photo_table_get_instance (), &_tmp1_), _tmp1_);
#line 1283 "BatchImport.c"
	_database_table_unref0 (_tmp0_);
#line 68 "BatchImport.vala"
	if (prefailed != NULL) {
#line 1287 "BatchImport.c"
		{
			GeeIterator* _job_it;
			_job_it = gee_iterable_iterator (GEE_ITERABLE (prefailed));
#line 69 "BatchImport.vala"
			while (TRUE) {
#line 1293 "BatchImport.c"
				BatchImportJob* job;
				char* _tmp2_;
				BatchImportResult* _tmp3_;
				BatchImportResult* batch_result;
#line 69 "BatchImport.vala"
				if (!gee_iterator_next (_job_it)) {
#line 69 "BatchImport.vala"
					break;
#line 1302 "BatchImport.c"
				}
#line 69 "BatchImport.vala"
				job = (BatchImportJob*) gee_iterator_get (_job_it);
#line 70 "BatchImport.vala"
				batch_result = (_tmp3_ = batch_import_result_new (job, NULL, _tmp2_ = batch_import_job_get_identifier (job), IMPORT_RESULT_FILE_ERROR), _g_free0 (_tmp2_), _tmp3_);
#line 72 "BatchImport.vala"
				import_manifest_add_result (self, batch_result);
#line 1310 "BatchImport.c"
				_batch_import_job_unref0 (job);
				_g_object_unref0 (batch_result);
			}
			_g_object_unref0 (_job_it);
		}
	}
#line 76 "BatchImport.vala"
	if (pre_already_imported != NULL) {
#line 1319 "BatchImport.c"
		{
			GeeIterator* _job_it;
			_job_it = gee_iterable_iterator (GEE_ITERABLE (pre_already_imported));
#line 77 "BatchImport.vala"
			while (TRUE) {
#line 1325 "BatchImport.c"
				BatchImportJob* job;
				char* _tmp4_;
				BatchImportResult* _tmp5_;
				BatchImportResult* batch_result;
#line 77 "BatchImport.vala"
				if (!gee_iterator_next (_job_it)) {
#line 77 "BatchImport.vala"
					break;
#line 1334 "BatchImport.c"
				}
#line 77 "BatchImport.vala"
				job = (BatchImportJob*) gee_iterator_get (_job_it);
#line 78 "BatchImport.vala"
				batch_result = (_tmp5_ = batch_import_result_new (job, NULL, _tmp4_ = batch_import_job_get_identifier (job), IMPORT_RESULT_PHOTO_EXISTS), _g_free0 (_tmp4_), _tmp5_);
#line 80 "BatchImport.vala"
				import_manifest_add_result (self, batch_result);
#line 1342 "BatchImport.c"
				_batch_import_job_unref0 (job);
				_g_object_unref0 (batch_result);
			}
			_g_object_unref0 (_job_it);
		}
	}
	return self;
}


#line 65 "BatchImport.vala"
ImportManifest* import_manifest_new (GeeList* prefailed, GeeList* pre_already_imported) {
#line 65 "BatchImport.vala"
	return import_manifest_construct (TYPE_IMPORT_MANIFEST, prefailed, pre_already_imported);
#line 1357 "BatchImport.c"
}


#line 85 "BatchImport.vala"
void import_manifest_add_result (ImportManifest* self, BatchImportResult* batch_result) {
#line 1363 "BatchImport.c"
	gboolean reported;
#line 85 "BatchImport.vala"
	g_return_if_fail (IS_IMPORT_MANIFEST (self));
#line 85 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_RESULT (batch_result));
#line 86 "BatchImport.vala"
	reported = TRUE;
#line 87 "BatchImport.vala"
	switch (batch_result->result) {
#line 1373 "BatchImport.c"
		case IMPORT_RESULT_SUCCESS:
		{
#line 89 "BatchImport.vala"
			gee_collection_add (GEE_COLLECTION (self->success), batch_result);
#line 90 "BatchImport.vala"
			break;
#line 1380 "BatchImport.c"
		}
		case IMPORT_RESULT_USER_ABORT:
		{
			gboolean _tmp0_ = FALSE;
#line 93 "BatchImport.vala"
			if (batch_result->file != NULL) {
#line 93 "BatchImport.vala"
				_tmp0_ = !query_is_directory (batch_result->file);
#line 1389 "BatchImport.c"
			} else {
#line 93 "BatchImport.vala"
				_tmp0_ = FALSE;
#line 1393 "BatchImport.c"
			}
#line 93 "BatchImport.vala"
			if (_tmp0_) {
#line 94 "BatchImport.vala"
				gee_collection_add (GEE_COLLECTION (self->aborted), batch_result);
#line 1399 "BatchImport.c"
			} else {
#line 96 "BatchImport.vala"
				reported = FALSE;
#line 1403 "BatchImport.c"
			}
#line 97 "BatchImport.vala"
			break;
#line 1407 "BatchImport.c"
		}
		case IMPORT_RESULT_UNSUPPORTED_FORMAT:
		{
#line 100 "BatchImport.vala"
			gee_collection_add (GEE_COLLECTION (self->skipped_photos), batch_result);
#line 101 "BatchImport.vala"
			break;
#line 1415 "BatchImport.c"
		}
		case IMPORT_RESULT_NOT_A_FILE:
		case IMPORT_RESULT_NOT_AN_IMAGE:
		{
#line 105 "BatchImport.vala"
			gee_collection_add (GEE_COLLECTION (self->skipped_files), batch_result);
#line 106 "BatchImport.vala"
			break;
#line 1424 "BatchImport.c"
		}
		case IMPORT_RESULT_PHOTO_EXISTS:
		{
#line 109 "BatchImport.vala"
			gee_collection_add (GEE_COLLECTION (self->already_imported), batch_result);
#line 110 "BatchImport.vala"
			break;
#line 1432 "BatchImport.c"
		}
		case IMPORT_RESULT_CAMERA_ERROR:
		{
#line 113 "BatchImport.vala"
			gee_collection_add (GEE_COLLECTION (self->camera_failed), batch_result);
#line 114 "BatchImport.vala"
			break;
#line 1440 "BatchImport.c"
		}
		default:
		{
#line 117 "BatchImport.vala"
			gee_collection_add (GEE_COLLECTION (self->failed), batch_result);
#line 118 "BatchImport.vala"
			break;
#line 1448 "BatchImport.c"
		}
	}
#line 121 "BatchImport.vala"
	if (reported) {
#line 122 "BatchImport.vala"
		gee_collection_add (GEE_COLLECTION (self->all), batch_result);
#line 1455 "BatchImport.c"
	}
}


static void import_manifest_class_init (ImportManifestClass * klass) {
	import_manifest_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = import_manifest_finalize;
}


static void import_manifest_instance_init (ImportManifest * self) {
	ImportID _tmp0_ = {0};
	self->import_id = (import_id_init (&_tmp0_, IMPORT_ID_INVALID), _tmp0_);
	self->total_imported_bytes = (guint64) 0;
	self->imported = GEE_LIST (gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->success = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->camera_failed = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->failed = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->skipped_photos = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->skipped_files = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->aborted = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->already_imported = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
	self->all = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
}


static void import_manifest_finalize (GObject* obj) {
	ImportManifest * self;
	self = IMPORT_MANIFEST (obj);
	_g_object_unref0 (self->imported);
	_g_object_unref0 (self->success);
	_g_object_unref0 (self->camera_failed);
	_g_object_unref0 (self->failed);
	_g_object_unref0 (self->skipped_photos);
	_g_object_unref0 (self->skipped_files);
	_g_object_unref0 (self->aborted);
	_g_object_unref0 (self->already_imported);
	_g_object_unref0 (self->all);
	G_OBJECT_CLASS (import_manifest_parent_class)->finalize (obj);
}


GType import_manifest_get_type (void) {
	static volatile gsize import_manifest_type_id__volatile = 0;
	if (g_once_init_enter (&import_manifest_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImportManifestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_manifest_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportManifest), 0, (GInstanceInitFunc) import_manifest_instance_init, NULL };
		GType import_manifest_type_id;
		import_manifest_type_id = g_type_register_static (G_TYPE_OBJECT, "ImportManifest", &g_define_type_info, 0);
		g_once_init_leave (&import_manifest_type_id__volatile, import_manifest_type_id);
	}
	return import_manifest_type_id__volatile;
}


#line 198 "BatchImport.vala"
static void _batch_import_user_halt_app_window_user_quit (AppWindow* _sender, gpointer self) {
#line 1512 "BatchImport.c"
	batch_import_user_halt (self);
}


#line 168 "BatchImport.vala"
BatchImport* batch_import_construct (GType object_type, GeeIterable* jobs, const char* name, BatchImportImportReporter reporter, void* reporter_target, guint64 total_bytes, GeeArrayList* prefailed, GeeArrayList* pre_already_imported, GCancellable* cancellable) {
#line 1519 "BatchImport.c"
	BatchImport * self;
	GeeIterable* _tmp0_;
	char* _tmp1_;
	BatchImportImportReporter _tmp2_;
	ImportManifest* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* _tmp7_;
	AppWindow* _tmp8_;
#line 168 "BatchImport.vala"
	g_return_val_if_fail (GEE_IS_ITERABLE (jobs), NULL);
#line 168 "BatchImport.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 168 "BatchImport.vala"
	g_return_val_if_fail ((prefailed == NULL) || GEE_IS_ARRAY_LIST (prefailed), NULL);
#line 168 "BatchImport.vala"
	g_return_val_if_fail ((pre_already_imported == NULL) || GEE_IS_ARRAY_LIST (pre_already_imported), NULL);
#line 168 "BatchImport.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 168 "BatchImport.vala"
	self = (BatchImport*) g_object_new (object_type, NULL);
#line 172 "BatchImport.vala"
	self->priv->jobs = (_tmp0_ = _g_object_ref0 (jobs), _g_object_unref0 (self->priv->jobs), _tmp0_);
#line 173 "BatchImport.vala"
	self->priv->name = (_tmp1_ = g_strdup (name), _g_free0 (self->priv->name), _tmp1_);
#line 174 "BatchImport.vala"
	self->priv->reporter = (_tmp2_ = reporter, ((self->priv->reporter_target_destroy_notify == NULL) ? NULL : (self->priv->reporter_target_destroy_notify (self->priv->reporter_target), NULL), self->priv->reporter = NULL, self->priv->reporter_target = NULL, self->priv->reporter_target_destroy_notify = NULL), self->priv->reporter_target = reporter_target, self->priv->reporter_target_destroy_notify = NULL, _tmp2_);
#line 175 "BatchImport.vala"
	self->priv->total_bytes = total_bytes;
#line 176 "BatchImport.vala"
	self->priv->manifest = (_tmp3_ = import_manifest_new (GEE_LIST (prefailed), GEE_LIST (pre_already_imported)), _g_object_unref0 (self->priv->manifest), _tmp3_);
#line 1550 "BatchImport.c"
	_tmp4_ = NULL;
#line 177 "BatchImport.vala"
	if (cancellable != NULL) {
#line 1554 "BatchImport.c"
		GCancellable* _tmp5_;
#line 177 "BatchImport.vala"
		_tmp4_ = (_tmp5_ = _g_object_ref0 (cancellable), _g_object_unref0 (_tmp4_), _tmp5_);
#line 1558 "BatchImport.c"
	} else {
		GCancellable* _tmp6_;
#line 177 "BatchImport.vala"
		_tmp4_ = (_tmp6_ = g_cancellable_new (), _g_object_unref0 (_tmp4_), _tmp6_);
#line 1563 "BatchImport.c"
	}
#line 177 "BatchImport.vala"
	self->priv->cancellable = (_tmp7_ = _g_object_ref0 (_tmp4_), _g_object_unref0 (self->priv->cancellable), _tmp7_);
#line 180 "BatchImport.vala"
	g_signal_connect_object (_tmp8_ = app_window_get_instance (), "user-quit", (GCallback) _batch_import_user_halt_app_window_user_quit, self, 0);
#line 1569 "BatchImport.c"
	_g_object_unref0 (_tmp8_);
	_g_object_unref0 (_tmp4_);
	return self;
}


#line 168 "BatchImport.vala"
BatchImport* batch_import_new (GeeIterable* jobs, const char* name, BatchImportImportReporter reporter, void* reporter_target, guint64 total_bytes, GeeArrayList* prefailed, GeeArrayList* pre_already_imported, GCancellable* cancellable) {
#line 168 "BatchImport.vala"
	return batch_import_construct (TYPE_BATCH_IMPORT, jobs, name, reporter, reporter_target, total_bytes, prefailed, pre_already_imported, cancellable);
#line 1580 "BatchImport.c"
}


#line 190 "BatchImport.vala"
char* batch_import_get_name (BatchImport* self) {
#line 1586 "BatchImport.c"
	char* result = NULL;
#line 190 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), NULL);
#line 1590 "BatchImport.c"
	result = g_strdup (self->priv->name);
#line 191 "BatchImport.vala"
	return result;
#line 1594 "BatchImport.c"
}


#line 194 "BatchImport.vala"
guint64 batch_import_get_total_bytes (BatchImport* self) {
#line 1600 "BatchImport.c"
	guint64 result = 0ULL;
#line 194 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), 0ULL);
#line 1604 "BatchImport.c"
	result = self->priv->total_bytes;
#line 195 "BatchImport.vala"
	return result;
#line 1608 "BatchImport.c"
}


#line 198 "BatchImport.vala"
void batch_import_user_halt (BatchImport* self) {
#line 198 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 199 "BatchImport.vala"
	g_cancellable_cancel (self->priv->cancellable);
#line 1618 "BatchImport.c"
}


#line 202 "BatchImport.vala"
static void batch_import_log_status (BatchImport* self, const char* where) {
#line 202 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 202 "BatchImport.vala"
	g_return_if_fail (where != NULL);
#line 1628 "BatchImport.c"
}


#line 208 "BatchImport.vala"
static gboolean batch_import_report_failures (BatchImport* self, BackgroundImportJob* background_job) {
#line 1634 "BatchImport.c"
	gboolean result = FALSE;
	gboolean proceed;
#line 208 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), FALSE);
#line 208 "BatchImport.vala"
	g_return_val_if_fail (IS_BACKGROUND_IMPORT_JOB (background_job), FALSE);
#line 209 "BatchImport.vala"
	proceed = TRUE;
#line 1643 "BatchImport.c"
	{
		GeeIterator* _import_result_it;
		_import_result_it = gee_iterable_iterator (GEE_ITERABLE (background_job->failed));
#line 211 "BatchImport.vala"
		while (TRUE) {
#line 1649 "BatchImport.c"
			BatchImportResult* import_result;
			gboolean _tmp0_ = FALSE;
#line 211 "BatchImport.vala"
			if (!gee_iterator_next (_import_result_it)) {
#line 211 "BatchImport.vala"
				break;
#line 1656 "BatchImport.c"
			}
#line 211 "BatchImport.vala"
			import_result = (BatchImportResult*) gee_iterator_get (_import_result_it);
#line 212 "BatchImport.vala"
			import_manifest_add_result (self->priv->manifest, import_result);
#line 214 "BatchImport.vala"
			if (import_result->result != IMPORT_RESULT_SUCCESS) {
#line 215 "BatchImport.vala"
				g_signal_emit_by_name (self, "import-job-failed", import_result);
#line 1666 "BatchImport.c"
			}
#line 218 "BatchImport.vala"
			if (import_result_is_nonuser_abort (import_result->result)) {
#line 218 "BatchImport.vala"
				_tmp0_ = proceed;
#line 1672 "BatchImport.c"
			} else {
#line 218 "BatchImport.vala"
				_tmp0_ = FALSE;
#line 1676 "BatchImport.c"
			}
#line 218 "BatchImport.vala"
			if (_tmp0_) {
#line 219 "BatchImport.vala"
				g_signal_emit_by_name (self, "fatal-error", import_result->result, import_result->errmsg);
#line 220 "BatchImport.vala"
				proceed = FALSE;
#line 1684 "BatchImport.c"
			}
			_g_object_unref0 (import_result);
		}
		_g_object_unref0 (_import_result_it);
	}
	result = proceed;
#line 224 "BatchImport.vala"
	return result;
#line 1693 "BatchImport.c"
}


#line 227 "BatchImport.vala"
static void batch_import_report_completed (BatchImport* self, const char* where) {
#line 227 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 227 "BatchImport.vala"
	g_return_if_fail (where != NULL);
#line 228 "BatchImport.vala"
	if (self->priv->completed) {
#line 229 "BatchImport.vala"
		g_error ("BatchImport.vala:229: Attempted to complete already-completed import: " \
"%s", where);
#line 1707 "BatchImport.c"
	}
#line 231 "BatchImport.vala"
	self->priv->completed = TRUE;
#line 233 "BatchImport.vala"
	g_debug ("BatchImport.vala:233: Import completed: %s", where);
#line 236 "BatchImport.vala"
	if (self->priv->reporter != NULL) {
#line 237 "BatchImport.vala"
		self->priv->reporter (self->priv->manifest, self->priv->reporter_target);
#line 1717 "BatchImport.c"
	}
#line 239 "BatchImport.vala"
	g_signal_emit_by_name (self, "import-complete", self->priv->manifest);
#line 1721 "BatchImport.c"
}


#line 253 "BatchImport.vala"
static void _batch_import_on_work_sniffed_out_completion_callback (BackgroundJob* job, gpointer self) {
#line 1727 "BatchImport.c"
	batch_import_on_work_sniffed_out (self, job);
}


#line 275 "BatchImport.vala"
static void _batch_import_on_sniffer_cancelled_cancellation_callback (BackgroundJob* job, gpointer self) {
#line 1734 "BatchImport.c"
	batch_import_on_sniffer_cancelled (self, job);
}


#line 242 "BatchImport.vala"
void batch_import_schedule (BatchImport* self) {
#line 1741 "BatchImport.c"
	WorkSniffer* _tmp0_;
#line 242 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 243 "BatchImport.vala"
	g_assert (self->priv->scheduled == FALSE);
#line 244 "BatchImport.vala"
	self->priv->scheduled = TRUE;
#line 246 "BatchImport.vala"
	g_signal_emit_by_name (self, "starting");
#line 249 "BatchImport.vala"
	workers_enqueue (batch_import_workers, BACKGROUND_JOB (_tmp0_ = work_sniffer_new (self, self->priv->jobs, _batch_import_on_work_sniffed_out_completion_callback, self, self->priv->cancellable, _batch_import_on_sniffer_cancelled_cancellation_callback, self)));
#line 1753 "BatchImport.c"
	_background_job_unref0 (_tmp0_);
}


static gpointer _background_job_ref0 (gpointer self) {
	return self ? background_job_ref (self) : NULL;
}


#line 284 "BatchImport.vala"
static void _batch_import_on_file_prepared_notification_callback (BackgroundJob* job, NotificationObject* user, gpointer self) {
#line 1765 "BatchImport.c"
	batch_import_on_file_prepared (self, job, user);
}


#line 311 "BatchImport.vala"
static void _batch_import_on_files_prepared_completion_callback (BackgroundJob* job, gpointer self) {
#line 1772 "BatchImport.c"
	batch_import_on_files_prepared (self, job);
}


#line 332 "BatchImport.vala"
static void _batch_import_on_file_prepare_cancelled_cancellation_callback (BackgroundJob* job, gpointer self) {
#line 1779 "BatchImport.c"
	batch_import_on_file_prepare_cancelled (self, job);
}


#line 253 "BatchImport.vala"
static void batch_import_on_work_sniffed_out (BatchImport* self, BackgroundJob* j) {
#line 1786 "BatchImport.c"
	WorkSniffer* sniffer;
	gboolean _tmp0_ = FALSE;
	PrepareFilesJob* prepare_files_job;
#line 253 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 253 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 254 "BatchImport.vala"
	g_assert (!self->priv->completed);
#line 256 "BatchImport.vala"
	sniffer = _background_job_ref0 (WORK_SNIFFER (j));
#line 258 "BatchImport.vala"
	if (!batch_import_report_failures (self, BACKGROUND_IMPORT_JOB (sniffer))) {
#line 258 "BatchImport.vala"
		_tmp0_ = TRUE;
#line 1802 "BatchImport.c"
	} else {
#line 258 "BatchImport.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (sniffer->files_to_prepare)) == 0;
#line 1806 "BatchImport.c"
	}
#line 258 "BatchImport.vala"
	if (_tmp0_) {
#line 259 "BatchImport.vala"
		batch_import_report_completed (self, "work sniffed out: nothing to do");
#line 1812 "BatchImport.c"
		_background_job_unref0 (sniffer);
#line 261 "BatchImport.vala"
		return;
#line 1816 "BatchImport.c"
	}
#line 269 "BatchImport.vala"
	prepare_files_job = prepare_files_job_new (self, sniffer->files_to_prepare, _batch_import_on_file_prepared_notification_callback, self, _batch_import_on_files_prepared_completion_callback, self, self->priv->cancellable, _batch_import_on_file_prepare_cancelled_cancellation_callback, self);
#line 272 "BatchImport.vala"
	workers_enqueue (batch_import_workers, BACKGROUND_JOB (prepare_files_job));
#line 1822 "BatchImport.c"
	_background_job_unref0 (sniffer);
	_background_job_unref0 (prepare_files_job);
}


#line 275 "BatchImport.vala"
static void batch_import_on_sniffer_cancelled (BatchImport* self, BackgroundJob* j) {
#line 1830 "BatchImport.c"
	WorkSniffer* sniffer;
#line 275 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 275 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 276 "BatchImport.vala"
	g_assert (!self->priv->completed);
#line 278 "BatchImport.vala"
	sniffer = _background_job_ref0 (WORK_SNIFFER (j));
#line 280 "BatchImport.vala"
	batch_import_report_failures (self, BACKGROUND_IMPORT_JOB (sniffer));
#line 281 "BatchImport.vala"
	batch_import_report_completed (self, "work sniffer cancelled");
#line 1844 "BatchImport.c"
	_background_job_unref0 (sniffer);
}


static gpointer _notification_object_ref0 (gpointer self) {
	return self ? notification_object_ref (self) : NULL;
}


#line 352 "BatchImport.vala"
static void _batch_import_on_import_file_completed_completion_callback (BackgroundJob* job, gpointer self) {
#line 1856 "BatchImport.c"
	batch_import_on_import_file_completed (self, job);
}


#line 386 "BatchImport.vala"
static void _batch_import_on_import_file_cancelled_cancellation_callback (BackgroundJob* job, gpointer self) {
#line 1863 "BatchImport.c"
	batch_import_on_import_file_cancelled (self, job);
}


#line 284 "BatchImport.vala"
static void batch_import_on_file_prepared (BatchImport* self, BackgroundJob* j, NotificationObject* user) {
#line 1870 "BatchImport.c"
	PreparedFile* prepared_file;
	FileImportJob* file_import_job;
#line 284 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 284 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 284 "BatchImport.vala"
	g_return_if_fail (IS_NOTIFICATION_OBJECT (user));
#line 285 "BatchImport.vala"
	g_assert (!self->priv->completed);
#line 287 "BatchImport.vala"
	prepared_file = _notification_object_ref0 (PREPARED_FILE (user));
#line 289 "BatchImport.vala"
	if (transformable_photo_is_duplicate (prepared_file->file, prepared_file->exif_md5, prepared_file->thumbnail_md5, prepared_file->full_md5)) {
#line 1885 "BatchImport.c"
		BatchImportResult* _tmp1_;
		char* _tmp0_;
		gboolean _tmp2_ = FALSE;
#line 291 "BatchImport.vala"
		import_manifest_add_result (self->priv->manifest, _tmp1_ = batch_import_result_new (prepared_file->job, prepared_file->file, _tmp0_ = g_file_get_path (prepared_file->file), IMPORT_RESULT_PHOTO_EXISTS));
#line 1891 "BatchImport.c"
		_g_object_unref0 (_tmp1_);
		_g_free0 (_tmp0_);
#line 295 "BatchImport.vala"
		self->priv->file_imports_completed++;
#line 299 "BatchImport.vala"
		if (self->priv->file_imports_to_perform != (-1)) {
#line 299 "BatchImport.vala"
			_tmp2_ = self->priv->file_imports_completed == self->priv->file_imports_to_perform;
#line 1900 "BatchImport.c"
		} else {
#line 299 "BatchImport.vala"
			_tmp2_ = FALSE;
#line 1904 "BatchImport.c"
		}
#line 299 "BatchImport.vala"
		if (_tmp2_) {
#line 300 "BatchImport.vala"
			batch_import_report_completed (self, "completed preparing files, all outstanding imports completed");
#line 1910 "BatchImport.c"
		}
		_notification_object_unref0 (prepared_file);
#line 302 "BatchImport.vala"
		return;
#line 1915 "BatchImport.c"
	}
#line 305 "BatchImport.vala"
	file_import_job = file_import_job_new (self, prepared_file, &self->priv->manifest->import_id, _batch_import_on_import_file_completed_completion_callback, self, self->priv->cancellable, _batch_import_on_import_file_cancelled_cancellation_callback, self);
#line 308 "BatchImport.vala"
	workers_enqueue (batch_import_workers, BACKGROUND_JOB (file_import_job));
#line 1921 "BatchImport.c"
	_notification_object_unref0 (prepared_file);
	_background_job_unref0 (file_import_job);
}


#line 311 "BatchImport.vala"
static void batch_import_on_files_prepared (BatchImport* self, BackgroundJob* j) {
#line 1929 "BatchImport.c"
	PrepareFilesJob* prepare_files_job;
#line 311 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 311 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 312 "BatchImport.vala"
	g_assert (!self->priv->completed);
#line 314 "BatchImport.vala"
	prepare_files_job = _background_job_ref0 (PREPARE_FILES_JOB (j));
#line 316 "BatchImport.vala"
	batch_import_report_failures (self, BACKGROUND_IMPORT_JOB (prepare_files_job));
#line 319 "BatchImport.vala"
	self->priv->file_imports_to_perform = prepare_files_job->prepared_files;
#line 320 "BatchImport.vala"
	g_assert (self->priv->file_imports_to_perform >= self->priv->file_imports_completed);
#line 322 "BatchImport.vala"
	batch_import_log_status (self, "on_files_prepared");
#line 326 "BatchImport.vala"
	if (self->priv->file_imports_to_perform == 0) {
#line 327 "BatchImport.vala"
		batch_import_report_completed (self, "no files prepared for import");
#line 1951 "BatchImport.c"
	} else {
#line 328 "BatchImport.vala"
		if (self->priv->file_imports_completed == self->priv->file_imports_to_perform) {
#line 329 "BatchImport.vala"
			batch_import_report_completed (self, "completed preparing files, all outstanding imports completed");
#line 1957 "BatchImport.c"
		}
	}
	_background_job_unref0 (prepare_files_job);
}


#line 332 "BatchImport.vala"
static void batch_import_on_file_prepare_cancelled (BatchImport* self, BackgroundJob* j) {
#line 1966 "BatchImport.c"
	PrepareFilesJob* prepare_files_job;
#line 332 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 332 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 333 "BatchImport.vala"
	g_assert (!self->priv->completed);
#line 335 "BatchImport.vala"
	prepare_files_job = _background_job_ref0 (PREPARE_FILES_JOB (j));
#line 337 "BatchImport.vala"
	batch_import_report_failures (self, BACKGROUND_IMPORT_JOB (prepare_files_job));
#line 339 "BatchImport.vala"
	self->priv->file_imports_to_perform = prepare_files_job->prepared_files;
#line 340 "BatchImport.vala"
	g_assert (self->priv->file_imports_to_perform >= self->priv->file_imports_completed);
#line 342 "BatchImport.vala"
	batch_import_log_status (self, "on_file_prepare_cancelled");
#line 346 "BatchImport.vala"
	if (self->priv->file_imports_to_perform == 0) {
#line 347 "BatchImport.vala"
		batch_import_report_completed (self, "cancelled, no files prepared");
#line 1988 "BatchImport.c"
	} else {
#line 348 "BatchImport.vala"
		if (self->priv->file_imports_completed == self->priv->file_imports_to_perform) {
#line 349 "BatchImport.vala"
			batch_import_report_completed (self, "cancelled, all outstanding imports completed");
#line 1994 "BatchImport.c"
		}
	}
	_background_job_unref0 (prepare_files_job);
}


#line 352 "BatchImport.vala"
static void batch_import_on_import_file_completed (BatchImport* self, BackgroundJob* j) {
#line 2003 "BatchImport.c"
	FileImportJob* job;
	char* _tmp1_;
	char* _tmp0_;
	LibraryPhoto* photo;
	gboolean _tmp7_ = FALSE;
#line 352 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 352 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 353 "BatchImport.vala"
	g_assert (!self->priv->completed);
#line 355 "BatchImport.vala"
	job = _background_job_ref0 (FILE_IMPORT_JOB (j));
#line 357 "BatchImport.vala"
	self->priv->file_imports_completed++;
#line 358 "BatchImport.vala"
	if (self->priv->file_imports_to_perform != (-1)) {
#line 359 "BatchImport.vala"
		g_assert (self->priv->file_imports_completed <= self->priv->file_imports_to_perform);
#line 2023 "BatchImport.c"
	}
#line 361 "BatchImport.vala"
	batch_import_log_status (self, _tmp1_ = g_strdup_printf ("on_import_file_completed  (%s)", _tmp0_ = file_import_job_get_filename (job)));
#line 2027 "BatchImport.c"
	_g_free0 (_tmp1_);
	_g_free0 (_tmp0_);
#line 364 "BatchImport.vala"
	photo = NULL;
#line 365 "BatchImport.vala"
	if (job->batch_result->result == IMPORT_RESULT_SUCCESS) {
#line 2034 "BatchImport.c"
		LibraryPhoto* _tmp4_;
		ImportResult _tmp3_;
		LibraryPhoto* _tmp2_ = NULL;
#line 366 "BatchImport.vala"
		job->batch_result->result = (_tmp3_ = library_photo_import (&job->photo_row, job->thumbnails, &_tmp2_), photo = (_tmp4_ = _tmp2_, _g_object_unref0 (photo), _tmp4_), _tmp3_);
#line 2040 "BatchImport.c"
	}
#line 368 "BatchImport.vala"
	if (job->batch_result->result == IMPORT_RESULT_SUCCESS) {
#line 369 "BatchImport.vala"
		gee_collection_add (GEE_COLLECTION (self->priv->manifest->imported), photo);
#line 370 "BatchImport.vala"
		g_signal_emit_by_name (self, "imported", photo, job->pixbuf);
#line 2048 "BatchImport.c"
	} else {
		char* _tmp6_;
		char* _tmp5_;
#line 373 "BatchImport.vala"
		g_debug ("BatchImport.vala:373: Failed to import %s: %s (%s)", _tmp5_ = file_import_job_get_filename (job), _tmp6_ = import_result_to_string (job->batch_result->result), job->batch_result->errmsg);
#line 2054 "BatchImport.c"
		_g_free0 (_tmp6_);
		_g_free0 (_tmp5_);
#line 375 "BatchImport.vala"
		g_signal_emit_by_name (self, "import-job-failed", job->batch_result);
#line 2059 "BatchImport.c"
	}
#line 378 "BatchImport.vala"
	import_manifest_add_result (self->priv->manifest, job->batch_result);
#line 382 "BatchImport.vala"
	if (self->priv->file_imports_to_perform != (-1)) {
#line 382 "BatchImport.vala"
		_tmp7_ = self->priv->file_imports_completed == self->priv->file_imports_to_perform;
#line 2067 "BatchImport.c"
	} else {
#line 382 "BatchImport.vala"
		_tmp7_ = FALSE;
#line 2071 "BatchImport.c"
	}
#line 382 "BatchImport.vala"
	if (_tmp7_) {
#line 383 "BatchImport.vala"
		batch_import_report_completed (self, "all files prepared, all import jobs completed");
#line 2077 "BatchImport.c"
	}
	_background_job_unref0 (job);
	_g_object_unref0 (photo);
}


#line 386 "BatchImport.vala"
static void batch_import_on_import_file_cancelled (BatchImport* self, BackgroundJob* j) {
#line 2086 "BatchImport.c"
	FileImportJob* job;
	BatchImportResult* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 386 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 386 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 387 "BatchImport.vala"
	g_assert (!self->priv->completed);
#line 389 "BatchImport.vala"
	job = _background_job_ref0 (FILE_IMPORT_JOB (j));
#line 391 "BatchImport.vala"
	self->priv->file_imports_completed++;
#line 392 "BatchImport.vala"
	if (self->priv->file_imports_to_perform != (-1)) {
#line 393 "BatchImport.vala"
		g_assert (self->priv->file_imports_completed <= self->priv->file_imports_to_perform);
#line 2104 "BatchImport.c"
	}
#line 395 "BatchImport.vala"
	batch_import_log_status (self, "on_import_file_cancelled");
#line 397 "BatchImport.vala"
	_tmp0_ = file_import_job_abort (job);
#line 2110 "BatchImport.c"
	_g_object_unref0 (_tmp0_);
#line 399 "BatchImport.vala"
	g_signal_emit_by_name (self, "import-job-failed", job->batch_result);
#line 400 "BatchImport.vala"
	import_manifest_add_result (self->priv->manifest, job->batch_result);
#line 403 "BatchImport.vala"
	if (self->priv->file_imports_to_perform != (-1)) {
#line 403 "BatchImport.vala"
		_tmp1_ = self->priv->file_imports_completed == self->priv->file_imports_to_perform;
#line 2120 "BatchImport.c"
	} else {
#line 403 "BatchImport.vala"
		_tmp1_ = FALSE;
#line 2124 "BatchImport.c"
	}
#line 403 "BatchImport.vala"
	if (_tmp1_) {
#line 404 "BatchImport.vala"
		batch_import_report_completed (self, "cancelled, all import jobs completed");
#line 2130 "BatchImport.c"
	}
	_background_job_unref0 (job);
}


static void batch_import_class_init (BatchImportClass * klass) {
	batch_import_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BatchImportPrivate));
	G_OBJECT_CLASS (klass)->finalize = batch_import_finalize;
	g_signal_new ("starting", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("imported", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, GDK_TYPE_PIXBUF);
	g_signal_new ("fatal_error", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_STRING, G_TYPE_NONE, 2, TYPE_IMPORT_RESULT, G_TYPE_STRING);
	g_signal_new ("import_job_failed", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BATCH_IMPORT_RESULT);
	g_signal_new ("import_complete", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_IMPORT_MANIFEST);
	batch_import_workers = workers_new (2, FALSE);
}


static void batch_import_instance_init (BatchImport * self) {
	self->priv = BATCH_IMPORT_GET_PRIVATE (self);
	self->priv->scheduled = FALSE;
	self->priv->completed = FALSE;
	self->priv->file_imports_to_perform = -1;
	self->priv->file_imports_completed = 0;
	self->priv->cancellable = NULL;
}


static void batch_import_finalize (GObject* obj) {
	BatchImport * self;
	self = BATCH_IMPORT (obj);
	{
		guint _tmp2_;
		AppWindow* _tmp1_;
#line 187 "BatchImport.vala"
		g_signal_parse_name ("user-quit", TYPE_APP_WINDOW, &_tmp2_, NULL, FALSE);
#line 187 "BatchImport.vala"
		g_signal_handlers_disconnect_matched (_tmp1_ = app_window_get_instance (), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _batch_import_user_halt_app_window_user_quit, self);
#line 2169 "BatchImport.c"
		_g_object_unref0 (_tmp1_);
	}
	_g_object_unref0 (self->priv->jobs);
	_g_free0 (self->priv->name);
	(self->priv->reporter_target_destroy_notify == NULL) ? NULL : (self->priv->reporter_target_destroy_notify (self->priv->reporter_target), NULL);
	self->priv->reporter = NULL;
	self->priv->reporter_target = NULL;
	self->priv->reporter_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->manifest);
	_g_object_unref0 (self->priv->cancellable);
	G_OBJECT_CLASS (batch_import_parent_class)->finalize (obj);
}


GType batch_import_get_type (void) {
	static volatile gsize batch_import_type_id__volatile = 0;
	if (g_once_init_enter (&batch_import_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BatchImportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) batch_import_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatchImport), 0, (GInstanceInitFunc) batch_import_instance_init, NULL };
		GType batch_import_type_id;
		batch_import_type_id = g_type_register_static (G_TYPE_OBJECT, "BatchImport", &g_define_type_info, 0);
		g_once_init_leave (&batch_import_type_id__volatile, batch_import_type_id);
	}
	return batch_import_type_id__volatile;
}


#line 430 "BatchImport.vala"
BackgroundImportJob* background_import_job_construct (GType object_type, BatchImport* owner, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target) {
#line 2198 "BatchImport.c"
	BackgroundImportJob* self;
#line 430 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 430 "BatchImport.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 432 "BatchImport.vala"
	self = (BackgroundImportJob*) background_job_construct (object_type, G_OBJECT (owner), callback, callback_target, cancellable, cancellation, cancellation_target);
#line 2206 "BatchImport.c"
	return self;
}


#line 437 "BatchImport.vala"
ImportResult background_import_job_abort_check (BackgroundImportJob* self) {
#line 2213 "BatchImport.c"
	ImportResult result = 0;
	gboolean _tmp0_ = FALSE;
#line 437 "BatchImport.vala"
	g_return_val_if_fail (IS_BACKGROUND_IMPORT_JOB (self), 0);
#line 438 "BatchImport.vala"
	if (self->abort_flag == IMPORT_RESULT_SUCCESS) {
#line 438 "BatchImport.vala"
		_tmp0_ = background_job_is_cancelled (BACKGROUND_JOB (self));
#line 2222 "BatchImport.c"
	} else {
#line 438 "BatchImport.vala"
		_tmp0_ = FALSE;
#line 2226 "BatchImport.c"
	}
#line 438 "BatchImport.vala"
	if (_tmp0_) {
#line 439 "BatchImport.vala"
		self->abort_flag = IMPORT_RESULT_USER_ABORT;
#line 2232 "BatchImport.c"
	}
	result = self->abort_flag;
#line 441 "BatchImport.vala"
	return result;
#line 2237 "BatchImport.c"
}


#line 444 "BatchImport.vala"
void background_import_job_abort (BackgroundImportJob* self, ImportResult _result_) {
#line 444 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_IMPORT_JOB (self));
#line 446 "BatchImport.vala"
	if (self->abort_flag == IMPORT_RESULT_SUCCESS) {
#line 447 "BatchImport.vala"
		self->abort_flag = _result_;
#line 2249 "BatchImport.c"
	}
}


#line 450 "BatchImport.vala"
void background_import_job_report_failure (BackgroundImportJob* self, BatchImportJob* job, GFile* file, const char* identifier, ImportResult _result_) {
#line 2256 "BatchImport.c"
	BatchImportResult* _tmp1_;
#line 450 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_IMPORT_JOB (self));
#line 450 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (job));
#line 450 "BatchImport.vala"
	g_return_if_fail ((file == NULL) || G_IS_FILE (file));
#line 450 "BatchImport.vala"
	g_return_if_fail (identifier != NULL);
#line 452 "BatchImport.vala"
	g_assert (_result_ != IMPORT_RESULT_SUCCESS);
#line 455 "BatchImport.vala"
	if (import_result_is_abort (_result_)) {
#line 456 "BatchImport.vala"
		background_import_job_abort (self, _result_);
#line 2272 "BatchImport.c"
	} else {
		char* _tmp0_;
#line 458 "BatchImport.vala"
		g_debug ("BatchImport.vala:458: Import failure %s: %s", identifier, _tmp0_ = import_result_to_string (_result_));
#line 2277 "BatchImport.c"
		_g_free0 (_tmp0_);
	}
#line 460 "BatchImport.vala"
	gee_collection_add (GEE_COLLECTION (self->failed), _tmp1_ = batch_import_result_new (job, file, identifier, _result_));
#line 2282 "BatchImport.c"
	_g_object_unref0 (_tmp1_);
}


#line 463 "BatchImport.vala"
void background_import_job_report_error (BackgroundImportJob* self, BatchImportJob* job, GFile* file, const char* identifier, GError* err, ImportResult default_result) {
#line 2289 "BatchImport.c"
	ImportResult _result_;
	char* _tmp0_;
	BatchImportResult* _tmp1_;
#line 463 "BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_IMPORT_JOB (self));
#line 463 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (job));
#line 463 "BatchImport.vala"
	g_return_if_fail ((file == NULL) || G_IS_FILE (file));
#line 463 "BatchImport.vala"
	g_return_if_fail (identifier != NULL);
#line 465 "BatchImport.vala"
	_result_ = import_result_convert_error (err, default_result);
#line 467 "BatchImport.vala"
	g_debug ("BatchImport.vala:467: Import error %s: %s (%s)", identifier, err->message, _tmp0_ = import_result_to_string (_result_));
#line 2305 "BatchImport.c"
	_g_free0 (_tmp0_);
#line 469 "BatchImport.vala"
	if (import_result_is_abort (_result_)) {
#line 470 "BatchImport.vala"
		background_import_job_abort (self, _result_);
#line 2311 "BatchImport.c"
	}
#line 472 "BatchImport.vala"
	gee_collection_add (GEE_COLLECTION (self->failed), _tmp1_ = batch_import_result_new_from_error (job, file, identifier, err, default_result));
#line 2315 "BatchImport.c"
	_g_object_unref0 (_tmp1_);
}


static void background_import_job_class_init (BackgroundImportJobClass * klass) {
	background_import_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = background_import_job_finalize;
}


static void background_import_job_instance_init (BackgroundImportJob * self) {
	self->abort_flag = IMPORT_RESULT_SUCCESS;
	self->failed = GEE_LIST (gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
}


static void background_import_job_finalize (BackgroundJob* obj) {
	BackgroundImportJob * self;
	self = BACKGROUND_IMPORT_JOB (obj);
	_g_object_unref0 (self->failed);
	BACKGROUND_JOB_CLASS (background_import_job_parent_class)->finalize (obj);
}


GType background_import_job_get_type (void) {
	static volatile gsize background_import_job_type_id__volatile = 0;
	if (g_once_init_enter (&background_import_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BackgroundImportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_import_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundImportJob), 0, (GInstanceInitFunc) background_import_job_instance_init, NULL };
		GType background_import_job_type_id;
		background_import_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "BackgroundImportJob", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&background_import_job_type_id__volatile, background_import_job_type_id);
	}
	return background_import_job_type_id__volatile;
}


#line 481 "BatchImport.vala"
FileToPrepare* file_to_prepare_construct (GType object_type, BatchImportJob* job, GFile* file, gboolean copy_to_library) {
#line 2354 "BatchImport.c"
	FileToPrepare* self;
	BatchImportJob* _tmp0_;
	GFile* _tmp1_;
#line 481 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), NULL);
#line 481 "BatchImport.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 2362 "BatchImport.c"
	self = (FileToPrepare*) g_type_create_instance (object_type);
#line 482 "BatchImport.vala"
	self->job = (_tmp0_ = _batch_import_job_ref0 (job), _batch_import_job_unref0 (self->job), _tmp0_);
#line 483 "BatchImport.vala"
	self->file = (_tmp1_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp1_);
#line 484 "BatchImport.vala"
	self->copy_to_library = copy_to_library;
#line 2370 "BatchImport.c"
	return self;
}


#line 481 "BatchImport.vala"
FileToPrepare* file_to_prepare_new (BatchImportJob* job, GFile* file, gboolean copy_to_library) {
#line 481 "BatchImport.vala"
	return file_to_prepare_construct (TYPE_FILE_TO_PREPARE, job, file, copy_to_library);
#line 2379 "BatchImport.c"
}


static void value_file_to_prepare_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_file_to_prepare_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		file_to_prepare_unref (value->data[0].v_pointer);
	}
}


static void value_file_to_prepare_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = file_to_prepare_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_file_to_prepare_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_file_to_prepare_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		FileToPrepare* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = file_to_prepare_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_file_to_prepare_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	FileToPrepare** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = file_to_prepare_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_file_to_prepare (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecFileToPrepare* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FILE_TO_PREPARE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_file_to_prepare (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_TO_PREPARE), NULL);
	return value->data[0].v_pointer;
}


void value_set_file_to_prepare (GValue* value, gpointer v_object) {
	FileToPrepare* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_TO_PREPARE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FILE_TO_PREPARE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		file_to_prepare_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		file_to_prepare_unref (old);
	}
}


void value_take_file_to_prepare (GValue* value, gpointer v_object) {
	FileToPrepare* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_TO_PREPARE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FILE_TO_PREPARE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		file_to_prepare_unref (old);
	}
}


static void file_to_prepare_class_init (FileToPrepareClass * klass) {
	file_to_prepare_parent_class = g_type_class_peek_parent (klass);
	FILE_TO_PREPARE_CLASS (klass)->finalize = file_to_prepare_finalize;
}


static void file_to_prepare_instance_init (FileToPrepare * self) {
	self->ref_count = 1;
}


static void file_to_prepare_finalize (FileToPrepare* obj) {
	FileToPrepare * self;
	self = FILE_TO_PREPARE (obj);
	_batch_import_job_unref0 (self->job);
	_g_object_unref0 (self->file);
}


GType file_to_prepare_get_type (void) {
	static volatile gsize file_to_prepare_type_id__volatile = 0;
	if (g_once_init_enter (&file_to_prepare_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_file_to_prepare_init, value_file_to_prepare_free_value, value_file_to_prepare_copy_value, value_file_to_prepare_peek_pointer, "p", value_file_to_prepare_collect_value, "p", value_file_to_prepare_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (FileToPrepareClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_to_prepare_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileToPrepare), 0, (GInstanceInitFunc) file_to_prepare_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType file_to_prepare_type_id;
		file_to_prepare_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FileToPrepare", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&file_to_prepare_type_id__volatile, file_to_prepare_type_id);
	}
	return file_to_prepare_type_id__volatile;
}


gpointer file_to_prepare_ref (gpointer instance) {
	FileToPrepare* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void file_to_prepare_unref (gpointer instance) {
	FileToPrepare* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		FILE_TO_PREPARE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 493 "BatchImport.vala"
WorkSniffer* work_sniffer_construct (GType object_type, BatchImport* owner, GeeIterable* jobs, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target) {
#line 2546 "BatchImport.c"
	WorkSniffer* self;
	GeeIterable* _tmp0_;
#line 493 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 493 "BatchImport.vala"
	g_return_val_if_fail (GEE_IS_ITERABLE (jobs), NULL);
#line 493 "BatchImport.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 495 "BatchImport.vala"
	self = (WorkSniffer*) background_import_job_construct (object_type, owner, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 497 "BatchImport.vala"
	self->priv->jobs = (_tmp0_ = _g_object_ref0 (jobs), _g_object_unref0 (self->priv->jobs), _tmp0_);
#line 2559 "BatchImport.c"
	return self;
}


#line 493 "BatchImport.vala"
WorkSniffer* work_sniffer_new (BatchImport* owner, GeeIterable* jobs, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target) {
#line 493 "BatchImport.vala"
	return work_sniffer_construct (TYPE_WORK_SNIFFER, owner, jobs, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 2568 "BatchImport.c"
}


#line 500 "BatchImport.vala"
static void work_sniffer_real_execute (BackgroundJob* base) {
#line 2574 "BatchImport.c"
	WorkSniffer * self;
	GError * _inner_error_;
	self = WORK_SNIFFER (base);
	_inner_error_ = NULL;
	{
		GeeIterator* _job_it;
		_job_it = gee_iterable_iterator (self->priv->jobs);
#line 504 "BatchImport.vala"
		while (TRUE) {
#line 2584 "BatchImport.c"
			BatchImportJob* job;
			ImportResult _result_;
#line 504 "BatchImport.vala"
			if (!gee_iterator_next (_job_it)) {
#line 504 "BatchImport.vala"
				break;
#line 2591 "BatchImport.c"
			}
#line 504 "BatchImport.vala"
			job = (BatchImportJob*) gee_iterator_get (_job_it);
#line 505 "BatchImport.vala"
			_result_ = background_import_job_abort_check (BACKGROUND_IMPORT_JOB (self));
#line 506 "BatchImport.vala"
			if (_result_ != IMPORT_RESULT_SUCCESS) {
#line 2599 "BatchImport.c"
				char* _tmp0_;
#line 507 "BatchImport.vala"
				background_import_job_report_failure (BACKGROUND_IMPORT_JOB (self), job, NULL, _tmp0_ = batch_import_job_get_identifier (job), _result_);
#line 2603 "BatchImport.c"
				_g_free0 (_tmp0_);
				_batch_import_job_unref0 (job);
#line 509 "BatchImport.vala"
				continue;
#line 2608 "BatchImport.c"
			}
			{
#line 513 "BatchImport.vala"
				work_sniffer_sniff_job (self, job, &_inner_error_);
#line 2613 "BatchImport.c"
				if (_inner_error_ != NULL) {
					goto __catch102_g_error;
				}
			}
			goto __finally102;
			__catch102_g_error:
			{
				GError * err;
				err = _inner_error_;
				_inner_error_ = NULL;
				{
					char* _tmp1_;
#line 515 "BatchImport.vala"
					background_import_job_report_error (BACKGROUND_IMPORT_JOB (self), job, NULL, _tmp1_ = batch_import_job_get_identifier (job), err, IMPORT_RESULT_FILE_ERROR);
#line 2628 "BatchImport.c"
					_g_free0 (_tmp1_);
					_g_error_free0 (err);
				}
			}
			__finally102:
			if (_inner_error_ != NULL) {
				_batch_import_job_unref0 (job);
				_g_object_unref0 (_job_it);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_batch_import_job_unref0 (job);
		}
		_g_object_unref0 (_job_it);
	}
}


#line 520 "BatchImport.vala"
static void work_sniffer_sniff_job (WorkSniffer* self, BatchImportJob* job, GError** error) {
#line 2650 "BatchImport.c"
	GError * _inner_error_;
#line 520 "BatchImport.vala"
	g_return_if_fail (IS_WORK_SNIFFER (self));
#line 520 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (job));
#line 2656 "BatchImport.c"
	_inner_error_ = NULL;
#line 521 "BatchImport.vala"
	if (batch_import_job_is_directory (job)) {
#line 2660 "BatchImport.c"
		GFile* dir;
		gboolean copy_to_library = FALSE;
		GFile* _tmp2_;
		gboolean _tmp1_;
		GFile* _tmp0_ = NULL;
		gboolean _tmp3_;
		dir = NULL;
#line 526 "BatchImport.vala"
		_tmp3_ = (_tmp1_ = batch_import_job_prepare (job, &_tmp0_, &copy_to_library, &_inner_error_), dir = (_tmp2_ = _tmp0_, _g_object_unref0 (dir), _tmp2_), _tmp1_);
#line 2670 "BatchImport.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (dir);
			return;
		}
#line 526 "BatchImport.vala"
		if (!_tmp3_) {
#line 2678 "BatchImport.c"
			char* _tmp4_;
#line 527 "BatchImport.vala"
			background_import_job_report_failure (BACKGROUND_IMPORT_JOB (self), job, NULL, _tmp4_ = batch_import_job_get_identifier (job), IMPORT_RESULT_FILE_ERROR);
#line 2682 "BatchImport.c"
			_g_free0 (_tmp4_);
			_g_object_unref0 (dir);
#line 529 "BatchImport.vala"
			return;
#line 2687 "BatchImport.c"
		}
#line 531 "BatchImport.vala"
		g_assert (query_is_directory (dir));
#line 2691 "BatchImport.c"
		{
#line 534 "BatchImport.vala"
			work_sniffer_search_dir (self, job, dir, copy_to_library, &_inner_error_);
#line 2695 "BatchImport.c"
			if (_inner_error_ != NULL) {
				goto __catch103_g_error;
			}
		}
		goto __finally103;
		__catch103_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp5_;
#line 536 "BatchImport.vala"
				background_import_job_report_error (BACKGROUND_IMPORT_JOB (self), job, dir, _tmp5_ = g_file_get_path (dir), err, IMPORT_RESULT_FILE_ERROR);
#line 2710 "BatchImport.c"
				_g_free0 (_tmp5_);
				_g_error_free0 (err);
			}
		}
		__finally103:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (dir);
			return;
		}
		_g_object_unref0 (dir);
	} else {
		FileToPrepare* _tmp6_;
#line 540 "BatchImport.vala"
		gee_collection_add (GEE_COLLECTION (self->files_to_prepare), _tmp6_ = file_to_prepare_new (job, NULL, TRUE));
#line 2726 "BatchImport.c"
		_file_to_prepare_unref0 (_tmp6_);
	}
}


#line 544 "BatchImport.vala"
void work_sniffer_search_dir (WorkSniffer* self, BatchImportJob* job, GFile* dir, gboolean copy_to_library, GError** error) {
#line 2734 "BatchImport.c"
	GError * _inner_error_;
	GFileEnumerator* enumerator;
	GFileInfo* info;
#line 544 "BatchImport.vala"
	g_return_if_fail (IS_WORK_SNIFFER (self));
#line 544 "BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (job));
#line 544 "BatchImport.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 2744 "BatchImport.c"
	_inner_error_ = NULL;
#line 545 "BatchImport.vala"
	enumerator = g_file_enumerate_children (dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 2748 "BatchImport.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 548 "BatchImport.vala"
	info = NULL;
#line 549 "BatchImport.vala"
	while (TRUE) {
#line 2757 "BatchImport.c"
		GFileInfo* _tmp0_;
		GFileInfo* _tmp1_;
		GFile* child;
		GFileType file_type;
#line 549 "BatchImport.vala"
		_tmp0_ = g_file_enumerator_next_file (enumerator, NULL, &_inner_error_);
#line 2764 "BatchImport.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (info);
			return;
		}
#line 549 "BatchImport.vala"
		if (!((info = (_tmp1_ = _tmp0_, _g_object_unref0 (info), _tmp1_)) != NULL)) {
#line 549 "BatchImport.vala"
			break;
#line 2775 "BatchImport.c"
		}
#line 550 "BatchImport.vala"
		child = g_file_get_child (dir, g_file_info_get_name (info));
#line 551 "BatchImport.vala"
		file_type = g_file_info_get_file_type (info);
#line 553 "BatchImport.vala"
		if (file_type == G_FILE_TYPE_DIRECTORY) {
#line 554 "BatchImport.vala"
			if (g_str_has_prefix (g_file_info_get_name (info), ".")) {
#line 2785 "BatchImport.c"
				_g_object_unref0 (child);
#line 555 "BatchImport.vala"
				continue;
#line 2789 "BatchImport.c"
			}
			{
#line 558 "BatchImport.vala"
				work_sniffer_search_dir (self, job, child, copy_to_library, &_inner_error_);
#line 2794 "BatchImport.c"
				if (_inner_error_ != NULL) {
					goto __catch104_g_error;
				}
			}
			goto __finally104;
			__catch104_g_error:
			{
				GError * err;
				err = _inner_error_;
				_inner_error_ = NULL;
				{
					char* _tmp2_;
#line 560 "BatchImport.vala"
					background_import_job_report_error (BACKGROUND_IMPORT_JOB (self), job, child, _tmp2_ = g_file_get_path (child), err, IMPORT_RESULT_FILE_ERROR);
#line 2809 "BatchImport.c"
					_g_free0 (_tmp2_);
					_g_error_free0 (err);
				}
			}
			__finally104:
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (child);
				_g_object_unref0 (enumerator);
				_g_object_unref0 (info);
				return;
			}
		} else {
#line 562 "BatchImport.vala"
			if (file_type == G_FILE_TYPE_REGULAR) {
#line 2825 "BatchImport.c"
				FileToPrepare* _tmp3_;
#line 563 "BatchImport.vala"
				gee_collection_add (GEE_COLLECTION (self->files_to_prepare), _tmp3_ = file_to_prepare_new (job, child, copy_to_library));
#line 2829 "BatchImport.c"
				_file_to_prepare_unref0 (_tmp3_);
			} else {
				char* _tmp4_;
#line 565 "BatchImport.vala"
				g_warning ("BatchImport.vala:565: Ignoring import of %s file type %d", _tmp4_ = g_file_get_path (child), (gint) file_type);
#line 2835 "BatchImport.c"
				_g_free0 (_tmp4_);
			}
		}
		_g_object_unref0 (child);
	}
	_g_object_unref0 (enumerator);
	_g_object_unref0 (info);
}


static void work_sniffer_class_init (WorkSnifferClass * klass) {
	work_sniffer_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = work_sniffer_finalize;
	g_type_class_add_private (klass, sizeof (WorkSnifferPrivate));
	BACKGROUND_JOB_CLASS (klass)->execute = work_sniffer_real_execute;
}


static void work_sniffer_instance_init (WorkSniffer * self) {
	self->priv = WORK_SNIFFER_GET_PRIVATE (self);
	self->files_to_prepare = GEE_LIST (gee_array_list_new (TYPE_FILE_TO_PREPARE, (GBoxedCopyFunc) file_to_prepare_ref, file_to_prepare_unref, NULL));
}


static void work_sniffer_finalize (BackgroundJob* obj) {
	WorkSniffer * self;
	self = WORK_SNIFFER (obj);
	_g_object_unref0 (self->files_to_prepare);
	_g_object_unref0 (self->priv->jobs);
	BACKGROUND_JOB_CLASS (work_sniffer_parent_class)->finalize (obj);
}


GType work_sniffer_get_type (void) {
	static volatile gsize work_sniffer_type_id__volatile = 0;
	if (g_once_init_enter (&work_sniffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WorkSnifferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) work_sniffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WorkSniffer), 0, (GInstanceInitFunc) work_sniffer_instance_init, NULL };
		GType work_sniffer_type_id;
		work_sniffer_type_id = g_type_register_static (TYPE_BACKGROUND_IMPORT_JOB, "WorkSniffer", &g_define_type_info, 0);
		g_once_init_leave (&work_sniffer_type_id__volatile, work_sniffer_type_id);
	}
	return work_sniffer_type_id__volatile;
}


#line 581 "BatchImport.vala"
PreparedFile* prepared_file_construct (GType object_type, BatchImportJob* job, GFile* file, const char* id, gboolean copy_to_library, const char* exif_md5, const char* thumbnail_md5, const char* full_md5) {
#line 2883 "BatchImport.c"
	PreparedFile* self;
	BatchImportJob* _tmp0_;
	GFile* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	char* _tmp4_;
	char* _tmp5_;
#line 581 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), NULL);
#line 581 "BatchImport.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 581 "BatchImport.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 581 "BatchImport.vala"
	self = (PreparedFile*) notification_object_construct (object_type);
#line 583 "BatchImport.vala"
	self->job = (_tmp0_ = _batch_import_job_ref0 (job), _batch_import_job_unref0 (self->job), _tmp0_);
#line 584 "BatchImport.vala"
	self->result = IMPORT_RESULT_SUCCESS;
#line 585 "BatchImport.vala"
	self->file = (_tmp1_ = _g_object_ref0 (file), _g_object_unref0 (self->file), _tmp1_);
#line 586 "BatchImport.vala"
	self->id = (_tmp2_ = g_strdup (id), _g_free0 (self->id), _tmp2_);
#line 587 "BatchImport.vala"
	self->copy_to_library = copy_to_library;
#line 588 "BatchImport.vala"
	self->exif_md5 = (_tmp3_ = g_strdup (exif_md5), _g_free0 (self->exif_md5), _tmp3_);
#line 589 "BatchImport.vala"
	self->thumbnail_md5 = (_tmp4_ = g_strdup (thumbnail_md5), _g_free0 (self->thumbnail_md5), _tmp4_);
#line 590 "BatchImport.vala"
	self->full_md5 = (_tmp5_ = g_strdup (full_md5), _g_free0 (self->full_md5), _tmp5_);
#line 2915 "BatchImport.c"
	return self;
}


#line 581 "BatchImport.vala"
PreparedFile* prepared_file_new (BatchImportJob* job, GFile* file, const char* id, gboolean copy_to_library, const char* exif_md5, const char* thumbnail_md5, const char* full_md5) {
#line 581 "BatchImport.vala"
	return prepared_file_construct (TYPE_PREPARED_FILE, job, file, id, copy_to_library, exif_md5, thumbnail_md5, full_md5);
#line 2924 "BatchImport.c"
}


static void prepared_file_class_init (PreparedFileClass * klass) {
	prepared_file_parent_class = g_type_class_peek_parent (klass);
	NOTIFICATION_OBJECT_CLASS (klass)->finalize = prepared_file_finalize;
}


static void prepared_file_instance_init (PreparedFile * self) {
}


static void prepared_file_finalize (NotificationObject* obj) {
	PreparedFile * self;
	self = PREPARED_FILE (obj);
	_batch_import_job_unref0 (self->job);
	_g_object_unref0 (self->file);
	_g_free0 (self->id);
	_g_free0 (self->exif_md5);
	_g_free0 (self->thumbnail_md5);
	_g_free0 (self->full_md5);
	NOTIFICATION_OBJECT_CLASS (prepared_file_parent_class)->finalize (obj);
}


GType prepared_file_get_type (void) {
	static volatile gsize prepared_file_type_id__volatile = 0;
	if (g_once_init_enter (&prepared_file_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PreparedFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prepared_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreparedFile), 0, (GInstanceInitFunc) prepared_file_instance_init, NULL };
		GType prepared_file_type_id;
		prepared_file_type_id = g_type_register_static (TYPE_NOTIFICATION_OBJECT, "PreparedFile", &g_define_type_info, 0);
		g_once_init_leave (&prepared_file_type_id__volatile, prepared_file_type_id);
	}
	return prepared_file_type_id__volatile;
}


#line 607 "BatchImport.vala"
PrepareFilesJob* prepare_files_job_construct (GType object_type, BatchImport* owner, GeeList* files_to_prepare, NotificationCallback notification, void* notification_target, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target) {
#line 2965 "BatchImport.c"
	PrepareFilesJob* self;
	GeeList* _tmp0_;
	NotificationCallback _tmp1_;
	GFile* _tmp2_;
#line 607 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 607 "BatchImport.vala"
	g_return_val_if_fail (GEE_IS_LIST (files_to_prepare), NULL);
#line 607 "BatchImport.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 610 "BatchImport.vala"
	self = (PrepareFilesJob*) background_import_job_construct (object_type, owner, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 612 "BatchImport.vala"
	self->priv->files_to_prepare = (_tmp0_ = _g_object_ref0 (files_to_prepare), _g_object_unref0 (self->priv->files_to_prepare), _tmp0_);
#line 613 "BatchImport.vala"
	self->priv->notification = (_tmp1_ = notification, ((self->priv->notification_target_destroy_notify == NULL) ? NULL : (self->priv->notification_target_destroy_notify (self->priv->notification_target), NULL), self->priv->notification = NULL, self->priv->notification_target = NULL, self->priv->notification_target_destroy_notify = NULL), self->priv->notification_target = notification_target, self->priv->notification_target_destroy_notify = NULL, _tmp1_);
#line 614 "BatchImport.vala"
	self->priv->library_dir = (_tmp2_ = app_dirs_get_photos_dir (), _g_object_unref0 (self->priv->library_dir), _tmp2_);
#line 615 "BatchImport.vala"
	self->priv->fail_every = prepare_files_job_get_test_variable ("SHOTWELL_FAIL_EVERY");
#line 616 "BatchImport.vala"
	self->priv->skip_every = prepare_files_job_get_test_variable ("SHOTWELL_SKIP_EVERY");
#line 2988 "BatchImport.c"
	return self;
}


#line 607 "BatchImport.vala"
PrepareFilesJob* prepare_files_job_new (BatchImport* owner, GeeList* files_to_prepare, NotificationCallback notification, void* notification_target, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target) {
#line 607 "BatchImport.vala"
	return prepare_files_job_construct (TYPE_PREPARE_FILES_JOB, owner, files_to_prepare, notification, notification_target, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 2997 "BatchImport.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
#line 1062 "glib-2.0.vapi"
	return result;
#line 3007 "BatchImport.c"
}


#line 619 "BatchImport.vala"
static gint prepare_files_job_get_test_variable (const char* name) {
#line 3013 "BatchImport.c"
	gint result = 0;
	char* value;
	gint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
#line 619 "BatchImport.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 620 "BatchImport.vala"
	value = g_strdup (g_getenv (name));
#line 622 "BatchImport.vala"
	if (value == NULL) {
#line 622 "BatchImport.vala"
		_tmp1_ = TRUE;
#line 3026 "BatchImport.c"
	} else {
#line 622 "BatchImport.vala"
		_tmp1_ = string_get_length (value) == 0;
#line 3030 "BatchImport.c"
	}
#line 622 "BatchImport.vala"
	if (_tmp1_) {
#line 622 "BatchImport.vala"
		_tmp0_ = 0;
#line 3036 "BatchImport.c"
	} else {
#line 622 "BatchImport.vala"
		_tmp0_ = atoi (value);
#line 3040 "BatchImport.c"
	}
	result = _tmp0_;
	_g_free0 (value);
#line 622 "BatchImport.vala"
	return result;
#line 3046 "BatchImport.c"
}


#line 625 "BatchImport.vala"
static void prepare_files_job_real_execute (BackgroundJob* base) {
#line 3052 "BatchImport.c"
	PrepareFilesJob * self;
	GError * _inner_error_;
	self = PREPARE_FILES_JOB (base);
	_inner_error_ = NULL;
	{
		GeeIterator* _file_to_prepare_it;
		_file_to_prepare_it = gee_iterable_iterator (GEE_ITERABLE (self->priv->files_to_prepare));
#line 626 "BatchImport.vala"
		while (TRUE) {
#line 3062 "BatchImport.c"
			FileToPrepare* file_to_prepare;
			ImportResult _result_;
			BatchImportJob* job;
			GFile* file;
			gboolean copy_to_library;
#line 626 "BatchImport.vala"
			if (!gee_iterator_next (_file_to_prepare_it)) {
#line 626 "BatchImport.vala"
				break;
#line 3072 "BatchImport.c"
			}
#line 626 "BatchImport.vala"
			file_to_prepare = (FileToPrepare*) gee_iterator_get (_file_to_prepare_it);
#line 627 "BatchImport.vala"
			_result_ = background_import_job_abort_check (BACKGROUND_IMPORT_JOB (self));
#line 628 "BatchImport.vala"
			if (_result_ != IMPORT_RESULT_SUCCESS) {
#line 3080 "BatchImport.c"
				char* _tmp0_;
#line 629 "BatchImport.vala"
				background_import_job_report_failure (BACKGROUND_IMPORT_JOB (self), file_to_prepare->job, NULL, _tmp0_ = batch_import_job_get_identifier (file_to_prepare->job), _result_);
#line 3084 "BatchImport.c"
				_g_free0 (_tmp0_);
				_file_to_prepare_unref0 (file_to_prepare);
#line 632 "BatchImport.vala"
				continue;
#line 3089 "BatchImport.c"
			}
#line 635 "BatchImport.vala"
			job = _batch_import_job_ref0 (file_to_prepare->job);
#line 636 "BatchImport.vala"
			file = _g_object_ref0 (file_to_prepare->file);
#line 637 "BatchImport.vala"
			copy_to_library = file_to_prepare->copy_to_library;
#line 640 "BatchImport.vala"
			if (file == NULL) {
#line 3099 "BatchImport.c"
				{
					GFile* _tmp3_;
					gboolean _tmp2_;
					GFile* _tmp1_ = NULL;
					gboolean _tmp4_;
#line 642 "BatchImport.vala"
					_tmp4_ = (_tmp2_ = batch_import_job_prepare (job, &_tmp1_, &copy_to_library, &_inner_error_), file = (_tmp3_ = _tmp1_, _g_object_unref0 (file), _tmp3_), _tmp2_);
#line 3107 "BatchImport.c"
					if (_inner_error_ != NULL) {
						goto __catch105_g_error;
					}
#line 642 "BatchImport.vala"
					if (!_tmp4_) {
#line 3113 "BatchImport.c"
						char* _tmp5_;
#line 643 "BatchImport.vala"
						background_import_job_report_failure (BACKGROUND_IMPORT_JOB (self), job, NULL, _tmp5_ = batch_import_job_get_identifier (job), IMPORT_RESULT_FILE_ERROR);
#line 3117 "BatchImport.c"
						_g_free0 (_tmp5_);
						_file_to_prepare_unref0 (file_to_prepare);
						_batch_import_job_unref0 (job);
						_g_object_unref0 (file);
#line 645 "BatchImport.vala"
						continue;
#line 3124 "BatchImport.c"
					}
				}
				goto __finally105;
				__catch105_g_error:
				{
					GError * err;
					err = _inner_error_;
					_inner_error_ = NULL;
					{
						char* _tmp6_;
#line 648 "BatchImport.vala"
						background_import_job_report_error (BACKGROUND_IMPORT_JOB (self), job, NULL, _tmp6_ = batch_import_job_get_identifier (job), err, IMPORT_RESULT_FILE_ERROR);
#line 3137 "BatchImport.c"
						_g_free0 (_tmp6_);
						_g_error_free0 (err);
						_file_to_prepare_unref0 (file_to_prepare);
						_batch_import_job_unref0 (job);
						_g_object_unref0 (file);
#line 650 "BatchImport.vala"
						continue;
#line 3145 "BatchImport.c"
					}
				}
				__finally105:
				if (_inner_error_ != NULL) {
					_file_to_prepare_unref0 (file_to_prepare);
					_batch_import_job_unref0 (job);
					_g_object_unref0 (file);
					_g_object_unref0 (_file_to_prepare_it);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
			{
				ImportResult _tmp7_;
#line 655 "BatchImport.vala"
				_tmp7_ = prepare_files_job_prepare_file (self, job, file, copy_to_library, &_inner_error_);
#line 3163 "BatchImport.c"
				if (_inner_error_ != NULL) {
					goto __catch106_g_error;
				}
#line 655 "BatchImport.vala"
				_result_ = _tmp7_;
#line 656 "BatchImport.vala"
				if (_result_ != IMPORT_RESULT_SUCCESS) {
#line 3171 "BatchImport.c"
					char* _tmp8_;
#line 657 "BatchImport.vala"
					background_import_job_report_failure (BACKGROUND_IMPORT_JOB (self), job, file, _tmp8_ = g_file_get_path (file), _result_);
#line 3175 "BatchImport.c"
					_g_free0 (_tmp8_);
				}
			}
			goto __finally106;
			__catch106_g_error:
			{
				GError * err;
				err = _inner_error_;
				_inner_error_ = NULL;
				{
					char* _tmp9_;
#line 659 "BatchImport.vala"
					background_import_job_report_error (BACKGROUND_IMPORT_JOB (self), job, file, _tmp9_ = g_file_get_path (file), err, IMPORT_RESULT_FILE_ERROR);
#line 3189 "BatchImport.c"
					_g_free0 (_tmp9_);
					_g_error_free0 (err);
				}
			}
			__finally106:
			if (_inner_error_ != NULL) {
				_file_to_prepare_unref0 (file_to_prepare);
				_batch_import_job_unref0 (job);
				_g_object_unref0 (file);
				_g_object_unref0 (_file_to_prepare_it);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_file_to_prepare_unref0 (file_to_prepare);
			_batch_import_job_unref0 (job);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_to_prepare_it);
	}
}


#line 664 "BatchImport.vala"
static ImportResult prepare_files_job_prepare_file (PrepareFilesJob* self, BatchImportJob* job, GFile* file, gboolean copy_to_library, GError** error) {
#line 3215 "BatchImport.c"
	ImportResult result = 0;
	GError * _inner_error_;
	char* exif_md5;
	char* thumbnail_md5;
	char* full_md5;
	PhotoExif* photo_exif;
	gboolean _tmp5_ = FALSE;
	gboolean is_in_library_dir;
	gboolean _tmp9_ = FALSE;
	PreparedFile* _tmp11_;
	char* _tmp10_;
#line 664 "BatchImport.vala"
	g_return_val_if_fail (IS_PREPARE_FILES_JOB (self), 0);
#line 664 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), 0);
#line 664 "BatchImport.vala"
	g_return_val_if_fail (G_IS_FILE (file), 0);
#line 3233 "BatchImport.c"
	_inner_error_ = NULL;
#line 665 "BatchImport.vala"
	if (!transformable_photo_is_file_image (file)) {
#line 3237 "BatchImport.c"
		char* _tmp0_;
#line 666 "BatchImport.vala"
		g_message ("BatchImport.vala:666: Not importing %s: Not an image file", _tmp0_ = g_file_get_path (file));
#line 3241 "BatchImport.c"
		_g_free0 (_tmp0_);
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 668 "BatchImport.vala"
		return result;
#line 3246 "BatchImport.c"
	}
#line 671 "BatchImport.vala"
	if (!transformable_photo_is_file_supported (file)) {
#line 3250 "BatchImport.c"
		char* _tmp1_;
#line 672 "BatchImport.vala"
		g_message ("BatchImport.vala:672: Not importing %s: Unsupported extension", _tmp1_ = g_file_get_path (file));
#line 3254 "BatchImport.c"
		_g_free0 (_tmp1_);
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 674 "BatchImport.vala"
		return result;
#line 3259 "BatchImport.c"
	}
#line 677 "BatchImport.vala"
	self->priv->import_file_count++;
#line 680 "BatchImport.vala"
	if (self->priv->fail_every > 0) {
#line 681 "BatchImport.vala"
		if ((self->priv->import_file_count % self->priv->fail_every) == 0) {
#line 3267 "BatchImport.c"
			result = IMPORT_RESULT_FILE_ERROR;
#line 682 "BatchImport.vala"
			return result;
#line 3271 "BatchImport.c"
		}
	}
#line 686 "BatchImport.vala"
	if (self->priv->skip_every > 0) {
#line 687 "BatchImport.vala"
		if ((self->priv->import_file_count % self->priv->skip_every) == 0) {
#line 3278 "BatchImport.c"
			result = IMPORT_RESULT_NOT_A_FILE;
#line 688 "BatchImport.vala"
			return result;
#line 3282 "BatchImport.c"
		}
	}
#line 691 "BatchImport.vala"
	exif_md5 = NULL;
#line 692 "BatchImport.vala"
	thumbnail_md5 = NULL;
#line 693 "BatchImport.vala"
	full_md5 = NULL;
#line 697 "BatchImport.vala"
	photo_exif = photo_exif_new (file);
#line 3293 "BatchImport.c"
	{
#line 699 "BatchImport.vala"
		photo_exif_load (photo_exif, &_inner_error_);
#line 3297 "BatchImport.c"
		if (_inner_error_ != NULL) {
			goto __catch107_g_error;
		}
	}
	goto __finally107;
	__catch107_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			PhotoExif* _tmp2_;
#line 701 "BatchImport.vala"
			photo_exif = (_tmp2_ = NULL, _photo_exif_unref0 (photo_exif), _tmp2_);
#line 3312 "BatchImport.c"
			_g_error_free0 (err);
		}
	}
	__finally107:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (exif_md5);
		_g_free0 (thumbnail_md5);
		_g_free0 (full_md5);
		_photo_exif_unref0 (photo_exif);
		return 0;
	}
#line 704 "BatchImport.vala"
	if (photo_exif != NULL) {
#line 3327 "BatchImport.c"
		char* _tmp3_;
		char* _tmp4_;
#line 706 "BatchImport.vala"
		exif_md5 = (_tmp3_ = photo_exif_get_md5 (photo_exif), _g_free0 (exif_md5), _tmp3_);
#line 707 "BatchImport.vala"
		thumbnail_md5 = (_tmp4_ = photo_exif_get_thumbnail_md5 (photo_exif), _g_free0 (thumbnail_md5), _tmp4_);
#line 3334 "BatchImport.c"
	}
#line 713 "BatchImport.vala"
	if (exif_md5 == NULL) {
#line 713 "BatchImport.vala"
		_tmp5_ = TRUE;
#line 3340 "BatchImport.c"
	} else {
#line 713 "BatchImport.vala"
		_tmp5_ = thumbnail_md5 == NULL;
#line 3344 "BatchImport.c"
	}
#line 713 "BatchImport.vala"
	if (_tmp5_) {
#line 3348 "BatchImport.c"
		{
			char* _tmp6_;
			char* _tmp7_;
#line 715 "BatchImport.vala"
			_tmp6_ = md5_file (file, &_inner_error_);
#line 3354 "BatchImport.c"
			if (_inner_error_ != NULL) {
				goto __catch108_g_error;
			}
#line 715 "BatchImport.vala"
			full_md5 = (_tmp7_ = _tmp6_, _g_free0 (full_md5), _tmp7_);
#line 3360 "BatchImport.c"
		}
		goto __finally108;
		__catch108_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp8_;
#line 717 "BatchImport.vala"
				g_warning ("BatchImport.vala:717: Unable to perform MD5 checksum on %s: %s", _tmp8_ = g_file_get_path (file), err->message);
#line 3372 "BatchImport.c"
				_g_free0 (_tmp8_);
				_g_error_free0 (err);
			}
		}
		__finally108:
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (exif_md5);
			_g_free0 (thumbnail_md5);
			_g_free0 (full_md5);
			_photo_exif_unref0 (photo_exif);
			return 0;
		}
	}
#line 722 "BatchImport.vala"
	is_in_library_dir = g_file_has_prefix (file, self->priv->library_dir);
#line 725 "BatchImport.vala"
	self->prepared_files++;
#line 727 "BatchImport.vala"
	if (copy_to_library) {
#line 727 "BatchImport.vala"
		_tmp9_ = !is_in_library_dir;
#line 3395 "BatchImport.c"
	} else {
#line 727 "BatchImport.vala"
		_tmp9_ = FALSE;
#line 3399 "BatchImport.c"
	}
#line 726 "BatchImport.vala"
	background_job_notify (BACKGROUND_JOB (self), self->priv->notification, self->priv->notification_target, NOTIFICATION_OBJECT (_tmp11_ = prepared_file_new (job, file, _tmp10_ = g_file_get_path (file), _tmp9_, exif_md5, thumbnail_md5, full_md5)));
#line 3403 "BatchImport.c"
	_notification_object_unref0 (_tmp11_);
	_g_free0 (_tmp10_);
	result = IMPORT_RESULT_SUCCESS;
	_g_free0 (exif_md5);
	_g_free0 (thumbnail_md5);
	_g_free0 (full_md5);
	_photo_exif_unref0 (photo_exif);
#line 729 "BatchImport.vala"
	return result;
#line 3413 "BatchImport.c"
}


static void prepare_files_job_class_init (PrepareFilesJobClass * klass) {
	prepare_files_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = prepare_files_job_finalize;
	g_type_class_add_private (klass, sizeof (PrepareFilesJobPrivate));
	BACKGROUND_JOB_CLASS (klass)->execute = prepare_files_job_real_execute;
}


static void prepare_files_job_instance_init (PrepareFilesJob * self) {
	self->priv = PREPARE_FILES_JOB_GET_PRIVATE (self);
	self->prepared_files = 0;
	self->priv->import_file_count = 0;
	self->priv->fail_every = 0;
	self->priv->skip_every = 0;
}


static void prepare_files_job_finalize (BackgroundJob* obj) {
	PrepareFilesJob * self;
	self = PREPARE_FILES_JOB (obj);
	_g_object_unref0 (self->priv->files_to_prepare);
	(self->priv->notification_target_destroy_notify == NULL) ? NULL : (self->priv->notification_target_destroy_notify (self->priv->notification_target), NULL);
	self->priv->notification = NULL;
	self->priv->notification_target = NULL;
	self->priv->notification_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->library_dir);
	BACKGROUND_JOB_CLASS (prepare_files_job_parent_class)->finalize (obj);
}


GType prepare_files_job_get_type (void) {
	static volatile gsize prepare_files_job_type_id__volatile = 0;
	if (g_once_init_enter (&prepare_files_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrepareFilesJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prepare_files_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrepareFilesJob), 0, (GInstanceInitFunc) prepare_files_job_instance_init, NULL };
		GType prepare_files_job_type_id;
		prepare_files_job_type_id = g_type_register_static (TYPE_BACKGROUND_IMPORT_JOB, "PrepareFilesJob", &g_define_type_info, 0);
		g_once_init_leave (&prepare_files_job_type_id__volatile, prepare_files_job_type_id);
	}
	return prepare_files_job_type_id__volatile;
}


#line 743 "BatchImport.vala"
FileImportJob* file_import_job_construct (GType object_type, BatchImport* owner, PreparedFile* prepared_file, ImportID* import_id, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target) {
#line 3461 "BatchImport.c"
	FileImportJob* self;
	PreparedFile* _tmp0_;
#line 743 "BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 743 "BatchImport.vala"
	g_return_val_if_fail (IS_PREPARED_FILE (prepared_file), NULL);
#line 743 "BatchImport.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 745 "BatchImport.vala"
	self = (FileImportJob*) background_job_construct (object_type, G_OBJECT (owner), callback, callback_target, cancellable, cancellation, cancellation_target);
#line 747 "BatchImport.vala"
	self->priv->import_id = *import_id;
#line 748 "BatchImport.vala"
	self->priv->prepared_file = (_tmp0_ = _notification_object_ref0 (prepared_file), _notification_object_unref0 (self->priv->prepared_file), _tmp0_);
#line 3476 "BatchImport.c"
	return self;
}


#line 743 "BatchImport.vala"
FileImportJob* file_import_job_new (BatchImport* owner, PreparedFile* prepared_file, ImportID* import_id, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target) {
#line 743 "BatchImport.vala"
	return file_import_job_construct (TYPE_FILE_IMPORT_JOB, owner, prepared_file, import_id, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 3485 "BatchImport.c"
}


#line 752 "BatchImport.vala"
char* file_import_job_get_filename (FileImportJob* self) {
#line 3491 "BatchImport.c"
	char* result = NULL;
	char* _tmp0_;
#line 752 "BatchImport.vala"
	g_return_val_if_fail (IS_FILE_IMPORT_JOB (self), NULL);
#line 3496 "BatchImport.c"
	_tmp0_ = NULL;
#line 753 "BatchImport.vala"
	if (self->priv->final_file != NULL) {
#line 3500 "BatchImport.c"
		char* _tmp1_;
#line 753 "BatchImport.vala"
		_tmp0_ = (_tmp1_ = g_file_get_path (self->priv->final_file), _g_free0 (_tmp0_), _tmp1_);
#line 3504 "BatchImport.c"
	} else {
		char* _tmp2_;
#line 753 "BatchImport.vala"
		_tmp0_ = (_tmp2_ = g_file_get_path (self->priv->prepared_file->file), _g_free0 (_tmp0_), _tmp2_);
#line 3509 "BatchImport.c"
	}
	result = _tmp0_;
#line 753 "BatchImport.vala"
	return result;
#line 3514 "BatchImport.c"
}


#line 756 "BatchImport.vala"
static void file_import_job_real_execute (BackgroundJob* base) {
#line 3520 "BatchImport.c"
	FileImportJob * self;
	GError * _inner_error_;
	BatchImportJob* job;
	GFile* _tmp0_;
	Scaling _tmp7_;
	Scaling _tmp6_ = {0};
	AppWindow* _tmp5_;
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* interrogator;
	Thumbnails* _tmp9_;
	GdkPixbuf* _tmp15_;
	ImportResult _tmp14_;
	GdkPixbuf* _tmp13_ = NULL;
	PhotoRow _tmp12_;
	ImportResult _tmp11_;
	PhotoRow _tmp10_ = {0};
	ImportResult _result_;
	gboolean _tmp16_ = FALSE;
	BatchImportResult* _tmp19_;
	self = FILE_IMPORT_JOB (base);
	_inner_error_ = NULL;
#line 757 "BatchImport.vala"
	job = _batch_import_job_ref0 (self->priv->prepared_file->job);
#line 758 "BatchImport.vala"
	self->priv->final_file = (_tmp0_ = _g_object_ref0 (self->priv->prepared_file->file), _g_object_unref0 (self->priv->final_file), _tmp0_);
#line 760 "BatchImport.vala"
	if (self->priv->prepared_file->copy_to_library) {
#line 3548 "BatchImport.c"
		{
			GFile* _tmp1_;
			GFile* _tmp2_;
#line 762 "BatchImport.vala"
			_tmp1_ = library_files_duplicate (self->priv->prepared_file->file, NULL, NULL, &_inner_error_);
#line 3554 "BatchImport.c"
			if (_inner_error_ != NULL) {
				goto __catch109_g_error;
			}
#line 762 "BatchImport.vala"
			self->priv->final_file = (_tmp2_ = _tmp1_, _g_object_unref0 (self->priv->final_file), _tmp2_);
#line 763 "BatchImport.vala"
			if (self->priv->final_file == NULL) {
#line 3562 "BatchImport.c"
				BatchImportResult* _tmp3_;
#line 764 "BatchImport.vala"
				self->batch_result = (_tmp3_ = batch_import_result_new (job, self->priv->prepared_file->file, self->priv->prepared_file->id, IMPORT_RESULT_FILE_ERROR), _g_object_unref0 (self->batch_result), _tmp3_);
#line 3566 "BatchImport.c"
				_batch_import_job_unref0 (job);
#line 767 "BatchImport.vala"
				return;
#line 3570 "BatchImport.c"
			}
		}
		goto __finally109;
		__catch109_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				BatchImportResult* _tmp4_;
#line 770 "BatchImport.vala"
				self->batch_result = (_tmp4_ = batch_import_result_new_from_error (job, self->priv->prepared_file->file, self->priv->prepared_file->id, err, IMPORT_RESULT_FILE_ERROR), _g_object_unref0 (self->batch_result), _tmp4_);
#line 3583 "BatchImport.c"
				_g_error_free0 (err);
				_batch_import_job_unref0 (job);
#line 773 "BatchImport.vala"
				return;
#line 3588 "BatchImport.c"
			}
		}
		__finally109:
		if (_inner_error_ != NULL) {
			_batch_import_job_unref0 (job);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 777 "BatchImport.vala"
	interrogator = (_tmp8_ = photo_file_interrogator_new (self->priv->final_file, PHOTO_FILE_INTERROGATOR_OPTIONS_GET_ALL, (_tmp7_ = (scaling_for_screen (GTK_WINDOW (_tmp5_ = app_window_get_instance ()), FALSE, &_tmp6_), _tmp6_), &_tmp7_)), _g_object_unref0 (_tmp5_), _tmp8_);
#line 779 "BatchImport.vala"
	self->thumbnails = (_tmp9_ = thumbnails_new (), _thumbnails_unref0 (self->thumbnails), _tmp9_);
#line 781 "BatchImport.vala"
	_result_ = (_tmp14_ = (_tmp11_ = transformable_photo_prepare_for_import (self->priv->final_file, &self->priv->import_id, interrogator, &_tmp10_, &_tmp13_, self->thumbnails), self->photo_row = (_tmp12_ = _tmp10_, photo_row_destroy (&self->photo_row), _tmp12_), _tmp11_), self->pixbuf = (_tmp15_ = _tmp13_, _g_object_unref0 (self->pixbuf), _tmp15_), _tmp14_);
#line 783 "BatchImport.vala"
	if (_result_ != IMPORT_RESULT_SUCCESS) {
#line 783 "BatchImport.vala"
		_tmp16_ = self->priv->final_file != self->priv->prepared_file->file;
#line 3609 "BatchImport.c"
	} else {
#line 783 "BatchImport.vala"
		_tmp16_ = FALSE;
#line 3613 "BatchImport.c"
	}
#line 783 "BatchImport.vala"
	if (_tmp16_) {
#line 3617 "BatchImport.c"
		char* _tmp17_;
#line 784 "BatchImport.vala"
		g_debug ("BatchImport.vala:784: Deleting failed imported copy %s", _tmp17_ = g_file_get_path (self->priv->final_file));
#line 3621 "BatchImport.c"
		_g_free0 (_tmp17_);
		{
#line 786 "BatchImport.vala"
			g_file_delete (self->priv->final_file, NULL, &_inner_error_);
#line 3626 "BatchImport.c"
			if (_inner_error_ != NULL) {
				goto __catch110_g_error;
			}
		}
		goto __finally110;
		__catch110_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp18_;
#line 789 "BatchImport.vala"
				g_warning ("BatchImport.vala:789: Unable to delete copy of imported file %s: %s", _tmp18_ = g_file_get_path (self->priv->final_file), err->message);
#line 3641 "BatchImport.c"
				_g_free0 (_tmp18_);
				_g_error_free0 (err);
			}
		}
		__finally110:
		if (_inner_error_ != NULL) {
			_batch_import_job_unref0 (job);
			_photo_file_interrogator_unref0 (interrogator);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 794 "BatchImport.vala"
	self->batch_result = (_tmp19_ = batch_import_result_new (job, self->priv->final_file, self->priv->prepared_file->id, _result_), _g_object_unref0 (self->batch_result), _tmp19_);
#line 3657 "BatchImport.c"
	_batch_import_job_unref0 (job);
	_photo_file_interrogator_unref0 (interrogator);
}


#line 798 "BatchImport.vala"
BatchImportResult* file_import_job_abort (FileImportJob* self) {
#line 3665 "BatchImport.c"
	BatchImportResult* result = NULL;
	GError * _inner_error_;
	gboolean _tmp0_ = FALSE;
	BatchImportResult* _tmp3_;
#line 798 "BatchImport.vala"
	g_return_val_if_fail (IS_FILE_IMPORT_JOB (self), NULL);
#line 3672 "BatchImport.c"
	_inner_error_ = NULL;
#line 800 "BatchImport.vala"
	if (self->priv->final_file != NULL) {
#line 800 "BatchImport.vala"
		_tmp0_ = self->priv->final_file != self->priv->prepared_file->file;
#line 3678 "BatchImport.c"
	} else {
#line 800 "BatchImport.vala"
		_tmp0_ = FALSE;
#line 3682 "BatchImport.c"
	}
#line 800 "BatchImport.vala"
	if (_tmp0_) {
#line 3686 "BatchImport.c"
		char* _tmp1_;
#line 801 "BatchImport.vala"
		g_debug ("BatchImport.vala:801: Deleting aborted import copy %s", _tmp1_ = g_file_get_path (self->priv->final_file));
#line 3690 "BatchImport.c"
		_g_free0 (_tmp1_);
		{
#line 803 "BatchImport.vala"
			g_file_delete (self->priv->final_file, NULL, &_inner_error_);
#line 3695 "BatchImport.c"
			if (_inner_error_ != NULL) {
				goto __catch111_g_error;
			}
		}
		goto __finally111;
		__catch111_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp2_;
#line 805 "BatchImport.vala"
				g_warning ("BatchImport.vala:805: Unable to delete copy of imported file (aborted " \
"import) %s: %s", _tmp2_ = g_file_get_path (self->priv->final_file), err->message);
#line 3710 "BatchImport.c"
				_g_free0 (_tmp2_);
				_g_error_free0 (err);
			}
		}
		__finally111:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
#line 810 "BatchImport.vala"
	self->batch_result = (_tmp3_ = batch_import_result_new (self->priv->prepared_file->job, self->priv->prepared_file->file, self->priv->prepared_file->id, IMPORT_RESULT_USER_ABORT), _g_object_unref0 (self->batch_result), _tmp3_);
#line 3724 "BatchImport.c"
	result = _g_object_ref0 (self->batch_result);
#line 813 "BatchImport.vala"
	return result;
#line 3728 "BatchImport.c"
}


static void file_import_job_class_init (FileImportJobClass * klass) {
	file_import_job_parent_class = g_type_class_peek_parent (klass);
	BACKGROUND_JOB_CLASS (klass)->finalize = file_import_job_finalize;
	g_type_class_add_private (klass, sizeof (FileImportJobPrivate));
	BACKGROUND_JOB_CLASS (klass)->execute = file_import_job_real_execute;
}


static void file_import_job_instance_init (FileImportJob * self) {
	PhotoRow _tmp3_ = {0};
	self->priv = FILE_IMPORT_JOB_GET_PRIVATE (self);
	self->batch_result = NULL;
	self->photo_row = (photo_row_init (&_tmp3_), _tmp3_);
	self->pixbuf = NULL;
	self->thumbnails = NULL;
	self->priv->final_file = NULL;
}


static void file_import_job_finalize (BackgroundJob* obj) {
	FileImportJob * self;
	self = FILE_IMPORT_JOB (obj);
	_g_object_unref0 (self->batch_result);
	photo_row_destroy (&self->photo_row);
	_g_object_unref0 (self->pixbuf);
	_thumbnails_unref0 (self->thumbnails);
	_notification_object_unref0 (self->priv->prepared_file);
	_g_object_unref0 (self->priv->final_file);
	BACKGROUND_JOB_CLASS (file_import_job_parent_class)->finalize (obj);
}


GType file_import_job_get_type (void) {
	static volatile gsize file_import_job_type_id__volatile = 0;
	if (g_once_init_enter (&file_import_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FileImportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_import_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileImportJob), 0, (GInstanceInitFunc) file_import_job_instance_init, NULL };
		GType file_import_job_type_id;
		file_import_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "FileImportJob", &g_define_type_info, 0);
		g_once_init_leave (&file_import_job_type_id__volatile, file_import_job_type_id);
	}
	return file_import_job_type_id__volatile;
}



static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ENUM_STRING) (gpointer data1, gint arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__ENUM_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_string (param_values + 2), data2);
}



