/* Box.c generated by valac, the Vala compiler
 * generated from Box.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>


#define TYPE_BOX_LOCATION (box_location_get_type ())

#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;

typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _Dimensions {
	gint width;
	gint height;
};



GType box_location_get_type (void);
GType box_complements_get_type (void);
BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement);
GType box_get_type (void);
Box* box_dup (const Box* self);
void box_free (Box* self);
#define BOX_HAND_GRENADES 12
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
void box_from_rectangle (GdkRectangle* rect, Box* result);
void box_from_allocation (GtkAllocation* alloc, Box* result);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
gboolean box_is_valid (Box *self);
gboolean box_equals (Box *self, Box* box);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void box_get_dimensions (Box *self, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result);
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_get_rectangle (Box *self, GdkRectangle* result);
void box_rotate_clockwise (Box *self, Dimensions* space, Box* result);
void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result);
void box_flip_left_to_right (Box *self, Dimensions* space, Box* result);
void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result);
gboolean box_intersects (Box *self, Box* compare);
void box_get_reduced (Box *self, gint amount, Box* result);
void box_get_expanded (Box *self, gint amount, Box* result);
gboolean box_contains (Box *self, GdkPoint* point);
BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged);
BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted);
void box_rubber_band (Box *self, GdkPoint* point, Box* result);
char* dimensions_to_string (Dimensions *self);
char* box_to_string (Box *self);
static gboolean box_in_between (double pos, gint top, gint bottom);
static gboolean box_in_zone (double pos, gint zone);
static gboolean box_near_in_between (double pos, gint top, gint bottom);
BoxLocation box_approx_location (Box *self, gint x, gint y);



GType box_location_get_type (void) {
	static volatile gsize box_location_type_id__volatile = 0;
	if (g_once_init_enter (&box_location_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_LOCATION_OUTSIDE, "BOX_LOCATION_OUTSIDE", "outside"}, {BOX_LOCATION_INSIDE, "BOX_LOCATION_INSIDE", "inside"}, {BOX_LOCATION_TOP_SIDE, "BOX_LOCATION_TOP_SIDE", "top-side"}, {BOX_LOCATION_LEFT_SIDE, "BOX_LOCATION_LEFT_SIDE", "left-side"}, {BOX_LOCATION_RIGHT_SIDE, "BOX_LOCATION_RIGHT_SIDE", "right-side"}, {BOX_LOCATION_BOTTOM_SIDE, "BOX_LOCATION_BOTTOM_SIDE", "bottom-side"}, {BOX_LOCATION_TOP_LEFT, "BOX_LOCATION_TOP_LEFT", "top-left"}, {BOX_LOCATION_BOTTOM_LEFT, "BOX_LOCATION_BOTTOM_LEFT", "bottom-left"}, {BOX_LOCATION_TOP_RIGHT, "BOX_LOCATION_TOP_RIGHT", "top-right"}, {BOX_LOCATION_BOTTOM_RIGHT, "BOX_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType box_location_type_id;
		box_location_type_id = g_enum_register_static ("BoxLocation", values);
		g_once_init_leave (&box_location_type_id__volatile, box_location_type_id);
	}
	return box_location_type_id__volatile;
}


#line 26 "Box.vala"
BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement) {
#line 126 "Box.c"
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
#line 27 "Box.vala"
	if (horizontal_complement) {
#line 27 "Box.vala"
		_tmp0_ = vertical_complement;
#line 133 "Box.c"
	} else {
#line 27 "Box.vala"
		_tmp0_ = FALSE;
#line 137 "Box.c"
	}
#line 27 "Box.vala"
	if (_tmp0_) {
#line 141 "Box.c"
		result = BOX_COMPLEMENTS_BOTH;
#line 28 "Box.vala"
		return result;
#line 145 "Box.c"
	} else {
#line 29 "Box.vala"
		if (horizontal_complement) {
#line 149 "Box.c"
			result = BOX_COMPLEMENTS_HORIZONTAL;
#line 30 "Box.vala"
			return result;
#line 153 "Box.c"
		} else {
#line 31 "Box.vala"
			if (vertical_complement) {
#line 157 "Box.c"
				result = BOX_COMPLEMENTS_VERTICAL;
#line 32 "Box.vala"
				return result;
#line 161 "Box.c"
			}
		}
	}
	result = BOX_COMPLEMENTS_NONE;
#line 34 "Box.vala"
	return result;
#line 168 "Box.c"
}


GType box_complements_get_type (void) {
	static volatile gsize box_complements_type_id__volatile = 0;
	if (g_once_init_enter (&box_complements_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_COMPLEMENTS_NONE, "BOX_COMPLEMENTS_NONE", "none"}, {BOX_COMPLEMENTS_VERTICAL, "BOX_COMPLEMENTS_VERTICAL", "vertical"}, {BOX_COMPLEMENTS_HORIZONTAL, "BOX_COMPLEMENTS_HORIZONTAL", "horizontal"}, {BOX_COMPLEMENTS_BOTH, "BOX_COMPLEMENTS_BOTH", "both"}, {0, NULL, NULL}};
		GType box_complements_type_id;
		box_complements_type_id = g_enum_register_static ("BoxComplements", values);
		g_once_init_leave (&box_complements_type_id__volatile, box_complements_type_id);
	}
	return box_complements_type_id__volatile;
}


#line 46 "Box.vala"
void box_init (Box *self, gint left, gint top, gint right, gint bottom) {
#line 186 "Box.c"
	memset (self, 0, sizeof (Box));
#line 47 "Box.vala"
	g_assert (left >= 0);
#line 48 "Box.vala"
	g_assert (top >= 0);
#line 49 "Box.vala"
	g_assert (right >= left);
#line 50 "Box.vala"
	g_assert (bottom >= top);
#line 52 "Box.vala"
	(*self).left = left;
#line 53 "Box.vala"
	(*self).top = top;
#line 54 "Box.vala"
	(*self).right = right;
#line 55 "Box.vala"
	(*self).bottom = bottom;
#line 204 "Box.c"
}


#line 58 "Box.vala"
void box_from_rectangle (GdkRectangle* rect, Box* result) {
#line 210 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*rect).x, (*rect).y, ((*rect).x + (*rect).width) - 1, ((*rect).y + (*rect).height) - 1), _tmp0_);
#line 59 "Box.vala"
	return;
#line 215 "Box.c"
}


#line 62 "Box.vala"
void box_from_allocation (GtkAllocation* alloc, Box* result) {
#line 221 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*alloc).x, (*alloc).y, ((*alloc).x + (*alloc).width) - 1, ((*alloc).y + (*alloc).height) - 1), _tmp0_);
#line 63 "Box.vala"
	return;
#line 226 "Box.c"
}


#line 68 "Box.vala"
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result) {
#line 232 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, MIN ((*corner1).x, (*corner2).x), MIN ((*corner1).y, (*corner2).y), MAX ((*corner1).x, (*corner2).x), MAX ((*corner1).y, (*corner2).y)), _tmp0_);
#line 69 "Box.vala"
	return;
#line 237 "Box.c"
}


#line 73 "Box.vala"
gint box_get_width (Box *self) {
#line 243 "Box.c"
	gint result = 0;
#line 74 "Box.vala"
	g_assert ((*self).right >= (*self).left);
#line 247 "Box.c"
	result = ((*self).right - (*self).left) + 1;
#line 76 "Box.vala"
	return result;
#line 251 "Box.c"
}


#line 79 "Box.vala"
gint box_get_height (Box *self) {
#line 257 "Box.c"
	gint result = 0;
#line 80 "Box.vala"
	g_assert ((*self).bottom >= (*self).top);
#line 261 "Box.c"
	result = ((*self).bottom - (*self).top) + 1;
#line 82 "Box.vala"
	return result;
#line 265 "Box.c"
}


#line 85 "Box.vala"
gboolean box_is_valid (Box *self) {
#line 271 "Box.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 86 "Box.vala"
	if ((*self).left >= 0) {
#line 86 "Box.vala"
		_tmp2_ = (*self).top >= 0;
#line 280 "Box.c"
	} else {
#line 86 "Box.vala"
		_tmp2_ = FALSE;
#line 284 "Box.c"
	}
#line 86 "Box.vala"
	if (_tmp2_) {
#line 86 "Box.vala"
		_tmp1_ = (*self).right >= (*self).left;
#line 290 "Box.c"
	} else {
#line 86 "Box.vala"
		_tmp1_ = FALSE;
#line 294 "Box.c"
	}
#line 86 "Box.vala"
	if (_tmp1_) {
#line 86 "Box.vala"
		_tmp0_ = (*self).bottom >= (*self).top;
#line 300 "Box.c"
	} else {
#line 86 "Box.vala"
		_tmp0_ = FALSE;
#line 304 "Box.c"
	}
	result = _tmp0_;
#line 86 "Box.vala"
	return result;
#line 309 "Box.c"
}


#line 89 "Box.vala"
gboolean box_equals (Box *self, Box* box) {
#line 315 "Box.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 90 "Box.vala"
	if ((*self).left == (*box).left) {
#line 90 "Box.vala"
		_tmp2_ = (*self).top == (*box).top;
#line 324 "Box.c"
	} else {
#line 90 "Box.vala"
		_tmp2_ = FALSE;
#line 328 "Box.c"
	}
#line 90 "Box.vala"
	if (_tmp2_) {
#line 90 "Box.vala"
		_tmp1_ = (*self).right == (*box).right;
#line 334 "Box.c"
	} else {
#line 90 "Box.vala"
		_tmp1_ = FALSE;
#line 338 "Box.c"
	}
#line 90 "Box.vala"
	if (_tmp1_) {
#line 90 "Box.vala"
		_tmp0_ = (*self).bottom == (*box).bottom;
#line 344 "Box.c"
	} else {
#line 90 "Box.vala"
		_tmp0_ = FALSE;
#line 348 "Box.c"
	}
	result = _tmp0_;
#line 90 "Box.vala"
	return result;
#line 353 "Box.c"
}


#line 93 "Box.vala"
void box_get_scaled (Box *self, Dimensions* scaled, Box* result) {
#line 359 "Box.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	Dimensions _tmp1_;
	Dimensions _tmp0_ = {0};
	gint l;
	gint t;
	gint r;
	gint b;
	Box box = {0};
#line 95 "Box.vala"
	dimensions_get_scale_ratios ((_tmp1_ = (box_get_dimensions (&(*self), &_tmp0_), _tmp0_), &_tmp1_), scaled, &x_scale, &y_scale);
#line 97 "Box.vala"
	l = (gint) round (((double) (*self).left) * x_scale);
#line 98 "Box.vala"
	t = (gint) round (((double) (*self).top) * y_scale);
#line 101 "Box.vala"
	r = (l + (*scaled).width) - 1;
#line 102 "Box.vala"
	b = (t + (*scaled).height) - 1;
#line 379 "Box.c"
	box_init (&box, l, t, r, b);
#line 105 "Box.vala"
	g_assert ((box_get_width (&box) == (*scaled).width) || (box_get_height (&box) == (*scaled).height));
#line 383 "Box.c"
	*result = box;
#line 107 "Box.vala"
	return;
#line 387 "Box.c"
}


#line 110 "Box.vala"
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result) {
#line 393 "Box.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	gint l;
	gint t;
	gint r;
	gint b;
	Box _tmp0_ = {0};
#line 112 "Box.vala"
	dimensions_get_scale_ratios (original, scaled, &x_scale, &y_scale);
#line 114 "Box.vala"
	l = (gint) round (((double) (*self).left) * x_scale);
#line 115 "Box.vala"
	t = (gint) round (((double) (*self).top) * y_scale);
#line 116 "Box.vala"
	r = (gint) round (((double) (*self).right) * x_scale);
#line 117 "Box.vala"
	b = (gint) round (((double) (*self).bottom) * y_scale);
#line 120 "Box.vala"
	if (r >= (*scaled).width) {
#line 121 "Box.vala"
		r = (*scaled).width - 1;
#line 415 "Box.c"
	}
#line 123 "Box.vala"
	if (b >= (*scaled).height) {
#line 124 "Box.vala"
		b = (*scaled).height - 1;
#line 421 "Box.c"
	}
	*result = (box_init (&_tmp0_, l, t, r, b), _tmp0_);
#line 126 "Box.vala"
	return;
#line 426 "Box.c"
}


#line 129 "Box.vala"
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result) {
#line 432 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*self).left + xofs, (*self).top + yofs, (*self).right + xofs, (*self).bottom + yofs), _tmp0_);
#line 130 "Box.vala"
	return;
#line 437 "Box.c"
}


#line 133 "Box.vala"
void box_get_dimensions (Box *self, Dimensions* result) {
#line 443 "Box.c"
	Dimensions _tmp0_ = {0};
	*result = (dimensions_init (&_tmp0_, box_get_width (&(*self)), box_get_height (&(*self))), _tmp0_);
#line 134 "Box.vala"
	return;
#line 448 "Box.c"
}


#line 137 "Box.vala"
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right) {
#line 138 "Box.vala"
	(*top_left).x = (*self).left;
#line 139 "Box.vala"
	(*top_left).y = (*self).top;
#line 141 "Box.vala"
	(*bottom_right).x = (*self).right;
#line 142 "Box.vala"
	(*bottom_right).y = (*self).bottom;
#line 462 "Box.c"
}


#line 145 "Box.vala"
void box_get_rectangle (Box *self, GdkRectangle* result) {
#line 468 "Box.c"
	GdkRectangle rect = {0};
	memset (&rect, 0, sizeof (GdkRectangle));
#line 147 "Box.vala"
	rect.x = (*self).left;
#line 148 "Box.vala"
	rect.y = (*self).top;
#line 149 "Box.vala"
	rect.width = box_get_width (&(*self));
#line 150 "Box.vala"
	rect.height = box_get_height (&(*self));
#line 479 "Box.c"
	*result = rect;
#line 152 "Box.vala"
	return;
#line 483 "Box.c"
}


#line 155 "Box.vala"
void box_rotate_clockwise (Box *self, Dimensions* space, Box* result) {
#line 489 "Box.c"
	gint l;
	gint t;
	gint r;
	gint b;
	Box _tmp0_ = {0};
#line 156 "Box.vala"
	l = ((*space).width - (*self).bottom) - 1;
#line 157 "Box.vala"
	t = (*self).left;
#line 158 "Box.vala"
	r = ((*space).width - (*self).top) - 1;
#line 159 "Box.vala"
	b = (*self).right;
#line 503 "Box.c"
	*result = (box_init (&_tmp0_, l, t, r, b), _tmp0_);
#line 161 "Box.vala"
	return;
#line 507 "Box.c"
}


#line 164 "Box.vala"
void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result) {
#line 513 "Box.c"
	gint l;
	gint t;
	gint r;
	gint b;
	Box _tmp0_ = {0};
#line 165 "Box.vala"
	l = (*self).top;
#line 166 "Box.vala"
	t = ((*space).height - (*self).right) - 1;
#line 167 "Box.vala"
	r = (*self).bottom;
#line 168 "Box.vala"
	b = ((*space).height - (*self).left) - 1;
#line 527 "Box.c"
	*result = (box_init (&_tmp0_, l, t, r, b), _tmp0_);
#line 170 "Box.vala"
	return;
#line 531 "Box.c"
}


#line 173 "Box.vala"
void box_flip_left_to_right (Box *self, Dimensions* space, Box* result) {
#line 537 "Box.c"
	gint l;
	gint r;
	Box _tmp0_ = {0};
#line 174 "Box.vala"
	l = ((*space).width - (*self).right) - 1;
#line 175 "Box.vala"
	r = ((*space).width - (*self).left) - 1;
#line 545 "Box.c"
	*result = (box_init (&_tmp0_, l, (*self).top, r, (*self).bottom), _tmp0_);
#line 177 "Box.vala"
	return;
#line 549 "Box.c"
}


#line 180 "Box.vala"
void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result) {
#line 555 "Box.c"
	gint t;
	gint b;
	Box _tmp0_ = {0};
#line 181 "Box.vala"
	t = ((*space).height - (*self).bottom) - 1;
#line 182 "Box.vala"
	b = ((*space).height - (*self).top) - 1;
#line 563 "Box.c"
	*result = (box_init (&_tmp0_, (*self).left, t, (*self).right, b), _tmp0_);
#line 184 "Box.vala"
	return;
#line 567 "Box.c"
}


#line 187 "Box.vala"
gboolean box_intersects (Box *self, Box* compare) {
#line 573 "Box.c"
	gboolean result = FALSE;
	gint left_intersect;
	gint top_intersect;
	gint right_intersect;
	gint bottom_intersect;
	gboolean _tmp0_ = FALSE;
#line 188 "Box.vala"
	left_intersect = MAX ((*self).left, (*compare).left);
#line 189 "Box.vala"
	top_intersect = MAX ((*self).top, (*compare).top);
#line 190 "Box.vala"
	right_intersect = MIN ((*self).right, (*compare).right);
#line 191 "Box.vala"
	bottom_intersect = MIN ((*self).bottom, (*compare).bottom);
#line 193 "Box.vala"
	if (right_intersect >= left_intersect) {
#line 193 "Box.vala"
		_tmp0_ = bottom_intersect >= top_intersect;
#line 592 "Box.c"
	} else {
#line 193 "Box.vala"
		_tmp0_ = FALSE;
#line 596 "Box.c"
	}
	result = _tmp0_;
#line 193 "Box.vala"
	return result;
#line 601 "Box.c"
}


#line 196 "Box.vala"
void box_get_reduced (Box *self, gint amount, Box* result) {
#line 607 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*self).left + amount, (*self).top + amount, (*self).right - amount, (*self).bottom - amount), _tmp0_);
#line 197 "Box.vala"
	return;
#line 612 "Box.c"
}


#line 200 "Box.vala"
void box_get_expanded (Box *self, gint amount, Box* result) {
#line 618 "Box.c"
	Box _tmp0_ = {0};
	*result = (box_init (&_tmp0_, (*self).left - amount, (*self).top - amount, (*self).right + amount, (*self).bottom + amount), _tmp0_);
#line 201 "Box.vala"
	return;
#line 623 "Box.c"
}


#line 204 "Box.vala"
gboolean box_contains (Box *self, GdkPoint* point) {
#line 629 "Box.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 205 "Box.vala"
	if ((*point).x >= (*self).left) {
#line 205 "Box.vala"
		_tmp2_ = (*point).x <= (*self).right;
#line 638 "Box.c"
	} else {
#line 205 "Box.vala"
		_tmp2_ = FALSE;
#line 642 "Box.c"
	}
#line 205 "Box.vala"
	if (_tmp2_) {
#line 205 "Box.vala"
		_tmp1_ = (*point).y >= (*self).top;
#line 648 "Box.c"
	} else {
#line 205 "Box.vala"
		_tmp1_ = FALSE;
#line 652 "Box.c"
	}
#line 205 "Box.vala"
	if (_tmp1_) {
#line 205 "Box.vala"
		_tmp0_ = (*point).y <= (*self).bottom;
#line 658 "Box.c"
	} else {
#line 205 "Box.vala"
		_tmp0_ = FALSE;
#line 662 "Box.c"
	}
	result = _tmp0_;
#line 205 "Box.vala"
	return result;
#line 667 "Box.c"
}


#line 211 "Box.vala"
BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged) {
#line 673 "Box.c"
	BoxComplements result = 0;
	gint min_left;
	gint min_top;
	gint max_right;
	gint max_bottom;
	gboolean horizontal_complement;
	gboolean vertical_complement;
#line 213 "Box.vala"
	g_assert ((box_get_width (&(*self)) != box_get_width (resized)) || (box_get_height (&(*self)) != box_get_height (resized)));
#line 215 "Box.vala"
	min_left = MIN ((*self).left, (*resized).left);
#line 216 "Box.vala"
	min_top = MIN ((*self).top, (*resized).top);
#line 217 "Box.vala"
	max_right = MAX ((*self).right, (*resized).right);
#line 218 "Box.vala"
	max_bottom = MAX ((*self).bottom, (*resized).bottom);
#line 220 "Box.vala"
	horizontal_complement = TRUE;
#line 221 "Box.vala"
	if ((*resized).top < (*self).top) {
#line 695 "Box.c"
		Box _tmp0_ = {0};
#line 223 "Box.vala"
		*horizontal = (box_init (&_tmp0_, min_left, (*resized).top, max_right, (*self).top), _tmp0_);
#line 224 "Box.vala"
		*horizontal_enlarged = TRUE;
#line 701 "Box.c"
	} else {
#line 225 "Box.vala"
		if ((*resized).top > (*self).top) {
#line 705 "Box.c"
			Box _tmp1_ = {0};
#line 227 "Box.vala"
			*horizontal = (box_init (&_tmp1_, min_left, (*self).top, max_right, (*resized).top), _tmp1_);
#line 228 "Box.vala"
			*horizontal_enlarged = FALSE;
#line 711 "Box.c"
		} else {
#line 229 "Box.vala"
			if ((*resized).bottom < (*self).bottom) {
#line 715 "Box.c"
				Box _tmp2_ = {0};
#line 231 "Box.vala"
				*horizontal = (box_init (&_tmp2_, min_left, (*resized).bottom, max_right, (*self).bottom), _tmp2_);
#line 232 "Box.vala"
				*horizontal_enlarged = FALSE;
#line 721 "Box.c"
			} else {
#line 233 "Box.vala"
				if ((*resized).bottom > (*self).bottom) {
#line 725 "Box.c"
					Box _tmp3_ = {0};
#line 235 "Box.vala"
					*horizontal = (box_init (&_tmp3_, min_left, (*self).bottom, max_right, (*resized).bottom), _tmp3_);
#line 236 "Box.vala"
					*horizontal_enlarged = TRUE;
#line 731 "Box.c"
				} else {
#line 238 "Box.vala"
					horizontal_complement = FALSE;
#line 735 "Box.c"
				}
			}
		}
	}
#line 241 "Box.vala"
	vertical_complement = TRUE;
#line 242 "Box.vala"
	if ((*resized).left < (*self).left) {
#line 744 "Box.c"
		Box _tmp4_ = {0};
#line 244 "Box.vala"
		*vertical = (box_init (&_tmp4_, (*resized).left, min_top, (*self).left, max_bottom), _tmp4_);
#line 245 "Box.vala"
		*vertical_enlarged = TRUE;
#line 750 "Box.c"
	} else {
#line 246 "Box.vala"
		if ((*resized).left > (*self).left) {
#line 754 "Box.c"
			Box _tmp5_ = {0};
#line 248 "Box.vala"
			*vertical = (box_init (&_tmp5_, (*self).left, min_top, (*resized).left, max_bottom), _tmp5_);
#line 249 "Box.vala"
			*vertical_enlarged = FALSE;
#line 760 "Box.c"
		} else {
#line 250 "Box.vala"
			if ((*resized).right < (*self).right) {
#line 764 "Box.c"
				Box _tmp6_ = {0};
#line 252 "Box.vala"
				*vertical = (box_init (&_tmp6_, (*resized).right, min_top, (*self).right, max_bottom), _tmp6_);
#line 253 "Box.vala"
				*vertical_enlarged = FALSE;
#line 770 "Box.c"
			} else {
#line 254 "Box.vala"
				if ((*resized).right > (*self).right) {
#line 774 "Box.c"
					Box _tmp7_ = {0};
#line 256 "Box.vala"
					*vertical = (box_init (&_tmp7_, (*self).right, min_top, (*resized).right, max_bottom), _tmp7_);
#line 257 "Box.vala"
					*vertical_enlarged = TRUE;
#line 780 "Box.c"
				} else {
#line 259 "Box.vala"
					vertical_complement = FALSE;
#line 784 "Box.c"
				}
			}
		}
	}
	result = box_complements_derive (horizontal_complement, vertical_complement);
#line 262 "Box.vala"
	return result;
#line 792 "Box.c"
}


#line 268 "Box.vala"
BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted) {
#line 798 "Box.c"
	BoxComplements result = 0;
	gboolean horizontal_complement;
	gboolean _tmp0_ = FALSE;
	gboolean vertical_complement;
	gboolean _tmp6_ = FALSE;
#line 270 "Box.vala"
	g_assert (box_get_width (&(*self)) == box_get_width (shifted));
#line 271 "Box.vala"
	g_assert (box_get_height (&(*self)) == box_get_height (shifted));
#line 273 "Box.vala"
	horizontal_complement = TRUE;
#line 274 "Box.vala"
	if ((*shifted).top < (*self).top) {
#line 274 "Box.vala"
		_tmp0_ = (*shifted).bottom > (*self).top;
#line 814 "Box.c"
	} else {
#line 274 "Box.vala"
		_tmp0_ = FALSE;
#line 818 "Box.c"
	}
#line 274 "Box.vala"
	if (_tmp0_) {
#line 822 "Box.c"
		Box _tmp1_ = {0};
		Box _tmp2_ = {0};
#line 276 "Box.vala"
		*horizontal_this = (box_init (&_tmp1_, (*self).left, (*shifted).bottom, (*self).right, (*self).bottom), _tmp1_);
#line 277 "Box.vala"
		*horizontal_shifted = (box_init (&_tmp2_, (*shifted).left, (*shifted).top, (*shifted).right, (*self).top), _tmp2_);
#line 829 "Box.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 278 "Box.vala"
		if ((*shifted).top > (*self).top) {
#line 278 "Box.vala"
			_tmp3_ = (*shifted).top < (*self).bottom;
#line 836 "Box.c"
		} else {
#line 278 "Box.vala"
			_tmp3_ = FALSE;
#line 840 "Box.c"
		}
#line 278 "Box.vala"
		if (_tmp3_) {
#line 844 "Box.c"
			Box _tmp4_ = {0};
			Box _tmp5_ = {0};
#line 280 "Box.vala"
			*horizontal_this = (box_init (&_tmp4_, (*self).left, (*self).top, (*self).right, (*shifted).top), _tmp4_);
#line 281 "Box.vala"
			*horizontal_shifted = (box_init (&_tmp5_, (*shifted).left, (*self).bottom, (*shifted).right, (*shifted).bottom), _tmp5_);
#line 851 "Box.c"
		} else {
#line 284 "Box.vala"
			horizontal_complement = FALSE;
#line 855 "Box.c"
		}
	}
#line 287 "Box.vala"
	vertical_complement = TRUE;
#line 288 "Box.vala"
	if ((*shifted).left < (*self).left) {
#line 288 "Box.vala"
		_tmp6_ = (*shifted).right > (*self).left;
#line 864 "Box.c"
	} else {
#line 288 "Box.vala"
		_tmp6_ = FALSE;
#line 868 "Box.c"
	}
#line 288 "Box.vala"
	if (_tmp6_) {
#line 872 "Box.c"
		Box _tmp7_ = {0};
		Box _tmp8_ = {0};
#line 290 "Box.vala"
		*vertical_this = (box_init (&_tmp7_, (*shifted).right, (*self).top, (*self).right, (*self).bottom), _tmp7_);
#line 291 "Box.vala"
		*vertical_shifted = (box_init (&_tmp8_, (*shifted).left, (*shifted).top, (*self).left, (*shifted).bottom), _tmp8_);
#line 879 "Box.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 292 "Box.vala"
		if ((*shifted).left > (*self).left) {
#line 292 "Box.vala"
			_tmp9_ = (*shifted).left < (*self).right;
#line 886 "Box.c"
		} else {
#line 292 "Box.vala"
			_tmp9_ = FALSE;
#line 890 "Box.c"
		}
#line 292 "Box.vala"
		if (_tmp9_) {
#line 894 "Box.c"
			Box _tmp10_ = {0};
			Box _tmp11_ = {0};
#line 294 "Box.vala"
			*vertical_this = (box_init (&_tmp10_, (*self).left, (*self).top, (*shifted).left, (*self).bottom), _tmp10_);
#line 295 "Box.vala"
			*vertical_shifted = (box_init (&_tmp11_, (*self).right, (*shifted).top, (*shifted).right, (*shifted).bottom), _tmp11_);
#line 901 "Box.c"
		} else {
#line 298 "Box.vala"
			vertical_complement = FALSE;
#line 905 "Box.c"
		}
	}
	result = box_complements_derive (horizontal_complement, vertical_complement);
#line 301 "Box.vala"
	return result;
#line 911 "Box.c"
}


#line 304 "Box.vala"
void box_rubber_band (Box *self, GdkPoint* point, Box* result) {
#line 917 "Box.c"
	gint t;
	gint b;
	gint l;
	gint r;
	Box _tmp0_ = {0};
#line 305 "Box.vala"
	g_assert ((*point).x >= 0);
#line 306 "Box.vala"
	g_assert ((*point).y >= 0);
#line 308 "Box.vala"
	t = MIN ((*self).top, (*point).y);
#line 309 "Box.vala"
	b = MAX ((*self).bottom, (*point).y);
#line 310 "Box.vala"
	l = MIN ((*self).left, (*point).x);
#line 311 "Box.vala"
	r = MAX ((*self).right, (*point).x);
#line 935 "Box.c"
	*result = (box_init (&_tmp0_, l, t, r, b), _tmp0_);
#line 313 "Box.vala"
	return;
#line 939 "Box.c"
}


#line 316 "Box.vala"
char* box_to_string (Box *self) {
#line 945 "Box.c"
	char* result = NULL;
	char* _tmp2_;
	Dimensions _tmp1_;
	Dimensions _tmp0_ = {0};
	char* _tmp3_;
	result = (_tmp3_ = g_strdup_printf ("%d,%d %d,%d (%s)", (*self).left, (*self).top, (*self).right, (*self).bottom, _tmp2_ = dimensions_to_string ((_tmp1_ = (box_get_dimensions (&(*self), &_tmp0_), _tmp0_), &_tmp1_))), _g_free0 (_tmp2_), _tmp3_);
#line 317 "Box.vala"
	return result;
#line 954 "Box.c"
}


#line 320 "Box.vala"
static gboolean box_in_zone (double pos, gint zone) {
#line 960 "Box.c"
	gboolean result = FALSE;
	gint top_zone;
	gint bottom_zone;
#line 321 "Box.vala"
	top_zone = zone - BOX_HAND_GRENADES;
#line 322 "Box.vala"
	bottom_zone = zone + BOX_HAND_GRENADES;
#line 968 "Box.c"
	result = box_in_between (pos, top_zone, bottom_zone);
#line 324 "Box.vala"
	return result;
#line 972 "Box.c"
}


#line 327 "Box.vala"
static gboolean box_in_between (double pos, gint top, gint bottom) {
#line 978 "Box.c"
	gboolean result = FALSE;
	gint ipos;
	gboolean _tmp0_ = FALSE;
#line 328 "Box.vala"
	ipos = (gint) pos;
#line 330 "Box.vala"
	if (ipos > top) {
#line 330 "Box.vala"
		_tmp0_ = ipos < bottom;
#line 988 "Box.c"
	} else {
#line 330 "Box.vala"
		_tmp0_ = FALSE;
#line 992 "Box.c"
	}
	result = _tmp0_;
#line 330 "Box.vala"
	return result;
#line 997 "Box.c"
}


#line 333 "Box.vala"
static gboolean box_near_in_between (double pos, gint top, gint bottom) {
#line 1003 "Box.c"
	gboolean result = FALSE;
	gint ipos;
	gint top_zone;
	gint bottom_zone;
	gboolean _tmp0_ = FALSE;
#line 334 "Box.vala"
	ipos = (gint) pos;
#line 335 "Box.vala"
	top_zone = top - BOX_HAND_GRENADES;
#line 336 "Box.vala"
	bottom_zone = bottom + BOX_HAND_GRENADES;
#line 338 "Box.vala"
	if (ipos > top_zone) {
#line 338 "Box.vala"
		_tmp0_ = ipos < bottom_zone;
#line 1019 "Box.c"
	} else {
#line 338 "Box.vala"
		_tmp0_ = FALSE;
#line 1023 "Box.c"
	}
	result = _tmp0_;
#line 338 "Box.vala"
	return result;
#line 1028 "Box.c"
}


#line 341 "Box.vala"
BoxLocation box_approx_location (Box *self, gint x, gint y) {
#line 1034 "Box.c"
	BoxLocation result = 0;
	gboolean near_width;
	gboolean near_height;
	gboolean _tmp0_ = FALSE;
#line 342 "Box.vala"
	near_width = box_near_in_between ((double) x, (*self).left, (*self).right);
#line 343 "Box.vala"
	near_height = box_near_in_between ((double) y, (*self).top, (*self).bottom);
#line 345 "Box.vala"
	if (box_in_zone ((double) x, (*self).left)) {
#line 345 "Box.vala"
		_tmp0_ = near_height;
#line 1047 "Box.c"
	} else {
#line 345 "Box.vala"
		_tmp0_ = FALSE;
#line 1051 "Box.c"
	}
#line 345 "Box.vala"
	if (_tmp0_) {
#line 346 "Box.vala"
		if (box_in_zone ((double) y, (*self).top)) {
#line 1057 "Box.c"
			result = BOX_LOCATION_TOP_LEFT;
#line 347 "Box.vala"
			return result;
#line 1061 "Box.c"
		} else {
#line 348 "Box.vala"
			if (box_in_zone ((double) y, (*self).bottom)) {
#line 1065 "Box.c"
				result = BOX_LOCATION_BOTTOM_LEFT;
#line 349 "Box.vala"
				return result;
#line 1069 "Box.c"
			} else {
				result = BOX_LOCATION_LEFT_SIDE;
#line 351 "Box.vala"
				return result;
#line 1074 "Box.c"
			}
		}
	} else {
		gboolean _tmp1_ = FALSE;
#line 353 "Box.vala"
		if (box_in_zone ((double) x, (*self).right)) {
#line 353 "Box.vala"
			_tmp1_ = near_height;
#line 1083 "Box.c"
		} else {
#line 353 "Box.vala"
			_tmp1_ = FALSE;
#line 1087 "Box.c"
		}
#line 353 "Box.vala"
		if (_tmp1_) {
#line 354 "Box.vala"
			if (box_in_zone ((double) y, (*self).top)) {
#line 1093 "Box.c"
				result = BOX_LOCATION_TOP_RIGHT;
#line 355 "Box.vala"
				return result;
#line 1097 "Box.c"
			} else {
#line 356 "Box.vala"
				if (box_in_zone ((double) y, (*self).bottom)) {
#line 1101 "Box.c"
					result = BOX_LOCATION_BOTTOM_RIGHT;
#line 357 "Box.vala"
					return result;
#line 1105 "Box.c"
				} else {
					result = BOX_LOCATION_RIGHT_SIDE;
#line 359 "Box.vala"
					return result;
#line 1110 "Box.c"
				}
			}
		} else {
			gboolean _tmp2_ = FALSE;
#line 361 "Box.vala"
			if (box_in_zone ((double) y, (*self).top)) {
#line 361 "Box.vala"
				_tmp2_ = near_width;
#line 1119 "Box.c"
			} else {
#line 361 "Box.vala"
				_tmp2_ = FALSE;
#line 1123 "Box.c"
			}
#line 361 "Box.vala"
			if (_tmp2_) {
#line 1127 "Box.c"
				result = BOX_LOCATION_TOP_SIDE;
#line 363 "Box.vala"
				return result;
#line 1131 "Box.c"
			} else {
				gboolean _tmp3_ = FALSE;
#line 364 "Box.vala"
				if (box_in_zone ((double) y, (*self).bottom)) {
#line 364 "Box.vala"
					_tmp3_ = near_width;
#line 1138 "Box.c"
				} else {
#line 364 "Box.vala"
					_tmp3_ = FALSE;
#line 1142 "Box.c"
				}
#line 364 "Box.vala"
				if (_tmp3_) {
#line 1146 "Box.c"
					result = BOX_LOCATION_BOTTOM_SIDE;
#line 366 "Box.vala"
					return result;
#line 1150 "Box.c"
				} else {
					gboolean _tmp4_ = FALSE;
#line 367 "Box.vala"
					if (box_in_between ((double) x, (*self).left, (*self).right)) {
#line 367 "Box.vala"
						_tmp4_ = box_in_between ((double) y, (*self).top, (*self).bottom);
#line 1157 "Box.c"
					} else {
#line 367 "Box.vala"
						_tmp4_ = FALSE;
#line 1161 "Box.c"
					}
#line 367 "Box.vala"
					if (_tmp4_) {
#line 1165 "Box.c"
						result = BOX_LOCATION_INSIDE;
#line 368 "Box.vala"
						return result;
#line 1169 "Box.c"
					} else {
						result = BOX_LOCATION_OUTSIDE;
#line 370 "Box.vala"
						return result;
#line 1174 "Box.c"
					}
				}
			}
		}
	}
}


Box* box_dup (const Box* self) {
	Box* dup;
	dup = g_new0 (Box, 1);
	memcpy (dup, self, sizeof (Box));
	return dup;
}


void box_free (Box* self) {
	g_free (self);
}


GType box_get_type (void) {
	static volatile gsize box_type_id__volatile = 0;
	if (g_once_init_enter (&box_type_id__volatile)) {
		GType box_type_id;
		box_type_id = g_boxed_type_register_static ("Box", (GBoxedCopyFunc) box_dup, (GBoxedFreeFunc) box_free);
		g_once_init_leave (&box_type_id__volatile, box_type_id);
	}
	return box_type_id__volatile;
}




