/* CommandManager.c generated by valac, the Vala compiler
 * generated from CommandManager.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_COMMAND_DESCRIPTION (command_description_get_type ())
#define COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescription))
#define IS_COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_DESCRIPTION))
#define COMMAND_DESCRIPTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescriptionIface))

typedef struct _CommandDescription CommandDescription;
typedef struct _CommandDescriptionIface CommandDescriptionIface;

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
typedef struct _CommandPrivate CommandPrivate;

#define TYPE_COMMAND_MANAGER (command_manager_get_type ())
#define COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_MANAGER, CommandManager))
#define COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND_MANAGER, CommandManagerClass))
#define IS_COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_MANAGER))
#define IS_COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND_MANAGER))
#define COMMAND_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND_MANAGER, CommandManagerClass))

typedef struct _CommandManager CommandManager;
typedef struct _CommandManagerClass CommandManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _CommandManagerPrivate CommandManagerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecCommandManager ParamSpecCommandManager;

struct _CommandDescriptionIface {
	GTypeInterface parent_iface;
	char* (*get_name) (CommandDescription* self);
	char* (*get_explanation) (CommandDescription* self);
};

struct _Command {
	GObject parent_instance;
	CommandPrivate * priv;
};

struct _CommandClass {
	GObjectClass parent_class;
	void (*prepare) (Command* self);
	void (*execute) (Command* self);
	void (*undo) (Command* self);
	void (*redo) (Command* self);
	gboolean (*compress) (Command* self, Command* command);
	char* (*get_name) (Command* self);
	char* (*get_explanation) (Command* self);
};

struct _CommandPrivate {
	char* name;
	char* explanation;
	CommandManager* manager;
};

struct _CommandManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CommandManagerPrivate * priv;
};

struct _CommandManagerClass {
	GTypeClass parent_class;
	void (*finalize) (CommandManager *self);
};

struct _CommandManagerPrivate {
	gint depth;
	GeeArrayList* undo_stack;
	GeeArrayList* redo_stack;
};

struct _ParamSpecCommandManager {
	GParamSpec parent_instance;
};


static gpointer command_parent_class = NULL;
static CommandDescriptionIface* command_command_description_parent_iface = NULL;
static gpointer command_manager_parent_class = NULL;

GType command_description_get_type (void);
char* command_description_get_name (CommandDescription* self);
char* command_description_get_explanation (CommandDescription* self);
GType command_get_type (void);
gpointer command_manager_ref (gpointer instance);
void command_manager_unref (gpointer instance);
GParamSpec* param_spec_command_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_command_manager (GValue* value, gpointer v_object);
void value_take_command_manager (GValue* value, gpointer v_object);
gpointer value_get_command_manager (const GValue* value);
GType command_manager_get_type (void);
#define COMMAND_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COMMAND, CommandPrivate))
enum  {
	COMMAND_DUMMY_PROPERTY
};
Command* command_construct (GType object_type, const char* name, const char* explanation);
void command_prepare (Command* self);
static void command_real_prepare (Command* self);
void command_execute (Command* self);
static void command_real_execute (Command* self);
void command_undo (Command* self);
static void command_real_undo (Command* self);
void command_redo (Command* self);
static void command_real_redo (Command* self);
gboolean command_compress (Command* self, Command* command);
static gboolean command_real_compress (Command* self, Command* command);
char* command_get_name (Command* self);
static char* command_real_get_name (Command* self);
char* command_get_explanation (Command* self);
static char* command_real_get_explanation (Command* self);
CommandManager* command_get_command_manager (Command* self);
void command_internal_set_command_manager (Command* self, CommandManager* manager);
static void command_finalize (GObject* obj);
#define COMMAND_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COMMAND_MANAGER, CommandManagerPrivate))
enum  {
	COMMAND_MANAGER_DUMMY_PROPERTY
};
#define COMMAND_MANAGER_DEFAULT_DEPTH 20
CommandManager* command_manager_new (gint depth);
CommandManager* command_manager_construct (GType object_type, gint depth);
void command_manager_reset (CommandManager* self);
static Command* command_manager_top (CommandManager* self, GeeArrayList* stack);
static void command_manager_push (CommandManager* self, GeeArrayList* stack, Command* command);
gboolean command_manager_can_undo (CommandManager* self);
gboolean command_manager_can_redo (CommandManager* self);
void command_manager_execute (CommandManager* self, Command* command);
CommandDescription* command_manager_get_undo_description (CommandManager* self);
static Command* command_manager_pop (CommandManager* self, GeeArrayList* stack);
gboolean command_manager_undo (CommandManager* self);
CommandDescription* command_manager_get_redo_description (CommandManager* self);
gboolean command_manager_redo (CommandManager* self);
static void command_manager_finalize (CommandManager* obj);


static void g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 8 "CommandManager.vala"
char* command_description_get_name (CommandDescription* self) {
#line 8 "CommandManager.vala"
	return COMMAND_DESCRIPTION_GET_INTERFACE (self)->get_name (self);
#line 166 "CommandManager.c"
}


#line 10 "CommandManager.vala"
char* command_description_get_explanation (CommandDescription* self) {
#line 10 "CommandManager.vala"
	return COMMAND_DESCRIPTION_GET_INTERFACE (self)->get_explanation (self);
#line 174 "CommandManager.c"
}


static void command_description_base_init (CommandDescriptionIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType command_description_get_type (void) {
	static volatile gsize command_description_type_id__volatile = 0;
	if (g_once_init_enter (&command_description_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CommandDescriptionIface), (GBaseInitFunc) command_description_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType command_description_type_id;
		command_description_type_id = g_type_register_static (G_TYPE_INTERFACE, "CommandDescription", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (command_description_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&command_description_type_id__volatile, command_description_type_id);
	}
	return command_description_type_id__volatile;
}


#line 32 "CommandManager.vala"
Command* command_construct (GType object_type, const char* name, const char* explanation) {
#line 201 "CommandManager.c"
	Command * self;
	char* _tmp0_;
	char* _tmp1_;
#line 32 "CommandManager.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 32 "CommandManager.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 32 "CommandManager.vala"
	self = (Command*) g_object_new (object_type, NULL);
#line 33 "CommandManager.vala"
	self->priv->name = (_tmp0_ = g_strdup (name), _g_free0 (self->priv->name), _tmp0_);
#line 34 "CommandManager.vala"
	self->priv->explanation = (_tmp1_ = g_strdup (explanation), _g_free0 (self->priv->explanation), _tmp1_);
#line 215 "CommandManager.c"
	return self;
}


#line 43 "CommandManager.vala"
static void command_real_prepare (Command* self) {
#line 43 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND (self));
#line 224 "CommandManager.c"
}


#line 43 "CommandManager.vala"
void command_prepare (Command* self) {
#line 43 "CommandManager.vala"
	COMMAND_GET_CLASS (self)->prepare (self);
#line 232 "CommandManager.c"
}


#line 46 "CommandManager.vala"
static void command_real_execute (Command* self) {
#line 238 "CommandManager.c"
	g_return_if_fail (IS_COMMAND (self));
	g_critical ("Type `%s' does not implement abstract method `command_execute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 46 "CommandManager.vala"
void command_execute (Command* self) {
#line 46 "CommandManager.vala"
	COMMAND_GET_CLASS (self)->execute (self);
#line 249 "CommandManager.c"
}


#line 48 "CommandManager.vala"
static void command_real_undo (Command* self) {
#line 255 "CommandManager.c"
	g_return_if_fail (IS_COMMAND (self));
	g_critical ("Type `%s' does not implement abstract method `command_undo'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 48 "CommandManager.vala"
void command_undo (Command* self) {
#line 48 "CommandManager.vala"
	COMMAND_GET_CLASS (self)->undo (self);
#line 266 "CommandManager.c"
}


#line 50 "CommandManager.vala"
static void command_real_redo (Command* self) {
#line 50 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND (self));
#line 51 "CommandManager.vala"
	command_execute (self);
#line 276 "CommandManager.c"
}


#line 50 "CommandManager.vala"
void command_redo (Command* self) {
#line 50 "CommandManager.vala"
	COMMAND_GET_CLASS (self)->redo (self);
#line 284 "CommandManager.c"
}


#line 56 "CommandManager.vala"
static gboolean command_real_compress (Command* self, Command* command) {
#line 290 "CommandManager.c"
	gboolean result = FALSE;
#line 56 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND (self), FALSE);
#line 56 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 296 "CommandManager.c"
	result = FALSE;
#line 57 "CommandManager.vala"
	return result;
#line 300 "CommandManager.c"
}


#line 56 "CommandManager.vala"
gboolean command_compress (Command* self, Command* command) {
#line 56 "CommandManager.vala"
	return COMMAND_GET_CLASS (self)->compress (self, command);
#line 308 "CommandManager.c"
}


#line 60 "CommandManager.vala"
static char* command_real_get_name (Command* self) {
#line 314 "CommandManager.c"
	char* result = NULL;
#line 60 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND (self), NULL);
#line 318 "CommandManager.c"
	result = g_strdup (self->priv->name);
#line 61 "CommandManager.vala"
	return result;
#line 322 "CommandManager.c"
}


#line 60 "CommandManager.vala"
char* command_get_name (Command* self) {
#line 60 "CommandManager.vala"
	return COMMAND_GET_CLASS (self)->get_name (self);
#line 330 "CommandManager.c"
}


#line 64 "CommandManager.vala"
static char* command_real_get_explanation (Command* self) {
#line 336 "CommandManager.c"
	char* result = NULL;
#line 64 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND (self), NULL);
#line 340 "CommandManager.c"
	result = g_strdup (self->priv->explanation);
#line 65 "CommandManager.vala"
	return result;
#line 344 "CommandManager.c"
}


#line 64 "CommandManager.vala"
char* command_get_explanation (Command* self) {
#line 64 "CommandManager.vala"
	return COMMAND_GET_CLASS (self)->get_explanation (self);
#line 352 "CommandManager.c"
}


#line 68 "CommandManager.vala"
CommandManager* command_get_command_manager (Command* self) {
#line 358 "CommandManager.c"
	CommandManager* result = NULL;
#line 68 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND (self), NULL);
#line 362 "CommandManager.c"
	result = self->priv->manager;
#line 69 "CommandManager.vala"
	return result;
#line 366 "CommandManager.c"
}


#line 73 "CommandManager.vala"
void command_internal_set_command_manager (Command* self, CommandManager* manager) {
#line 73 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND (self));
#line 73 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND_MANAGER (manager));
#line 74 "CommandManager.vala"
	g_assert (self->priv->manager == NULL);
#line 76 "CommandManager.vala"
	self->priv->manager = manager;
#line 380 "CommandManager.c"
}


static void command_class_init (CommandClass * klass) {
	command_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CommandPrivate));
	COMMAND_CLASS (klass)->prepare = command_real_prepare;
	COMMAND_CLASS (klass)->execute = command_real_execute;
	COMMAND_CLASS (klass)->undo = command_real_undo;
	COMMAND_CLASS (klass)->redo = command_real_redo;
	COMMAND_CLASS (klass)->compress = command_real_compress;
	COMMAND_CLASS (klass)->get_name = command_real_get_name;
	COMMAND_CLASS (klass)->get_explanation = command_real_get_explanation;
	G_OBJECT_CLASS (klass)->finalize = command_finalize;
}


static void command_command_description_interface_init (CommandDescriptionIface * iface) {
	command_command_description_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_name = (char* (*)(CommandDescription*)) command_get_name;
	iface->get_explanation = (char* (*)(CommandDescription*)) command_get_explanation;
}


static void command_instance_init (Command * self) {
	self->priv = COMMAND_GET_PRIVATE (self);
	self->priv->manager = NULL;
}


static void command_finalize (GObject* obj) {
	Command * self;
	self = COMMAND (obj);
	{
	}
	_g_free0 (self->priv->name);
	_g_free0 (self->priv->explanation);
	G_OBJECT_CLASS (command_parent_class)->finalize (obj);
}


GType command_get_type (void) {
	static volatile gsize command_type_id__volatile = 0;
	if (g_once_init_enter (&command_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Command), 0, (GInstanceInitFunc) command_instance_init, NULL };
		static const GInterfaceInfo command_description_info = { (GInterfaceInitFunc) command_command_description_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType command_type_id;
		command_type_id = g_type_register_static (G_TYPE_OBJECT, "Command", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (command_type_id, TYPE_COMMAND_DESCRIPTION, &command_description_info);
		g_once_init_leave (&command_type_id__volatile, command_type_id);
	}
	return command_type_id__volatile;
}


#line 89 "CommandManager.vala"
CommandManager* command_manager_construct (GType object_type, gint depth) {
#line 438 "CommandManager.c"
	CommandManager* self;
	self = (CommandManager*) g_type_create_instance (object_type);
#line 90 "CommandManager.vala"
	g_assert (depth > 0);
#line 92 "CommandManager.vala"
	self->priv->depth = depth;
#line 445 "CommandManager.c"
	return self;
}


#line 89 "CommandManager.vala"
CommandManager* command_manager_new (gint depth) {
#line 89 "CommandManager.vala"
	return command_manager_construct (TYPE_COMMAND_MANAGER, depth);
#line 454 "CommandManager.c"
}


#line 95 "CommandManager.vala"
void command_manager_reset (CommandManager* self) {
#line 95 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND_MANAGER (self));
#line 96 "CommandManager.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->undo_stack));
#line 97 "CommandManager.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->redo_stack));
#line 99 "CommandManager.vala"
	g_signal_emit_by_name (self, "altered", FALSE, FALSE);
#line 468 "CommandManager.c"
}


#line 102 "CommandManager.vala"
void command_manager_execute (CommandManager* self, Command* command) {
#line 474 "CommandManager.c"
	Command* top_command;
#line 102 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND_MANAGER (self));
#line 102 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND (command));
#line 104 "CommandManager.vala"
	command_internal_set_command_manager (command, self);
#line 107 "CommandManager.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->redo_stack));
#line 110 "CommandManager.vala"
	top_command = command_manager_top (self, self->priv->undo_stack);
#line 111 "CommandManager.vala"
	if (top_command != NULL) {
#line 112 "CommandManager.vala"
		if (command_compress (top_command, command)) {
#line 490 "CommandManager.c"
			_g_object_unref0 (top_command);
#line 113 "CommandManager.vala"
			return;
#line 494 "CommandManager.c"
		}
	}
#line 117 "CommandManager.vala"
	command_manager_push (self, self->priv->undo_stack, command);
#line 119 "CommandManager.vala"
	command_prepare (command);
#line 120 "CommandManager.vala"
	command_execute (command);
#line 123 "CommandManager.vala"
	g_signal_emit_by_name (self, "altered", command_manager_can_undo (self), command_manager_can_redo (self));
#line 505 "CommandManager.c"
	_g_object_unref0 (top_command);
}


#line 126 "CommandManager.vala"
gboolean command_manager_can_undo (CommandManager* self) {
#line 512 "CommandManager.c"
	gboolean result = FALSE;
#line 126 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND_MANAGER (self), FALSE);
#line 516 "CommandManager.c"
	result = gee_collection_get_size (GEE_COLLECTION (self->priv->undo_stack)) > 0;
#line 127 "CommandManager.vala"
	return result;
#line 520 "CommandManager.c"
}


#line 130 "CommandManager.vala"
CommandDescription* command_manager_get_undo_description (CommandManager* self) {
#line 526 "CommandManager.c"
	CommandDescription* result = NULL;
#line 130 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND_MANAGER (self), NULL);
#line 530 "CommandManager.c"
	result = COMMAND_DESCRIPTION (command_manager_top (self, self->priv->undo_stack));
#line 131 "CommandManager.vala"
	return result;
#line 534 "CommandManager.c"
}


#line 134 "CommandManager.vala"
gboolean command_manager_undo (CommandManager* self) {
#line 540 "CommandManager.c"
	gboolean result = FALSE;
	Command* command;
#line 134 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND_MANAGER (self), FALSE);
#line 135 "CommandManager.vala"
	command = command_manager_pop (self, self->priv->undo_stack);
#line 136 "CommandManager.vala"
	if (command == NULL) {
#line 549 "CommandManager.c"
		result = FALSE;
		_g_object_unref0 (command);
#line 137 "CommandManager.vala"
		return result;
#line 554 "CommandManager.c"
	}
#line 140 "CommandManager.vala"
	command_manager_push (self, self->priv->redo_stack, command);
#line 143 "CommandManager.vala"
	command_prepare (command);
#line 144 "CommandManager.vala"
	command_undo (command);
#line 147 "CommandManager.vala"
	g_signal_emit_by_name (self, "altered", command_manager_can_undo (self), command_manager_can_redo (self));
#line 564 "CommandManager.c"
	result = TRUE;
	_g_object_unref0 (command);
#line 149 "CommandManager.vala"
	return result;
#line 569 "CommandManager.c"
}


#line 152 "CommandManager.vala"
gboolean command_manager_can_redo (CommandManager* self) {
#line 575 "CommandManager.c"
	gboolean result = FALSE;
#line 152 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND_MANAGER (self), FALSE);
#line 579 "CommandManager.c"
	result = gee_collection_get_size (GEE_COLLECTION (self->priv->redo_stack)) > 0;
#line 153 "CommandManager.vala"
	return result;
#line 583 "CommandManager.c"
}


#line 156 "CommandManager.vala"
CommandDescription* command_manager_get_redo_description (CommandManager* self) {
#line 589 "CommandManager.c"
	CommandDescription* result = NULL;
#line 156 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND_MANAGER (self), NULL);
#line 593 "CommandManager.c"
	result = COMMAND_DESCRIPTION (command_manager_top (self, self->priv->redo_stack));
#line 157 "CommandManager.vala"
	return result;
#line 597 "CommandManager.c"
}


#line 160 "CommandManager.vala"
gboolean command_manager_redo (CommandManager* self) {
#line 603 "CommandManager.c"
	gboolean result = FALSE;
	Command* command;
#line 160 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND_MANAGER (self), FALSE);
#line 161 "CommandManager.vala"
	command = command_manager_pop (self, self->priv->redo_stack);
#line 162 "CommandManager.vala"
	if (command == NULL) {
#line 612 "CommandManager.c"
		result = FALSE;
		_g_object_unref0 (command);
#line 163 "CommandManager.vala"
		return result;
#line 617 "CommandManager.c"
	}
#line 166 "CommandManager.vala"
	command_manager_push (self, self->priv->undo_stack, command);
#line 169 "CommandManager.vala"
	command_prepare (command);
#line 170 "CommandManager.vala"
	command_redo (command);
#line 173 "CommandManager.vala"
	g_signal_emit_by_name (self, "altered", command_manager_can_undo (self), command_manager_can_redo (self));
#line 627 "CommandManager.c"
	result = TRUE;
	_g_object_unref0 (command);
#line 175 "CommandManager.vala"
	return result;
#line 632 "CommandManager.c"
}


#line 178 "CommandManager.vala"
static Command* command_manager_top (CommandManager* self, GeeArrayList* stack) {
#line 638 "CommandManager.c"
	Command* result = NULL;
	Command* _tmp0_;
#line 178 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND_MANAGER (self), NULL);
#line 178 "CommandManager.vala"
	g_return_val_if_fail (GEE_IS_ARRAY_LIST (stack), NULL);
#line 645 "CommandManager.c"
	_tmp0_ = NULL;
#line 179 "CommandManager.vala"
	if (gee_collection_get_size (GEE_COLLECTION (stack)) > 0) {
#line 649 "CommandManager.c"
		Command* _tmp1_;
#line 179 "CommandManager.vala"
		_tmp0_ = (_tmp1_ = (Command*) gee_abstract_list_get (GEE_ABSTRACT_LIST (stack), gee_collection_get_size (GEE_COLLECTION (stack)) - 1), _g_object_unref0 (_tmp0_), _tmp1_);
#line 653 "CommandManager.c"
	} else {
		Command* _tmp2_;
#line 179 "CommandManager.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 658 "CommandManager.c"
	}
	result = _tmp0_;
#line 179 "CommandManager.vala"
	return result;
#line 663 "CommandManager.c"
}


#line 182 "CommandManager.vala"
static void command_manager_push (CommandManager* self, GeeArrayList* stack, Command* command) {
#line 182 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND_MANAGER (self));
#line 182 "CommandManager.vala"
	g_return_if_fail (GEE_IS_ARRAY_LIST (stack));
#line 182 "CommandManager.vala"
	g_return_if_fail (IS_COMMAND (command));
#line 183 "CommandManager.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (stack), command);
#line 186 "CommandManager.vala"
	while (TRUE) {
#line 679 "CommandManager.c"
		Command* _tmp0_;
#line 186 "CommandManager.vala"
		if (!(gee_collection_get_size (GEE_COLLECTION (stack)) >= self->priv->depth)) {
#line 186 "CommandManager.vala"
			break;
#line 685 "CommandManager.c"
		}
#line 187 "CommandManager.vala"
		_tmp0_ = (Command*) gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (stack), 0);
#line 689 "CommandManager.c"
		_g_object_unref0 (_tmp0_);
	}
}


#line 190 "CommandManager.vala"
static Command* command_manager_pop (CommandManager* self, GeeArrayList* stack) {
#line 697 "CommandManager.c"
	Command* result = NULL;
	Command* command;
	gboolean removed;
#line 190 "CommandManager.vala"
	g_return_val_if_fail (IS_COMMAND_MANAGER (self), NULL);
#line 190 "CommandManager.vala"
	g_return_val_if_fail (GEE_IS_ARRAY_LIST (stack), NULL);
#line 191 "CommandManager.vala"
	if (gee_collection_get_size (GEE_COLLECTION (stack)) <= 0) {
#line 707 "CommandManager.c"
		result = NULL;
#line 192 "CommandManager.vala"
		return result;
#line 711 "CommandManager.c"
	}
#line 194 "CommandManager.vala"
	command = (Command*) gee_abstract_list_get (GEE_ABSTRACT_LIST (stack), gee_collection_get_size (GEE_COLLECTION (stack)) - 1);
#line 195 "CommandManager.vala"
	removed = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (stack), command);
#line 196 "CommandManager.vala"
	g_assert (removed);
#line 719 "CommandManager.c"
	result = command;
#line 198 "CommandManager.vala"
	return result;
#line 723 "CommandManager.c"
}


static void value_command_manager_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_command_manager_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		command_manager_unref (value->data[0].v_pointer);
	}
}


static void value_command_manager_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = command_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_command_manager_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_command_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		CommandManager* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = command_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_command_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	CommandManager** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = command_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_command_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecCommandManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_COMMAND_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_command_manager (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMMAND_MANAGER), NULL);
	return value->data[0].v_pointer;
}


void value_set_command_manager (GValue* value, gpointer v_object) {
	CommandManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMMAND_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_COMMAND_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		command_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		command_manager_unref (old);
	}
}


void value_take_command_manager (GValue* value, gpointer v_object) {
	CommandManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMMAND_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_COMMAND_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		command_manager_unref (old);
	}
}


static void command_manager_class_init (CommandManagerClass * klass) {
	command_manager_parent_class = g_type_class_peek_parent (klass);
	COMMAND_MANAGER_CLASS (klass)->finalize = command_manager_finalize;
	g_type_class_add_private (klass, sizeof (CommandManagerPrivate));
	g_signal_new ("altered", TYPE_COMMAND_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
}


static void command_manager_instance_init (CommandManager * self) {
	self->priv = COMMAND_MANAGER_GET_PRIVATE (self);
	self->priv->undo_stack = gee_array_list_new (TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->priv->redo_stack = gee_array_list_new (TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->ref_count = 1;
}


static void command_manager_finalize (CommandManager* obj) {
	CommandManager * self;
	self = COMMAND_MANAGER (obj);
	_g_object_unref0 (self->priv->undo_stack);
	_g_object_unref0 (self->priv->redo_stack);
}


GType command_manager_get_type (void) {
	static volatile gsize command_manager_type_id__volatile = 0;
	if (g_once_init_enter (&command_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_command_manager_init, value_command_manager_free_value, value_command_manager_copy_value, value_command_manager_peek_pointer, "p", value_command_manager_collect_value, "p", value_command_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (CommandManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) command_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CommandManager), 0, (GInstanceInitFunc) command_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType command_manager_type_id;
		command_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CommandManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&command_manager_type_id__volatile, command_manager_type_id);
	}
	return command_manager_type_id__volatile;
}


gpointer command_manager_ref (gpointer instance) {
	CommandManager* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void command_manager_unref (gpointer instance) {
	CommandManager* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		COMMAND_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



static void g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (gpointer data1, gboolean arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}



