/* Config.c generated by valac, the Vala compiler
 * generated from Config.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gconf/gconf-client.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gconf/gconf.h>
#include <gobject/gvaluecollector.h>


#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
typedef struct _ConfigPrivate ConfigPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))
#define _gconf_value_free0(var) ((var == NULL) ? NULL : (var = (gconf_value_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define COLLECTION_PAGE_TYPE_SORT_BY (collection_page_sort_by_get_type ())
typedef struct _ParamSpecConfig ParamSpecConfig;

struct _Config {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ConfigPrivate * priv;
};

struct _ConfigClass {
	GTypeClass parent_class;
	void (*finalize) (Config *self);
};

struct _ConfigPrivate {
	GConfClient* client;
};

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	COLLECTION_PAGE_SORT_BY_TITLE = 1,
	COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE = 2
} CollectionPageSortBy;

struct _ParamSpecConfig {
	GParamSpec parent_instance;
};


static Config* config_instance;
static Config* config_instance = NULL;
static gpointer config_parent_class = NULL;

gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
void value_take_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void);
#define CONFIG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CONFIG, ConfigPrivate))
enum  {
	CONFIG_DUMMY_PROPERTY
};
#define CONFIG_SLIDESHOW_DELAY_MAX 30.0
#define CONFIG_SLIDESHOW_DELAY_MIN 1.0
#define CONFIG_SLIDESHOW_DELAY_DEFAULT 5.0
#define CONFIG_WIDTH_DEFAULT 1024
#define CONFIG_HEIGHT_DEFAULT 768
#define CONFIG_SIDEBAR_MIN_POSITION 180
#define CONFIG_SIDEBAR_MAX_POSITION 1000
static Config* config_new (void);
static Config* config_construct (GType object_type);
Config* config_get_instance (void);
static void config_report_get_error (Config* self, const char* path, GError* err);
static void config_report_set_error (Config* self, const char* path, GError* err);
static gboolean config_get_bool (Config* self, const char* path, gboolean def);
static gboolean config_set_bool (Config* self, const char* path, gboolean value);
static gint config_get_int (Config* self, const char* path, gint def);
static gboolean config_set_int (Config* self, const char* path, gint value);
static double config_get_double (Config* self, const char* path, double def);
static gboolean config_set_double (Config* self, const char* path, double value);
gboolean is_string_empty (const char* s);
static char* config_get_string (Config* self, const char* path, const char* def);
static gboolean config_set_string (Config* self, const char* path, const char* value);
gboolean config_set_flickr_auth_token (Config* self, const char* token);
gboolean config_clear_flickr_auth_token (Config* self);
char* config_get_flickr_auth_token (Config* self);
gboolean config_set_flickr_username (Config* self, const char* username);
gboolean config_clear_flickr_username (Config* self);
char* config_get_flickr_username (Config* self);
gboolean config_set_flickr_default_size (Config* self, gint sizecode);
gint config_get_flickr_default_size (Config* self);
gboolean config_set_flickr_visibility (Config* self, gint viscode);
gint config_get_flickr_visibility (Config* self);
gboolean config_set_default_service (Config* self, gint service_code);
gint config_get_default_service (Config* self);
gboolean config_set_facebook_session_key (Config* self, const char* key);
gboolean config_clear_facebook_session_key (Config* self);
char* config_get_facebook_session_key (Config* self);
gboolean config_set_facebook_session_secret (Config* self, const char* secret);
gboolean config_clear_facebook_session_secret (Config* self);
char* config_get_facebook_session_secret (Config* self);
gboolean config_set_facebook_uid (Config* self, const char* uid);
gboolean config_clear_facebook_uid (Config* self);
char* config_get_facebook_uid (Config* self);
gboolean config_set_facebook_user_name (Config* self, const char* user_name);
gboolean config_clear_facebook_user_name (Config* self);
char* config_get_facebook_user_name (Config* self);
gboolean config_set_picasa_user_name (Config* self, const char* user_name);
char* config_get_picasa_user_name (Config* self);
gboolean config_set_picasa_auth_token (Config* self, const char* auth_token);
gboolean config_set_picasa_default_size (Config* self, gint default_size);
gint config_get_picasa_default_size (Config* self);
char* config_get_picasa_auth_token (Config* self);
gboolean config_set_printing_content_layout (Config* self, gint layout_code);
gint config_get_printing_content_layout (Config* self);
gboolean config_set_printing_content_ppi (Config* self, gint content_ppi);
gint config_get_printing_content_ppi (Config* self);
gboolean config_set_printing_content_width (Config* self, double content_width);
double config_get_printing_content_width (Config* self);
gboolean config_set_printing_content_height (Config* self, double content_height);
double config_get_printing_content_height (Config* self);
gboolean config_set_printing_content_units (Config* self, gint units_code);
gint config_get_printing_content_units (Config* self);
gboolean config_set_printing_size_selection (Config* self, gint size_code);
gint config_get_printing_size_selection (Config* self);
gboolean config_set_printing_match_aspect_ratio (Config* self, gboolean match_aspect_ratio);
gboolean config_get_printing_match_aspect_ratio (Config* self);
gboolean config_set_display_basic_properties (Config* self, gboolean display);
gboolean config_get_display_basic_properties (Config* self);
gboolean config_set_display_extended_properties (Config* self, gboolean display);
gboolean config_get_display_extended_properties (Config* self);
gboolean config_set_display_photo_titles (Config* self, gboolean display);
gboolean config_get_display_photo_titles (Config* self);
gboolean config_get_display_photo_tags (Config* self);
gboolean config_set_display_photo_tags (Config* self, gboolean display);
gboolean config_set_slideshow_delay (Config* self, double delay);
double config_get_slideshow_delay (Config* self);
gboolean config_get_display_favorite_photos (Config* self);
gboolean config_set_display_favorite_photos (Config* self, gboolean display);
gboolean config_get_display_hidden_photos (Config* self);
gboolean config_set_display_hidden_photos (Config* self, gboolean display);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void config_get_library_window_state (Config* self, gboolean* maximize, Dimensions* dimensions);
gboolean config_set_library_window_state (Config* self, gboolean maximize, Dimensions* dimensions);
void config_get_direct_window_state (Config* self, gboolean* maximize, Dimensions* dimensions);
gboolean config_set_direct_window_state (Config* self, gboolean maximize, Dimensions* dimensions);
gint config_get_sidebar_position (Config* self);
gboolean config_set_sidebar_position (Config* self, gint position);
gboolean config_get_events_sort_ascending (Config* self);
gboolean config_set_events_sort_ascending (Config* self, gboolean sort);
GType collection_page_sort_by_get_type (void);
void config_get_library_photos_sort (Config* self, gboolean* sort_order, gint* sort_by);
gboolean config_set_library_photos_sort (Config* self, gboolean sort_order, gint sort_by);
void config_get_event_photos_sort (Config* self, gboolean* sort_order, gint* sort_by);
gboolean config_set_event_photos_sort (Config* self, gboolean sort_order, gint sort_by);
gboolean config_get_24_hr_time (Config* self);
gboolean config_set_24_hr_time (Config* self, gboolean twentyfour_hr_time);
gboolean config_get_keep_relativity (Config* self);
gboolean config_set_keep_relativity (Config* self, gboolean keep_relativity);
gboolean config_get_modify_originals (Config* self);
gboolean config_set_modify_originals (Config* self, gboolean modify_originals);
char* config_get_background (Config* self);
gboolean config_set_background (Config* self, const char* filename);
gboolean config_get_show_welcome_dialog (Config* self);
gboolean config_set_show_welcome_dialog (Config* self, gboolean show);
static void config_finalize (Config* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 20 "Config.vala"
static Config* config_construct (GType object_type) {
#line 207 "Config.c"
	Config* self;
	GConfClient* _tmp0_;
	self = (Config*) g_type_create_instance (object_type);
#line 22 "Config.vala"
	g_assert (config_instance == NULL);
#line 24 "Config.vala"
	self->priv->client = (_tmp0_ = _g_object_ref0 (gconf_client_get_default ()), _g_object_unref0 (self->priv->client), _tmp0_);
#line 25 "Config.vala"
	g_assert (self->priv->client != NULL);
#line 217 "Config.c"
	return self;
}


#line 20 "Config.vala"
static Config* config_new (void) {
#line 20 "Config.vala"
	return config_construct (TYPE_CONFIG);
#line 226 "Config.c"
}


static gpointer _config_ref0 (gpointer self) {
	return self ? config_ref (self) : NULL;
}


#line 28 "Config.vala"
Config* config_get_instance (void) {
#line 237 "Config.c"
	Config* result = NULL;
#line 29 "Config.vala"
	if (config_instance == NULL) {
#line 241 "Config.c"
		Config* _tmp0_;
#line 30 "Config.vala"
		config_instance = (_tmp0_ = config_new (), _config_unref0 (config_instance), _tmp0_);
#line 245 "Config.c"
	}
	result = _config_ref0 (config_instance);
#line 32 "Config.vala"
	return result;
#line 250 "Config.c"
}


#line 35 "Config.vala"
static void config_report_get_error (Config* self, const char* path, GError* err) {
#line 35 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 35 "Config.vala"
	g_return_if_fail (path != NULL);
#line 36 "Config.vala"
	g_warning ("Config.vala:36: Unable to get GConf value at %s: %s", path, err->message);
#line 262 "Config.c"
}


#line 39 "Config.vala"
static void config_report_set_error (Config* self, const char* path, GError* err) {
#line 39 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 39 "Config.vala"
	g_return_if_fail (path != NULL);
#line 40 "Config.vala"
	g_warning ("Config.vala:40: Unable to set GConf value at %s: %s", path, err->message);
#line 274 "Config.c"
}


#line 43 "Config.vala"
static gboolean config_get_bool (Config* self, const char* path, gboolean def) {
#line 280 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_;
#line 43 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 43 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 287 "Config.c"
	_inner_error_ = NULL;
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 45 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 296 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch124_g_error;
		}
#line 45 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 302 "Config.c"
			result = def;
#line 46 "Config.vala"
			return result;
#line 306 "Config.c"
		}
#line 48 "Config.vala"
		_tmp3_ = gconf_client_get_bool (self->priv->client, path, &_inner_error_);
#line 310 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch124_g_error;
		}
		result = _tmp3_;
#line 48 "Config.vala"
		return result;
#line 317 "Config.c"
	}
	goto __finally124;
	__catch124_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 50 "Config.vala"
			config_report_get_error (self, path, err);
#line 328 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 52 "Config.vala"
			return result;
#line 333 "Config.c"
		}
	}
	__finally124:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 56 "Config.vala"
static gboolean config_set_bool (Config* self, const char* path, gboolean value) {
#line 347 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_;
#line 56 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 56 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 354 "Config.c"
	_inner_error_ = NULL;
	{
#line 58 "Config.vala"
		gconf_client_set_bool (self->priv->client, path, value, &_inner_error_);
#line 359 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch125_g_error;
		}
		result = TRUE;
#line 60 "Config.vala"
		return result;
#line 366 "Config.c"
	}
	goto __finally125;
	__catch125_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 62 "Config.vala"
			config_report_set_error (self, path, err);
#line 377 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 64 "Config.vala"
			return result;
#line 382 "Config.c"
		}
	}
	__finally125:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 68 "Config.vala"
static gint config_get_int (Config* self, const char* path, gint def) {
#line 396 "Config.c"
	gint result = 0;
	GError * _inner_error_;
#line 68 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 68 "Config.vala"
	g_return_val_if_fail (path != NULL, 0);
#line 403 "Config.c"
	_inner_error_ = NULL;
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		gint value;
		gint _tmp3_ = 0;
#line 70 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 413 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch126_g_error;
		}
#line 70 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 419 "Config.c"
			result = def;
#line 71 "Config.vala"
			return result;
#line 423 "Config.c"
		}
#line 73 "Config.vala"
		value = gconf_client_get_int (self->priv->client, path, &_inner_error_);
#line 427 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch126_g_error;
		}
#line 75 "Config.vala"
		if (value != 0.0) {
#line 75 "Config.vala"
			_tmp3_ = value;
#line 435 "Config.c"
		} else {
#line 75 "Config.vala"
			_tmp3_ = def;
#line 439 "Config.c"
		}
		result = _tmp3_;
#line 75 "Config.vala"
		return result;
#line 444 "Config.c"
	}
	goto __finally126;
	__catch126_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 77 "Config.vala"
			config_report_get_error (self, path, err);
#line 455 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 79 "Config.vala"
			return result;
#line 460 "Config.c"
		}
	}
	__finally126:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
}


#line 83 "Config.vala"
static gboolean config_set_int (Config* self, const char* path, gint value) {
#line 474 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_;
#line 83 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 83 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 481 "Config.c"
	_inner_error_ = NULL;
	{
#line 85 "Config.vala"
		gconf_client_set_int (self->priv->client, path, value, &_inner_error_);
#line 486 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch127_g_error;
		}
		result = TRUE;
#line 87 "Config.vala"
		return result;
#line 493 "Config.c"
	}
	goto __finally127;
	__catch127_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 89 "Config.vala"
			config_report_set_error (self, path, err);
#line 504 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 91 "Config.vala"
			return result;
#line 509 "Config.c"
		}
	}
	__finally127:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 95 "Config.vala"
static double config_get_double (Config* self, const char* path, double def) {
#line 523 "Config.c"
	double result = 0.0;
	GError * _inner_error_;
#line 95 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 95 "Config.vala"
	g_return_val_if_fail (path != NULL, 0.0);
#line 530 "Config.c"
	_inner_error_ = NULL;
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		double value;
		double _tmp3_ = 0.0;
#line 97 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 540 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch128_g_error;
		}
#line 97 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 546 "Config.c"
			result = def;
#line 98 "Config.vala"
			return result;
#line 550 "Config.c"
		}
#line 100 "Config.vala"
		value = gconf_client_get_float (self->priv->client, path, &_inner_error_);
#line 554 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch128_g_error;
		}
#line 102 "Config.vala"
		if (value != 0.0) {
#line 102 "Config.vala"
			_tmp3_ = value;
#line 562 "Config.c"
		} else {
#line 102 "Config.vala"
			_tmp3_ = def;
#line 566 "Config.c"
		}
		result = _tmp3_;
#line 102 "Config.vala"
		return result;
#line 571 "Config.c"
	}
	goto __finally128;
	__catch128_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 104 "Config.vala"
			config_report_get_error (self, path, err);
#line 582 "Config.c"
			result = def;
			_g_error_free0 (err);
#line 106 "Config.vala"
			return result;
#line 587 "Config.c"
		}
	}
	__finally128:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0.0;
	}
}


#line 110 "Config.vala"
static gboolean config_set_double (Config* self, const char* path, double value) {
#line 601 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_;
#line 110 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 110 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 608 "Config.c"
	_inner_error_ = NULL;
	{
#line 112 "Config.vala"
		gconf_client_set_float (self->priv->client, path, value, &_inner_error_);
#line 613 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch129_g_error;
		}
		result = TRUE;
#line 114 "Config.vala"
		return result;
#line 620 "Config.c"
	}
	goto __finally129;
	__catch129_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 116 "Config.vala"
			config_report_set_error (self, path, err);
#line 631 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 118 "Config.vala"
			return result;
#line 636 "Config.c"
		}
	}
	__finally129:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 122 "Config.vala"
static char* config_get_string (Config* self, const char* path, const char* def) {
#line 650 "Config.c"
	char* result = NULL;
	GError * _inner_error_;
#line 122 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 122 "Config.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 657 "Config.c"
	_inner_error_ = NULL;
	{
		GConfValue* _tmp0_;
		GConfValue* _tmp1_;
		gboolean _tmp2_;
		char* stored;
		const char* _tmp3_;
#line 124 "Config.vala"
		_tmp0_ = gconf_client_get (self->priv->client, path, &_inner_error_);
#line 667 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch130_g_error;
		}
#line 124 "Config.vala"
		if ((_tmp2_ = (_tmp1_ = _tmp0_) == NULL, _gconf_value_free0 (_tmp1_), _tmp2_)) {
#line 673 "Config.c"
			result = g_strdup (def);
#line 125 "Config.vala"
			return result;
#line 677 "Config.c"
		}
#line 127 "Config.vala"
		stored = gconf_client_get_string (self->priv->client, path, &_inner_error_);
#line 681 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch130_g_error;
		}
		_tmp3_ = NULL;
#line 129 "Config.vala"
		if (is_string_empty (stored)) {
#line 129 "Config.vala"
			_tmp3_ = NULL;
#line 690 "Config.c"
		} else {
#line 129 "Config.vala"
			_tmp3_ = stored;
#line 694 "Config.c"
		}
		result = g_strdup (_tmp3_);
		_g_free0 (stored);
#line 129 "Config.vala"
		return result;
#line 700 "Config.c"
	}
	goto __finally130;
	__catch130_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 131 "Config.vala"
			config_report_get_error (self, path, err);
#line 711 "Config.c"
			result = g_strdup (def);
			_g_error_free0 (err);
#line 133 "Config.vala"
			return result;
#line 716 "Config.c"
		}
	}
	__finally130:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 137 "Config.vala"
static gboolean config_set_string (Config* self, const char* path, const char* value) {
#line 730 "Config.c"
	gboolean result = FALSE;
	GError * _inner_error_;
#line 137 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 137 "Config.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 137 "Config.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 739 "Config.c"
	_inner_error_ = NULL;
	{
#line 139 "Config.vala"
		gconf_client_set_string (self->priv->client, path, value, &_inner_error_);
#line 744 "Config.c"
		if (_inner_error_ != NULL) {
			goto __catch131_g_error;
		}
		result = TRUE;
#line 141 "Config.vala"
		return result;
#line 751 "Config.c"
	}
	goto __finally131;
	__catch131_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 143 "Config.vala"
			config_report_set_error (self, path, err);
#line 762 "Config.c"
			result = FALSE;
			_g_error_free0 (err);
#line 145 "Config.vala"
			return result;
#line 767 "Config.c"
		}
	}
	__finally131:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 149 "Config.vala"
gboolean config_clear_flickr_auth_token (Config* self) {
#line 781 "Config.c"
	gboolean result = FALSE;
#line 149 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 785 "Config.c"
	result = config_set_flickr_auth_token (self, "");
#line 150 "Config.vala"
	return result;
#line 789 "Config.c"
}


#line 153 "Config.vala"
gboolean config_set_flickr_auth_token (Config* self, const char* token) {
#line 795 "Config.c"
	gboolean result = FALSE;
#line 153 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 153 "Config.vala"
	g_return_val_if_fail (token != NULL, FALSE);
#line 801 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/flickr/auth_token", token);
#line 154 "Config.vala"
	return result;
#line 805 "Config.c"
}


#line 157 "Config.vala"
char* config_get_flickr_auth_token (Config* self) {
#line 811 "Config.c"
	char* result = NULL;
	char* stored_value;
	const char* _tmp0_;
#line 157 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 158 "Config.vala"
	stored_value = config_get_string (self, "/apps/shotwell/sharing/flickr/auth_token", NULL);
#line 819 "Config.c"
	_tmp0_ = NULL;
#line 159 "Config.vala"
	if (_vala_strcmp0 (stored_value, "") != 0) {
#line 159 "Config.vala"
		_tmp0_ = stored_value;
#line 825 "Config.c"
	} else {
#line 159 "Config.vala"
		_tmp0_ = NULL;
#line 829 "Config.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (stored_value);
#line 159 "Config.vala"
	return result;
#line 835 "Config.c"
}


#line 162 "Config.vala"
gboolean config_clear_flickr_username (Config* self) {
#line 841 "Config.c"
	gboolean result = FALSE;
#line 162 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 845 "Config.c"
	result = config_set_flickr_username (self, "");
#line 163 "Config.vala"
	return result;
#line 849 "Config.c"
}


#line 166 "Config.vala"
gboolean config_set_flickr_username (Config* self, const char* username) {
#line 855 "Config.c"
	gboolean result = FALSE;
#line 166 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 166 "Config.vala"
	g_return_val_if_fail (username != NULL, FALSE);
#line 861 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/flickr/username", username);
#line 167 "Config.vala"
	return result;
#line 865 "Config.c"
}


#line 170 "Config.vala"
char* config_get_flickr_username (Config* self) {
#line 871 "Config.c"
	char* result = NULL;
	char* stored_value;
	const char* _tmp0_;
#line 170 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 171 "Config.vala"
	stored_value = config_get_string (self, "/apps/shotwell/sharing/flickr/username", NULL);
#line 879 "Config.c"
	_tmp0_ = NULL;
#line 172 "Config.vala"
	if (_vala_strcmp0 (stored_value, "") != 0) {
#line 172 "Config.vala"
		_tmp0_ = stored_value;
#line 885 "Config.c"
	} else {
#line 172 "Config.vala"
		_tmp0_ = NULL;
#line 889 "Config.c"
	}
	result = g_strdup (_tmp0_);
	_g_free0 (stored_value);
#line 172 "Config.vala"
	return result;
#line 895 "Config.c"
}


#line 175 "Config.vala"
gboolean config_set_flickr_default_size (Config* self, gint sizecode) {
#line 901 "Config.c"
	gboolean result = FALSE;
#line 175 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 905 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/flickr/default_size", sizecode + 1);
#line 176 "Config.vala"
	return result;
#line 909 "Config.c"
}


#line 179 "Config.vala"
gint config_get_flickr_default_size (Config* self) {
#line 915 "Config.c"
	gint result = 0;
#line 179 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 919 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/flickr/default_size", 2) - 1;
#line 180 "Config.vala"
	return result;
#line 923 "Config.c"
}


#line 183 "Config.vala"
gboolean config_set_flickr_visibility (Config* self, gint viscode) {
#line 929 "Config.c"
	gboolean result = FALSE;
#line 183 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 933 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/flickr/visibility", viscode + 1);
#line 184 "Config.vala"
	return result;
#line 937 "Config.c"
}


#line 187 "Config.vala"
gint config_get_flickr_visibility (Config* self) {
#line 943 "Config.c"
	gint result = 0;
#line 187 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 947 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/flickr/visibility", 1) - 1;
#line 188 "Config.vala"
	return result;
#line 951 "Config.c"
}


#line 191 "Config.vala"
gboolean config_set_default_service (Config* self, gint service_code) {
#line 957 "Config.c"
	gboolean result = FALSE;
#line 191 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 961 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/default_service", service_code + 1);
#line 192 "Config.vala"
	return result;
#line 965 "Config.c"
}


#line 195 "Config.vala"
gint config_get_default_service (Config* self) {
#line 971 "Config.c"
	gint result = 0;
#line 195 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 975 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/default_service", 1) - 1;
#line 196 "Config.vala"
	return result;
#line 979 "Config.c"
}


#line 199 "Config.vala"
gboolean config_clear_facebook_session_key (Config* self) {
#line 985 "Config.c"
	gboolean result = FALSE;
#line 199 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 989 "Config.c"
	result = config_set_facebook_session_key (self, "");
#line 200 "Config.vala"
	return result;
#line 993 "Config.c"
}


#line 203 "Config.vala"
gboolean config_set_facebook_session_key (Config* self, const char* key) {
#line 999 "Config.c"
	gboolean result = FALSE;
#line 203 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 203 "Config.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 1005 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/session_key", key);
#line 204 "Config.vala"
	return result;
#line 1009 "Config.c"
}


#line 207 "Config.vala"
char* config_get_facebook_session_key (Config* self) {
#line 1015 "Config.c"
	char* result = NULL;
#line 207 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1019 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/session_key", NULL);
#line 208 "Config.vala"
	return result;
#line 1023 "Config.c"
}


#line 211 "Config.vala"
gboolean config_clear_facebook_session_secret (Config* self) {
#line 1029 "Config.c"
	gboolean result = FALSE;
#line 211 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1033 "Config.c"
	result = config_set_facebook_session_secret (self, "");
#line 212 "Config.vala"
	return result;
#line 1037 "Config.c"
}


#line 215 "Config.vala"
gboolean config_set_facebook_session_secret (Config* self, const char* secret) {
#line 1043 "Config.c"
	gboolean result = FALSE;
#line 215 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 215 "Config.vala"
	g_return_val_if_fail (secret != NULL, FALSE);
#line 1049 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/session_secret", secret);
#line 216 "Config.vala"
	return result;
#line 1053 "Config.c"
}


#line 219 "Config.vala"
char* config_get_facebook_session_secret (Config* self) {
#line 1059 "Config.c"
	char* result = NULL;
#line 219 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1063 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/session_secret", NULL);
#line 220 "Config.vala"
	return result;
#line 1067 "Config.c"
}


#line 223 "Config.vala"
gboolean config_clear_facebook_uid (Config* self) {
#line 1073 "Config.c"
	gboolean result = FALSE;
#line 223 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1077 "Config.c"
	result = config_set_facebook_uid (self, "");
#line 224 "Config.vala"
	return result;
#line 1081 "Config.c"
}


#line 227 "Config.vala"
gboolean config_set_facebook_uid (Config* self, const char* uid) {
#line 1087 "Config.c"
	gboolean result = FALSE;
#line 227 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 227 "Config.vala"
	g_return_val_if_fail (uid != NULL, FALSE);
#line 1093 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/uid", uid);
#line 228 "Config.vala"
	return result;
#line 1097 "Config.c"
}


#line 231 "Config.vala"
char* config_get_facebook_uid (Config* self) {
#line 1103 "Config.c"
	char* result = NULL;
#line 231 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1107 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/uid", NULL);
#line 232 "Config.vala"
	return result;
#line 1111 "Config.c"
}


#line 235 "Config.vala"
gboolean config_clear_facebook_user_name (Config* self) {
#line 1117 "Config.c"
	gboolean result = FALSE;
#line 235 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1121 "Config.c"
	result = config_set_facebook_user_name (self, "");
#line 236 "Config.vala"
	return result;
#line 1125 "Config.c"
}


#line 239 "Config.vala"
gboolean config_set_facebook_user_name (Config* self, const char* user_name) {
#line 1131 "Config.c"
	gboolean result = FALSE;
#line 239 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 239 "Config.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 1137 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/facebook/user_name", user_name);
#line 240 "Config.vala"
	return result;
#line 1141 "Config.c"
}


#line 243 "Config.vala"
char* config_get_facebook_user_name (Config* self) {
#line 1147 "Config.c"
	char* result = NULL;
#line 243 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1151 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/facebook/user_name", NULL);
#line 244 "Config.vala"
	return result;
#line 1155 "Config.c"
}


#line 247 "Config.vala"
gboolean config_set_picasa_user_name (Config* self, const char* user_name) {
#line 1161 "Config.c"
	gboolean result = FALSE;
#line 247 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 247 "Config.vala"
	g_return_val_if_fail (user_name != NULL, FALSE);
#line 1167 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/picasa/user_name", user_name);
#line 248 "Config.vala"
	return result;
#line 1171 "Config.c"
}


#line 251 "Config.vala"
char* config_get_picasa_user_name (Config* self) {
#line 1177 "Config.c"
	char* result = NULL;
#line 251 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1181 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/picasa/user_name", NULL);
#line 252 "Config.vala"
	return result;
#line 1185 "Config.c"
}


#line 255 "Config.vala"
gboolean config_set_picasa_auth_token (Config* self, const char* auth_token) {
#line 1191 "Config.c"
	gboolean result = FALSE;
#line 255 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 255 "Config.vala"
	g_return_val_if_fail (auth_token != NULL, FALSE);
#line 1197 "Config.c"
	result = config_set_string (self, "/apps/shotwell/sharing/picasa/auth_token", auth_token);
#line 256 "Config.vala"
	return result;
#line 1201 "Config.c"
}


#line 259 "Config.vala"
gboolean config_set_picasa_default_size (Config* self, gint default_size) {
#line 1207 "Config.c"
	gboolean result = FALSE;
#line 259 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1211 "Config.c"
	result = config_set_int (self, "/apps/shotwell/sharing/picasa/default_size", default_size + 1);
#line 260 "Config.vala"
	return result;
#line 1215 "Config.c"
}


#line 263 "Config.vala"
gint config_get_picasa_default_size (Config* self) {
#line 1221 "Config.c"
	gint result = 0;
#line 263 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1225 "Config.c"
	result = config_get_int (self, "/apps/shotwell/sharing/picasa/default_size", 3) - 1;
#line 264 "Config.vala"
	return result;
#line 1229 "Config.c"
}


#line 267 "Config.vala"
char* config_get_picasa_auth_token (Config* self) {
#line 1235 "Config.c"
	char* result = NULL;
#line 267 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1239 "Config.c"
	result = config_get_string (self, "/apps/shotwell/sharing/picasa/auth_token", NULL);
#line 268 "Config.vala"
	return result;
#line 1243 "Config.c"
}


#line 271 "Config.vala"
gboolean config_set_printing_content_layout (Config* self, gint layout_code) {
#line 1249 "Config.c"
	gboolean result = FALSE;
#line 271 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1253 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_layout", layout_code + 1);
#line 272 "Config.vala"
	return result;
#line 1257 "Config.c"
}


#line 275 "Config.vala"
gint config_get_printing_content_layout (Config* self) {
#line 1263 "Config.c"
	gint result = 0;
#line 275 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1267 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_layout", 1) - 1;
#line 276 "Config.vala"
	return result;
#line 1271 "Config.c"
}


#line 279 "Config.vala"
gboolean config_set_printing_content_ppi (Config* self, gint content_ppi) {
#line 1277 "Config.c"
	gboolean result = FALSE;
#line 279 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1281 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_ppi", content_ppi);
#line 280 "Config.vala"
	return result;
#line 1285 "Config.c"
}


#line 283 "Config.vala"
gint config_get_printing_content_ppi (Config* self) {
#line 1291 "Config.c"
	gint result = 0;
#line 283 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1295 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_ppi", 600);
#line 284 "Config.vala"
	return result;
#line 1299 "Config.c"
}


#line 287 "Config.vala"
gboolean config_set_printing_content_width (Config* self, double content_width) {
#line 1305 "Config.c"
	gboolean result = FALSE;
#line 287 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1309 "Config.c"
	result = config_set_double (self, "/apps/shotwell/printing/content_width", content_width);
#line 288 "Config.vala"
	return result;
#line 1313 "Config.c"
}


#line 291 "Config.vala"
double config_get_printing_content_width (Config* self) {
#line 1319 "Config.c"
	double result = 0.0;
#line 291 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1323 "Config.c"
	result = config_get_double (self, "/apps/shotwell/printing/content_width", 7.0);
#line 292 "Config.vala"
	return result;
#line 1327 "Config.c"
}


#line 295 "Config.vala"
gboolean config_set_printing_content_height (Config* self, double content_height) {
#line 1333 "Config.c"
	gboolean result = FALSE;
#line 295 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1337 "Config.c"
	result = config_set_double (self, "/apps/shotwell/printing/content_height", content_height);
#line 296 "Config.vala"
	return result;
#line 1341 "Config.c"
}


#line 299 "Config.vala"
double config_get_printing_content_height (Config* self) {
#line 1347 "Config.c"
	double result = 0.0;
#line 299 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1351 "Config.c"
	result = config_get_double (self, "/apps/shotwell/printing/content_height", 5.0);
#line 300 "Config.vala"
	return result;
#line 1355 "Config.c"
}


#line 303 "Config.vala"
gboolean config_set_printing_content_units (Config* self, gint units_code) {
#line 1361 "Config.c"
	gboolean result = FALSE;
#line 303 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1365 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/content_units", units_code + 1);
#line 304 "Config.vala"
	return result;
#line 1369 "Config.c"
}


#line 307 "Config.vala"
gint config_get_printing_content_units (Config* self) {
#line 1375 "Config.c"
	gint result = 0;
#line 307 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1379 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/content_units", 1) - 1;
#line 308 "Config.vala"
	return result;
#line 1383 "Config.c"
}


#line 311 "Config.vala"
gboolean config_set_printing_size_selection (Config* self, gint size_code) {
#line 1389 "Config.c"
	gboolean result = FALSE;
#line 311 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1393 "Config.c"
	result = config_set_int (self, "/apps/shotwell/printing/size_selection", size_code + 1);
#line 312 "Config.vala"
	return result;
#line 1397 "Config.c"
}


#line 315 "Config.vala"
gint config_get_printing_size_selection (Config* self) {
#line 1403 "Config.c"
	gint result = 0;
#line 315 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1407 "Config.c"
	result = config_get_int (self, "/apps/shotwell/printing/size_selection", 1) - 1;
#line 316 "Config.vala"
	return result;
#line 1411 "Config.c"
}


#line 319 "Config.vala"
gboolean config_set_printing_match_aspect_ratio (Config* self, gboolean match_aspect_ratio) {
#line 1417 "Config.c"
	gboolean result = FALSE;
#line 319 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1421 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/printing/match_aspect_ratio", match_aspect_ratio);
#line 320 "Config.vala"
	return result;
#line 1425 "Config.c"
}


#line 323 "Config.vala"
gboolean config_get_printing_match_aspect_ratio (Config* self) {
#line 1431 "Config.c"
	gboolean result = FALSE;
#line 323 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1435 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/printing/match_aspect_ratio", TRUE);
#line 324 "Config.vala"
	return result;
#line 1439 "Config.c"
}


#line 327 "Config.vala"
gboolean config_set_display_basic_properties (Config* self, gboolean display) {
#line 1445 "Config.c"
	gboolean result = FALSE;
#line 327 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1449 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_basic_properties", display);
#line 328 "Config.vala"
	return result;
#line 1453 "Config.c"
}


#line 331 "Config.vala"
gboolean config_get_display_basic_properties (Config* self) {
#line 1459 "Config.c"
	gboolean result = FALSE;
#line 331 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1463 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_basic_properties", TRUE);
#line 332 "Config.vala"
	return result;
#line 1467 "Config.c"
}


#line 335 "Config.vala"
gboolean config_set_display_extended_properties (Config* self, gboolean display) {
#line 1473 "Config.c"
	gboolean result = FALSE;
#line 335 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1477 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_extended_properties", display);
#line 336 "Config.vala"
	return result;
#line 1481 "Config.c"
}


#line 339 "Config.vala"
gboolean config_get_display_extended_properties (Config* self) {
#line 1487 "Config.c"
	gboolean result = FALSE;
#line 339 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1491 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_extended_properties", FALSE);
#line 340 "Config.vala"
	return result;
#line 1495 "Config.c"
}


#line 343 "Config.vala"
gboolean config_set_display_photo_titles (Config* self, gboolean display) {
#line 1501 "Config.c"
	gboolean result = FALSE;
#line 343 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1505 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_titles", display);
#line 344 "Config.vala"
	return result;
#line 1509 "Config.c"
}


#line 347 "Config.vala"
gboolean config_get_display_photo_titles (Config* self) {
#line 1515 "Config.c"
	gboolean result = FALSE;
#line 347 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1519 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_titles", FALSE);
#line 348 "Config.vala"
	return result;
#line 1523 "Config.c"
}


#line 351 "Config.vala"
gboolean config_get_display_photo_tags (Config* self) {
#line 1529 "Config.c"
	gboolean result = FALSE;
#line 351 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1533 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_photo_tags", TRUE);
#line 352 "Config.vala"
	return result;
#line 1537 "Config.c"
}


#line 355 "Config.vala"
gboolean config_set_display_photo_tags (Config* self, gboolean display) {
#line 1543 "Config.c"
	gboolean result = FALSE;
#line 355 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1547 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_photo_tags", display);
#line 356 "Config.vala"
	return result;
#line 1551 "Config.c"
}


#line 359 "Config.vala"
gboolean config_set_slideshow_delay (Config* self, double delay) {
#line 1557 "Config.c"
	gboolean result = FALSE;
#line 359 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1561 "Config.c"
	result = config_set_double (self, "/apps/shotwell/preferences/slideshow/delay", delay);
#line 360 "Config.vala"
	return result;
#line 1565 "Config.c"
}


#line 363 "Config.vala"
double config_get_slideshow_delay (Config* self) {
#line 1571 "Config.c"
	double result = 0.0;
#line 363 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0.0);
#line 1575 "Config.c"
	result = CLAMP (config_get_double (self, "/apps/shotwell/preferences/slideshow/delay", CONFIG_SLIDESHOW_DELAY_DEFAULT), CONFIG_SLIDESHOW_DELAY_MIN, CONFIG_SLIDESHOW_DELAY_MAX);
#line 364 "Config.vala"
	return result;
#line 1579 "Config.c"
}


#line 368 "Config.vala"
gboolean config_get_display_favorite_photos (Config* self) {
#line 1585 "Config.c"
	gboolean result = FALSE;
#line 368 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1589 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_favorite_photos", FALSE);
#line 369 "Config.vala"
	return result;
#line 1593 "Config.c"
}


#line 372 "Config.vala"
gboolean config_set_display_favorite_photos (Config* self, gboolean display) {
#line 1599 "Config.c"
	gboolean result = FALSE;
#line 372 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1603 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_favorite_photos", display);
#line 373 "Config.vala"
	return result;
#line 1607 "Config.c"
}


#line 376 "Config.vala"
gboolean config_get_display_hidden_photos (Config* self) {
#line 1613 "Config.c"
	gboolean result = FALSE;
#line 376 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1617 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/display_hidden_photos", FALSE);
#line 377 "Config.vala"
	return result;
#line 1621 "Config.c"
}


#line 380 "Config.vala"
gboolean config_set_display_hidden_photos (Config* self, gboolean display) {
#line 1627 "Config.c"
	gboolean result = FALSE;
#line 380 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1631 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/display_hidden_photos", display);
#line 381 "Config.vala"
	return result;
#line 1635 "Config.c"
}


#line 384 "Config.vala"
void config_get_library_window_state (Config* self, gboolean* maximize, Dimensions* dimensions) {
#line 1641 "Config.c"
	Dimensions _tmp0_ = {0};
#line 384 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 385 "Config.vala"
	*maximize = config_get_bool (self, "/apps/shotwell/preferences/window/library_maximize", FALSE);
#line 386 "Config.vala"
	*dimensions = (dimensions_init (&_tmp0_, config_get_int (self, "/apps/shotwell/preferences/window/library_width", CONFIG_WIDTH_DEFAULT), config_get_int (self, "/apps/shotwell/preferences/window/library_height", CONFIG_HEIGHT_DEFAULT)), _tmp0_);
#line 1649 "Config.c"
}


#line 391 "Config.vala"
gboolean config_set_library_window_state (Config* self, gboolean maximize, Dimensions* dimensions) {
#line 1655 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 391 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 392 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/window/library_maximize", maximize)) {
#line 393 "Config.vala"
		_tmp1_ = config_set_int (self, "/apps/shotwell/preferences/window/library_width", (*dimensions).width);
#line 1665 "Config.c"
	} else {
#line 392 "Config.vala"
		_tmp1_ = FALSE;
#line 1669 "Config.c"
	}
#line 392 "Config.vala"
	if (_tmp1_) {
#line 394 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/window/library_height", (*dimensions).height);
#line 1675 "Config.c"
	} else {
#line 392 "Config.vala"
		_tmp0_ = FALSE;
#line 1679 "Config.c"
	}
	result = _tmp0_;
#line 392 "Config.vala"
	return result;
#line 1684 "Config.c"
}


#line 397 "Config.vala"
void config_get_direct_window_state (Config* self, gboolean* maximize, Dimensions* dimensions) {
#line 1690 "Config.c"
	Dimensions _tmp0_ = {0};
#line 397 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 398 "Config.vala"
	*maximize = config_get_bool (self, "/apps/shotwell/preferences/window/direct_maximize", FALSE);
#line 399 "Config.vala"
	*dimensions = (dimensions_init (&_tmp0_, config_get_int (self, "/apps/shotwell/preferences/window/direct_width", CONFIG_WIDTH_DEFAULT), config_get_int (self, "/apps/shotwell/preferences/window/direct_height", CONFIG_HEIGHT_DEFAULT)), _tmp0_);
#line 1698 "Config.c"
}


#line 404 "Config.vala"
gboolean config_set_direct_window_state (Config* self, gboolean maximize, Dimensions* dimensions) {
#line 1704 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 404 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 405 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/window/direct_maximize", maximize)) {
#line 406 "Config.vala"
		_tmp1_ = config_set_int (self, "/apps/shotwell/preferences/window/direct_width", (*dimensions).width);
#line 1714 "Config.c"
	} else {
#line 405 "Config.vala"
		_tmp1_ = FALSE;
#line 1718 "Config.c"
	}
#line 405 "Config.vala"
	if (_tmp1_) {
#line 407 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/window/direct_height", (*dimensions).height);
#line 1724 "Config.c"
	} else {
#line 405 "Config.vala"
		_tmp0_ = FALSE;
#line 1728 "Config.c"
	}
	result = _tmp0_;
#line 405 "Config.vala"
	return result;
#line 1733 "Config.c"
}


#line 410 "Config.vala"
gint config_get_sidebar_position (Config* self) {
#line 1739 "Config.c"
	gint result = 0;
#line 410 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), 0);
#line 1743 "Config.c"
	result = CLAMP (config_get_int (self, "/apps/shotwell/preferences/window/pane_position", CONFIG_SIDEBAR_MIN_POSITION), CONFIG_SIDEBAR_MIN_POSITION, CONFIG_SIDEBAR_MAX_POSITION);
#line 411 "Config.vala"
	return result;
#line 1747 "Config.c"
}


#line 414 "Config.vala"
gboolean config_set_sidebar_position (Config* self, gint position) {
#line 1753 "Config.c"
	gboolean result = FALSE;
#line 414 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1757 "Config.c"
	result = config_set_int (self, "/apps/shotwell/preferences/window/pane_position", position);
#line 415 "Config.vala"
	return result;
#line 1761 "Config.c"
}


#line 418 "Config.vala"
gboolean config_get_events_sort_ascending (Config* self) {
#line 1767 "Config.c"
	gboolean result = FALSE;
#line 418 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1771 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/events_sort_ascending", FALSE);
#line 419 "Config.vala"
	return result;
#line 1775 "Config.c"
}


#line 422 "Config.vala"
gboolean config_set_events_sort_ascending (Config* self, gboolean sort) {
#line 1781 "Config.c"
	gboolean result = FALSE;
#line 422 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1785 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/events_sort_ascending", sort);
#line 423 "Config.vala"
	return result;
#line 1789 "Config.c"
}


#line 426 "Config.vala"
void config_get_library_photos_sort (Config* self, gboolean* sort_order, gint* sort_by) {
#line 426 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 427 "Config.vala"
	*sort_order = config_get_bool (self, "/apps/shotwell/preferences/ui/library_photos_sort_ascending", FALSE);
#line 428 "Config.vala"
	*sort_by = config_get_int (self, "/apps/shotwell/preferences/ui/library_photos_sort_by", (gint) COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE);
#line 1801 "Config.c"
}


#line 431 "Config.vala"
gboolean config_set_library_photos_sort (Config* self, gboolean sort_order, gint sort_by) {
#line 1807 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 431 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 432 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/ui/library_photos_sort_ascending", sort_order)) {
#line 433 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/ui/library_photos_sort_by", sort_by);
#line 1816 "Config.c"
	} else {
#line 432 "Config.vala"
		_tmp0_ = FALSE;
#line 1820 "Config.c"
	}
	result = _tmp0_;
#line 432 "Config.vala"
	return result;
#line 1825 "Config.c"
}


#line 436 "Config.vala"
void config_get_event_photos_sort (Config* self, gboolean* sort_order, gint* sort_by) {
#line 436 "Config.vala"
	g_return_if_fail (IS_CONFIG (self));
#line 437 "Config.vala"
	*sort_order = config_get_bool (self, "/apps/shotwell/preferences/ui/event_photos_sort_ascending", TRUE);
#line 438 "Config.vala"
	*sort_by = config_get_int (self, "/apps/shotwell/preferences/ui/event_photos_sort_by", (gint) COLLECTION_PAGE_SORT_BY_EXPOSURE_DATE);
#line 1837 "Config.c"
}


#line 441 "Config.vala"
gboolean config_set_event_photos_sort (Config* self, gboolean sort_order, gint sort_by) {
#line 1843 "Config.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 441 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 442 "Config.vala"
	if (config_set_bool (self, "/apps/shotwell/preferences/ui/event_photos_sort_ascending", sort_order)) {
#line 443 "Config.vala"
		_tmp0_ = config_set_int (self, "/apps/shotwell/preferences/ui/event_photos_sort_by", sort_by);
#line 1852 "Config.c"
	} else {
#line 442 "Config.vala"
		_tmp0_ = FALSE;
#line 1856 "Config.c"
	}
	result = _tmp0_;
#line 442 "Config.vala"
	return result;
#line 1861 "Config.c"
}


#line 446 "Config.vala"
gboolean config_get_24_hr_time (Config* self) {
#line 1867 "Config.c"
	gboolean result = FALSE;
#line 446 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1871 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/twentyfour_hr_time", FALSE);
#line 447 "Config.vala"
	return result;
#line 1875 "Config.c"
}


#line 450 "Config.vala"
gboolean config_set_24_hr_time (Config* self, gboolean twentyfour_hr_time) {
#line 1881 "Config.c"
	gboolean result = FALSE;
#line 450 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1885 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/twentyfour_hr_time", twentyfour_hr_time);
#line 451 "Config.vala"
	return result;
#line 1889 "Config.c"
}


#line 454 "Config.vala"
gboolean config_get_keep_relativity (Config* self) {
#line 1895 "Config.c"
	gboolean result = FALSE;
#line 454 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1899 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/keep_relativity", TRUE);
#line 455 "Config.vala"
	return result;
#line 1903 "Config.c"
}


#line 458 "Config.vala"
gboolean config_set_keep_relativity (Config* self, gboolean keep_relativity) {
#line 1909 "Config.c"
	gboolean result = FALSE;
#line 458 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1913 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/keep_relativity", keep_relativity);
#line 459 "Config.vala"
	return result;
#line 1917 "Config.c"
}


#line 462 "Config.vala"
gboolean config_get_modify_originals (Config* self) {
#line 1923 "Config.c"
	gboolean result = FALSE;
#line 462 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1927 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/modify_originals", FALSE);
#line 463 "Config.vala"
	return result;
#line 1931 "Config.c"
}


#line 466 "Config.vala"
gboolean config_set_modify_originals (Config* self, gboolean modify_originals) {
#line 1937 "Config.c"
	gboolean result = FALSE;
#line 466 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1941 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/modify_originals", modify_originals);
#line 467 "Config.vala"
	return result;
#line 1945 "Config.c"
}


#line 471 "Config.vala"
char* config_get_background (Config* self) {
#line 1951 "Config.c"
	char* result = NULL;
#line 471 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), NULL);
#line 1955 "Config.c"
	result = config_get_string (self, "/desktop/gnome/background/picture_filename", NULL);
#line 472 "Config.vala"
	return result;
#line 1959 "Config.c"
}


#line 475 "Config.vala"
gboolean config_set_background (Config* self, const char* filename) {
#line 1965 "Config.c"
	gboolean result = FALSE;
#line 475 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 475 "Config.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 476 "Config.vala"
	if (!config_set_string (self, "/desktop/gnome/background/picture_options", "zoom")) {
#line 1973 "Config.c"
		result = FALSE;
#line 477 "Config.vala"
		return result;
#line 1977 "Config.c"
	}
	result = config_set_string (self, "/desktop/gnome/background/picture_filename", filename);
#line 478 "Config.vala"
	return result;
#line 1982 "Config.c"
}


#line 482 "Config.vala"
gboolean config_get_show_welcome_dialog (Config* self) {
#line 1988 "Config.c"
	gboolean result = FALSE;
#line 482 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 1992 "Config.c"
	result = config_get_bool (self, "/apps/shotwell/preferences/ui/show_welcome_dialog", TRUE);
#line 483 "Config.vala"
	return result;
#line 1996 "Config.c"
}


#line 486 "Config.vala"
gboolean config_set_show_welcome_dialog (Config* self, gboolean show) {
#line 2002 "Config.c"
	gboolean result = FALSE;
#line 486 "Config.vala"
	g_return_val_if_fail (IS_CONFIG (self), FALSE);
#line 2006 "Config.c"
	result = config_set_bool (self, "/apps/shotwell/preferences/ui/show_welcome_dialog", show);
#line 487 "Config.vala"
	return result;
#line 2010 "Config.c"
}


static void value_config_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_config_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		config_unref (value->data[0].v_pointer);
	}
}


static void value_config_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = config_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_config_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_config_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Config* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = config_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_config_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Config** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = config_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecConfig* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CONFIG), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_config (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG), NULL);
	return value->data[0].v_pointer;
}


void value_set_config (GValue* value, gpointer v_object) {
	Config* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIG));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		config_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		config_unref (old);
	}
}


void value_take_config (GValue* value, gpointer v_object) {
	Config* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIG));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIG));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		config_unref (old);
	}
}


static void config_class_init (ConfigClass * klass) {
	config_parent_class = g_type_class_peek_parent (klass);
	CONFIG_CLASS (klass)->finalize = config_finalize;
	g_type_class_add_private (klass, sizeof (ConfigPrivate));
}


static void config_instance_init (Config * self) {
	self->priv = CONFIG_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void config_finalize (Config* obj) {
	Config * self;
	self = CONFIG (obj);
	_g_object_unref0 (self->priv->client);
}


GType config_get_type (void) {
	static volatile gsize config_type_id__volatile = 0;
	if (g_once_init_enter (&config_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_config_init, value_config_free_value, value_config_copy_value, value_config_peek_pointer, "p", value_config_collect_value, "p", value_config_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ConfigClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) config_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Config), 0, (GInstanceInitFunc) config_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType config_type_id;
		config_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Config", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&config_type_id__volatile, config_type_id);
	}
	return config_type_id__volatile;
}


gpointer config_ref (gpointer instance) {
	Config* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void config_unref (gpointer instance) {
	Config* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		CONFIG_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




