/* DataObject.c generated by valac, the Vala compiler
 * generated from DataObject.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataObject*/
/**/
/* Object IDs are incremented for each DataObject, and therefore may be used to compare*/
/* creation order.  This behavior may be relied upon elsewhere.  Object IDs may be recycled when*/
/* DataObjects are reconstituted by a proxy.*/
/**/
/* Ordinal IDs are supplied by DataCollections to record the ordering of the object being added*/
/* to the collection.  This value is primarily only used by DataCollection, but may be used*/
/* elsewhere to resolve ordering questions (including stabilizing a sort).*/
/**/
/* TODO: When this bug is fixed, we should remove the inheritance from Object, as it's more*/
/* heavyweight than we require and impedes load-time at startup.*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=611845*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <time.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;
typedef struct _SourceSnapshotPrivate SourceSnapshotPrivate;
typedef struct _ParamSpecSourceSnapshot ParamSpecSourceSnapshot;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_THUMBNAIL_VIEW (thumbnail_view_get_type ())
#define THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailView))
#define THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))
#define IS_THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_VIEW))
#define IS_THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_VIEW))
#define THUMBNAIL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))

typedef struct _ThumbnailView ThumbnailView;
typedef struct _ThumbnailViewClass ThumbnailViewClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;
typedef struct _EventSourcePrivate EventSourcePrivate;

#define TYPE_SOURCE_PROXY (source_proxy_get_type ())
#define SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_PROXY, SourceProxy))
#define SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_PROXY, SourceProxyClass))
#define IS_SOURCE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_PROXY))
#define IS_SOURCE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_PROXY))
#define SOURCE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_PROXY, SourceProxyClass))

typedef struct _SourceProxy SourceProxy;
typedef struct _SourceProxyClass SourceProxyClass;
typedef struct _SourceProxyPrivate SourceProxyPrivate;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;
#define _source_snapshot_unref0(var) ((var == NULL) ? NULL : (var = (source_snapshot_unref (var), NULL)))
typedef struct _ParamSpecSourceProxy ParamSpecSourceProxy;

#define TYPE_PROXYABLE (proxyable_get_type ())
#define PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROXYABLE, Proxyable))
#define IS_PROXYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROXYABLE))
#define PROXYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_PROXYABLE, ProxyableIface))

typedef struct _Proxyable Proxyable;
typedef struct _ProxyableIface ProxyableIface;
typedef struct _DataViewPrivate DataViewPrivate;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ThumbnailViewPrivate ThumbnailViewPrivate;

#define TYPE_PHOTO_VIEW (photo_view_get_type ())
#define PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_VIEW, PhotoView))
#define PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_VIEW, PhotoViewClass))
#define IS_PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_VIEW))
#define IS_PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_VIEW))
#define PHOTO_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_VIEW, PhotoViewClass))

typedef struct _PhotoView PhotoView;
typedef struct _PhotoViewClass PhotoViewClass;
typedef struct _PhotoViewPrivate PhotoViewPrivate;

#define TYPE_EVENT_VIEW (event_view_get_type ())
#define EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_VIEW, EventView))
#define EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_VIEW, EventViewClass))
#define IS_EVENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_VIEW))
#define IS_EVENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_VIEW))
#define EVENT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_VIEW, EventViewClass))

typedef struct _EventView EventView;
typedef struct _EventViewClass EventViewClass;
typedef struct _EventViewPrivate EventViewPrivate;

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self);
	void (*notify_metadata_altered) (DataObject* self);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const char* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const char* name);
	char* (*get_name) (DataObject* self);
	char* (*to_string) (DataObject* self);
	void (*altered) (DataObject* self);
	void (*metadata_altered) (DataObject* self);
};

struct _DataObjectPrivate {
	gint64 object_id;
	DataCollection* member_of;
	gint64 ordinal;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);
struct _SourceSnapshot {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceSnapshotPrivate * priv;
};

struct _SourceSnapshotClass {
	GTypeClass parent_class;
	void (*finalize) (SourceSnapshot *self);
	void (*notify_broken) (SourceSnapshot* self);
	void (*broken) (SourceSnapshot* self);
};

struct _SourceSnapshotPrivate {
	gboolean snapshot_broken;
};

struct _ParamSpecSourceSnapshot {
	GParamSpec parent_instance;
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*destroyed) (DataSource* self);
};

struct _DataSourcePrivate {
	DataView** subscribers;
	gint subscribers_length1;
	gint _subscribers_size_;
	gboolean in_contact;
	gboolean marked_for_destroy;
	gboolean is_destroyed;
};

typedef void (*DataSourceContactSubscriber) (DataView* view, void* user_data);
struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _PhotoSource {
	ThumbnailSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	ThumbnailSourceClass parent_class;
	time_t (*get_exposure_time) (PhotoSource* self);
	void (*get_dimensions) (PhotoSource* self, Dimensions* result);
	guint64 (*get_filesize) (PhotoSource* self);
	ExifData* (*get_exif) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _EventSource {
	ThumbnailSource parent_instance;
	EventSourcePrivate * priv;
};

struct _EventSourceClass {
	ThumbnailSourceClass parent_class;
	time_t (*get_start_time) (EventSource* self);
	time_t (*get_end_time) (EventSource* self);
	guint64 (*get_total_filesize) (EventSource* self);
	gint (*get_photo_count) (EventSource* self);
	GeeIterable* (*get_photos) (EventSource* self);
};

struct _SourceProxy {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceProxyPrivate * priv;
};

struct _SourceProxyClass {
	GTypeClass parent_class;
	void (*finalize) (SourceProxy *self);
	DataSource* (*reconstitute) (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
	void (*notify_reconstituted) (SourceProxy* self, DataSource* source);
	void (*notify_dehydrated) (SourceProxy* self);
	void (*notify_broken) (SourceProxy* self);
	void (*reconstituted) (SourceProxy* self, DataSource* source);
	void (*dehydrated) (SourceProxy* self);
	void (*broken) (SourceProxy* self);
};

struct _SourceProxyPrivate {
	gint64 object_id;
	char* source_string;
	DataSource* source;
	SourceSnapshot* snapshot;
	SourceCollection* membership;
};

struct _ParamSpecSourceProxy {
	GParamSpec parent_instance;
};

struct _ProxyableIface {
	GTypeInterface parent_iface;
	SourceProxy* (*get_proxy) (Proxyable* self);
};

struct _DataView {
	DataObject parent_instance;
	DataViewPrivate * priv;
};

struct _DataViewClass {
	DataObjectClass parent_class;
	void (*notify_view_altered) (DataView* self);
	void (*notify_geometry_altered) (DataView* self);
	void (*state_changed) (DataView* self, gboolean selected);
	void (*visibility_changed) (DataView* self, gboolean visible);
	void (*view_altered) (DataView* self);
	void (*geometry_altered) (DataView* self);
};

struct _DataViewPrivate {
	DataSource* source;
	gboolean selected;
	gboolean visible;
};

struct _ThumbnailView {
	DataView parent_instance;
	ThumbnailViewPrivate * priv;
};

struct _ThumbnailViewClass {
	DataViewClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailView* self);
	void (*thumbnail_altered) (ThumbnailView* self);
};

struct _PhotoView {
	ThumbnailView parent_instance;
	PhotoViewPrivate * priv;
};

struct _PhotoViewClass {
	ThumbnailViewClass parent_class;
};

struct _EventView {
	ThumbnailView parent_instance;
	EventViewPrivate * priv;
};

struct _EventViewClass {
	ThumbnailViewClass parent_class;
};


static gint64 data_object_object_id_generator;
static gint64 data_object_object_id_generator = (gint64) 0;
static gpointer data_object_parent_class = NULL;
static gpointer source_snapshot_parent_class = NULL;
static gpointer data_source_parent_class = NULL;
static gpointer thumbnail_source_parent_class = NULL;
static gpointer photo_source_parent_class = NULL;
static gpointer event_source_parent_class = NULL;
static gpointer source_proxy_parent_class = NULL;
static gpointer data_view_parent_class = NULL;
static gpointer thumbnail_view_parent_class = NULL;
static gpointer photo_view_parent_class = NULL;
static gpointer event_view_parent_class = NULL;

GType data_object_get_type (void);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void);
#define DATA_OBJECT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_OBJECT, DataObjectPrivate))
enum  {
	DATA_OBJECT_DUMMY_PROPERTY
};
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataObject* data_object_construct (GType object_type, gint64 object_id);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object);
void data_object_notify_altered (DataObject* self);
static void data_object_real_notify_altered (DataObject* self);
void data_collection_internal_notify_metadata_altered (DataCollection* self, DataObject* object);
void data_object_notify_metadata_altered (DataObject* self);
static void data_object_real_notify_metadata_altered (DataObject* self);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection);
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
static void data_object_real_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
void data_object_notify_collection_property_cleared (DataObject* self, const char* name);
static void data_object_real_notify_collection_property_cleared (DataObject* self, const char* name);
char* data_object_get_name (DataObject* self);
static char* data_object_real_get_name (DataObject* self);
char* data_object_to_string (DataObject* self);
static char* data_object_real_to_string (DataObject* self);
DataCollection* data_object_get_membership (DataObject* self);
gboolean data_object_has_membership (DataObject* self);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
void data_object_internal_clear_membership (DataObject* self);
gint64 data_object_internal_get_ordinal (DataObject* self);
gint64 data_object_get_object_id (DataObject* self);
static GValue* _g_value_dup (GValue* self);
GValue* data_collection_get_property (DataCollection* self, const char* name);
GValue* data_object_get_collection_property (DataObject* self, const char* name, GValue* def);
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_object_set_collection_property (DataObject* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_collection_clear_property (DataCollection* self, const char* name);
void data_object_clear_collection_property (DataObject* self, const char* name);
void data_object_altered (DataObject* self);
static void data_object_real_altered (DataObject* self);
void data_object_metadata_altered (DataObject* self);
static void data_object_real_metadata_altered (DataObject* self);
static void data_object_finalize (GObject* obj);
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void);
#define SOURCE_SNAPSHOT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_SNAPSHOT, SourceSnapshotPrivate))
enum  {
	SOURCE_SNAPSHOT_DUMMY_PROPERTY
};
void source_snapshot_notify_broken (SourceSnapshot* self);
static void source_snapshot_real_notify_broken (SourceSnapshot* self);
gboolean source_snapshot_is_broken (SourceSnapshot* self);
SourceSnapshot* source_snapshot_construct (GType object_type);
void source_snapshot_broken (SourceSnapshot* self);
static void source_snapshot_real_broken (SourceSnapshot* self);
static void source_snapshot_finalize (SourceSnapshot* obj);
GType data_source_get_type (void);
GType data_view_get_type (void);
#define DATA_SOURCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SOURCE, DataSourcePrivate))
enum  {
	DATA_SOURCE_DUMMY_PROPERTY
};
DataSource* data_source_construct (GType object_type, gint64 object_id);
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target);
static void data_source_subscriber_altered (DataSource* self, DataView* view);
static void _data_source_subscriber_altered_data_source_contact_subscriber (DataView* view, gpointer self);
static void data_source_real_notify_altered (DataObject* base);
static void data_source_subscriber_metadata_altered (DataSource* self, DataView* view);
static void _data_source_subscriber_metadata_altered_data_source_contact_subscriber (DataView* view, gpointer self);
static void data_source_real_notify_metadata_altered (DataObject* base);
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection);
SourceSnapshot* data_source_save_snapshot (DataSource* self);
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self);
void data_source_internal_mark_for_destroy (DataSource* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error);
gboolean data_source_equals (DataSource* self, DataSource* source);
static gboolean data_source_real_equals (DataSource* self, DataSource* source);
void data_source_destroy (DataSource* self);
static void data_source_real_destroy (DataSource* self);
static void _vala_array_add135 (DataView*** array, int* length, int* size, DataView* value);
void data_source_internal_subscribe (DataSource* self, DataView* view);
void data_source_internal_unsubscribe (DataSource* self, DataView* view);
void data_source_destroyed (DataSource* self);
static void data_source_real_destroyed (DataSource* self);
static void data_source_finalize (GObject* obj);
GType thumbnail_source_get_type (void);
enum  {
	THUMBNAIL_SOURCE_DUMMY_PROPERTY
};
ThumbnailSource* thumbnail_source_construct (GType object_type, gint64 object_id);
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self, DataView* view);
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view, gpointer self);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self);
GType thumbnail_view_get_type (void);
void thumbnail_view_notify_thumbnail_altered (ThumbnailView* self);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
void thumbnail_source_thumbnail_altered (ThumbnailSource* self);
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self);
GType photo_source_get_type (void);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void);
GType scale_constraint_get_type (void);
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
enum  {
	PHOTO_SOURCE_DUMMY_PROPERTY
};
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
time_t photo_source_get_exposure_time (PhotoSource* self);
static time_t photo_source_real_get_exposure_time (PhotoSource* self);
void photo_source_get_dimensions (PhotoSource* self, Dimensions* result);
static void photo_source_real_get_dimensions (PhotoSource* self, Dimensions* result);
guint64 photo_source_get_filesize (PhotoSource* self);
static guint64 photo_source_real_get_filesize (PhotoSource* self);
ExifData* photo_source_get_exif (PhotoSource* self);
static ExifData* photo_source_real_get_exif (PhotoSource* self);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
GType event_source_get_type (void);
enum  {
	EVENT_SOURCE_DUMMY_PROPERTY
};
EventSource* event_source_construct (GType object_type, gint64 object_id);
time_t event_source_get_start_time (EventSource* self);
static time_t event_source_real_get_start_time (EventSource* self);
time_t event_source_get_end_time (EventSource* self);
static time_t event_source_real_get_end_time (EventSource* self);
guint64 event_source_get_total_filesize (EventSource* self);
static guint64 event_source_real_get_total_filesize (EventSource* self);
gint event_source_get_photo_count (EventSource* self);
static gint event_source_real_get_photo_count (EventSource* self);
GeeIterable* event_source_get_photos (EventSource* self);
static GeeIterable* event_source_real_get_photos (EventSource* self);
gpointer source_proxy_ref (gpointer instance);
void source_proxy_unref (gpointer instance);
GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_proxy (GValue* value, gpointer v_object);
void value_take_source_proxy (GValue* value, gpointer v_object);
gpointer value_get_source_proxy (const GValue* value);
GType source_proxy_get_type (void);
GType source_collection_get_type (void);
#define SOURCE_PROXY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_PROXY, SourceProxyPrivate))
enum  {
	SOURCE_PROXY_DUMMY_PROPERTY
};
static void source_proxy_on_snapshot_broken (SourceProxy* self);
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self);
static void source_proxy_set_source (SourceProxy* self, DataSource* source);
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added);
static void _source_proxy_on_source_added_data_collection_items_added (SourceCollection* _sender, GeeIterable* added, gpointer self);
SourceProxy* source_proxy_construct (GType object_type, DataSource* source);
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot);
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_notify_dehydrated (SourceProxy* self);
static void source_proxy_real_notify_dehydrated (SourceProxy* self);
void source_proxy_notify_broken (SourceProxy* self);
static void source_proxy_real_notify_broken (SourceProxy* self);
static void source_proxy_drop_source (SourceProxy* self);
static void source_proxy_on_destroyed (SourceProxy* self);
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
DataSource* source_proxy_get_source (SourceProxy* self);
void source_proxy_reconstituted (SourceProxy* self, DataSource* source);
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source);
void source_proxy_dehydrated (SourceProxy* self);
static void source_proxy_real_dehydrated (SourceProxy* self);
void source_proxy_broken (SourceProxy* self);
static void source_proxy_real_broken (SourceProxy* self);
static void source_proxy_finalize (SourceProxy* obj);
GType proxyable_get_type (void);
SourceProxy* proxyable_get_proxy (Proxyable* self);
#define DATA_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_VIEW, DataViewPrivate))
enum  {
	DATA_VIEW_DUMMY_PROPERTY
};
DataView* data_view_new (DataSource* source);
DataView* data_view_construct (GType object_type, DataSource* source);
static char* data_view_real_get_name (DataObject* base);
static char* data_view_real_to_string (DataObject* base);
DataSource* data_view_get_source (DataView* self);
gboolean data_view_is_selected (DataView* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
gboolean data_view_internal_toggle (DataView* self);
gboolean data_view_is_visible (DataView* self);
void data_view_internal_set_visible (DataView* self, gboolean visible);
GType view_collection_get_type (void);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
void data_view_notify_view_altered (DataView* self);
static void data_view_real_notify_view_altered (DataView* self);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
void data_view_notify_geometry_altered (DataView* self);
static void data_view_real_notify_geometry_altered (DataView* self);
void data_view_state_changed (DataView* self, gboolean selected);
static void data_view_real_state_changed (DataView* self, gboolean selected);
void data_view_visibility_changed (DataView* self, gboolean visible);
static void data_view_real_visibility_changed (DataView* self, gboolean visible);
void data_view_view_altered (DataView* self);
static void data_view_real_view_altered (DataView* self);
void data_view_geometry_altered (DataView* self);
static void data_view_real_geometry_altered (DataView* self);
static void data_view_finalize (GObject* obj);
enum  {
	THUMBNAIL_VIEW_DUMMY_PROPERTY
};
ThumbnailView* thumbnail_view_new (ThumbnailSource* source);
ThumbnailView* thumbnail_view_construct (GType object_type, ThumbnailSource* source);
static void thumbnail_view_real_notify_thumbnail_altered (ThumbnailView* self);
void thumbnail_view_thumbnail_altered (ThumbnailView* self);
static void thumbnail_view_real_thumbnail_altered (ThumbnailView* self);
GType photo_view_get_type (void);
enum  {
	PHOTO_VIEW_DUMMY_PROPERTY
};
PhotoView* photo_view_new (PhotoSource* source);
PhotoView* photo_view_construct (GType object_type, PhotoSource* source);
PhotoSource* photo_view_get_photo_source (PhotoView* self);
GType event_view_get_type (void);
enum  {
	EVENT_VIEW_DUMMY_PROPERTY
};
EventView* event_view_new (EventSource* source);
EventView* event_view_construct (GType object_type, EventSource* source);
EventSource* event_view_get_event_source (EventView* self);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);



#line 51 "DataObject.vala"
DataObject* data_object_construct (GType object_type, gint64 object_id) {
#line 688 "DataObject.c"
	DataObject * self;
	gint64 _tmp0_ = 0LL;
#line 51 "DataObject.vala"
	self = (DataObject*) g_object_new (object_type, NULL);
#line 52 "DataObject.vala"
	if (object_id == DATA_OBJECT_INVALID_OBJECT_ID) {
#line 52 "DataObject.vala"
		_tmp0_ = data_object_object_id_generator++;
#line 697 "DataObject.c"
	} else {
#line 52 "DataObject.vala"
		_tmp0_ = object_id;
#line 701 "DataObject.c"
	}
#line 52 "DataObject.vala"
	self->priv->object_id = _tmp0_;
#line 705 "DataObject.c"
	return self;
}


#line 55 "DataObject.vala"
static void data_object_real_notify_altered (DataObject* self) {
#line 55 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 57 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 58 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (self->priv->member_of)) {
#line 59 "DataObject.vala"
			g_signal_emit_by_name (self, "altered");
#line 720 "DataObject.c"
		}
	} else {
#line 61 "DataObject.vala"
		g_signal_emit_by_name (self, "altered");
#line 725 "DataObject.c"
	}
#line 65 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 66 "DataObject.vala"
		data_collection_internal_notify_altered (self->priv->member_of, self);
#line 731 "DataObject.c"
	}
}


#line 55 "DataObject.vala"
void data_object_notify_altered (DataObject* self) {
#line 55 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_altered (self);
#line 740 "DataObject.c"
}


#line 69 "DataObject.vala"
static void data_object_real_notify_metadata_altered (DataObject* self) {
#line 69 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 71 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 72 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (self->priv->member_of)) {
#line 73 "DataObject.vala"
			g_signal_emit_by_name (self, "metadata-altered");
#line 754 "DataObject.c"
		}
	} else {
#line 75 "DataObject.vala"
		g_signal_emit_by_name (self, "metadata-altered");
#line 759 "DataObject.c"
	}
#line 79 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 80 "DataObject.vala"
		data_collection_internal_notify_metadata_altered (self->priv->member_of, self);
#line 765 "DataObject.c"
	}
}


#line 69 "DataObject.vala"
void data_object_notify_metadata_altered (DataObject* self) {
#line 69 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_metadata_altered (self);
#line 774 "DataObject.c"
}


#line 92 "DataObject.vala"
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 92 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 92 "DataObject.vala"
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
#line 784 "DataObject.c"
}


#line 92 "DataObject.vala"
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection) {
#line 92 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_membership_changed (self, collection);
#line 792 "DataObject.c"
}


#line 97 "DataObject.vala"
static void data_object_real_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val) {
#line 97 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 97 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 802 "DataObject.c"
}


#line 97 "DataObject.vala"
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val) {
#line 97 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_set (self, name, old, val);
#line 810 "DataObject.c"
}


#line 102 "DataObject.vala"
static void data_object_real_notify_collection_property_cleared (DataObject* self, const char* name) {
#line 102 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 102 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 820 "DataObject.c"
}


#line 102 "DataObject.vala"
void data_object_notify_collection_property_cleared (DataObject* self, const char* name) {
#line 102 "DataObject.vala"
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_cleared (self, name);
#line 828 "DataObject.c"
}


#line 105 "DataObject.vala"
static char* data_object_real_get_name (DataObject* self) {
#line 834 "DataObject.c"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_get_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 105 "DataObject.vala"
char* data_object_get_name (DataObject* self) {
#line 105 "DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->get_name (self);
#line 845 "DataObject.c"
}


#line 107 "DataObject.vala"
static char* data_object_real_to_string (DataObject* self) {
#line 851 "DataObject.c"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 107 "DataObject.vala"
char* data_object_to_string (DataObject* self) {
#line 107 "DataObject.vala"
	return DATA_OBJECT_GET_CLASS (self)->to_string (self);
#line 862 "DataObject.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


#line 109 "DataObject.vala"
DataCollection* data_object_get_membership (DataObject* self) {
#line 873 "DataObject.c"
	DataCollection* result = NULL;
#line 109 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
#line 877 "DataObject.c"
	result = _data_collection_ref0 (self->priv->member_of);
#line 110 "DataObject.vala"
	return result;
#line 881 "DataObject.c"
}


#line 113 "DataObject.vala"
gboolean data_object_has_membership (DataObject* self) {
#line 887 "DataObject.c"
	gboolean result = FALSE;
#line 113 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), FALSE);
#line 891 "DataObject.c"
	result = self->priv->member_of != NULL;
#line 114 "DataObject.vala"
	return result;
#line 895 "DataObject.c"
}


#line 119 "DataObject.vala"
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal) {
#line 901 "DataObject.c"
	DataCollection* _tmp0_;
#line 119 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 119 "DataObject.vala"
	g_return_if_fail (IS_DATA_COLLECTION (collection));
#line 120 "DataObject.vala"
	g_assert (self->priv->member_of == NULL);
#line 122 "DataObject.vala"
	self->priv->member_of = (_tmp0_ = _data_collection_ref0 (collection), _data_collection_unref0 (self->priv->member_of), _tmp0_);
#line 123 "DataObject.vala"
	self->priv->ordinal = ordinal;
#line 913 "DataObject.c"
}


#line 132 "DataObject.vala"
void data_object_internal_clear_membership (DataObject* self) {
#line 919 "DataObject.c"
	DataCollection* _tmp0_;
#line 132 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 133 "DataObject.vala"
	self->priv->member_of = (_tmp0_ = NULL, _data_collection_unref0 (self->priv->member_of), _tmp0_);
#line 134 "DataObject.vala"
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
#line 927 "DataObject.c"
}


#line 138 "DataObject.vala"
inline gint64 data_object_internal_get_ordinal (DataObject* self) {
#line 933 "DataObject.c"
	gint64 result = 0LL;
#line 138 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
#line 139 "DataObject.vala"
	g_assert (self->priv->member_of != NULL);
#line 939 "DataObject.c"
	result = self->priv->ordinal;
#line 141 "DataObject.vala"
	return result;
#line 943 "DataObject.c"
}


#line 144 "DataObject.vala"
inline gint64 data_object_get_object_id (DataObject* self) {
#line 949 "DataObject.c"
	gint64 result = 0LL;
#line 144 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
#line 953 "DataObject.c"
	result = self->priv->object_id;
#line 145 "DataObject.vala"
	return result;
#line 957 "DataObject.c"
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


#line 148 "DataObject.vala"
GValue* data_object_get_collection_property (DataObject* self, const char* name, GValue* def) {
#line 973 "DataObject.c"
	GValue* result = NULL;
	GValue* _result_;
	GValue* _tmp0_ = NULL;
#line 148 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
#line 148 "DataObject.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 149 "DataObject.vala"
	if (self->priv->member_of == NULL) {
#line 983 "DataObject.c"
		result = __g_value_dup0 (def);
#line 150 "DataObject.vala"
		return result;
#line 987 "DataObject.c"
	}
#line 152 "DataObject.vala"
	_result_ = data_collection_get_property (self->priv->member_of, name);
#line 154 "DataObject.vala"
	if (_result_ != NULL) {
#line 154 "DataObject.vala"
		_tmp0_ = _result_;
#line 995 "DataObject.c"
	} else {
#line 154 "DataObject.vala"
		_tmp0_ = def;
#line 999 "DataObject.c"
	}
	result = __g_value_dup0 (_tmp0_);
	_g_free0 (_result_);
#line 154 "DataObject.vala"
	return result;
#line 1005 "DataObject.c"
}


#line 157 "DataObject.vala"
void data_object_set_collection_property (DataObject* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
#line 157 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 157 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 158 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 159 "DataObject.vala"
		data_collection_set_property (self->priv->member_of, name, val, value_equals, value_equals_target);
#line 1019 "DataObject.c"
	}
}


#line 162 "DataObject.vala"
void data_object_clear_collection_property (DataObject* self, const char* name) {
#line 162 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 162 "DataObject.vala"
	g_return_if_fail (name != NULL);
#line 163 "DataObject.vala"
	if (self->priv->member_of != NULL) {
#line 164 "DataObject.vala"
		data_collection_clear_property (self->priv->member_of, name);
#line 1034 "DataObject.c"
	}
}


#line 40 "DataObject.vala"
static void data_object_real_altered (DataObject* self) {
#line 40 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 1043 "DataObject.c"
}


#line 46 "DataObject.vala"
static void data_object_real_metadata_altered (DataObject* self) {
#line 46 "DataObject.vala"
	g_return_if_fail (IS_DATA_OBJECT (self));
#line 1051 "DataObject.c"
}


static void data_object_class_init (DataObjectClass * klass) {
	data_object_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataObjectPrivate));
	DATA_OBJECT_CLASS (klass)->notify_altered = data_object_real_notify_altered;
	DATA_OBJECT_CLASS (klass)->notify_metadata_altered = data_object_real_notify_metadata_altered;
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_object_real_notify_membership_changed;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_set = data_object_real_notify_collection_property_set;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_cleared = data_object_real_notify_collection_property_cleared;
	DATA_OBJECT_CLASS (klass)->get_name = data_object_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_object_real_to_string;
	DATA_OBJECT_CLASS (klass)->altered = data_object_real_altered;
	DATA_OBJECT_CLASS (klass)->metadata_altered = data_object_real_metadata_altered;
	G_OBJECT_CLASS (klass)->finalize = data_object_finalize;
	g_signal_new ("altered", TYPE_DATA_OBJECT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataObjectClass, altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("metadata_altered", TYPE_DATA_OBJECT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataObjectClass, metadata_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_object_instance_init (DataObject * self) {
	self->priv = DATA_OBJECT_GET_PRIVATE (self);
	self->priv->object_id = DATA_OBJECT_INVALID_OBJECT_ID;
	self->priv->member_of = NULL;
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
}


static void data_object_finalize (GObject* obj) {
	DataObject * self;
	self = DATA_OBJECT (obj);
	_data_collection_unref0 (self->priv->member_of);
	G_OBJECT_CLASS (data_object_parent_class)->finalize (obj);
}


GType data_object_get_type (void) {
	static volatile gsize data_object_type_id__volatile = 0;
	if (g_once_init_enter (&data_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataObject), 0, (GInstanceInitFunc) data_object_instance_init, NULL };
		GType data_object_type_id;
		data_object_type_id = g_type_register_static (G_TYPE_OBJECT, "DataObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_object_type_id__volatile, data_object_type_id);
	}
	return data_object_type_id__volatile;
}


#line 207 "DataObject.vala"
static void source_snapshot_real_notify_broken (SourceSnapshot* self) {
#line 207 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
#line 208 "DataObject.vala"
	self->priv->snapshot_broken = TRUE;
#line 210 "DataObject.vala"
	g_signal_emit_by_name (self, "broken");
#line 1109 "DataObject.c"
}


#line 207 "DataObject.vala"
void source_snapshot_notify_broken (SourceSnapshot* self) {
#line 207 "DataObject.vala"
	SOURCE_SNAPSHOT_GET_CLASS (self)->notify_broken (self);
#line 1117 "DataObject.c"
}


#line 213 "DataObject.vala"
gboolean source_snapshot_is_broken (SourceSnapshot* self) {
#line 1123 "DataObject.c"
	gboolean result = FALSE;
#line 213 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_SNAPSHOT (self), FALSE);
#line 1127 "DataObject.c"
	result = self->priv->snapshot_broken;
#line 214 "DataObject.vala"
	return result;
#line 1131 "DataObject.c"
}


#line 199 "DataObject.vala"
SourceSnapshot* source_snapshot_construct (GType object_type) {
#line 1137 "DataObject.c"
	SourceSnapshot* self;
	self = (SourceSnapshot*) g_type_create_instance (object_type);
	return self;
}


#line 204 "DataObject.vala"
static void source_snapshot_real_broken (SourceSnapshot* self) {
#line 204 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_SNAPSHOT (self));
#line 1148 "DataObject.c"
}


static void value_source_snapshot_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_snapshot_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_snapshot_unref (value->data[0].v_pointer);
	}
}


static void value_source_snapshot_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_snapshot_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_snapshot_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_snapshot_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceSnapshot* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_snapshot_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_snapshot_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceSnapshot** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_snapshot_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceSnapshot* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_SNAPSHOT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_snapshot (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_snapshot_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


void value_take_source_snapshot (GValue* value, gpointer v_object) {
	SourceSnapshot* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_SNAPSHOT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_SNAPSHOT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_snapshot_unref (old);
	}
}


static void source_snapshot_class_init (SourceSnapshotClass * klass) {
	source_snapshot_parent_class = g_type_class_peek_parent (klass);
	SOURCE_SNAPSHOT_CLASS (klass)->finalize = source_snapshot_finalize;
	g_type_class_add_private (klass, sizeof (SourceSnapshotPrivate));
	SOURCE_SNAPSHOT_CLASS (klass)->notify_broken = source_snapshot_real_notify_broken;
	SOURCE_SNAPSHOT_CLASS (klass)->broken = source_snapshot_real_broken;
	g_signal_new ("broken", TYPE_SOURCE_SNAPSHOT, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceSnapshotClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_snapshot_instance_init (SourceSnapshot * self) {
	self->priv = SOURCE_SNAPSHOT_GET_PRIVATE (self);
	self->priv->snapshot_broken = FALSE;
	self->ref_count = 1;
}


static void source_snapshot_finalize (SourceSnapshot* obj) {
	SourceSnapshot * self;
	self = SOURCE_SNAPSHOT (obj);
}


GType source_snapshot_get_type (void) {
	static volatile gsize source_snapshot_type_id__volatile = 0;
	if (g_once_init_enter (&source_snapshot_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_snapshot_init, value_source_snapshot_free_value, value_source_snapshot_copy_value, value_source_snapshot_peek_pointer, "p", value_source_snapshot_collect_value, "p", value_source_snapshot_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceSnapshotClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_snapshot_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceSnapshot), 0, (GInstanceInitFunc) source_snapshot_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_snapshot_type_id;
		source_snapshot_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceSnapshot", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_snapshot_type_id__volatile, source_snapshot_type_id);
	}
	return source_snapshot_type_id__volatile;
}


gpointer source_snapshot_ref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_snapshot_unref (gpointer instance) {
	SourceSnapshot* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_SNAPSHOT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 231 "DataObject.vala"
DataSource* data_source_construct (GType object_type, gint64 object_id) {
#line 1319 "DataObject.c"
	DataSource * self;
	DataView** _tmp0_;
#line 232 "DataObject.vala"
	self = (DataSource*) data_object_construct (object_type, object_id);
#line 236 "DataObject.vala"
	self->priv->subscribers = (_tmp0_ = g_new0 (DataView*, 4 + 1), self->priv->subscribers = (_vala_array_free (self->priv->subscribers, self->priv->subscribers_length1, (GDestroyNotify) g_object_unref), NULL), self->priv->subscribers_length1 = 4, self->priv->_subscribers_size_ = self->priv->subscribers_length1, _tmp0_);
#line 1326 "DataObject.c"
	return self;
}


#line 252 "DataObject.vala"
static void _data_source_subscriber_altered_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 1333 "DataObject.c"
	data_source_subscriber_altered (self, view);
}


#line 245 "DataObject.vala"
static void data_source_real_notify_altered (DataObject* base) {
#line 1340 "DataObject.c"
	DataSource * self;
	self = DATA_SOURCE (base);
#line 247 "DataObject.vala"
	data_source_contact_subscribers (self, _data_source_subscriber_altered_data_source_contact_subscriber, self);
#line 249 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_altered (DATA_OBJECT (self));
#line 1347 "DataObject.c"
}


#line 252 "DataObject.vala"
static void data_source_subscriber_altered (DataSource* self, DataView* view) {
#line 252 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 252 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 253 "DataObject.vala"
	data_object_notify_altered (DATA_OBJECT (view));
#line 1359 "DataObject.c"
}


#line 263 "DataObject.vala"
static void _data_source_subscriber_metadata_altered_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 1365 "DataObject.c"
	data_source_subscriber_metadata_altered (self, view);
}


#line 256 "DataObject.vala"
static void data_source_real_notify_metadata_altered (DataObject* base) {
#line 1372 "DataObject.c"
	DataSource * self;
	self = DATA_SOURCE (base);
#line 258 "DataObject.vala"
	data_source_contact_subscribers (self, _data_source_subscriber_metadata_altered_data_source_contact_subscriber, self);
#line 260 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_metadata_altered (DATA_OBJECT (self));
#line 1379 "DataObject.c"
}


#line 263 "DataObject.vala"
static void data_source_subscriber_metadata_altered (DataSource* self, DataView* view) {
#line 263 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 263 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 264 "DataObject.vala"
	data_object_notify_metadata_altered (DATA_OBJECT (view));
#line 1391 "DataObject.c"
}


#line 267 "DataObject.vala"
static void data_source_real_notify_membership_changed (DataObject* base, DataCollection* collection) {
#line 1397 "DataObject.c"
	DataSource * self;
	self = DATA_SOURCE (base);
#line 267 "DataObject.vala"
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
#line 270 "DataObject.vala"
	if (collection == NULL) {
#line 271 "DataObject.vala"
		g_assert (self->priv->is_destroyed);
#line 1406 "DataObject.c"
	} else {
#line 273 "DataObject.vala"
		g_assert (!self->priv->is_destroyed);
#line 1410 "DataObject.c"
	}
#line 276 "DataObject.vala"
	DATA_OBJECT_CLASS (data_source_parent_class)->notify_membership_changed (DATA_OBJECT (self), collection);
#line 1414 "DataObject.c"
}


#line 280 "DataObject.vala"
static SourceSnapshot* data_source_real_save_snapshot (DataSource* self) {
#line 1420 "DataObject.c"
	SourceSnapshot* result = NULL;
#line 280 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), NULL);
#line 1424 "DataObject.c"
	result = NULL;
#line 281 "DataObject.vala"
	return result;
#line 1428 "DataObject.c"
}


#line 280 "DataObject.vala"
SourceSnapshot* data_source_save_snapshot (DataSource* self) {
#line 280 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->save_snapshot (self);
#line 1436 "DataObject.c"
}


#line 285 "DataObject.vala"
void data_source_internal_mark_for_destroy (DataSource* self) {
#line 285 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 286 "DataObject.vala"
	self->priv->marked_for_destroy = TRUE;
#line 1446 "DataObject.c"
}


#line 293 "DataObject.vala"
static gboolean data_source_real_internal_delete_backing (DataSource* self, GError** error) {
#line 1452 "DataObject.c"
	gboolean result = FALSE;
#line 293 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 1456 "DataObject.c"
	result = TRUE;
#line 294 "DataObject.vala"
	return result;
#line 1460 "DataObject.c"
}


#line 293 "DataObject.vala"
gboolean data_source_internal_delete_backing (DataSource* self, GError** error) {
#line 293 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->internal_delete_backing (self, error);
#line 1468 "DataObject.c"
}


#line 299 "DataObject.vala"
static gboolean data_source_real_equals (DataSource* self, DataSource* source) {
#line 1474 "DataObject.c"
	gboolean result = FALSE;
#line 299 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (self), FALSE);
#line 299 "DataObject.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 1480 "DataObject.c"
	result = self == source;
#line 300 "DataObject.vala"
	return result;
#line 1484 "DataObject.c"
}


#line 299 "DataObject.vala"
gboolean data_source_equals (DataSource* self, DataSource* source) {
#line 299 "DataObject.vala"
	return DATA_SOURCE_GET_CLASS (self)->equals (self, source);
#line 1492 "DataObject.c"
}


#line 309 "DataObject.vala"
static void data_source_real_destroy (DataSource* self) {
#line 309 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 310 "DataObject.vala"
	g_assert (self->priv->marked_for_destroy);
#line 313 "DataObject.vala"
	self->priv->is_destroyed = TRUE;
#line 316 "DataObject.vala"
	g_signal_emit_by_name (self, "destroyed");
#line 1506 "DataObject.c"
}


#line 309 "DataObject.vala"
void data_source_destroy (DataSource* self) {
#line 309 "DataObject.vala"
	DATA_SOURCE_GET_CLASS (self)->destroy (self);
#line 1514 "DataObject.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _vala_array_add135 (DataView*** array, int* length, int* size, DataView* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DataView*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


#line 325 "DataObject.vala"
void data_source_internal_subscribe (DataSource* self, DataView* view) {
#line 1535 "DataObject.c"
	gboolean added;
#line 325 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 325 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 326 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 328 "DataObject.vala"
	added = FALSE;
#line 1545 "DataObject.c"
	{
		gint ctr;
#line 329 "DataObject.vala"
		ctr = 0;
#line 1550 "DataObject.c"
		{
			gboolean _tmp0_;
#line 329 "DataObject.vala"
			_tmp0_ = TRUE;
#line 329 "DataObject.vala"
			while (TRUE) {
#line 329 "DataObject.vala"
				if (!_tmp0_) {
#line 329 "DataObject.vala"
					ctr++;
#line 1561 "DataObject.c"
				}
#line 329 "DataObject.vala"
				_tmp0_ = FALSE;
#line 329 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 329 "DataObject.vala"
					break;
#line 1569 "DataObject.c"
				}
#line 330 "DataObject.vala"
				if (self->priv->subscribers[ctr] == NULL) {
#line 1573 "DataObject.c"
					DataView* _tmp1_;
#line 331 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = _g_object_ref0 (view), _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 332 "DataObject.vala"
					added = TRUE;
#line 334 "DataObject.vala"
					break;
#line 1581 "DataObject.c"
				}
			}
		}
	}
#line 338 "DataObject.vala"
	if (!added) {
#line 339 "DataObject.vala"
		_vala_array_add135 (&self->priv->subscribers, &self->priv->subscribers_length1, &self->priv->_subscribers_size_, _g_object_ref0 (view));
#line 1590 "DataObject.c"
	}
}


#line 343 "DataObject.vala"
void data_source_internal_unsubscribe (DataSource* self, DataView* view) {
#line 1597 "DataObject.c"
	gboolean removed;
#line 343 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 343 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 344 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 346 "DataObject.vala"
	removed = FALSE;
#line 1607 "DataObject.c"
	{
		gint ctr;
#line 347 "DataObject.vala"
		ctr = 0;
#line 1612 "DataObject.c"
		{
			gboolean _tmp0_;
#line 347 "DataObject.vala"
			_tmp0_ = TRUE;
#line 347 "DataObject.vala"
			while (TRUE) {
#line 347 "DataObject.vala"
				if (!_tmp0_) {
#line 347 "DataObject.vala"
					ctr++;
#line 1623 "DataObject.c"
				}
#line 347 "DataObject.vala"
				_tmp0_ = FALSE;
#line 347 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 347 "DataObject.vala"
					break;
#line 1631 "DataObject.c"
				}
#line 348 "DataObject.vala"
				if (self->priv->subscribers[ctr] == view) {
#line 1635 "DataObject.c"
					DataView* _tmp1_;
#line 349 "DataObject.vala"
					self->priv->subscribers[ctr] = (_tmp1_ = NULL, _g_object_unref0 (self->priv->subscribers[ctr]), _tmp1_);
#line 350 "DataObject.vala"
					removed = TRUE;
#line 352 "DataObject.vala"
					break;
#line 1643 "DataObject.c"
				}
			}
		}
	}
#line 356 "DataObject.vala"
	g_assert (removed);
#line 1650 "DataObject.c"
}


#line 359 "DataObject.vala"
void data_source_contact_subscribers (DataSource* self, DataSourceContactSubscriber contact_subscriber, void* contact_subscriber_target) {
#line 359 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 360 "DataObject.vala"
	g_assert (!self->priv->in_contact);
#line 362 "DataObject.vala"
	self->priv->in_contact = TRUE;
#line 1662 "DataObject.c"
	{
		gint ctr;
#line 363 "DataObject.vala"
		ctr = 0;
#line 1667 "DataObject.c"
		{
			gboolean _tmp0_;
#line 363 "DataObject.vala"
			_tmp0_ = TRUE;
#line 363 "DataObject.vala"
			while (TRUE) {
#line 363 "DataObject.vala"
				if (!_tmp0_) {
#line 363 "DataObject.vala"
					ctr++;
#line 1678 "DataObject.c"
				}
#line 363 "DataObject.vala"
				_tmp0_ = FALSE;
#line 363 "DataObject.vala"
				if (!(ctr < self->priv->subscribers_length1)) {
#line 363 "DataObject.vala"
					break;
#line 1686 "DataObject.c"
				}
#line 364 "DataObject.vala"
				if (self->priv->subscribers[ctr] != NULL) {
#line 365 "DataObject.vala"
					contact_subscriber (self->priv->subscribers[ctr], contact_subscriber_target);
#line 1692 "DataObject.c"
				}
			}
		}
	}
#line 367 "DataObject.vala"
	self->priv->in_contact = FALSE;
#line 1699 "DataObject.c"
}


#line 228 "DataObject.vala"
static void data_source_real_destroyed (DataSource* self) {
#line 228 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (self));
#line 1707 "DataObject.c"
}


static void data_source_class_init (DataSourceClass * klass) {
	data_source_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataSourcePrivate));
	DATA_OBJECT_CLASS (klass)->notify_altered = data_source_real_notify_altered;
	DATA_OBJECT_CLASS (klass)->notify_metadata_altered = data_source_real_notify_metadata_altered;
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_source_real_notify_membership_changed;
	DATA_SOURCE_CLASS (klass)->save_snapshot = data_source_real_save_snapshot;
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = data_source_real_internal_delete_backing;
	DATA_SOURCE_CLASS (klass)->equals = data_source_real_equals;
	DATA_SOURCE_CLASS (klass)->destroy = data_source_real_destroy;
	DATA_SOURCE_CLASS (klass)->destroyed = data_source_real_destroyed;
	G_OBJECT_CLASS (klass)->finalize = data_source_finalize;
	g_signal_new ("destroyed", TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataSourceClass, destroyed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_source_instance_init (DataSource * self) {
	self->priv = DATA_SOURCE_GET_PRIVATE (self);
	self->priv->subscribers = NULL;
	self->priv->in_contact = FALSE;
	self->priv->marked_for_destroy = FALSE;
	self->priv->is_destroyed = FALSE;
}


static void data_source_finalize (GObject* obj) {
	DataSource * self;
	self = DATA_SOURCE (obj);
	{
	}
	self->priv->subscribers = (_vala_array_free (self->priv->subscribers, self->priv->subscribers_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (data_source_parent_class)->finalize (obj);
}


GType data_source_get_type (void) {
	static volatile gsize data_source_type_id__volatile = 0;
	if (g_once_init_enter (&data_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSource), 0, (GInstanceInitFunc) data_source_instance_init, NULL };
		GType data_source_type_id;
		data_source_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_source_type_id__volatile, data_source_type_id);
	}
	return data_source_type_id__volatile;
}


#line 372 "DataObject.vala"
ThumbnailSource* thumbnail_source_construct (GType object_type, gint64 object_id) {
#line 1760 "DataObject.c"
	ThumbnailSource * self;
#line 373 "DataObject.vala"
	self = (ThumbnailSource*) data_source_construct (object_type, object_id);
#line 1764 "DataObject.c"
	return self;
}


#line 387 "DataObject.vala"
static void _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber (DataView* view, gpointer self) {
#line 1771 "DataObject.c"
	thumbnail_source_subscriber_thumbnail_altered (self, view);
}


#line 379 "DataObject.vala"
static void thumbnail_source_real_notify_thumbnail_altered (ThumbnailSource* self) {
#line 379 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 381 "DataObject.vala"
	g_signal_emit_by_name (self, "thumbnail-altered");
#line 384 "DataObject.vala"
	data_source_contact_subscribers (DATA_SOURCE (self), _thumbnail_source_subscriber_thumbnail_altered_data_source_contact_subscriber, self);
#line 1784 "DataObject.c"
}


#line 379 "DataObject.vala"
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self) {
#line 379 "DataObject.vala"
	THUMBNAIL_SOURCE_GET_CLASS (self)->notify_thumbnail_altered (self);
#line 1792 "DataObject.c"
}


#line 387 "DataObject.vala"
static void thumbnail_source_subscriber_thumbnail_altered (ThumbnailSource* self, DataView* view) {
#line 387 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 387 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 388 "DataObject.vala"
	thumbnail_view_notify_thumbnail_altered (THUMBNAIL_VIEW (view));
#line 1804 "DataObject.c"
}


#line 391 "DataObject.vala"
static GdkPixbuf* thumbnail_source_real_get_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 1810 "DataObject.c"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `thumbnail_source_get_thumbnail'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 391 "DataObject.vala"
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error) {
#line 391 "DataObject.vala"
	return THUMBNAIL_SOURCE_GET_CLASS (self)->get_thumbnail (self, scale, error);
#line 1821 "DataObject.c"
}


#line 376 "DataObject.vala"
static void thumbnail_source_real_thumbnail_altered (ThumbnailSource* self) {
#line 376 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_SOURCE (self));
#line 1829 "DataObject.c"
}


static void thumbnail_source_class_init (ThumbnailSourceClass * klass) {
	thumbnail_source_parent_class = g_type_class_peek_parent (klass);
	THUMBNAIL_SOURCE_CLASS (klass)->notify_thumbnail_altered = thumbnail_source_real_notify_thumbnail_altered;
	THUMBNAIL_SOURCE_CLASS (klass)->get_thumbnail = thumbnail_source_real_get_thumbnail;
	THUMBNAIL_SOURCE_CLASS (klass)->thumbnail_altered = thumbnail_source_real_thumbnail_altered;
	g_signal_new ("thumbnail_altered", TYPE_THUMBNAIL_SOURCE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailSourceClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void thumbnail_source_instance_init (ThumbnailSource * self) {
}


GType thumbnail_source_get_type (void) {
	static volatile gsize thumbnail_source_type_id__volatile = 0;
	if (g_once_init_enter (&thumbnail_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThumbnailSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailSource), 0, (GInstanceInitFunc) thumbnail_source_instance_init, NULL };
		GType thumbnail_source_type_id;
		thumbnail_source_type_id = g_type_register_static (TYPE_DATA_SOURCE, "ThumbnailSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&thumbnail_source_type_id__volatile, thumbnail_source_type_id);
	}
	return thumbnail_source_type_id__volatile;
}


#line 395 "DataObject.vala"
PhotoSource* photo_source_construct (GType object_type, gint64 object_id) {
#line 1860 "DataObject.c"
	PhotoSource * self;
#line 396 "DataObject.vala"
	self = (PhotoSource*) thumbnail_source_construct (object_type, object_id);
#line 1864 "DataObject.c"
	return self;
}


#line 399 "DataObject.vala"
static time_t photo_source_real_get_exposure_time (PhotoSource* self) {
#line 1871 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_exposure_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 399 "DataObject.vala"
time_t photo_source_get_exposure_time (PhotoSource* self) {
#line 399 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_exposure_time (self);
#line 1881 "DataObject.c"
}


#line 401 "DataObject.vala"
static void photo_source_real_get_dimensions (PhotoSource* self, Dimensions* result) {
#line 1887 "DataObject.c"
	g_return_if_fail (IS_PHOTO_SOURCE (self));
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_dimensions'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 401 "DataObject.vala"
void photo_source_get_dimensions (PhotoSource* self, Dimensions* result) {
#line 401 "DataObject.vala"
	PHOTO_SOURCE_GET_CLASS (self)->get_dimensions (self, result);
#line 1898 "DataObject.c"
}


#line 403 "DataObject.vala"
static guint64 photo_source_real_get_filesize (PhotoSource* self) {
#line 1904 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), 0ULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0ULL;
}


#line 403 "DataObject.vala"
guint64 photo_source_get_filesize (PhotoSource* self) {
#line 403 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_filesize (self);
#line 1915 "DataObject.c"
}


#line 405 "DataObject.vala"
static ExifData* photo_source_real_get_exif (PhotoSource* self) {
#line 1921 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_exif'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 405 "DataObject.vala"
ExifData* photo_source_get_exif (PhotoSource* self) {
#line 405 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_exif (self);
#line 1932 "DataObject.c"
}


#line 407 "DataObject.vala"
static GdkPixbuf* photo_source_real_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error) {
#line 1938 "DataObject.c"
	g_return_val_if_fail (IS_PHOTO_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_source_get_pixbuf'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 407 "DataObject.vala"
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error) {
#line 407 "DataObject.vala"
	return PHOTO_SOURCE_GET_CLASS (self)->get_pixbuf (self, scaling, error);
#line 1949 "DataObject.c"
}


static void photo_source_class_init (PhotoSourceClass * klass) {
	photo_source_parent_class = g_type_class_peek_parent (klass);
	PHOTO_SOURCE_CLASS (klass)->get_exposure_time = photo_source_real_get_exposure_time;
	PHOTO_SOURCE_CLASS (klass)->get_dimensions = photo_source_real_get_dimensions;
	PHOTO_SOURCE_CLASS (klass)->get_filesize = photo_source_real_get_filesize;
	PHOTO_SOURCE_CLASS (klass)->get_exif = photo_source_real_get_exif;
	PHOTO_SOURCE_CLASS (klass)->get_pixbuf = photo_source_real_get_pixbuf;
}


static void photo_source_instance_init (PhotoSource * self) {
}


GType photo_source_get_type (void) {
	static volatile gsize photo_source_type_id__volatile = 0;
	if (g_once_init_enter (&photo_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoSource), 0, (GInstanceInitFunc) photo_source_instance_init, NULL };
		GType photo_source_type_id;
		photo_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "PhotoSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_source_type_id__volatile, photo_source_type_id);
	}
	return photo_source_type_id__volatile;
}


#line 411 "DataObject.vala"
EventSource* event_source_construct (GType object_type, gint64 object_id) {
#line 1981 "DataObject.c"
	EventSource * self;
#line 412 "DataObject.vala"
	self = (EventSource*) thumbnail_source_construct (object_type, object_id);
#line 1985 "DataObject.c"
	return self;
}


#line 415 "DataObject.vala"
static time_t event_source_real_get_start_time (EventSource* self) {
#line 1992 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_start_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 415 "DataObject.vala"
time_t event_source_get_start_time (EventSource* self) {
#line 415 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_start_time (self);
#line 2002 "DataObject.c"
}


#line 417 "DataObject.vala"
static time_t event_source_real_get_end_time (EventSource* self) {
#line 2008 "DataObject.c"
	g_critical ("Type `%s' does not implement abstract method `event_source_get_end_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 417 "DataObject.vala"
time_t event_source_get_end_time (EventSource* self) {
#line 417 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_end_time (self);
#line 2018 "DataObject.c"
}


#line 419 "DataObject.vala"
static guint64 event_source_real_get_total_filesize (EventSource* self) {
#line 2024 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0ULL);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_total_filesize'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0ULL;
}


#line 419 "DataObject.vala"
guint64 event_source_get_total_filesize (EventSource* self) {
#line 419 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_total_filesize (self);
#line 2035 "DataObject.c"
}


#line 421 "DataObject.vala"
static gint event_source_real_get_photo_count (EventSource* self) {
#line 2041 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), 0);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_photo_count'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


#line 421 "DataObject.vala"
gint event_source_get_photo_count (EventSource* self) {
#line 421 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_photo_count (self);
#line 2052 "DataObject.c"
}


#line 423 "DataObject.vala"
static GeeIterable* event_source_real_get_photos (EventSource* self) {
#line 2058 "DataObject.c"
	g_return_val_if_fail (IS_EVENT_SOURCE (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `event_source_get_photos'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 423 "DataObject.vala"
GeeIterable* event_source_get_photos (EventSource* self) {
#line 423 "DataObject.vala"
	return EVENT_SOURCE_GET_CLASS (self)->get_photos (self);
#line 2069 "DataObject.c"
}


static void event_source_class_init (EventSourceClass * klass) {
	event_source_parent_class = g_type_class_peek_parent (klass);
	EVENT_SOURCE_CLASS (klass)->get_start_time = event_source_real_get_start_time;
	EVENT_SOURCE_CLASS (klass)->get_end_time = event_source_real_get_end_time;
	EVENT_SOURCE_CLASS (klass)->get_total_filesize = event_source_real_get_total_filesize;
	EVENT_SOURCE_CLASS (klass)->get_photo_count = event_source_real_get_photo_count;
	EVENT_SOURCE_CLASS (klass)->get_photos = event_source_real_get_photos;
}


static void event_source_instance_init (EventSource * self) {
}


GType event_source_get_type (void) {
	static volatile gsize event_source_type_id__volatile = 0;
	if (g_once_init_enter (&event_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventSource), 0, (GInstanceInitFunc) event_source_instance_init, NULL };
		GType event_source_type_id;
		event_source_type_id = g_type_register_static (TYPE_THUMBNAIL_SOURCE, "EventSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&event_source_type_id__volatile, event_source_type_id);
	}
	return event_source_type_id__volatile;
}


#line 502 "DataObject.vala"
static void _source_proxy_on_snapshot_broken_source_snapshot_broken (SourceSnapshot* _sender, gpointer self) {
#line 2101 "DataObject.c"
	source_proxy_on_snapshot_broken (self);
}


#line 550 "DataObject.vala"
static void _source_proxy_on_source_added_data_collection_items_added (SourceCollection* _sender, GeeIterable* added, gpointer self) {
#line 2108 "DataObject.c"
	source_proxy_on_source_added (self, added);
}


#line 468 "DataObject.vala"
SourceProxy* source_proxy_construct (GType object_type, DataSource* source) {
#line 2115 "DataObject.c"
	SourceProxy* self;
	char* _tmp0_;
	SourceSnapshot* _tmp1_;
	SourceCollection* _tmp2_;
#line 468 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 2122 "DataObject.c"
	self = (SourceProxy*) g_type_create_instance (object_type);
#line 469 "DataObject.vala"
	self->priv->object_id = data_object_get_object_id (DATA_OBJECT (source));
#line 470 "DataObject.vala"
	self->priv->source_string = (_tmp0_ = data_object_to_string (DATA_OBJECT (source)), _g_free0 (self->priv->source_string), _tmp0_);
#line 472 "DataObject.vala"
	self->priv->snapshot = (_tmp1_ = data_source_save_snapshot (source), _source_snapshot_unref0 (self->priv->snapshot), _tmp1_);
#line 473 "DataObject.vala"
	g_assert (self->priv->snapshot != NULL);
#line 474 "DataObject.vala"
	g_signal_connect (self->priv->snapshot, "broken", (GCallback) _source_proxy_on_snapshot_broken_source_snapshot_broken, self);
#line 476 "DataObject.vala"
	source_proxy_set_source (self, source);
#line 478 "DataObject.vala"
	self->priv->membership = (_tmp2_ = SOURCE_COLLECTION (data_object_get_membership (DATA_OBJECT (source))), _data_collection_unref0 (self->priv->membership), _tmp2_);
#line 479 "DataObject.vala"
	g_assert (self->priv->membership != NULL);
#line 480 "DataObject.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->membership), "items-added", (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 2142 "DataObject.c"
	return self;
}


#line 488 "DataObject.vala"
static DataSource* source_proxy_real_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
#line 2149 "DataObject.c"
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `source_proxy_reconstitute'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 488 "DataObject.vala"
DataSource* source_proxy_reconstitute (SourceProxy* self, gint64 object_id, SourceSnapshot* snapshot) {
#line 488 "DataObject.vala"
	return SOURCE_PROXY_GET_CLASS (self)->reconstitute (self, object_id, snapshot);
#line 2160 "DataObject.c"
}


#line 490 "DataObject.vala"
static void source_proxy_real_notify_reconstituted (SourceProxy* self, DataSource* source) {
#line 490 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 490 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 491 "DataObject.vala"
	g_signal_emit_by_name (self, "reconstituted", source);
#line 2172 "DataObject.c"
}


#line 490 "DataObject.vala"
void source_proxy_notify_reconstituted (SourceProxy* self, DataSource* source) {
#line 490 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_reconstituted (self, source);
#line 2180 "DataObject.c"
}


#line 494 "DataObject.vala"
static void source_proxy_real_notify_dehydrated (SourceProxy* self) {
#line 494 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 495 "DataObject.vala"
	g_signal_emit_by_name (self, "dehydrated");
#line 2190 "DataObject.c"
}


#line 494 "DataObject.vala"
void source_proxy_notify_dehydrated (SourceProxy* self) {
#line 494 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_dehydrated (self);
#line 2198 "DataObject.c"
}


#line 498 "DataObject.vala"
static void source_proxy_real_notify_broken (SourceProxy* self) {
#line 498 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 499 "DataObject.vala"
	g_signal_emit_by_name (self, "broken");
#line 2208 "DataObject.c"
}


#line 498 "DataObject.vala"
void source_proxy_notify_broken (SourceProxy* self) {
#line 498 "DataObject.vala"
	SOURCE_PROXY_GET_CLASS (self)->notify_broken (self);
#line 2216 "DataObject.c"
}


#line 502 "DataObject.vala"
static void source_proxy_on_snapshot_broken (SourceProxy* self) {
#line 502 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 503 "DataObject.vala"
	source_proxy_drop_source (self);
#line 505 "DataObject.vala"
	source_proxy_notify_broken (self);
#line 2228 "DataObject.c"
}


#line 541 "DataObject.vala"
static void _source_proxy_on_destroyed_data_source_destroyed (DataSource* _sender, gpointer self) {
#line 2234 "DataObject.c"
	source_proxy_on_destroyed (self);
}


#line 508 "DataObject.vala"
static void source_proxy_set_source (SourceProxy* self, DataSource* source) {
#line 2241 "DataObject.c"
	DataSource* _tmp0_;
#line 508 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 508 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 509 "DataObject.vala"
	source_proxy_drop_source (self);
#line 511 "DataObject.vala"
	self->priv->source = (_tmp0_ = _g_object_ref0 (source), _g_object_unref0 (self->priv->source), _tmp0_);
#line 512 "DataObject.vala"
	g_signal_connect (source, "destroyed", (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 2253 "DataObject.c"
}


#line 515 "DataObject.vala"
static void source_proxy_drop_source (SourceProxy* self) {
#line 2259 "DataObject.c"
	guint _tmp0_;
	DataSource* _tmp1_;
#line 515 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 516 "DataObject.vala"
	if (self->priv->source == NULL) {
#line 517 "DataObject.vala"
		return;
#line 2268 "DataObject.c"
	}
#line 519 "DataObject.vala"
	g_signal_parse_name ("destroyed", TYPE_DATA_SOURCE, &_tmp0_, NULL, FALSE);
#line 519 "DataObject.vala"
	g_signal_handlers_disconnect_matched (self->priv->source, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_destroyed_data_source_destroyed, self);
#line 520 "DataObject.vala"
	self->priv->source = (_tmp1_ = NULL, _g_object_unref0 (self->priv->source), _tmp1_);
#line 2276 "DataObject.c"
}


#line 523 "DataObject.vala"
DataSource* source_proxy_get_source (SourceProxy* self) {
#line 2282 "DataObject.c"
	DataSource* result = NULL;
	DataSource* new_source;
#line 523 "DataObject.vala"
	g_return_val_if_fail (IS_SOURCE_PROXY (self), NULL);
#line 524 "DataObject.vala"
	if (source_snapshot_is_broken (self->priv->snapshot)) {
#line 2289 "DataObject.c"
		result = NULL;
#line 525 "DataObject.vala"
		return result;
#line 2293 "DataObject.c"
	}
#line 527 "DataObject.vala"
	if (self->priv->source != NULL) {
#line 2297 "DataObject.c"
		result = _g_object_ref0 (self->priv->source);
#line 528 "DataObject.vala"
		return result;
#line 2301 "DataObject.c"
	}
#line 533 "DataObject.vala"
	new_source = source_proxy_reconstitute (self, self->priv->object_id, self->priv->snapshot);
#line 534 "DataObject.vala"
	g_assert (self->priv->source == new_source);
#line 535 "DataObject.vala"
	g_assert (data_object_get_object_id (DATA_OBJECT (self->priv->source)) == self->priv->object_id);
#line 536 "DataObject.vala"
	g_assert (data_collection_contains (DATA_COLLECTION (self->priv->membership), DATA_OBJECT (self->priv->source)));
#line 2311 "DataObject.c"
	result = _g_object_ref0 (self->priv->source);
	_g_object_unref0 (new_source);
#line 538 "DataObject.vala"
	return result;
#line 2316 "DataObject.c"
}


#line 541 "DataObject.vala"
static void source_proxy_on_destroyed (SourceProxy* self) {
#line 541 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 542 "DataObject.vala"
	g_assert (self->priv->source != NULL);
#line 545 "DataObject.vala"
	source_proxy_drop_source (self);
#line 547 "DataObject.vala"
	source_proxy_notify_dehydrated (self);
#line 2330 "DataObject.c"
}


#line 550 "DataObject.vala"
static void source_proxy_on_source_added (SourceProxy* self, GeeIterable* added) {
#line 550 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 550 "DataObject.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 552 "DataObject.vala"
	if (self->priv->source != NULL) {
#line 553 "DataObject.vala"
		return;
#line 2344 "DataObject.c"
	}
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (added);
#line 555 "DataObject.vala"
		while (TRUE) {
#line 2351 "DataObject.c"
			DataObject* object;
#line 555 "DataObject.vala"
			if (!gee_iterator_next (_object_it)) {
#line 555 "DataObject.vala"
				break;
#line 2357 "DataObject.c"
			}
#line 555 "DataObject.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 557 "DataObject.vala"
			if (data_object_get_object_id (object) != self->priv->object_id) {
#line 2363 "DataObject.c"
				_g_object_unref0 (object);
#line 558 "DataObject.vala"
				continue;
#line 2367 "DataObject.c"
			}
#line 561 "DataObject.vala"
			source_proxy_set_source (self, DATA_SOURCE (object));
#line 563 "DataObject.vala"
			source_proxy_notify_reconstituted (self, DATA_SOURCE (object));
#line 2373 "DataObject.c"
			_g_object_unref0 (object);
#line 565 "DataObject.vala"
			break;
#line 2377 "DataObject.c"
		}
		_g_object_unref0 (_object_it);
	}
}


#line 455 "DataObject.vala"
static void source_proxy_real_reconstituted (SourceProxy* self, DataSource* source) {
#line 455 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 455 "DataObject.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 2390 "DataObject.c"
}


#line 460 "DataObject.vala"
static void source_proxy_real_dehydrated (SourceProxy* self) {
#line 460 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 2398 "DataObject.c"
}


#line 465 "DataObject.vala"
static void source_proxy_real_broken (SourceProxy* self) {
#line 465 "DataObject.vala"
	g_return_if_fail (IS_SOURCE_PROXY (self));
#line 2406 "DataObject.c"
}


static void value_source_proxy_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_proxy_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_proxy_unref (value->data[0].v_pointer);
	}
}


static void value_source_proxy_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_proxy_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_proxy_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_proxy_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceProxy* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_proxy_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_proxy_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceProxy** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_proxy_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_proxy (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceProxy* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_PROXY), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_proxy (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_proxy_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


void value_take_source_proxy (GValue* value, gpointer v_object) {
	SourceProxy* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_PROXY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_PROXY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_proxy_unref (old);
	}
}


static void source_proxy_class_init (SourceProxyClass * klass) {
	source_proxy_parent_class = g_type_class_peek_parent (klass);
	SOURCE_PROXY_CLASS (klass)->finalize = source_proxy_finalize;
	g_type_class_add_private (klass, sizeof (SourceProxyPrivate));
	SOURCE_PROXY_CLASS (klass)->reconstitute = source_proxy_real_reconstitute;
	SOURCE_PROXY_CLASS (klass)->notify_reconstituted = source_proxy_real_notify_reconstituted;
	SOURCE_PROXY_CLASS (klass)->notify_dehydrated = source_proxy_real_notify_dehydrated;
	SOURCE_PROXY_CLASS (klass)->notify_broken = source_proxy_real_notify_broken;
	SOURCE_PROXY_CLASS (klass)->reconstituted = source_proxy_real_reconstituted;
	SOURCE_PROXY_CLASS (klass)->dehydrated = source_proxy_real_dehydrated;
	SOURCE_PROXY_CLASS (klass)->broken = source_proxy_real_broken;
	g_signal_new ("reconstituted", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, reconstituted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
	g_signal_new ("dehydrated", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, dehydrated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("broken", TYPE_SOURCE_PROXY, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceProxyClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void source_proxy_instance_init (SourceProxy * self) {
	self->priv = SOURCE_PROXY_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void source_proxy_finalize (SourceProxy* obj) {
	SourceProxy * self;
	self = SOURCE_PROXY (obj);
	{
		guint _tmp0_;
#line 484 "DataObject.vala"
		source_proxy_drop_source (self);
#line 485 "DataObject.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 485 "DataObject.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->membership), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_proxy_on_source_added_data_collection_items_added, self);
#line 2554 "DataObject.c"
	}
	_g_free0 (self->priv->source_string);
	_g_object_unref0 (self->priv->source);
	_source_snapshot_unref0 (self->priv->snapshot);
	_data_collection_unref0 (self->priv->membership);
}


GType source_proxy_get_type (void) {
	static volatile gsize source_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&source_proxy_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_proxy_init, value_source_proxy_free_value, value_source_proxy_copy_value, value_source_proxy_peek_pointer, "p", value_source_proxy_collect_value, "p", value_source_proxy_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceProxyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_proxy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceProxy), 0, (GInstanceInitFunc) source_proxy_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_proxy_type_id;
		source_proxy_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceProxy", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&source_proxy_type_id__volatile, source_proxy_type_id);
	}
	return source_proxy_type_id__volatile;
}


gpointer source_proxy_ref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_proxy_unref (gpointer instance) {
	SourceProxy* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_PROXY_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 571 "DataObject.vala"
SourceProxy* proxyable_get_proxy (Proxyable* self) {
#line 571 "DataObject.vala"
	return PROXYABLE_GET_INTERFACE (self)->get_proxy (self);
#line 2599 "DataObject.c"
}


static void proxyable_base_init (ProxyableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType proxyable_get_type (void) {
	static volatile gsize proxyable_type_id__volatile = 0;
	if (g_once_init_enter (&proxyable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ProxyableIface), (GBaseInitFunc) proxyable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType proxyable_type_id;
		proxyable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Proxyable", &g_define_type_info, 0);
		g_once_init_leave (&proxyable_type_id__volatile, proxyable_type_id);
	}
	return proxyable_type_id__volatile;
}


#line 600 "DataObject.vala"
DataView* data_view_construct (GType object_type, DataSource* source) {
#line 2625 "DataObject.c"
	DataView * self;
	DataSource* _tmp0_;
#line 600 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 600 "DataObject.vala"
	self = (DataView*) data_object_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 601 "DataObject.vala"
	self->priv->source = (_tmp0_ = _g_object_ref0 (source), _g_object_unref0 (self->priv->source), _tmp0_);
#line 605 "DataObject.vala"
	data_source_internal_subscribe (source, self);
#line 2636 "DataObject.c"
	return self;
}


#line 600 "DataObject.vala"
DataView* data_view_new (DataSource* source) {
#line 600 "DataObject.vala"
	return data_view_construct (TYPE_DATA_VIEW, source);
#line 2645 "DataObject.c"
}


#line 614 "DataObject.vala"
static char* data_view_real_get_name (DataObject* base) {
#line 2651 "DataObject.c"
	DataView * self;
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
	self = DATA_VIEW (base);
	result = (_tmp1_ = g_strdup_printf ("View of %s", _tmp0_ = data_object_get_name (DATA_OBJECT (self->priv->source))), _g_free0 (_tmp0_), _tmp1_);
#line 615 "DataObject.vala"
	return result;
#line 2660 "DataObject.c"
}


#line 618 "DataObject.vala"
static char* data_view_real_to_string (DataObject* base) {
#line 2666 "DataObject.c"
	DataView * self;
	char* result = NULL;
	char* _tmp1_;
	char* _tmp0_;
	char* _tmp2_;
	self = DATA_VIEW (base);
	result = (_tmp2_ = g_strdup_printf ("DataView %s [DataSource %s]", _tmp0_ = data_object_get_name (DATA_OBJECT (self)), _tmp1_ = data_object_to_string (DATA_OBJECT (self->priv->source))), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp2_);
#line 619 "DataObject.vala"
	return result;
#line 2676 "DataObject.c"
}


#line 622 "DataObject.vala"
DataSource* data_view_get_source (DataView* self) {
#line 2682 "DataObject.c"
	DataSource* result = NULL;
#line 622 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), NULL);
#line 2686 "DataObject.c"
	result = _g_object_ref0 (self->priv->source);
#line 623 "DataObject.vala"
	return result;
#line 2690 "DataObject.c"
}


#line 626 "DataObject.vala"
gboolean data_view_is_selected (DataView* self) {
#line 2696 "DataObject.c"
	gboolean result = FALSE;
#line 626 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 2700 "DataObject.c"
	result = self->priv->selected;
#line 627 "DataObject.vala"
	return result;
#line 2704 "DataObject.c"
}


#line 631 "DataObject.vala"
void data_view_internal_set_selected (DataView* self, gboolean selected) {
#line 631 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 632 "DataObject.vala"
	if (self->priv->selected == selected) {
#line 633 "DataObject.vala"
		return;
#line 2716 "DataObject.c"
	}
#line 635 "DataObject.vala"
	self->priv->selected = selected;
#line 636 "DataObject.vala"
	g_signal_emit_by_name (self, "state-changed", selected);
#line 2722 "DataObject.c"
}


#line 640 "DataObject.vala"
gboolean data_view_internal_toggle (DataView* self) {
#line 2728 "DataObject.c"
	gboolean result = FALSE;
#line 640 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 641 "DataObject.vala"
	self->priv->selected = !self->priv->selected;
#line 642 "DataObject.vala"
	g_signal_emit_by_name (self, "state-changed", self->priv->selected);
#line 2736 "DataObject.c"
	result = self->priv->selected;
#line 644 "DataObject.vala"
	return result;
#line 2740 "DataObject.c"
}


#line 647 "DataObject.vala"
gboolean data_view_is_visible (DataView* self) {
#line 2746 "DataObject.c"
	gboolean result = FALSE;
#line 647 "DataObject.vala"
	g_return_val_if_fail (IS_DATA_VIEW (self), FALSE);
#line 2750 "DataObject.c"
	result = self->priv->visible;
#line 648 "DataObject.vala"
	return result;
#line 2754 "DataObject.c"
}


#line 652 "DataObject.vala"
void data_view_internal_set_visible (DataView* self, gboolean visible) {
#line 652 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 653 "DataObject.vala"
	if (self->priv->visible == visible) {
#line 654 "DataObject.vala"
		return;
#line 2766 "DataObject.c"
	}
#line 656 "DataObject.vala"
	self->priv->visible = visible;
#line 657 "DataObject.vala"
	g_signal_emit_by_name (self, "visibility-changed", visible);
#line 2772 "DataObject.c"
}


#line 660 "DataObject.vala"
static void data_view_real_notify_view_altered (DataView* self) {
#line 2778 "DataObject.c"
	DataCollection* _tmp0_;
	ViewCollection* vc;
#line 660 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 662 "DataObject.vala"
	if (!self->priv->visible) {
#line 663 "DataObject.vala"
		return;
#line 2787 "DataObject.c"
	}
#line 665 "DataObject.vala"
	vc = (_tmp0_ = data_object_get_membership (DATA_OBJECT (self)), IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL);
#line 666 "DataObject.vala"
	if (vc != NULL) {
#line 667 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (DATA_COLLECTION (vc))) {
#line 668 "DataObject.vala"
			g_signal_emit_by_name (self, "view-altered");
#line 2797 "DataObject.c"
		}
#line 671 "DataObject.vala"
		view_collection_internal_notify_view_altered (vc, self);
#line 2801 "DataObject.c"
	} else {
#line 673 "DataObject.vala"
		g_signal_emit_by_name (self, "view-altered");
#line 2805 "DataObject.c"
	}
	_data_collection_unref0 (vc);
}


#line 660 "DataObject.vala"
void data_view_notify_view_altered (DataView* self) {
#line 660 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_view_altered (self);
#line 2815 "DataObject.c"
}


#line 677 "DataObject.vala"
static void data_view_real_notify_geometry_altered (DataView* self) {
#line 2821 "DataObject.c"
	DataCollection* _tmp0_;
	ViewCollection* vc;
#line 677 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 679 "DataObject.vala"
	if (!self->priv->visible) {
#line 680 "DataObject.vala"
		return;
#line 2830 "DataObject.c"
	}
#line 682 "DataObject.vala"
	vc = (_tmp0_ = data_object_get_membership (DATA_OBJECT (self)), IS_VIEW_COLLECTION (_tmp0_) ? ((ViewCollection*) _tmp0_) : NULL);
#line 683 "DataObject.vala"
	if (vc != NULL) {
#line 684 "DataObject.vala"
		if (!data_collection_are_notifications_frozen (DATA_COLLECTION (vc))) {
#line 685 "DataObject.vala"
			g_signal_emit_by_name (self, "geometry-altered");
#line 2840 "DataObject.c"
		}
#line 688 "DataObject.vala"
		view_collection_internal_notify_geometry_altered (vc, self);
#line 2844 "DataObject.c"
	} else {
#line 690 "DataObject.vala"
		g_signal_emit_by_name (self, "geometry-altered");
#line 2848 "DataObject.c"
	}
	_data_collection_unref0 (vc);
}


#line 677 "DataObject.vala"
void data_view_notify_geometry_altered (DataView* self) {
#line 677 "DataObject.vala"
	DATA_VIEW_GET_CLASS (self)->notify_geometry_altered (self);
#line 2858 "DataObject.c"
}


#line 584 "DataObject.vala"
static void data_view_real_state_changed (DataView* self, gboolean selected) {
#line 584 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 2866 "DataObject.c"
}


#line 588 "DataObject.vala"
static void data_view_real_visibility_changed (DataView* self, gboolean visible) {
#line 588 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 2874 "DataObject.c"
}


#line 592 "DataObject.vala"
static void data_view_real_view_altered (DataView* self) {
#line 592 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 2882 "DataObject.c"
}


#line 597 "DataObject.vala"
static void data_view_real_geometry_altered (DataView* self) {
#line 597 "DataObject.vala"
	g_return_if_fail (IS_DATA_VIEW (self));
#line 2890 "DataObject.c"
}


static void data_view_class_init (DataViewClass * klass) {
	data_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataViewPrivate));
	DATA_OBJECT_CLASS (klass)->get_name = data_view_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_view_real_to_string;
	DATA_VIEW_CLASS (klass)->notify_view_altered = data_view_real_notify_view_altered;
	DATA_VIEW_CLASS (klass)->notify_geometry_altered = data_view_real_notify_geometry_altered;
	DATA_VIEW_CLASS (klass)->state_changed = data_view_real_state_changed;
	DATA_VIEW_CLASS (klass)->visibility_changed = data_view_real_visibility_changed;
	DATA_VIEW_CLASS (klass)->view_altered = data_view_real_view_altered;
	DATA_VIEW_CLASS (klass)->geometry_altered = data_view_real_geometry_altered;
	G_OBJECT_CLASS (klass)->finalize = data_view_finalize;
	g_signal_new ("state_changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, state_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("visibility_changed", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	g_signal_new ("view_altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, view_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("geometry_altered", TYPE_DATA_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataViewClass, geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void data_view_instance_init (DataView * self) {
	self->priv = DATA_VIEW_GET_PRIVATE (self);
	self->priv->selected = FALSE;
	self->priv->visible = TRUE;
}


static void data_view_finalize (GObject* obj) {
	DataView * self;
	self = DATA_VIEW (obj);
	{
	}
	_g_object_unref0 (self->priv->source);
	G_OBJECT_CLASS (data_view_parent_class)->finalize (obj);
}


GType data_view_get_type (void) {
	static volatile gsize data_view_type_id__volatile = 0;
	if (g_once_init_enter (&data_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataView), 0, (GInstanceInitFunc) data_view_instance_init, NULL };
		GType data_view_type_id;
		data_view_type_id = g_type_register_static (TYPE_DATA_OBJECT, "DataView", &g_define_type_info, 0);
		g_once_init_leave (&data_view_type_id__volatile, data_view_type_id);
	}
	return data_view_type_id__volatile;
}


#line 699 "DataObject.vala"
ThumbnailView* thumbnail_view_construct (GType object_type, ThumbnailSource* source) {
#line 2944 "DataObject.c"
	ThumbnailView * self;
#line 699 "DataObject.vala"
	g_return_val_if_fail (IS_THUMBNAIL_SOURCE (source), NULL);
#line 700 "DataObject.vala"
	self = (ThumbnailView*) data_view_construct (object_type, DATA_SOURCE (source));
#line 2950 "DataObject.c"
	return self;
}


#line 699 "DataObject.vala"
ThumbnailView* thumbnail_view_new (ThumbnailSource* source) {
#line 699 "DataObject.vala"
	return thumbnail_view_construct (TYPE_THUMBNAIL_VIEW, source);
#line 2959 "DataObject.c"
}


#line 703 "DataObject.vala"
static void thumbnail_view_real_notify_thumbnail_altered (ThumbnailView* self) {
#line 703 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_VIEW (self));
#line 705 "DataObject.vala"
	g_signal_emit_by_name (self, "thumbnail-altered");
#line 2969 "DataObject.c"
}


#line 703 "DataObject.vala"
void thumbnail_view_notify_thumbnail_altered (ThumbnailView* self) {
#line 703 "DataObject.vala"
	THUMBNAIL_VIEW_GET_CLASS (self)->notify_thumbnail_altered (self);
#line 2977 "DataObject.c"
}


#line 696 "DataObject.vala"
static void thumbnail_view_real_thumbnail_altered (ThumbnailView* self) {
#line 696 "DataObject.vala"
	g_return_if_fail (IS_THUMBNAIL_VIEW (self));
#line 2985 "DataObject.c"
}


static void thumbnail_view_class_init (ThumbnailViewClass * klass) {
	thumbnail_view_parent_class = g_type_class_peek_parent (klass);
	THUMBNAIL_VIEW_CLASS (klass)->notify_thumbnail_altered = thumbnail_view_real_notify_thumbnail_altered;
	THUMBNAIL_VIEW_CLASS (klass)->thumbnail_altered = thumbnail_view_real_thumbnail_altered;
	g_signal_new ("thumbnail_altered", TYPE_THUMBNAIL_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ThumbnailViewClass, thumbnail_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void thumbnail_view_instance_init (ThumbnailView * self) {
}


GType thumbnail_view_get_type (void) {
	static volatile gsize thumbnail_view_type_id__volatile = 0;
	if (g_once_init_enter (&thumbnail_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThumbnailViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailView), 0, (GInstanceInitFunc) thumbnail_view_instance_init, NULL };
		GType thumbnail_view_type_id;
		thumbnail_view_type_id = g_type_register_static (TYPE_DATA_VIEW, "ThumbnailView", &g_define_type_info, 0);
		g_once_init_leave (&thumbnail_view_type_id__volatile, thumbnail_view_type_id);
	}
	return thumbnail_view_type_id__volatile;
}


#line 710 "DataObject.vala"
PhotoView* photo_view_construct (GType object_type, PhotoSource* source) {
#line 3015 "DataObject.c"
	PhotoView * self;
#line 710 "DataObject.vala"
	g_return_val_if_fail (IS_PHOTO_SOURCE (source), NULL);
#line 711 "DataObject.vala"
	self = (PhotoView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 3021 "DataObject.c"
	return self;
}


#line 710 "DataObject.vala"
PhotoView* photo_view_new (PhotoSource* source) {
#line 710 "DataObject.vala"
	return photo_view_construct (TYPE_PHOTO_VIEW, source);
#line 3030 "DataObject.c"
}


#line 714 "DataObject.vala"
PhotoSource* photo_view_get_photo_source (PhotoView* self) {
#line 3036 "DataObject.c"
	PhotoSource* result = NULL;
#line 714 "DataObject.vala"
	g_return_val_if_fail (IS_PHOTO_VIEW (self), NULL);
#line 3040 "DataObject.c"
	result = PHOTO_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 715 "DataObject.vala"
	return result;
#line 3044 "DataObject.c"
}


static void photo_view_class_init (PhotoViewClass * klass) {
	photo_view_parent_class = g_type_class_peek_parent (klass);
}


static void photo_view_instance_init (PhotoView * self) {
}


GType photo_view_get_type (void) {
	static volatile gsize photo_view_type_id__volatile = 0;
	if (g_once_init_enter (&photo_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoView), 0, (GInstanceInitFunc) photo_view_instance_init, NULL };
		GType photo_view_type_id;
		photo_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "PhotoView", &g_define_type_info, 0);
		g_once_init_leave (&photo_view_type_id__volatile, photo_view_type_id);
	}
	return photo_view_type_id__volatile;
}


#line 720 "DataObject.vala"
EventView* event_view_construct (GType object_type, EventSource* source) {
#line 3071 "DataObject.c"
	EventView * self;
#line 720 "DataObject.vala"
	g_return_val_if_fail (IS_EVENT_SOURCE (source), NULL);
#line 721 "DataObject.vala"
	self = (EventView*) thumbnail_view_construct (object_type, THUMBNAIL_SOURCE (source));
#line 3077 "DataObject.c"
	return self;
}


#line 720 "DataObject.vala"
EventView* event_view_new (EventSource* source) {
#line 720 "DataObject.vala"
	return event_view_construct (TYPE_EVENT_VIEW, source);
#line 3086 "DataObject.c"
}


#line 724 "DataObject.vala"
EventSource* event_view_get_event_source (EventView* self) {
#line 3092 "DataObject.c"
	EventSource* result = NULL;
#line 724 "DataObject.vala"
	g_return_val_if_fail (IS_EVENT_VIEW (self), NULL);
#line 3096 "DataObject.c"
	result = EVENT_SOURCE (data_view_get_source (DATA_VIEW (self)));
#line 725 "DataObject.vala"
	return result;
#line 3100 "DataObject.c"
}


static void event_view_class_init (EventViewClass * klass) {
	event_view_parent_class = g_type_class_peek_parent (klass);
}


static void event_view_instance_init (EventView * self) {
}


GType event_view_get_type (void) {
	static volatile gsize event_view_type_id__volatile = 0;
	if (g_once_init_enter (&event_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EventViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) event_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EventView), 0, (GInstanceInitFunc) event_view_instance_init, NULL };
		GType event_view_type_id;
		event_view_type_id = g_type_register_static (TYPE_THUMBNAIL_VIEW, "EventView", &g_define_type_info, 0);
		g_once_init_leave (&event_view_type_id__volatile, event_view_type_id);
	}
	return event_view_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}




