/* Debug.c generated by valac, the Vala compiler
 * generated from Debug.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define _g_mutex_free0(var) ((var == NULL) ? NULL : (var = (g_mutex_free (var), NULL)))


extern gboolean debug_info_enabled;
gboolean debug_info_enabled = FALSE;
extern gboolean debug_debug_enabled;
gboolean debug_debug_enabled = FALSE;
extern gboolean debug_message_enabled;
gboolean debug_message_enabled = FALSE;
extern gboolean debug_warning_enabled;
gboolean debug_warning_enabled = FALSE;
extern gboolean debug_critical_enabled;
gboolean debug_critical_enabled = FALSE;
extern GMutex* debug_log_mutex;
GMutex* debug_log_mutex = NULL;

void debug_info_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_info_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_debug_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_debug_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_message_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_message_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_warning_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_warning_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_critical_handler (const char* domain, GLogLevelFlags flags, const char* message);
static void _debug_critical_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self);
void debug_init (void);
void debug_terminate (void);
void debug_log (FILE* stream, const char* prefix, const char* message);



#line 51 "Debug.vala"
static void _debug_info_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 51 "Debug.c"
	debug_info_handler (log_domain, log_levels, message);
}


#line 56 "Debug.vala"
static void _debug_debug_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 58 "Debug.c"
	debug_debug_handler (log_domain, log_levels, message);
}


#line 61 "Debug.vala"
static void _debug_message_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 65 "Debug.c"
	debug_message_handler (log_domain, log_levels, message);
}


#line 66 "Debug.vala"
static void _debug_warning_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 72 "Debug.c"
	debug_warning_handler (log_domain, log_levels, message);
}


#line 71 "Debug.vala"
static void _debug_critical_handler_glog_func (const char* log_domain, GLogLevelFlags log_levels, const char* message, gpointer self) {
#line 79 "Debug.c"
	debug_critical_handler (log_domain, log_levels, message);
}


#line 15 "Debug.vala"
void debug_init (void) {
#line 86 "Debug.c"
	GMutex* _tmp0_;
#line 16 "Debug.vala"
	debug_log_mutex = (_tmp0_ = g_mutex_new (), _g_mutex_free0 (debug_log_mutex), _tmp0_);
#line 18 "Debug.vala"
	if (g_getenv ("SHOTWELL_LOG") != NULL) {
#line 19 "Debug.vala"
		debug_info_enabled = TRUE;
#line 20 "Debug.vala"
		debug_debug_enabled = TRUE;
#line 21 "Debug.vala"
		debug_message_enabled = TRUE;
#line 22 "Debug.vala"
		debug_warning_enabled = TRUE;
#line 23 "Debug.vala"
		debug_critical_enabled = TRUE;
#line 102 "Debug.c"
	} else {
#line 25 "Debug.vala"
		debug_info_enabled = g_getenv ("SHOTWELL_INFO") != NULL;
#line 26 "Debug.vala"
		debug_debug_enabled = g_getenv ("SHOTWELL_DEBUG") != NULL;
#line 27 "Debug.vala"
		debug_message_enabled = g_getenv ("SHOTWELL_MESSAGE") != NULL;
#line 28 "Debug.vala"
		debug_warning_enabled = g_getenv ("SHOTWELL_WARNING") != NULL;
#line 29 "Debug.vala"
		debug_critical_enabled = g_getenv ("SHOTWELL_CRITICAL") != NULL;
#line 114 "Debug.c"
	}
#line 32 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_INFO, _debug_info_handler_glog_func, NULL);
#line 33 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_DEBUG, _debug_debug_handler_glog_func, NULL);
#line 34 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_MESSAGE, _debug_message_handler_glog_func, NULL);
#line 35 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_WARNING, _debug_warning_handler_glog_func, NULL);
#line 36 "Debug.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_CRITICAL, _debug_critical_handler_glog_func, NULL);
#line 126 "Debug.c"
}


#line 39 "Debug.vala"
void debug_terminate (void) {
#line 132 "Debug.c"
}


#line 42 "Debug.vala"
void debug_log (FILE* stream, const char* prefix, const char* message) {
#line 42 "Debug.vala"
	g_return_if_fail (stream != NULL);
#line 42 "Debug.vala"
	g_return_if_fail (prefix != NULL);
#line 42 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 43 "Debug.vala"
	g_mutex_lock (debug_log_mutex);
#line 44 "Debug.vala"
	fputs (prefix, stream);
#line 45 "Debug.vala"
	fputs (message, stream);
#line 46 "Debug.vala"
	fputc ('\n', stream);
#line 47 "Debug.vala"
	fflush (stream);
#line 48 "Debug.vala"
	g_mutex_unlock (debug_log_mutex);
#line 156 "Debug.c"
}


#line 51 "Debug.vala"
void debug_info_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 51 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 52 "Debug.vala"
	if (debug_info_enabled) {
#line 53 "Debug.vala"
		debug_log (stdout, "[INF] ", message);
#line 168 "Debug.c"
	}
}


#line 56 "Debug.vala"
void debug_debug_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 56 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 57 "Debug.vala"
	if (debug_debug_enabled) {
#line 58 "Debug.vala"
		debug_log (stdout, "[DBG] ", message);
#line 181 "Debug.c"
	}
}


#line 61 "Debug.vala"
void debug_message_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 61 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 62 "Debug.vala"
	if (debug_message_enabled) {
#line 63 "Debug.vala"
		debug_log (stderr, "[MSG] ", message);
#line 194 "Debug.c"
	}
}


#line 66 "Debug.vala"
void debug_warning_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 66 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 67 "Debug.vala"
	if (debug_warning_enabled) {
#line 68 "Debug.vala"
		debug_log (stderr, "[WRN] ", message);
#line 207 "Debug.c"
	}
}


#line 71 "Debug.vala"
void debug_critical_handler (const char* domain, GLogLevelFlags flags, const char* message) {
#line 71 "Debug.vala"
	g_return_if_fail (message != NULL);
#line 72 "Debug.vala"
	if (debug_critical_enabled) {
#line 73 "Debug.vala"
		debug_log (stderr, "[CRT] ", message);
#line 220 "Debug.c"
	}
}




