/* Dimensions.c generated by valac, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};



GType scale_constraint_get_type (void);
char* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result);
char* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result);
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio);
double dimensions_get_aspect_ratio (Dimensions *self);
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result);
GType scaling_get_type (void);
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result);
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result);
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result);
void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
char* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self, Scaling* scaling);



#line 14 "Dimensions.vala"
char* scale_constraint_to_string (ScaleConstraint self) {
#line 113 "Dimensions.c"
	char* result = NULL;
#line 15 "Dimensions.vala"
	switch (self) {
#line 117 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			result = g_strdup (_ ("Original size"));
#line 17 "Dimensions.vala"
			return result;
#line 123 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			result = g_strdup (_ ("Width or height"));
#line 20 "Dimensions.vala"
			return result;
#line 130 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			result = g_strdup (_ ("Width"));
#line 23 "Dimensions.vala"
			return result;
#line 137 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			result = g_strdup (_ ("Height"));
#line 26 "Dimensions.vala"
			return result;
#line 144 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = g_strdup ("Fill Viewport");
#line 30 "Dimensions.vala"
			return result;
#line 151 "Dimensions.c"
		}
	}
#line 33 "Dimensions.vala"
	g_warn_if_reached ();
#line 156 "Dimensions.c"
	result = NULL;
#line 35 "Dimensions.vala"
	return result;
#line 160 "Dimensions.c"
}


GType scale_constraint_get_type (void) {
	static volatile gsize scale_constraint_type_id__volatile = 0;
	if (g_once_init_enter (&scale_constraint_type_id__volatile)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		GType scale_constraint_type_id;
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
		g_once_init_leave (&scale_constraint_type_id__volatile, scale_constraint_type_id);
	}
	return scale_constraint_type_id__volatile;
}


#line 43 "Dimensions.vala"
void dimensions_init (Dimensions *self, gint width, gint height) {
#line 178 "Dimensions.c"
	memset (self, 0, sizeof (Dimensions));
#line 44 "Dimensions.vala"
	g_assert ((width >= 0) && (height >= 0));
#line 46 "Dimensions.vala"
	(*self).width = width;
#line 47 "Dimensions.vala"
	(*self).height = height;
#line 186 "Dimensions.c"
}


#line 50 "Dimensions.vala"
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result) {
#line 192 "Dimensions.c"
	Dimensions _tmp0_ = {0};
#line 50 "Dimensions.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 196 "Dimensions.c"
	*result = (dimensions_init (&_tmp0_, gdk_pixbuf_get_width (pixbuf), gdk_pixbuf_get_height (pixbuf)), _tmp0_);
#line 51 "Dimensions.vala"
	return;
#line 200 "Dimensions.c"
}


#line 54 "Dimensions.vala"
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result) {
#line 206 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	*result = (dimensions_init (&_tmp0_, (*allocation).width, (*allocation).height), _tmp0_);
#line 55 "Dimensions.vala"
	return;
#line 211 "Dimensions.c"
}


#line 58 "Dimensions.vala"
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result) {
#line 217 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	*result = (dimensions_init (&_tmp0_, (*rect).width, (*rect).height), _tmp0_);
#line 59 "Dimensions.vala"
	return;
#line 222 "Dimensions.c"
}


#line 62 "Dimensions.vala"
gboolean dimensions_has_area (Dimensions *self) {
#line 228 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 63 "Dimensions.vala"
	if ((*self).width > 0) {
#line 63 "Dimensions.vala"
		_tmp0_ = (*self).height > 0;
#line 235 "Dimensions.c"
	} else {
#line 63 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 239 "Dimensions.c"
	}
	result = _tmp0_;
#line 63 "Dimensions.vala"
	return result;
#line 244 "Dimensions.c"
}


#line 66 "Dimensions.vala"
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result) {
#line 250 "Dimensions.c"
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
#line 67 "Dimensions.vala"
	if ((*self).width > (*min).width) {
#line 67 "Dimensions.vala"
		_tmp0_ = (*self).width;
#line 258 "Dimensions.c"
	} else {
#line 67 "Dimensions.vala"
		_tmp0_ = (*min).width;
#line 262 "Dimensions.c"
	}
#line 68 "Dimensions.vala"
	if ((*self).height > (*min).height) {
#line 68 "Dimensions.vala"
		_tmp1_ = (*self).height;
#line 268 "Dimensions.c"
	} else {
#line 68 "Dimensions.vala"
		_tmp1_ = (*min).height;
#line 272 "Dimensions.c"
	}
	*result = (dimensions_init (&_tmp2_, _tmp0_, _tmp1_), _tmp2_);
#line 67 "Dimensions.vala"
	return;
#line 277 "Dimensions.c"
}


#line 71 "Dimensions.vala"
char* dimensions_to_string (Dimensions *self) {
#line 283 "Dimensions.c"
	char* result = NULL;
	result = g_strdup_printf ("%dx%d", (*self).width, (*self).height);
#line 72 "Dimensions.vala"
	return result;
#line 288 "Dimensions.c"
}


#line 75 "Dimensions.vala"
gboolean dimensions_equals (Dimensions *self, Dimensions* dim) {
#line 294 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 76 "Dimensions.vala"
	if ((*self).width == (*dim).width) {
#line 76 "Dimensions.vala"
		_tmp0_ = (*self).height == (*dim).height;
#line 301 "Dimensions.c"
	} else {
#line 76 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 305 "Dimensions.c"
	}
	result = _tmp0_;
#line 76 "Dimensions.vala"
	return result;
#line 310 "Dimensions.c"
}


#line 80 "Dimensions.vala"
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge) {
#line 316 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 81 "Dimensions.vala"
	if (abs ((*self).width - (*dim).width) <= fudge) {
#line 81 "Dimensions.vala"
		_tmp0_ = abs ((*self).height - (*dim).height) <= fudge;
#line 323 "Dimensions.c"
	} else {
#line 81 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 327 "Dimensions.c"
	}
	result = _tmp0_;
#line 81 "Dimensions.vala"
	return result;
#line 332 "Dimensions.c"
}


#line 84 "Dimensions.vala"
gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge) {
#line 338 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 85 "Dimensions.vala"
	if ((*self).width <= (scale + fudge)) {
#line 85 "Dimensions.vala"
		_tmp0_ = (*self).height <= (scale + fudge);
#line 345 "Dimensions.c"
	} else {
#line 85 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 349 "Dimensions.c"
	}
	result = _tmp0_;
#line 85 "Dimensions.vala"
	return result;
#line 354 "Dimensions.c"
}


#line 88 "Dimensions.vala"
gint dimensions_major_axis (Dimensions *self) {
#line 360 "Dimensions.c"
	gint result = 0;
	result = MAX ((*self).width, (*self).height);
#line 89 "Dimensions.vala"
	return result;
#line 365 "Dimensions.c"
}


#line 92 "Dimensions.vala"
gint dimensions_minor_axis (Dimensions *self) {
#line 371 "Dimensions.c"
	gint result = 0;
	result = MIN ((*self).width, (*self).height);
#line 93 "Dimensions.vala"
	return result;
#line 376 "Dimensions.c"
}


#line 96 "Dimensions.vala"
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result) {
#line 382 "Dimensions.c"
	Dimensions min = {0};
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	dimensions_init (&min, 0, 0);
#line 98 "Dimensions.vala"
	if ((*self).width > min_width) {
#line 98 "Dimensions.vala"
		_tmp0_ = (*self).width;
#line 391 "Dimensions.c"
	} else {
#line 98 "Dimensions.vala"
		_tmp0_ = min_width;
#line 395 "Dimensions.c"
	}
#line 98 "Dimensions.vala"
	min.width = _tmp0_;
#line 99 "Dimensions.vala"
	if ((*self).height > min_height) {
#line 99 "Dimensions.vala"
		_tmp1_ = (*self).height;
#line 403 "Dimensions.c"
	} else {
#line 99 "Dimensions.vala"
		_tmp1_ = min_height;
#line 407 "Dimensions.c"
	}
#line 99 "Dimensions.vala"
	min.height = _tmp1_;
#line 411 "Dimensions.c"
	*result = min;
#line 101 "Dimensions.vala"
	return;
#line 415 "Dimensions.c"
}


#line 104 "Dimensions.vala"
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result) {
#line 421 "Dimensions.c"
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 105 "Dimensions.vala"
	g_assert (scale > 0);
#line 108 "Dimensions.vala"
	if ((*self).width == scale) {
#line 108 "Dimensions.vala"
		_tmp0_ = TRUE;
#line 430 "Dimensions.c"
	} else {
#line 108 "Dimensions.vala"
		_tmp0_ = (*self).height == scale;
#line 434 "Dimensions.c"
	}
#line 108 "Dimensions.vala"
	if (_tmp0_) {
#line 438 "Dimensions.c"
		Dimensions _tmp1_ = {0};
		*result = (dimensions_init (&_tmp1_, (*self).width, (*self).height), _tmp1_);
#line 109 "Dimensions.vala"
		return;
#line 443 "Dimensions.c"
	}
#line 112 "Dimensions.vala"
	if (!scale_up) {
#line 447 "Dimensions.c"
		gboolean _tmp3_ = FALSE;
#line 112 "Dimensions.vala"
		if ((*self).width < scale) {
#line 112 "Dimensions.vala"
			_tmp3_ = (*self).height < scale;
#line 453 "Dimensions.c"
		} else {
#line 112 "Dimensions.vala"
			_tmp3_ = FALSE;
#line 457 "Dimensions.c"
		}
#line 112 "Dimensions.vala"
		_tmp2_ = _tmp3_;
#line 461 "Dimensions.c"
	} else {
#line 112 "Dimensions.vala"
		_tmp2_ = FALSE;
#line 465 "Dimensions.c"
	}
#line 112 "Dimensions.vala"
	if (_tmp2_) {
#line 469 "Dimensions.c"
		Dimensions _tmp4_ = {0};
		*result = (dimensions_init (&_tmp4_, (*self).width, (*self).height), _tmp4_);
#line 113 "Dimensions.vala"
		return;
#line 474 "Dimensions.c"
	}
#line 115 "Dimensions.vala"
	if (((*self).width - scale) > ((*self).height - scale)) {
#line 478 "Dimensions.c"
		Dimensions _tmp5_ = {0};
		*result = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp5_), _tmp5_);
#line 116 "Dimensions.vala"
		return;
#line 483 "Dimensions.c"
	} else {
		Dimensions _tmp6_ = {0};
		*result = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp6_), _tmp6_);
#line 118 "Dimensions.vala"
		return;
#line 489 "Dimensions.c"
	}
}


#line 121 "Dimensions.vala"
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, double* width_ratio, double* height_ratio) {
#line 122 "Dimensions.vala"
	*width_ratio = ((double) (*scaled).width) / ((double) (*self).width);
#line 123 "Dimensions.vala"
	*height_ratio = ((double) (*scaled).height) / ((double) (*self).height);
#line 500 "Dimensions.c"
}


#line 126 "Dimensions.vala"
double dimensions_get_aspect_ratio (Dimensions *self) {
#line 506 "Dimensions.c"
	double result = 0.0;
	result = ((double) (*self).width) / (*self).height;
#line 127 "Dimensions.vala"
	return result;
#line 511 "Dimensions.c"
}


#line 130 "Dimensions.vala"
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result) {
#line 517 "Dimensions.c"
	double width_ratio = 0.0;
	double height_ratio = 0.0;
	double scaled_width = 0.0;
	double scaled_height = 0.0;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp3_;
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions scaled;
#line 132 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), viewport, &width_ratio, &height_ratio);
#line 135 "Dimensions.vala"
	if (width_ratio < height_ratio) {
#line 136 "Dimensions.vala"
		scaled_width = (double) (*viewport).width;
#line 137 "Dimensions.vala"
		scaled_height = ((double) (*self).height) * width_ratio;
#line 536 "Dimensions.c"
	} else {
#line 139 "Dimensions.vala"
		scaled_width = ((double) (*self).width) * height_ratio;
#line 140 "Dimensions.vala"
		scaled_height = (double) (*viewport).height;
#line 542 "Dimensions.c"
	}
#line 143 "Dimensions.vala"
	scaled = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (scaled_width), (gint) round (scaled_height)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 145 "Dimensions.vala"
	g_assert (scaled.height <= (*viewport).height);
#line 146 "Dimensions.vala"
	g_assert (scaled.width <= (*viewport).width);
#line 550 "Dimensions.c"
	*result = scaled;
#line 148 "Dimensions.vala"
	return;
#line 554 "Dimensions.c"
}


#line 151 "Dimensions.vala"
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result) {
#line 560 "Dimensions.c"
	double width_ratio = 0.0;
	double height_ratio = 0.0;
	double scaled_width = 0.0;
	double scaled_height = 0.0;
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp5_;
	Dimensions _tmp4_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
#line 153 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), viewport, &width_ratio, &height_ratio);
#line 156 "Dimensions.vala"
	if ((*self).width < (*viewport).width) {
#line 156 "Dimensions.vala"
		_tmp0_ = (*self).height >= (*viewport).height;
#line 577 "Dimensions.c"
	} else {
#line 156 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 581 "Dimensions.c"
	}
#line 156 "Dimensions.vala"
	if (_tmp0_) {
#line 158 "Dimensions.vala"
		scaled_width = (double) (*viewport).width;
#line 159 "Dimensions.vala"
		scaled_height = ((double) (*self).height) * width_ratio;
#line 589 "Dimensions.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 160 "Dimensions.vala"
		if ((*self).width >= (*viewport).width) {
#line 160 "Dimensions.vala"
			_tmp1_ = (*self).height < (*viewport).height;
#line 596 "Dimensions.c"
		} else {
#line 160 "Dimensions.vala"
			_tmp1_ = FALSE;
#line 600 "Dimensions.c"
		}
#line 160 "Dimensions.vala"
		if (_tmp1_) {
#line 162 "Dimensions.vala"
			scaled_width = ((double) (*self).width) * height_ratio;
#line 163 "Dimensions.vala"
			scaled_height = (double) (*viewport).height;
#line 608 "Dimensions.c"
		} else {
			double ratio;
#line 166 "Dimensions.vala"
			ratio = MAX (width_ratio, height_ratio);
#line 168 "Dimensions.vala"
			scaled_width = ((double) (*self).width) * ratio;
#line 169 "Dimensions.vala"
			scaled_height = ((double) (*self).height) * ratio;
#line 617 "Dimensions.c"
		}
	}
	*result = (dimensions_floor ((_tmp4_ = (dimensions_init (&_tmp2_, (gint) round (scaled_width), (gint) round (scaled_height)), _tmp2_), &_tmp4_), (_tmp5_ = (dimensions_init (&_tmp3_, 1, 1), _tmp3_), &_tmp5_), &_tmp6_), _tmp6_);
#line 172 "Dimensions.vala"
	return;
#line 623 "Dimensions.c"
}


#line 175 "Dimensions.vala"
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result) {
#line 629 "Dimensions.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	GdkRectangle scaled_rect = {0};
#line 177 "Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), scaled, &x_scale, &y_scale);
#line 635 "Dimensions.c"
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
#line 180 "Dimensions.vala"
	scaled_rect.x = (gint) round (((double) (*rect).x) * x_scale);
#line 181 "Dimensions.vala"
	scaled_rect.y = (gint) round (((double) (*rect).y) * y_scale);
#line 182 "Dimensions.vala"
	scaled_rect.width = (gint) round (((double) (*rect).width) * x_scale);
#line 183 "Dimensions.vala"
	scaled_rect.height = (gint) round (((double) (*rect).height) * y_scale);
#line 185 "Dimensions.vala"
	if (scaled_rect.width <= 0) {
#line 186 "Dimensions.vala"
		scaled_rect.width = 1;
#line 649 "Dimensions.c"
	}
#line 188 "Dimensions.vala"
	if (scaled_rect.height <= 0) {
#line 189 "Dimensions.vala"
		scaled_rect.height = 1;
#line 655 "Dimensions.c"
	}
	*result = scaled_rect;
#line 191 "Dimensions.vala"
	return;
#line 660 "Dimensions.c"
}


#line 195 "Dimensions.vala"
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result) {
#line 666 "Dimensions.c"
	double x_scale = 0.0;
	double y_scale = 0.0;
	double scale;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp3_;
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 197 "Dimensions.vala"
	dimensions_get_scale_ratios (original, scaled, &x_scale, &y_scale);
#line 199 "Dimensions.vala"
	scale = MIN (x_scale, y_scale);
#line 679 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (((double) (*self).width) * scale), (gint) round (((double) (*self).height) * scale)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 201 "Dimensions.vala"
	return;
#line 683 "Dimensions.c"
}


#line 205 "Dimensions.vala"
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result) {
#line 689 "Dimensions.c"
	double ratio;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp3_;
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 206 "Dimensions.vala"
	g_assert (scale > 0);
#line 208 "Dimensions.vala"
	ratio = ((double) scale) / ((double) (*self).width);
#line 700 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, scale, (gint) round (((double) (*self).height) * ratio)), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 210 "Dimensions.vala"
	return;
#line 704 "Dimensions.c"
}


#line 213 "Dimensions.vala"
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result) {
#line 710 "Dimensions.c"
	double ratio;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp3_;
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
#line 214 "Dimensions.vala"
	g_assert (scale > 0);
#line 216 "Dimensions.vala"
	ratio = ((double) scale) / ((double) (*self).height);
#line 721 "Dimensions.c"
	*result = (dimensions_floor ((_tmp2_ = (dimensions_init (&_tmp0_, (gint) round (((double) (*self).width) * ratio), scale), _tmp0_), &_tmp2_), (_tmp3_ = (dimensions_init (&_tmp1_, 1, 1), _tmp1_), &_tmp3_), &_tmp4_), _tmp4_);
#line 218 "Dimensions.vala"
	return;
#line 725 "Dimensions.c"
}


#line 221 "Dimensions.vala"
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result) {
#line 731 "Dimensions.c"
	Dimensions _tmp6_ = {0};
#line 222 "Dimensions.vala"
	switch (constraint) {
#line 735 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			Dimensions _tmp0_ = {0};
			*result = (dimensions_init (&_tmp0_, (*self).width, (*self).height), _tmp0_);
#line 224 "Dimensions.vala"
			return;
#line 742 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			Dimensions _tmp1_ = {0};
#line 227 "Dimensions.vala"
			if ((*self).width >= (*self).height) {
#line 749 "Dimensions.c"
				Dimensions _tmp2_ = {0};
#line 227 "Dimensions.vala"
				_tmp1_ = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp2_), _tmp2_);
#line 753 "Dimensions.c"
			} else {
				Dimensions _tmp3_ = {0};
#line 227 "Dimensions.vala"
				_tmp1_ = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp3_), _tmp3_);
#line 758 "Dimensions.c"
			}
			*result = _tmp1_;
#line 227 "Dimensions.vala"
			return;
#line 763 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			Dimensions _tmp4_ = {0};
			*result = (dimensions_get_scaled_by_width (&(*self), scale, &_tmp4_), _tmp4_);
#line 230 "Dimensions.vala"
			return;
#line 771 "Dimensions.c"
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			Dimensions _tmp5_ = {0};
			*result = (dimensions_get_scaled_by_height (&(*self), scale, &_tmp5_), _tmp5_);
#line 233 "Dimensions.vala"
			return;
#line 779 "Dimensions.c"
		}
	}
#line 236 "Dimensions.vala"
	g_error ("Dimensions.vala:236: Bad constraint: %d", (gint) constraint);
#line 784 "Dimensions.c"
	*result = (dimensions_init (&_tmp6_, 0, 0), _tmp6_);
#line 238 "Dimensions.vala"
	return;
#line 788 "Dimensions.c"
}


Dimensions* dimensions_dup (const Dimensions* self) {
	Dimensions* dup;
	dup = g_new0 (Dimensions, 1);
	memcpy (dup, self, sizeof (Dimensions));
	return dup;
}


void dimensions_free (Dimensions* self) {
	g_free (self);
}


GType dimensions_get_type (void) {
	static volatile gsize dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&dimensions_type_id__volatile)) {
		GType dimensions_type_id;
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
		g_once_init_leave (&dimensions_type_id__volatile, dimensions_type_id);
	}
	return dimensions_type_id__volatile;
}


#line 250 "Dimensions.vala"
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up) {
#line 818 "Dimensions.c"
	memset (self, 0, sizeof (Scaling));
#line 251 "Dimensions.vala"
	(*self).constraint = constraint;
#line 252 "Dimensions.vala"
	(*self).scale = scale;
#line 253 "Dimensions.vala"
	(*self).viewport = *viewport;
#line 254 "Dimensions.vala"
	(*self).scale_up = scale_up;
#line 828 "Dimensions.c"
}


#line 257 "Dimensions.vala"
void scaling_for_original (Scaling* result) {
#line 834 "Dimensions.c"
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, (_tmp2_ = (dimensions_init (&_tmp0_, 0, 0), _tmp0_), &_tmp2_), FALSE), _tmp1_);
#line 258 "Dimensions.vala"
	return;
#line 841 "Dimensions.c"
}


#line 261 "Dimensions.vala"
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result) {
#line 847 "Dimensions.c"
	Scaling _tmp2_ = {0};
	Dimensions _tmp1_;
	Dimensions _tmp0_ = {0};
#line 261 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 853 "Dimensions.c"
	*result = (scaling_for_viewport ((_tmp1_ = (scaling_get_screen_dimensions (window, &_tmp0_), _tmp0_), &_tmp1_), scale_up, &_tmp2_), _tmp2_);
#line 262 "Dimensions.vala"
	return;
#line 857 "Dimensions.c"
}


#line 265 "Dimensions.vala"
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result) {
#line 863 "Dimensions.c"
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 266 "Dimensions.vala"
	g_assert (pixels > 0);
#line 869 "Dimensions.c"
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, pixels, (_tmp2_ = (dimensions_init (&_tmp0_, 0, 0), _tmp0_), &_tmp2_), scale_up), _tmp1_);
#line 268 "Dimensions.vala"
	return;
#line 873 "Dimensions.c"
}


#line 271 "Dimensions.vala"
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result) {
#line 879 "Dimensions.c"
	Scaling _tmp0_ = {0};
#line 272 "Dimensions.vala"
	g_assert (dimensions_has_area (viewport));
#line 883 "Dimensions.c"
	*result = (scaling_init (&_tmp0_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, viewport, scale_up), _tmp0_);
#line 274 "Dimensions.vala"
	return;
#line 887 "Dimensions.c"
}


#line 277 "Dimensions.vala"
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result) {
#line 893 "Dimensions.c"
	Dimensions _tmp0_ = {0};
	Dimensions viewport;
	Scaling _tmp1_ = {0};
#line 277 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WIDGET (widget));
#line 278 "Dimensions.vala"
	viewport = (dimensions_for_allocation (&widget->allocation, &_tmp0_), _tmp0_);
#line 279 "Dimensions.vala"
	g_assert (dimensions_has_area (&viewport));
#line 903 "Dimensions.c"
	*result = (scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &viewport, scale_up), _tmp1_);
#line 281 "Dimensions.vala"
	return;
#line 907 "Dimensions.c"
}


#line 284 "Dimensions.vala"
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result) {
#line 913 "Dimensions.c"
	Scaling _tmp0_ = {0};
#line 285 "Dimensions.vala"
	g_assert (dimensions_has_area (viewport));
#line 917 "Dimensions.c"
	*result = (scaling_init (&_tmp0_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, viewport, TRUE), _tmp0_);
#line 287 "Dimensions.vala"
	return;
#line 921 "Dimensions.c"
}


#line 290 "Dimensions.vala"
void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result) {
#line 927 "Dimensions.c"
	Dimensions _tmp2_;
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
	*result = (scaling_init (&_tmp1_, constraint, scale, (_tmp2_ = (dimensions_init (&_tmp0_, 0, 0), _tmp0_), &_tmp2_), scale_up), _tmp1_);
#line 291 "Dimensions.vala"
	return;
#line 934 "Dimensions.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 294 "Dimensions.vala"
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result) {
#line 945 "Dimensions.c"
	GdkScreen* screen;
	Dimensions _tmp0_ = {0};
#line 294 "Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 295 "Dimensions.vala"
	screen = _g_object_ref0 (gtk_window_get_screen (window));
#line 952 "Dimensions.c"
	*result = (dimensions_init (&_tmp0_, gdk_screen_get_width (screen), gdk_screen_get_height (screen)), _tmp0_);
	_g_object_unref0 (screen);
#line 297 "Dimensions.vala"
	return;
#line 957 "Dimensions.c"
	_g_object_unref0 (screen);
}


#line 300 "Dimensions.vala"
static gint scaling_scale_to_pixels (Scaling *self) {
#line 964 "Dimensions.c"
	gint result = 0;
	gint _tmp0_ = 0;
#line 301 "Dimensions.vala"
	if ((*self).scale >= 0) {
#line 301 "Dimensions.vala"
		_tmp0_ = (*self).scale;
#line 971 "Dimensions.c"
	} else {
#line 301 "Dimensions.vala"
		_tmp0_ = 0;
#line 975 "Dimensions.c"
	}
	result = _tmp0_;
#line 301 "Dimensions.vala"
	return result;
#line 980 "Dimensions.c"
}


#line 304 "Dimensions.vala"
gboolean scaling_is_unscaled (Scaling *self) {
#line 986 "Dimensions.c"
	gboolean result = FALSE;
	result = (*self).constraint == SCALE_CONSTRAINT_ORIGINAL;
#line 305 "Dimensions.vala"
	return result;
#line 991 "Dimensions.c"
}


#line 308 "Dimensions.vala"
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels) {
#line 997 "Dimensions.c"
	gboolean result = FALSE;
#line 309 "Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 1001 "Dimensions.c"
		result = FALSE;
#line 310 "Dimensions.vala"
		return result;
#line 1005 "Dimensions.c"
	}
#line 312 "Dimensions.vala"
	switch ((*self).constraint) {
#line 1009 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
#line 315 "Dimensions.vala"
			return result;
#line 1016 "Dimensions.c"
		}
		default:
		{
#line 318 "Dimensions.vala"
			*pixels = scaling_scale_to_pixels (&(*self));
#line 319 "Dimensions.vala"
			g_assert ((*pixels) > 0);
#line 1024 "Dimensions.c"
			result = TRUE;
#line 321 "Dimensions.vala"
			return result;
#line 1028 "Dimensions.c"
		}
	}
}


#line 325 "Dimensions.vala"
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 1036 "Dimensions.c"
	gboolean result = FALSE;
#line 326 "Dimensions.vala"
	if ((*self).scale == SCALING_NO_SCALE) {
#line 1040 "Dimensions.c"
		result = FALSE;
#line 327 "Dimensions.vala"
		return result;
#line 1044 "Dimensions.c"
	}
#line 329 "Dimensions.vala"
	switch ((*self).constraint) {
#line 1048 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
#line 332 "Dimensions.vala"
			return result;
#line 1055 "Dimensions.c"
		}
		default:
		{
			gint pixels;
			Dimensions _tmp0_ = {0};
#line 335 "Dimensions.vala"
			pixels = scaling_scale_to_pixels (&(*self));
#line 336 "Dimensions.vala"
			g_assert (pixels > 0);
#line 338 "Dimensions.vala"
			*scaled = (dimensions_get_scaled_by_constraint (original, pixels, (*self).constraint, &_tmp0_), _tmp0_);
#line 1067 "Dimensions.c"
			result = TRUE;
#line 340 "Dimensions.vala"
			return result;
#line 1071 "Dimensions.c"
		}
	}
}


#line 344 "Dimensions.vala"
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 1079 "Dimensions.c"
	gboolean result = FALSE;
#line 345 "Dimensions.vala"
	if ((*self).scale != SCALING_NO_SCALE) {
#line 1083 "Dimensions.c"
		result = FALSE;
#line 346 "Dimensions.vala"
		return result;
#line 1087 "Dimensions.c"
	}
#line 348 "Dimensions.vala"
	switch ((*self).constraint) {
#line 1091 "Dimensions.c"
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
#line 351 "Dimensions.vala"
			return result;
#line 1098 "Dimensions.c"
		}
		default:
		{
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
#line 354 "Dimensions.vala"
			g_assert (dimensions_has_area (&(*self).viewport));
#line 356 "Dimensions.vala"
			if (!(*self).scale_up) {
#line 356 "Dimensions.vala"
				_tmp1_ = (*original).width < (*self).viewport.width;
#line 1110 "Dimensions.c"
			} else {
#line 356 "Dimensions.vala"
				_tmp1_ = FALSE;
#line 1114 "Dimensions.c"
			}
#line 356 "Dimensions.vala"
			if (_tmp1_) {
#line 356 "Dimensions.vala"
				_tmp0_ = (*original).height < (*self).viewport.height;
#line 1120 "Dimensions.c"
			} else {
#line 356 "Dimensions.vala"
				_tmp0_ = FALSE;
#line 1124 "Dimensions.c"
			}
#line 356 "Dimensions.vala"
			if (_tmp0_) {
#line 357 "Dimensions.vala"
				*scaled = *original;
#line 1130 "Dimensions.c"
			} else {
				Dimensions _tmp2_ = {0};
#line 359 "Dimensions.vala"
				*scaled = (dimensions_get_scaled_proportional (original, &(*self).viewport, &_tmp2_), _tmp2_);
#line 1135 "Dimensions.c"
			}
			result = TRUE;
#line 361 "Dimensions.vala"
			return result;
#line 1140 "Dimensions.c"
		}
	}
}


#line 365 "Dimensions.vala"
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
#line 1148 "Dimensions.c"
	gboolean result = FALSE;
	Dimensions _tmp0_ = {0};
#line 366 "Dimensions.vala"
	if ((*self).constraint != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 1153 "Dimensions.c"
		result = FALSE;
#line 367 "Dimensions.vala"
		return result;
#line 1157 "Dimensions.c"
	}
#line 369 "Dimensions.vala"
	g_assert (dimensions_has_area (&(*self).viewport));
#line 370 "Dimensions.vala"
	*scaled = (dimensions_get_scaled_to_fill_viewport (original, &(*self).viewport, &_tmp0_), _tmp0_);
#line 1163 "Dimensions.c"
	result = TRUE;
#line 372 "Dimensions.vala"
	return result;
#line 1167 "Dimensions.c"
}


#line 375 "Dimensions.vala"
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result) {
#line 1173 "Dimensions.c"
	Dimensions scaled = {0};
	gboolean is_viewport;
#line 376 "Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 1178 "Dimensions.c"
		*result = *original;
#line 377 "Dimensions.vala"
		return;
#line 1182 "Dimensions.c"
	}
#line 380 "Dimensions.vala"
	if (scaling_is_fill_viewport (&(*self), original, &scaled)) {
#line 1186 "Dimensions.c"
		*result = scaled;
#line 381 "Dimensions.vala"
		return;
#line 1190 "Dimensions.c"
	}
#line 383 "Dimensions.vala"
	if (scaling_is_best_fit_dimensions (&(*self), original, &scaled)) {
#line 1194 "Dimensions.c"
		*result = scaled;
#line 384 "Dimensions.vala"
		return;
#line 1198 "Dimensions.c"
	}
#line 386 "Dimensions.vala"
	is_viewport = scaling_is_for_viewport (&(*self), original, &scaled);
#line 387 "Dimensions.vala"
	g_assert (is_viewport);
#line 1204 "Dimensions.c"
	*result = scaled;
#line 389 "Dimensions.vala"
	return;
#line 1208 "Dimensions.c"
}


#line 392 "Dimensions.vala"
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up) {
#line 1214 "Dimensions.c"
	GdkPixbuf* result = NULL;
	Dimensions _tmp0_ = {0};
	Dimensions pixbuf_dim;
	gint pixels = 0;
	Dimensions scaled = {0};
	gboolean is_viewport;
#line 392 "Dimensions.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 393 "Dimensions.vala"
	if (scaling_is_unscaled (&(*self))) {
#line 1225 "Dimensions.c"
		result = _g_object_ref0 (pixbuf);
#line 394 "Dimensions.vala"
		return result;
#line 1229 "Dimensions.c"
	}
#line 396 "Dimensions.vala"
	pixbuf_dim = (dimensions_for_pixbuf (pixbuf, &_tmp0_), _tmp0_);
#line 399 "Dimensions.vala"
	if (scaling_is_best_fit (&(*self), &pixbuf_dim, &pixels)) {
#line 1235 "Dimensions.c"
		result = scale_pixbuf (pixbuf, pixels, interp, scale_up);
#line 400 "Dimensions.vala"
		return result;
#line 1239 "Dimensions.c"
	}
#line 403 "Dimensions.vala"
	if (scaling_is_fill_viewport (&(*self), &pixbuf_dim, &scaled)) {
#line 1243 "Dimensions.c"
		result = resize_pixbuf (pixbuf, &scaled, interp);
#line 404 "Dimensions.vala"
		return result;
#line 1247 "Dimensions.c"
	}
#line 406 "Dimensions.vala"
	is_viewport = scaling_is_for_viewport (&(*self), &pixbuf_dim, &scaled);
#line 407 "Dimensions.vala"
	g_assert (is_viewport);
#line 1253 "Dimensions.c"
	result = resize_pixbuf (pixbuf, &scaled, interp);
#line 409 "Dimensions.vala"
	return result;
#line 1257 "Dimensions.c"
}


#line 412 "Dimensions.vala"
char* scaling_to_string (Scaling *self) {
#line 1263 "Dimensions.c"
	char* result = NULL;
#line 413 "Dimensions.vala"
	if ((*self).constraint == SCALE_CONSTRAINT_ORIGINAL) {
#line 1267 "Dimensions.c"
		result = g_strdup ("scaling: UNSCALED");
#line 414 "Dimensions.vala"
		return result;
#line 1271 "Dimensions.c"
	} else {
#line 415 "Dimensions.vala"
		if ((*self).constraint == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 1275 "Dimensions.c"
			char* _tmp0_;
			char* _tmp1_;
			result = (_tmp1_ = g_strdup_printf ("scaling: fill viewport %s", _tmp0_ = dimensions_to_string (&(*self).viewport)), _g_free0 (_tmp0_), _tmp1_);
#line 416 "Dimensions.vala"
			return result;
#line 1281 "Dimensions.c"
		} else {
#line 417 "Dimensions.vala"
			if ((*self).scale != SCALING_NO_SCALE) {
#line 1285 "Dimensions.c"
				const char* _tmp2_;
				char* _tmp3_;
				char* _tmp4_;
				_tmp2_ = NULL;
#line 419 "Dimensions.vala"
				if ((*self).scale_up) {
#line 419 "Dimensions.vala"
					_tmp2_ = "scaled up";
#line 1294 "Dimensions.c"
				} else {
#line 419 "Dimensions.vala"
					_tmp2_ = "not scaled up";
#line 1298 "Dimensions.c"
				}
				result = (_tmp4_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp3_ = scale_constraint_to_string ((*self).constraint), scaling_scale_to_pixels (&(*self)), _tmp2_), _g_free0 (_tmp3_), _tmp4_);
#line 418 "Dimensions.vala"
				return result;
#line 1303 "Dimensions.c"
			} else {
				const char* _tmp5_;
				char* _tmp6_;
				char* _tmp7_;
				_tmp5_ = NULL;
#line 422 "Dimensions.vala"
				if ((*self).scale_up) {
#line 422 "Dimensions.vala"
					_tmp5_ = "scaled up";
#line 1313 "Dimensions.c"
				} else {
#line 422 "Dimensions.vala"
					_tmp5_ = "not scaled up";
#line 1317 "Dimensions.c"
				}
				result = (_tmp7_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp6_ = dimensions_to_string (&(*self).viewport), _tmp5_), _g_free0 (_tmp6_), _tmp7_);
#line 421 "Dimensions.vala"
				return result;
#line 1322 "Dimensions.c"
			}
		}
	}
}


#line 425 "Dimensions.vala"
gboolean scaling_equals (Scaling *self, Scaling* scaling) {
#line 1331 "Dimensions.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 426 "Dimensions.vala"
	if ((*self).constraint == (*scaling).constraint) {
#line 426 "Dimensions.vala"
		_tmp1_ = (*self).scale == (*scaling).scale;
#line 1339 "Dimensions.c"
	} else {
#line 426 "Dimensions.vala"
		_tmp1_ = FALSE;
#line 1343 "Dimensions.c"
	}
#line 426 "Dimensions.vala"
	if (_tmp1_) {
#line 427 "Dimensions.vala"
		_tmp0_ = dimensions_equals (&(*self).viewport, &(*scaling).viewport);
#line 1349 "Dimensions.c"
	} else {
#line 426 "Dimensions.vala"
		_tmp0_ = FALSE;
#line 1353 "Dimensions.c"
	}
	result = _tmp0_;
#line 426 "Dimensions.vala"
	return result;
#line 1358 "Dimensions.c"
}


Scaling* scaling_dup (const Scaling* self) {
	Scaling* dup;
	dup = g_new0 (Scaling, 1);
	memcpy (dup, self, sizeof (Scaling));
	return dup;
}


void scaling_free (Scaling* self) {
	g_free (self);
}


GType scaling_get_type (void) {
	static volatile gsize scaling_type_id__volatile = 0;
	if (g_once_init_enter (&scaling_type_id__volatile)) {
		GType scaling_type_id;
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
		g_once_init_leave (&scaling_type_id__volatile, scaling_type_id);
	}
	return scaling_type_id__volatile;
}




