/* Exif.c generated by valac, the Vala compiler
 * generated from Exif.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <libexif/exif-data.h>
#include <libexif/exif-data-type.h>
#include <libexif/exif-ifd.h>
#include <libexif/exif-tag.h>
#include <libexif/exif-entry.h>
#include <libexif/exif-content.h>
#include <libexif/exif-format.h>
#include <libexif/exif-mem.h>
#include <stdlib.h>
#include <string.h>
#include <libexif/exif-utils.h>
#include <time.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <libexif/exif-byte-order.h>
#include <gio/gio.h>
#include <errno.h>
#include <gobject/gvaluecollector.h>

#define _exif_entry_unref0(var) ((var == NULL) ? NULL : (var = (exif_entry_unref (var), NULL)))
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))
#define _exif_content_unref0(var) ((var == NULL) ? NULL : (var = (exif_content_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_PHOTO_EXIF (photo_exif_get_type ())
#define PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_EXIF, PhotoExif))
#define PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_EXIF, PhotoExifClass))
#define IS_PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_EXIF))
#define IS_PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_EXIF))
#define PHOTO_EXIF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_EXIF, PhotoExifClass))

typedef struct _PhotoExif PhotoExif;
typedef struct _PhotoExifClass PhotoExifClass;
typedef struct _PhotoExifPrivate PhotoExifPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define JPEG_TYPE_MARKER (jpeg_marker_get_type ())
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _ParamSpecPhotoExif ParamSpecPhotoExif;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	EXIF_ERROR_FILE_FORMAT
} ExifError;
#define EXIF_ERROR exif_error_quark ()
struct _PhotoExif {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoExifPrivate * priv;
};

struct _PhotoExifClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoExif *self);
};

struct _PhotoExifPrivate {
	GFile* file;
	ExifData* exif;
};

typedef enum  {
	JPEG_MARKER_SOI = 0xD8,
	JPEG_MARKER_EOI = 0xD9,
	JPEG_MARKER_APP0 = 0xE0,
	JPEG_MARKER_APP1 = 0xE1
} JpegMarker;

struct _ParamSpecPhotoExif {
	GParamSpec parent_instance;
};


static gpointer photo_exif_parent_class = NULL;

gboolean exif_find_ifd (ExifTag tag, ExifDataType data_type, ExifIfd* ifd);
ExifEntry* exif_alloc_entry (ExifData* exif, ExifTag tag, ExifFormat format);
void exif_realloc_ascii (ExifEntry* entry, const char* str);
void exif_realloc_long (ExifData* parent, ExifEntry* entry, guint32 l);
ExifEntry* exif_find_first_entry (ExifData* data, ExifTag tag, ExifFormat format, gint size);
ExifEntry* exif_find_first_entry_multiformat (ExifData* exif, ExifTag tag, ExifFormat format1, ExifFormat format2);
gint exif_remove_all_tags (ExifData* data, ExifTag tag);
gboolean exif_convert_datetime (const char* datetime, time_t* timestamp);
char* exif_convert_timestamp (time_t timestamp);
gboolean exif_get_timestamp (ExifData* exif, time_t* timestamp);
void exif_set_datetime (ExifData* exif, const char* datetime);
void exif_set_timestamp (ExifData* exif, time_t timestamp);
char* exif_get_datetime (ExifData* exif);
double exif_rational_to_double (ExifRational rational);
GType orientation_get_type (void);
Orientation exif_get_orientation (ExifData* exif);
void exif_set_orientation (ExifData** exif, Orientation orientation);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
gboolean exif_get_dimensions (ExifData* exif, Dimensions* dim);
void exif_set_dimensions (ExifData** exif, Dimensions* dim);
char* exif_get_exposure (ExifData* exif);
char* exif_get_aperture (ExifData* exif);
char* exif_get_iso (ExifData* exif);
char* exif_get_camera_make (ExifData* exif);
char* exif_get_camera_model (ExifData* exif);
char* exif_get_flash (ExifData* exif);
char* exif_get_focal_length (ExifData* exif);
ExifRational* exif_get_gps_rationals (ExifEntry* entry, ExifByteOrder byte_order, int* result_length1);
ExifRational* exif_get_raw_gps_lat (ExifData* exif, int* result_length1);
ExifRational* exif_get_raw_gps_long (ExifData* exif, int* result_length1);
double exif_get_angle (ExifRational* rationals, int rationals_length1);
double exif_get_gps_lat (ExifData* exif);
double exif_get_gps_long (ExifData* exif);
char* exif_get_gps_lat_ref (ExifData* exif);
char* exif_get_gps_long_ref (ExifData* exif);
char* exif_get_artist (ExifData* exif);
char* exif_get_copyright (ExifData* exif);
char* exif_get_software (ExifData* exif);
GQuark exif_error_quark (void);
gpointer photo_exif_ref (gpointer instance);
void photo_exif_unref (gpointer instance);
GParamSpec* param_spec_photo_exif (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_exif (GValue* value, gpointer v_object);
void value_take_photo_exif (GValue* value, gpointer v_object);
gpointer value_get_photo_exif (const GValue* value);
GType photo_exif_get_type (void);
#define PHOTO_EXIF_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_EXIF, PhotoExifPrivate))
enum  {
	PHOTO_EXIF_DUMMY_PROPERTY
};
PhotoExif* photo_exif_new (GFile* file);
PhotoExif* photo_exif_construct (GType object_type, GFile* file);
guint8* photo_exif_get_raw_exif (PhotoExif* self, gsize* raw_length, int* result_length1, GError** error);
void photo_exif_load (PhotoExif* self, GError** error);
gboolean photo_exif_query_has_exif (PhotoExif* self);
GType jpeg_marker_get_type (void);
gint jpeg_read_marker (GFileInputStream* fins, JpegMarker* marker, GError** error);
#define JPEG_MARKER_PREFIX ((guint8) 0xFF)
static guchar* photo_exif_flatten_sans_thumbnail (PhotoExif* self, gint* size);
char* md5_binary (guint8* buffer, gsize length);
char* photo_exif_get_md5 (PhotoExif* self);
char* photo_exif_get_thumbnail_md5 (PhotoExif* self);
ExifData* photo_exif_get_exif (PhotoExif* self);
void photo_exif_set_exif (PhotoExif* self, ExifData* exif);
Orientation photo_exif_get_orientation (PhotoExif* self);
void photo_exif_set_orientation (PhotoExif* self, Orientation orientation);
gboolean photo_exif_get_dimensions (PhotoExif* self, Dimensions* dim);
void photo_exif_set_dimensions (PhotoExif* self, Dimensions* dim);
char* photo_exif_get_datetime (PhotoExif* self);
void photo_exif_set_datetime (PhotoExif* self, const char* datetime);
gboolean photo_exif_get_timestamp (PhotoExif* self, time_t* timestamp);
void photo_exif_set_timestamp (PhotoExif* self, time_t timestamp);
gint photo_exif_remove_all_tags (PhotoExif* self, ExifTag tag);
gboolean photo_exif_remove_thumbnail (PhotoExif* self);
static guchar* photo_exif_flatten (PhotoExif* self, gint* size);
static GFileOutputStream* photo_exif_create_temp (GFile* original, GFile** temp, GError** error);
void jpeg_write_marker (GFileOutputStream* fouts, JpegMarker marker, gint length, GError** error);
void photo_exif_commit (PhotoExif* self, GError** error);
static void photo_exif_finalize (PhotoExif* obj);

const guint8 EXIF_SIGNATURE[4] = {(guint8) 0x45, (guint8) 0x78, (guint8) 0x69, (guint8) 0x66};


#line 128 "libexif.vapi"
static gboolean exif_data_type_is_valid (ExifDataType self) {
#line 202 "Exif.c"
	gboolean result = FALSE;
#line 129 "libexif.vapi"
	switch (self) {
#line 206 "Exif.c"
		case EXIF_DATA_TYPE_UNCOMPRESSED_CHUNKY:
		case EXIF_DATA_TYPE_UNCOMPRESSED_PLANAR:
		case EXIF_DATA_TYPE_UNCOMPRESSED_YCC:
		case EXIF_DATA_TYPE_COMPRESSED:
		{
			result = TRUE;
#line 134 "libexif.vapi"
			return result;
#line 215 "Exif.c"
		}
		default:
		{
			result = FALSE;
#line 137 "libexif.vapi"
			return result;
#line 222 "Exif.c"
		}
	}
}


#line 12 "Exif.vala"
ExifEntry* exif_alloc_entry (ExifData* exif, ExifTag tag, ExifFormat format) {
#line 230 "Exif.c"
	ExifEntry* result = NULL;
	ExifIfd ifd = 0;
	gboolean found;
	ExifEntry* entry;
#line 12 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 13 "Exif.vala"
	g_assert (exif_data_type_is_valid (exif_data_get_data_type (exif)));
#line 19 "Exif.vala"
	found = exif_find_ifd (tag, exif_data_get_data_type (exif), &ifd);
#line 20 "Exif.vala"
	g_assert (found);
#line 22 "Exif.vala"
	entry = exif_entry_new ();
#line 23 "Exif.vala"
	exif_content_add_entry (exif->ifd[ifd], entry);
#line 24 "Exif.vala"
	exif_entry_initialize (entry, tag);
#line 249 "Exif.c"
	result = entry;
#line 26 "Exif.vala"
	return result;
#line 253 "Exif.c"
}


#line 29 "Exif.vala"
void exif_realloc_ascii (ExifEntry* entry, const char* str) {
#line 259 "Exif.c"
	ExifMem* mem;
#line 29 "Exif.vala"
	g_return_if_fail (entry != NULL);
#line 29 "Exif.vala"
	g_return_if_fail (str != NULL);
#line 30 "Exif.vala"
	mem = exif_mem_new_default ();
#line 32 "Exif.vala"
	if (entry->data != NULL) {
#line 33 "Exif.vala"
		exif_mem_free (mem, entry->data);
#line 34 "Exif.vala"
		entry->data = NULL;
#line 273 "Exif.c"
	}
#line 37 "Exif.vala"
	entry->format = EXIF_FORMAT_ASCII;
#line 38 "Exif.vala"
	entry->components = (gulong) (strlen (str) + 1);
#line 39 "Exif.vala"
	entry->size = exif_format_get_size (EXIF_FORMAT_ASCII) * ((guint) entry->components);
#line 42 "Exif.vala"
	entry->data = exif_mem_alloc (mem, (guint32) entry->size);
#line 43 "Exif.vala"
	memcpy (entry->data, str, (gsize) entry->size);
#line 285 "Exif.c"
	_exif_mem_unref0 (mem);
}


#line 46 "Exif.vala"
void exif_realloc_long (ExifData* parent, ExifEntry* entry, guint32 l) {
#line 292 "Exif.c"
	ExifMem* mem;
#line 46 "Exif.vala"
	g_return_if_fail (parent != NULL);
#line 46 "Exif.vala"
	g_return_if_fail (entry != NULL);
#line 47 "Exif.vala"
	mem = exif_mem_new_default ();
#line 49 "Exif.vala"
	if (entry->data != NULL) {
#line 50 "Exif.vala"
		exif_mem_free (mem, entry->data);
#line 51 "Exif.vala"
		entry->data = NULL;
#line 306 "Exif.c"
	}
#line 54 "Exif.vala"
	entry->format = EXIF_FORMAT_LONG;
#line 55 "Exif.vala"
	entry->components = (gulong) 1;
#line 56 "Exif.vala"
	entry->size = exif_format_get_size (EXIF_FORMAT_LONG) * ((guint) entry->components);
#line 57 "Exif.vala"
	entry->data = exif_mem_alloc (mem, (guint32) entry->size);
#line 58 "Exif.vala"
	exif_set_long (entry->data, exif_data_get_byte_order (parent), l);
#line 318 "Exif.c"
	_exif_mem_unref0 (mem);
}


#line 63 "Exif.vala"
gboolean exif_find_ifd (ExifTag tag, ExifDataType data_type, ExifIfd* ifd) {
#line 325 "Exif.c"
	gboolean result = FALSE;
	gint mandatory;
	gint optional;
#line 64 "Exif.vala"
	mandatory = -1;
#line 65 "Exif.vala"
	optional = -1;
#line 333 "Exif.c"
	{
		gint ctr;
#line 67 "Exif.vala"
		ctr = 0;
#line 338 "Exif.c"
		{
			gboolean _tmp0_;
#line 67 "Exif.vala"
			_tmp0_ = TRUE;
#line 67 "Exif.vala"
			while (TRUE) {
#line 67 "Exif.vala"
				if (!_tmp0_) {
#line 67 "Exif.vala"
					ctr++;
#line 349 "Exif.c"
				}
#line 67 "Exif.vala"
				_tmp0_ = FALSE;
#line 67 "Exif.vala"
				if (!(ctr < ((gint) EXIF_IFD_COUNT))) {
#line 67 "Exif.vala"
					break;
#line 357 "Exif.c"
				}
#line 68 "Exif.vala"
				switch (exif_tag_get_support_level_in_ifd (tag, (ExifIfd) ctr, data_type)) {
#line 361 "Exif.c"
					case EXIF_SUPPORT_LEVEL_MANDATORY:
					{
#line 70 "Exif.vala"
						if (mandatory == (-1)) {
#line 71 "Exif.vala"
							mandatory = ctr;
#line 368 "Exif.c"
						}
#line 72 "Exif.vala"
						break;
#line 372 "Exif.c"
					}
					case EXIF_SUPPORT_LEVEL_OPTIONAL:
					{
#line 75 "Exif.vala"
						if (optional == (-1)) {
#line 76 "Exif.vala"
							optional = ctr;
#line 380 "Exif.c"
						}
#line 77 "Exif.vala"
						break;
#line 384 "Exif.c"
					}
					default:
					{
#line 81 "Exif.vala"
						break;
#line 390 "Exif.c"
					}
				}
			}
		}
	}
#line 85 "Exif.vala"
	if (mandatory != (-1)) {
#line 86 "Exif.vala"
		*ifd = (ExifIfd) mandatory;
#line 400 "Exif.c"
	} else {
#line 87 "Exif.vala"
		if (optional != (-1)) {
#line 88 "Exif.vala"
			*ifd = (ExifIfd) optional;
#line 406 "Exif.c"
		} else {
			result = FALSE;
#line 90 "Exif.vala"
			return result;
#line 411 "Exif.c"
		}
	}
	result = TRUE;
#line 92 "Exif.vala"
	return result;
#line 417 "Exif.c"
}


#line 95 "Exif.vala"
ExifEntry* exif_find_first_entry (ExifData* data, ExifTag tag, ExifFormat format, gint size) {
#line 423 "Exif.c"
	ExifEntry* result = NULL;
#line 95 "Exif.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 427 "Exif.c"
	{
		gint ctr;
#line 96 "Exif.vala"
		ctr = 0;
#line 432 "Exif.c"
		{
			gboolean _tmp0_;
#line 96 "Exif.vala"
			_tmp0_ = TRUE;
#line 96 "Exif.vala"
			while (TRUE) {
#line 439 "Exif.c"
				ExifContent* _tmp1_;
				ExifContent* content;
				ExifEntry* _tmp2_;
				ExifEntry* entry;
				gboolean _tmp3_ = FALSE;
#line 96 "Exif.vala"
				if (!_tmp0_) {
#line 96 "Exif.vala"
					ctr++;
#line 449 "Exif.c"
				}
#line 96 "Exif.vala"
				_tmp0_ = FALSE;
#line 96 "Exif.vala"
				if (!(ctr < ((gint) EXIF_IFD_COUNT))) {
#line 96 "Exif.vala"
					break;
#line 457 "Exif.c"
				}
#line 97 "Exif.vala"
				content = (_tmp1_ = data->ifd[ctr], (_tmp1_ == NULL) ? NULL : exif_content_ref (_tmp1_), _tmp1_);
#line 98 "Exif.vala"
				if (content == NULL) {
#line 463 "Exif.c"
					_exif_content_unref0 (content);
#line 99 "Exif.vala"
					continue;
#line 467 "Exif.c"
				}
#line 101 "Exif.vala"
				entry = (_tmp2_ = exif_content_get_entry (content, tag), (_tmp2_ == NULL) ? NULL : exif_entry_ref (_tmp2_), _tmp2_);
#line 102 "Exif.vala"
				if (entry == NULL) {
#line 473 "Exif.c"
					_exif_content_unref0 (content);
					_exif_entry_unref0 (entry);
#line 103 "Exif.vala"
					continue;
#line 478 "Exif.c"
				}
#line 105 "Exif.vala"
				if (entry->format != format) {
#line 482 "Exif.c"
					_exif_content_unref0 (content);
					_exif_entry_unref0 (entry);
#line 106 "Exif.vala"
					continue;
#line 487 "Exif.c"
				}
#line 108 "Exif.vala"
				if (format != EXIF_FORMAT_ASCII) {
#line 108 "Exif.vala"
					_tmp3_ = format != EXIF_FORMAT_UNDEFINED;
#line 493 "Exif.c"
				} else {
#line 108 "Exif.vala"
					_tmp3_ = FALSE;
#line 497 "Exif.c"
				}
#line 108 "Exif.vala"
				if (_tmp3_) {
#line 109 "Exif.vala"
					if (entry->size != (exif_format_get_size (format) * size)) {
#line 503 "Exif.c"
						_exif_content_unref0 (content);
						_exif_entry_unref0 (entry);
#line 110 "Exif.vala"
						continue;
#line 508 "Exif.c"
					}
				}
				result = entry;
				_exif_content_unref0 (content);
#line 113 "Exif.vala"
				return result;
#line 515 "Exif.c"
			}
		}
	}
	result = NULL;
#line 116 "Exif.vala"
	return result;
#line 522 "Exif.c"
}


#line 119 "Exif.vala"
ExifEntry* exif_find_first_entry_multiformat (ExifData* exif, ExifTag tag, ExifFormat format1, ExifFormat format2) {
#line 528 "Exif.c"
	ExifEntry* result = NULL;
#line 119 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 532 "Exif.c"
	{
		gint ctr;
#line 121 "Exif.vala"
		ctr = 0;
#line 537 "Exif.c"
		{
			gboolean _tmp0_;
#line 121 "Exif.vala"
			_tmp0_ = TRUE;
#line 121 "Exif.vala"
			while (TRUE) {
#line 544 "Exif.c"
				ExifContent* _tmp1_;
				ExifContent* content;
				ExifEntry* _tmp2_;
				ExifEntry* entry;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
#line 121 "Exif.vala"
				if (!_tmp0_) {
#line 121 "Exif.vala"
					ctr++;
#line 555 "Exif.c"
				}
#line 121 "Exif.vala"
				_tmp0_ = FALSE;
#line 121 "Exif.vala"
				if (!(ctr < EXIF_IFD_COUNT)) {
#line 121 "Exif.vala"
					break;
#line 563 "Exif.c"
				}
#line 122 "Exif.vala"
				content = (_tmp1_ = exif->ifd[(gint) ctr], (_tmp1_ == NULL) ? NULL : exif_content_ref (_tmp1_), _tmp1_);
#line 123 "Exif.vala"
				if (content == NULL) {
#line 569 "Exif.c"
					_exif_content_unref0 (content);
#line 124 "Exif.vala"
					continue;
#line 573 "Exif.c"
				}
#line 126 "Exif.vala"
				entry = (_tmp2_ = exif_content_get_entry (content, tag), (_tmp2_ == NULL) ? NULL : exif_entry_ref (_tmp2_), _tmp2_);
#line 127 "Exif.vala"
				if (entry == NULL) {
#line 579 "Exif.c"
					_exif_content_unref0 (content);
					_exif_entry_unref0 (entry);
#line 128 "Exif.vala"
					continue;
#line 584 "Exif.c"
				}
#line 130 "Exif.vala"
				if (entry->format != format1) {
#line 130 "Exif.vala"
					_tmp3_ = entry->format != format2;
#line 590 "Exif.c"
				} else {
#line 130 "Exif.vala"
					_tmp3_ = FALSE;
#line 594 "Exif.c"
				}
#line 130 "Exif.vala"
				if (_tmp3_) {
#line 598 "Exif.c"
					_exif_content_unref0 (content);
					_exif_entry_unref0 (entry);
#line 131 "Exif.vala"
					continue;
#line 603 "Exif.c"
				}
#line 134 "Exif.vala"
				if (entry->format != EXIF_FORMAT_ASCII) {
#line 134 "Exif.vala"
					_tmp4_ = entry->format != EXIF_FORMAT_UNDEFINED;
#line 609 "Exif.c"
				} else {
#line 134 "Exif.vala"
					_tmp4_ = FALSE;
#line 613 "Exif.c"
				}
#line 134 "Exif.vala"
				if (_tmp4_) {
#line 617 "Exif.c"
					gboolean _tmp5_ = FALSE;
#line 135 "Exif.vala"
					if (entry->size != exif_format_get_size (format1)) {
#line 135 "Exif.vala"
						_tmp5_ = entry->size != exif_format_get_size (format2);
#line 623 "Exif.c"
					} else {
#line 135 "Exif.vala"
						_tmp5_ = FALSE;
#line 627 "Exif.c"
					}
#line 135 "Exif.vala"
					if (_tmp5_) {
#line 631 "Exif.c"
						_exif_content_unref0 (content);
						_exif_entry_unref0 (entry);
#line 136 "Exif.vala"
						continue;
#line 636 "Exif.c"
					}
				}
				result = entry;
				_exif_content_unref0 (content);
#line 139 "Exif.vala"
				return result;
#line 643 "Exif.c"
			}
		}
	}
	result = NULL;
#line 142 "Exif.vala"
	return result;
#line 650 "Exif.c"
}


#line 145 "Exif.vala"
gint exif_remove_all_tags (ExifData* data, ExifTag tag) {
#line 656 "Exif.c"
	gint result = 0;
	gint count;
#line 145 "Exif.vala"
	g_return_val_if_fail (data != NULL, 0);
#line 146 "Exif.vala"
	count = 0;
#line 663 "Exif.c"
	{
		gint ctr;
#line 147 "Exif.vala"
		ctr = 0;
#line 668 "Exif.c"
		{
			gboolean _tmp0_;
#line 147 "Exif.vala"
			_tmp0_ = TRUE;
#line 147 "Exif.vala"
			while (TRUE) {
#line 675 "Exif.c"
				ExifContent* _tmp1_;
				ExifContent* content;
				ExifEntry* _tmp2_;
				ExifEntry* entry;
#line 147 "Exif.vala"
				if (!_tmp0_) {
#line 147 "Exif.vala"
					ctr++;
#line 684 "Exif.c"
				}
#line 147 "Exif.vala"
				_tmp0_ = FALSE;
#line 147 "Exif.vala"
				if (!(ctr < ((gint) EXIF_IFD_COUNT))) {
#line 147 "Exif.vala"
					break;
#line 692 "Exif.c"
				}
#line 148 "Exif.vala"
				content = (_tmp1_ = data->ifd[ctr], (_tmp1_ == NULL) ? NULL : exif_content_ref (_tmp1_), _tmp1_);
#line 149 "Exif.vala"
				if (content == NULL) {
#line 698 "Exif.c"
					_exif_content_unref0 (content);
#line 150 "Exif.vala"
					continue;
#line 702 "Exif.c"
				}
#line 152 "Exif.vala"
				entry = (_tmp2_ = exif_content_get_entry (content, tag), (_tmp2_ == NULL) ? NULL : exif_entry_ref (_tmp2_), _tmp2_);
#line 153 "Exif.vala"
				if (entry == NULL) {
#line 708 "Exif.c"
					_exif_content_unref0 (content);
					_exif_entry_unref0 (entry);
#line 154 "Exif.vala"
					continue;
#line 713 "Exif.c"
				}
#line 156 "Exif.vala"
				exif_content_remove_entry (content, entry);
#line 157 "Exif.vala"
				count++;
#line 719 "Exif.c"
				_exif_content_unref0 (content);
				_exif_entry_unref0 (entry);
			}
		}
	}
	result = count;
#line 160 "Exif.vala"
	return result;
#line 728 "Exif.c"
}


#line 163 "Exif.vala"
gboolean exif_convert_datetime (const char* datetime, time_t* timestamp) {
#line 734 "Exif.c"
	gboolean result = FALSE;
	struct tm tm = {0};
	gint count;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 163 "Exif.vala"
	g_return_val_if_fail (datetime != NULL, FALSE);
#line 745 "Exif.c"
	memset (&tm, 0, sizeof (struct tm));
#line 165 "Exif.vala"
	count = sscanf (datetime, "%d:%d:%d %d:%d:%d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec);
#line 167 "Exif.vala"
	if (count != 6) {
#line 751 "Exif.c"
		result = FALSE;
#line 168 "Exif.vala"
		return result;
#line 755 "Exif.c"
	}
#line 171 "Exif.vala"
	if (tm.tm_year <= 1900) {
#line 171 "Exif.vala"
		_tmp4_ = TRUE;
#line 761 "Exif.c"
	} else {
#line 171 "Exif.vala"
		_tmp4_ = tm.tm_mon <= 0;
#line 765 "Exif.c"
	}
#line 171 "Exif.vala"
	if (_tmp4_) {
#line 171 "Exif.vala"
		_tmp3_ = TRUE;
#line 771 "Exif.c"
	} else {
#line 171 "Exif.vala"
		_tmp3_ = tm.tm_mday < 0;
#line 775 "Exif.c"
	}
#line 171 "Exif.vala"
	if (_tmp3_) {
#line 171 "Exif.vala"
		_tmp2_ = TRUE;
#line 781 "Exif.c"
	} else {
#line 171 "Exif.vala"
		_tmp2_ = tm.tm_hour < 0;
#line 785 "Exif.c"
	}
#line 171 "Exif.vala"
	if (_tmp2_) {
#line 171 "Exif.vala"
		_tmp1_ = TRUE;
#line 791 "Exif.c"
	} else {
#line 171 "Exif.vala"
		_tmp1_ = tm.tm_min < 0;
#line 795 "Exif.c"
	}
#line 171 "Exif.vala"
	if (_tmp1_) {
#line 171 "Exif.vala"
		_tmp0_ = TRUE;
#line 801 "Exif.c"
	} else {
#line 171 "Exif.vala"
		_tmp0_ = tm.tm_sec < 0;
#line 805 "Exif.c"
	}
#line 171 "Exif.vala"
	if (_tmp0_) {
#line 809 "Exif.c"
		result = FALSE;
#line 172 "Exif.vala"
		return result;
#line 813 "Exif.c"
	}
#line 174 "Exif.vala"
	tm.tm_year = tm.tm_year - 1900;
#line 175 "Exif.vala"
	tm.tm_mon--;
#line 176 "Exif.vala"
	tm.tm_isdst = -1;
#line 178 "Exif.vala"
	*timestamp = mktime (&tm);
#line 823 "Exif.c"
	result = TRUE;
#line 180 "Exif.vala"
	return result;
#line 827 "Exif.c"
}


#line 2053 "glib-2.0.vapi"
static void g_time_local (time_t time, struct tm* result) {
#line 833 "Exif.c"
	struct tm _result_ = {0};
#line 2055 "glib-2.0.vapi"
	localtime_r (&time, &_result_);
#line 837 "Exif.c"
	*result = _result_;
#line 2056 "glib-2.0.vapi"
	return;
#line 841 "Exif.c"
}


#line 2063 "glib-2.0.vapi"
static char* g_time_format (struct tm *self, const char* format) {
#line 847 "Exif.c"
	char* result = NULL;
	gchar* _tmp0_;
	gint _buffer_size_;
	gint buffer_length1;
	gchar* buffer;
#line 2063 "glib-2.0.vapi"
	g_return_val_if_fail (format != NULL, NULL);
#line 855 "Exif.c"
	buffer = (_tmp0_ = g_new0 (gchar, 64), buffer_length1 = 64, _buffer_size_ = buffer_length1, _tmp0_);
#line 2065 "glib-2.0.vapi"
	strftime (buffer, buffer_length1, format, &(*self));
#line 859 "Exif.c"
	result = g_strdup ((const char*) buffer);
	buffer = (g_free (buffer), NULL);
#line 2066 "glib-2.0.vapi"
	return result;
#line 864 "Exif.c"
}


#line 183 "Exif.vala"
char* exif_convert_timestamp (time_t timestamp) {
#line 870 "Exif.c"
	char* result = NULL;
	struct tm _tmp1_;
	struct tm _tmp0_ = {0};
	result = g_time_format ((_tmp1_ = (g_time_local (timestamp, &_tmp0_), _tmp0_), &_tmp1_), "%Y:%m:%d %H:%M:%S");
#line 184 "Exif.vala"
	return result;
#line 877 "Exif.c"
}


#line 160 "libexif.vapi"
static char* exif_entry_get_string (ExifEntry* self) {
#line 883 "Exif.c"
	char* result = NULL;
	gchar* _tmp0_;
	gint _buffer_size_;
	gint buffer_length1;
	gchar* buffer;
	GString* builder;
#line 160 "libexif.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 892 "Exif.c"
	buffer = (_tmp0_ = g_new0 (gchar, 256), buffer_length1 = 256, _buffer_size_ = buffer_length1, _tmp0_);
#line 162 "libexif.vapi"
	exif_entry_get_value (self, buffer, (guint) 256);
#line 164 "libexif.vapi"
	builder = g_string_new ("");
#line 898 "Exif.c"
	{
		gchar* c_collection;
		int c_collection_length1;
		int c_it;
#line 165 "libexif.vapi"
		c_collection = buffer;
#line 905 "Exif.c"
		c_collection_length1 = buffer_length1;
		for (c_it = 0; c_it < buffer_length1; c_it = c_it + 1) {
			gchar c;
			c = c_collection[c_it];
			{
#line 166 "libexif.vapi"
				g_string_append_c (builder, c);
#line 913 "Exif.c"
			}
		}
	}
	result = g_strdup (builder->str);
	buffer = (g_free (buffer), NULL);
	_g_string_free0 (builder);
#line 168 "libexif.vapi"
	return result;
#line 922 "Exif.c"
}


#line 187 "Exif.vala"
gboolean exif_get_timestamp (ExifData* exif, time_t* timestamp) {
#line 928 "Exif.c"
	gboolean result = FALSE;
	ExifEntry* entry;
#line 187 "Exif.vala"
	g_return_val_if_fail (exif != NULL, FALSE);
#line 188 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_DATE_TIME_ORIGINAL, EXIF_FORMAT_ASCII, 1);
#line 190 "Exif.vala"
	*timestamp = (time_t) 0;
#line 192 "Exif.vala"
	if (entry != NULL) {
#line 939 "Exif.c"
		char* datetime;
#line 193 "Exif.vala"
		datetime = exif_entry_get_string (entry);
#line 194 "Exif.vala"
		if (datetime != NULL) {
#line 195 "Exif.vala"
			if (exif_convert_datetime (datetime, timestamp)) {
#line 947 "Exif.c"
				result = TRUE;
				_g_free0 (datetime);
				_exif_entry_unref0 (entry);
#line 196 "Exif.vala"
				return result;
#line 953 "Exif.c"
			}
		}
		_g_free0 (datetime);
	}
	result = FALSE;
	_exif_entry_unref0 (entry);
#line 200 "Exif.vala"
	return result;
#line 962 "Exif.c"
}


#line 203 "Exif.vala"
void exif_set_timestamp (ExifData* exif, time_t timestamp) {
#line 968 "Exif.c"
	char* _tmp0_;
#line 203 "Exif.vala"
	g_return_if_fail (exif != NULL);
#line 204 "Exif.vala"
	exif_set_datetime (exif, _tmp0_ = exif_convert_timestamp (timestamp));
#line 974 "Exif.c"
	_g_free0 (_tmp0_);
}


#line 207 "Exif.vala"
char* exif_get_datetime (ExifData* exif) {
#line 981 "Exif.c"
	char* result = NULL;
	ExifEntry* datetime;
	char* _tmp0_;
#line 207 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 208 "Exif.vala"
	datetime = exif_find_first_entry (exif, EXIF_TAG_DATE_TIME_ORIGINAL, EXIF_FORMAT_ASCII, 1);
#line 989 "Exif.c"
	_tmp0_ = NULL;
#line 210 "Exif.vala"
	if (datetime != NULL) {
#line 993 "Exif.c"
		char* _tmp1_;
#line 210 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (datetime), _g_free0 (_tmp0_), _tmp1_);
#line 997 "Exif.c"
	} else {
		char* _tmp2_;
#line 210 "Exif.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_free0 (_tmp0_), _tmp2_);
#line 1002 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (datetime);
#line 210 "Exif.vala"
	return result;
#line 1008 "Exif.c"
}


#line 213 "Exif.vala"
void exif_set_datetime (ExifData* exif, const char* datetime) {
#line 1014 "Exif.c"
	ExifEntry* entry;
#line 213 "Exif.vala"
	g_return_if_fail (exif != NULL);
#line 213 "Exif.vala"
	g_return_if_fail (datetime != NULL);
#line 214 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_DATE_TIME_ORIGINAL, EXIF_FORMAT_ASCII, 1);
#line 215 "Exif.vala"
	if (entry == NULL) {
#line 1024 "Exif.c"
		ExifEntry* _tmp0_;
#line 216 "Exif.vala"
		entry = (_tmp0_ = exif_alloc_entry (exif, EXIF_TAG_DATE_TIME_ORIGINAL, EXIF_FORMAT_ASCII), _exif_entry_unref0 (entry), _tmp0_);
#line 1028 "Exif.c"
	}
#line 218 "Exif.vala"
	exif_realloc_ascii (entry, datetime);
#line 1032 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 221 "Exif.vala"
double exif_rational_to_double (ExifRational rational) {
#line 1039 "Exif.c"
	double result = 0.0;
	result = ((double) rational.numerator) / ((double) rational.denominator);
#line 222 "Exif.vala"
	return result;
#line 1044 "Exif.c"
}


#line 225 "Exif.vala"
Orientation exif_get_orientation (ExifData* exif) {
#line 1050 "Exif.c"
	Orientation result = 0;
	ExifEntry* entry;
	gint o;
	gboolean _tmp0_ = FALSE;
#line 225 "Exif.vala"
	g_return_val_if_fail (exif != NULL, 0);
#line 226 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_ORIENTATION, EXIF_FORMAT_SHORT, 1);
#line 227 "Exif.vala"
	if (entry == NULL) {
#line 1061 "Exif.c"
		result = ORIENTATION_TOP_LEFT;
		_exif_entry_unref0 (entry);
#line 228 "Exif.vala"
		return result;
#line 1066 "Exif.c"
	}
#line 230 "Exif.vala"
	o = (gint) exif_get_short (entry->data, exif_data_get_byte_order (exif));
#line 231 "Exif.vala"
	if (o < ((gint) ORIENTATION_MIN)) {
#line 231 "Exif.vala"
		_tmp0_ = TRUE;
#line 1074 "Exif.c"
	} else {
#line 231 "Exif.vala"
		_tmp0_ = o > ((gint) ORIENTATION_MAX);
#line 1078 "Exif.c"
	}
#line 231 "Exif.vala"
	if (_tmp0_) {
#line 1082 "Exif.c"
		result = ORIENTATION_TOP_LEFT;
		_exif_entry_unref0 (entry);
#line 232 "Exif.vala"
		return result;
#line 1087 "Exif.c"
	}
	result = (Orientation) o;
	_exif_entry_unref0 (entry);
#line 234 "Exif.vala"
	return result;
#line 1093 "Exif.c"
}


#line 237 "Exif.vala"
void exif_set_orientation (ExifData** exif, Orientation orientation) {
#line 1099 "Exif.c"
	ExifEntry* entry;
#line 237 "Exif.vala"
	g_return_if_fail (exif != NULL);
#line 238 "Exif.vala"
	entry = exif_find_first_entry (*exif, EXIF_TAG_ORIENTATION, EXIF_FORMAT_SHORT, 1);
#line 239 "Exif.vala"
	if (entry == NULL) {
#line 1107 "Exif.c"
		ExifEntry* _tmp0_;
#line 240 "Exif.vala"
		entry = (_tmp0_ = exif_alloc_entry (*exif, EXIF_TAG_ORIENTATION, EXIF_FORMAT_SHORT), _exif_entry_unref0 (entry), _tmp0_);
#line 1111 "Exif.c"
	}
#line 242 "Exif.vala"
	exif_set_short (entry->data, exif_data_get_byte_order (*exif), (guint16) orientation);
#line 1115 "Exif.c"
	_exif_entry_unref0 (entry);
}


#line 245 "Exif.vala"
gboolean exif_get_dimensions (ExifData* exif, Dimensions* dim) {
#line 1122 "Exif.c"
	gboolean result = FALSE;
	Dimensions _tmp0_ = {0};
	ExifEntry* width;
	ExifEntry* height;
	gboolean _tmp1_ = FALSE;
#line 245 "Exif.vala"
	g_return_val_if_fail (exif != NULL, FALSE);
#line 246 "Exif.vala"
	*dim = (dimensions_init (&_tmp0_, 0, 0), _tmp0_);
#line 248 "Exif.vala"
	width = exif_find_first_entry_multiformat (exif, EXIF_TAG_PIXEL_X_DIMENSION, EXIF_FORMAT_SHORT, EXIF_FORMAT_LONG);
#line 250 "Exif.vala"
	height = exif_find_first_entry_multiformat (exif, EXIF_TAG_PIXEL_Y_DIMENSION, EXIF_FORMAT_SHORT, EXIF_FORMAT_LONG);
#line 252 "Exif.vala"
	if (width == NULL) {
#line 252 "Exif.vala"
		_tmp1_ = TRUE;
#line 1140 "Exif.c"
	} else {
#line 252 "Exif.vala"
		_tmp1_ = height == NULL;
#line 1144 "Exif.c"
	}
#line 252 "Exif.vala"
	if (_tmp1_) {
#line 1148 "Exif.c"
		result = FALSE;
		_exif_entry_unref0 (width);
		_exif_entry_unref0 (height);
#line 253 "Exif.vala"
		return result;
#line 1154 "Exif.c"
	}
#line 255 "Exif.vala"
	if (width->format == EXIF_FORMAT_SHORT) {
#line 256 "Exif.vala"
		(*dim).width = (gint) exif_get_short (width->data, exif_data_get_byte_order (exif));
#line 1160 "Exif.c"
	} else {
#line 257 "Exif.vala"
		if (width->format == EXIF_FORMAT_LONG) {
#line 258 "Exif.vala"
			(*dim).width = (gint) exif_get_long (width->data, exif_data_get_byte_order (exif));
#line 1166 "Exif.c"
		} else {
			result = FALSE;
			_exif_entry_unref0 (width);
			_exif_entry_unref0 (height);
#line 260 "Exif.vala"
			return result;
#line 1173 "Exif.c"
		}
	}
#line 262 "Exif.vala"
	if (height->format == EXIF_FORMAT_SHORT) {
#line 263 "Exif.vala"
		(*dim).height = (gint) exif_get_short (height->data, exif_data_get_byte_order (exif));
#line 1180 "Exif.c"
	} else {
#line 264 "Exif.vala"
		if (height->format == EXIF_FORMAT_LONG) {
#line 265 "Exif.vala"
			(*dim).height = (gint) exif_get_long (height->data, exif_data_get_byte_order (exif));
#line 1186 "Exif.c"
		} else {
			result = FALSE;
			_exif_entry_unref0 (width);
			_exif_entry_unref0 (height);
#line 267 "Exif.vala"
			return result;
#line 1193 "Exif.c"
		}
	}
	result = TRUE;
	_exif_entry_unref0 (width);
	_exif_entry_unref0 (height);
#line 269 "Exif.vala"
	return result;
#line 1201 "Exif.c"
}


#line 274 "Exif.vala"
void exif_set_dimensions (ExifData** exif, Dimensions* dim) {
#line 1207 "Exif.c"
	ExifEntry* width;
	ExifEntry* height;
#line 274 "Exif.vala"
	g_return_if_fail (exif != NULL);
#line 275 "Exif.vala"
	width = exif_find_first_entry_multiformat (*exif, EXIF_TAG_PIXEL_X_DIMENSION, EXIF_FORMAT_SHORT, EXIF_FORMAT_LONG);
#line 277 "Exif.vala"
	if (width == NULL) {
#line 1216 "Exif.c"
		ExifEntry* _tmp0_;
#line 278 "Exif.vala"
		width = (_tmp0_ = exif_alloc_entry (*exif, EXIF_TAG_PIXEL_X_DIMENSION, EXIF_FORMAT_LONG), _exif_entry_unref0 (width), _tmp0_);
#line 1220 "Exif.c"
	}
#line 280 "Exif.vala"
	height = exif_find_first_entry_multiformat (*exif, EXIF_TAG_PIXEL_Y_DIMENSION, EXIF_FORMAT_SHORT, EXIF_FORMAT_LONG);
#line 282 "Exif.vala"
	if (height == NULL) {
#line 1226 "Exif.c"
		ExifEntry* _tmp1_;
#line 283 "Exif.vala"
		height = (_tmp1_ = exif_alloc_entry (*exif, EXIF_TAG_PIXEL_Y_DIMENSION, EXIF_FORMAT_LONG), _exif_entry_unref0 (height), _tmp1_);
#line 1230 "Exif.c"
	}
#line 285 "Exif.vala"
	if (width->format == EXIF_FORMAT_SHORT) {
#line 286 "Exif.vala"
		exif_set_short (width->data, exif_data_get_byte_order (*exif), (guint16) (*dim).width);
#line 1236 "Exif.c"
	} else {
#line 287 "Exif.vala"
		if (width->format == EXIF_FORMAT_LONG) {
#line 288 "Exif.vala"
			exif_set_long (width->data, exif_data_get_byte_order (*exif), (guint32) (*dim).width);
#line 1242 "Exif.c"
		} else {
#line 290 "Exif.vala"
			exif_realloc_long (*exif, width, (guint32) (*dim).width);
#line 1246 "Exif.c"
		}
	}
#line 292 "Exif.vala"
	if (height->format == EXIF_FORMAT_SHORT) {
#line 293 "Exif.vala"
		exif_set_short (height->data, exif_data_get_byte_order (*exif), (guint16) (*dim).height);
#line 1253 "Exif.c"
	} else {
#line 294 "Exif.vala"
		if (height->format == EXIF_FORMAT_LONG) {
#line 295 "Exif.vala"
			exif_set_long (height->data, exif_data_get_byte_order (*exif), (guint32) (*dim).height);
#line 1259 "Exif.c"
		} else {
#line 297 "Exif.vala"
			exif_realloc_long (*exif, height, (guint32) (*dim).height);
#line 1263 "Exif.c"
		}
	}
	_exif_entry_unref0 (width);
	_exif_entry_unref0 (height);
}


#line 300 "Exif.vala"
char* exif_get_exposure (ExifData* exif) {
#line 1273 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 300 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 301 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_EXPOSURE_TIME, EXIF_FORMAT_RATIONAL, 1);
#line 1281 "Exif.c"
	_tmp0_ = NULL;
#line 303 "Exif.vala"
	if (entry != NULL) {
#line 1285 "Exif.c"
		char* _tmp1_;
#line 303 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1289 "Exif.c"
	} else {
		char* _tmp2_;
#line 303 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1294 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 303 "Exif.vala"
	return result;
#line 1300 "Exif.c"
}


#line 306 "Exif.vala"
char* exif_get_aperture (ExifData* exif) {
#line 1306 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 306 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 307 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_FNUMBER, EXIF_FORMAT_RATIONAL, 1);
#line 1314 "Exif.c"
	_tmp0_ = NULL;
#line 309 "Exif.vala"
	if (entry != NULL) {
#line 1318 "Exif.c"
		char* _tmp1_;
#line 309 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1322 "Exif.c"
	} else {
		char* _tmp2_;
#line 309 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1327 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 309 "Exif.vala"
	return result;
#line 1333 "Exif.c"
}


#line 312 "Exif.vala"
char* exif_get_iso (ExifData* exif) {
#line 1339 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 312 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 313 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_ISO_SPEED_RATINGS, EXIF_FORMAT_SHORT, 1);
#line 1347 "Exif.c"
	_tmp0_ = NULL;
#line 315 "Exif.vala"
	if (entry != NULL) {
#line 1351 "Exif.c"
		char* _tmp1_;
#line 315 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1355 "Exif.c"
	} else {
		char* _tmp2_;
#line 315 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1360 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 315 "Exif.vala"
	return result;
#line 1366 "Exif.c"
}


#line 318 "Exif.vala"
char* exif_get_camera_make (ExifData* exif) {
#line 1372 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 318 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 319 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_MAKE, EXIF_FORMAT_ASCII, 1);
#line 1380 "Exif.c"
	_tmp0_ = NULL;
#line 321 "Exif.vala"
	if (entry != NULL) {
#line 1384 "Exif.c"
		char* _tmp1_;
#line 321 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1388 "Exif.c"
	} else {
		char* _tmp2_;
#line 321 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1393 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 321 "Exif.vala"
	return result;
#line 1399 "Exif.c"
}


#line 324 "Exif.vala"
char* exif_get_camera_model (ExifData* exif) {
#line 1405 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 324 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 325 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_MODEL, EXIF_FORMAT_ASCII, 1);
#line 1413 "Exif.c"
	_tmp0_ = NULL;
#line 327 "Exif.vala"
	if (entry != NULL) {
#line 1417 "Exif.c"
		char* _tmp1_;
#line 327 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1421 "Exif.c"
	} else {
		char* _tmp2_;
#line 327 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1426 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 327 "Exif.vala"
	return result;
#line 1432 "Exif.c"
}


#line 331 "Exif.vala"
char* exif_get_flash (ExifData* exif) {
#line 1438 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 331 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 332 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_FLASH, EXIF_FORMAT_SHORT, 1);
#line 1446 "Exif.c"
	_tmp0_ = NULL;
#line 334 "Exif.vala"
	if (entry != NULL) {
#line 1450 "Exif.c"
		char* _tmp1_;
#line 334 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1454 "Exif.c"
	} else {
		char* _tmp2_;
#line 334 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1459 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 334 "Exif.vala"
	return result;
#line 1465 "Exif.c"
}


#line 338 "Exif.vala"
char* exif_get_focal_length (ExifData* exif) {
#line 1471 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 338 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 339 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_FOCAL_LENGTH, EXIF_FORMAT_RATIONAL, 1);
#line 1479 "Exif.c"
	_tmp0_ = NULL;
#line 341 "Exif.vala"
	if (entry != NULL) {
#line 1483 "Exif.c"
		char* _tmp1_;
#line 341 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1487 "Exif.c"
	} else {
		char* _tmp2_;
#line 341 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1492 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 341 "Exif.vala"
	return result;
#line 1498 "Exif.c"
}


#line 344 "Exif.vala"
ExifRational* exif_get_gps_rationals (ExifEntry* entry, ExifByteOrder byte_order, int* result_length1) {
#line 1504 "Exif.c"
	ExifRational* result = NULL;
	ExifRational* _tmp0_;
	gint _rationals_size_;
	gint rationals_length1;
	ExifRational* rationals;
	guchar* data;
	ExifRational* _tmp1_;
#line 344 "Exif.vala"
	g_return_val_if_fail (entry != NULL, NULL);
#line 1514 "Exif.c"
	rationals = (_tmp0_ = g_new0 (ExifRational, 3), rationals_length1 = 3, _rationals_size_ = rationals_length1, _tmp0_);
#line 347 "Exif.vala"
	data = entry->data;
#line 349 "Exif.vala"
	rationals[0] = exif_get_rational (data, byte_order);
#line 350 "Exif.vala"
	data = data + exif_format_get_size (entry->format);
#line 351 "Exif.vala"
	rationals[1] = exif_get_rational (data, byte_order);
#line 352 "Exif.vala"
	data = data + exif_format_get_size (entry->format);
#line 353 "Exif.vala"
	rationals[2] = exif_get_rational (data, byte_order);
#line 1528 "Exif.c"
	result = (_tmp1_ = rationals, *result_length1 = rationals_length1, _tmp1_);
#line 355 "Exif.vala"
	return result;
#line 1532 "Exif.c"
	rationals = (g_free (rationals), NULL);
}


#line 358 "Exif.vala"
ExifRational* exif_get_raw_gps_lat (ExifData* exif, int* result_length1) {
#line 1539 "Exif.c"
	ExifRational* result = NULL;
	ExifEntry* entry;
	gint __tmp0__size_;
	gint _tmp0__length1;
	ExifRational* _tmp0_;
	ExifRational* _tmp4_;
#line 358 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 359 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_GPS_LATITUDE, EXIF_FORMAT_RATIONAL, 3);
#line 1550 "Exif.c"
	_tmp0_ = (_tmp0__length1 = 0, NULL);
#line 361 "Exif.vala"
	if (entry != NULL) {
#line 1554 "Exif.c"
		ExifRational* _tmp2_;
		gint _tmp1_;
#line 361 "Exif.vala"
		_tmp0_ = (_tmp2_ = exif_get_gps_rationals (entry, exif_data_get_byte_order (exif), &_tmp1_), _tmp0_ = (g_free (_tmp0_), NULL), _tmp0__length1 = _tmp1_, __tmp0__size_ = _tmp0__length1, _tmp2_);
#line 1559 "Exif.c"
	} else {
		ExifRational* _tmp3_;
#line 361 "Exif.vala"
		_tmp0_ = (_tmp3_ = NULL, _tmp0_ = (g_free (_tmp0_), NULL), _tmp0__length1 = 0, __tmp0__size_ = _tmp0__length1, _tmp3_);
#line 1564 "Exif.c"
	}
	result = (_tmp4_ = _tmp0_, *result_length1 = _tmp0__length1, _tmp4_);
	_exif_entry_unref0 (entry);
#line 361 "Exif.vala"
	return result;
#line 1570 "Exif.c"
	_exif_entry_unref0 (entry);
	_tmp0_ = (g_free (_tmp0_), NULL);
}


#line 364 "Exif.vala"
ExifRational* exif_get_raw_gps_long (ExifData* exif, int* result_length1) {
#line 1578 "Exif.c"
	ExifRational* result = NULL;
	ExifEntry* entry;
	gint __tmp0__size_;
	gint _tmp0__length1;
	ExifRational* _tmp0_;
	ExifRational* _tmp4_;
#line 364 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 365 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_GPS_LONGITUDE, EXIF_FORMAT_RATIONAL, 3);
#line 1589 "Exif.c"
	_tmp0_ = (_tmp0__length1 = 0, NULL);
#line 367 "Exif.vala"
	if (entry != NULL) {
#line 1593 "Exif.c"
		ExifRational* _tmp2_;
		gint _tmp1_;
#line 367 "Exif.vala"
		_tmp0_ = (_tmp2_ = exif_get_gps_rationals (entry, exif_data_get_byte_order (exif), &_tmp1_), _tmp0_ = (g_free (_tmp0_), NULL), _tmp0__length1 = _tmp1_, __tmp0__size_ = _tmp0__length1, _tmp2_);
#line 1598 "Exif.c"
	} else {
		ExifRational* _tmp3_;
#line 367 "Exif.vala"
		_tmp0_ = (_tmp3_ = NULL, _tmp0_ = (g_free (_tmp0_), NULL), _tmp0__length1 = 0, __tmp0__size_ = _tmp0__length1, _tmp3_);
#line 1603 "Exif.c"
	}
	result = (_tmp4_ = _tmp0_, *result_length1 = _tmp0__length1, _tmp4_);
	_exif_entry_unref0 (entry);
#line 367 "Exif.vala"
	return result;
#line 1609 "Exif.c"
	_exif_entry_unref0 (entry);
	_tmp0_ = (g_free (_tmp0_), NULL);
}


#line 370 "Exif.vala"
double exif_get_angle (ExifRational* rationals, int rationals_length1) {
#line 1617 "Exif.c"
	double result = 0.0;
	result = (exif_rational_to_double (rationals[0]) + ((1.0 / 60.0) * exif_rational_to_double (rationals[1]))) + ((1.0 / 360.0) * exif_rational_to_double (rationals[2]));
#line 371 "Exif.vala"
	return result;
#line 1622 "Exif.c"
}


#line 375 "Exif.vala"
double exif_get_gps_lat (ExifData* exif) {
#line 1628 "Exif.c"
	double result = 0.0;
	ExifRational* _tmp1_;
	gint _rationals_size_;
	gint rationals_length1;
	gint _tmp0_;
	ExifRational* rationals;
	double _tmp2_ = 0.0;
#line 375 "Exif.vala"
	g_return_val_if_fail (exif != NULL, 0.0);
#line 1638 "Exif.c"
	rationals = (_tmp1_ = exif_get_raw_gps_lat (exif, &_tmp0_), rationals_length1 = _tmp0_, _rationals_size_ = rationals_length1, _tmp1_);
#line 378 "Exif.vala"
	if (rationals != NULL) {
#line 378 "Exif.vala"
		_tmp2_ = exif_get_angle (rationals, rationals_length1);
#line 1644 "Exif.c"
	} else {
#line 378 "Exif.vala"
		_tmp2_ = (double) (-1);
#line 1648 "Exif.c"
	}
	result = _tmp2_;
	rationals = (g_free (rationals), NULL);
#line 378 "Exif.vala"
	return result;
#line 1654 "Exif.c"
}


#line 381 "Exif.vala"
double exif_get_gps_long (ExifData* exif) {
#line 1660 "Exif.c"
	double result = 0.0;
	ExifRational* _tmp1_;
	gint _rationals_size_;
	gint rationals_length1;
	gint _tmp0_;
	ExifRational* rationals;
	double _tmp2_ = 0.0;
#line 381 "Exif.vala"
	g_return_val_if_fail (exif != NULL, 0.0);
#line 1670 "Exif.c"
	rationals = (_tmp1_ = exif_get_raw_gps_long (exif, &_tmp0_), rationals_length1 = _tmp0_, _rationals_size_ = rationals_length1, _tmp1_);
#line 384 "Exif.vala"
	if (rationals != NULL) {
#line 384 "Exif.vala"
		_tmp2_ = exif_get_angle (rationals, rationals_length1);
#line 1676 "Exif.c"
	} else {
#line 384 "Exif.vala"
		_tmp2_ = (double) (-1);
#line 1680 "Exif.c"
	}
	result = _tmp2_;
	rationals = (g_free (rationals), NULL);
#line 384 "Exif.vala"
	return result;
#line 1686 "Exif.c"
}


#line 387 "Exif.vala"
char* exif_get_gps_lat_ref (ExifData* exif) {
#line 1692 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 387 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 388 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_GPS_LATITUDE_REF, EXIF_FORMAT_ASCII, 1);
#line 1700 "Exif.c"
	_tmp0_ = NULL;
#line 390 "Exif.vala"
	if (entry != NULL) {
#line 1704 "Exif.c"
		char* _tmp1_;
#line 390 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1708 "Exif.c"
	} else {
		char* _tmp2_;
#line 390 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1713 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 390 "Exif.vala"
	return result;
#line 1719 "Exif.c"
}


#line 393 "Exif.vala"
char* exif_get_gps_long_ref (ExifData* exif) {
#line 1725 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 393 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 394 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_GPS_LONGITUDE_REF, EXIF_FORMAT_ASCII, 1);
#line 1733 "Exif.c"
	_tmp0_ = NULL;
#line 396 "Exif.vala"
	if (entry != NULL) {
#line 1737 "Exif.c"
		char* _tmp1_;
#line 396 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1741 "Exif.c"
	} else {
		char* _tmp2_;
#line 396 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1746 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 396 "Exif.vala"
	return result;
#line 1752 "Exif.c"
}


#line 399 "Exif.vala"
char* exif_get_artist (ExifData* exif) {
#line 1758 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 399 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 400 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_ARTIST, EXIF_FORMAT_ASCII, 1);
#line 1766 "Exif.c"
	_tmp0_ = NULL;
#line 402 "Exif.vala"
	if (entry != NULL) {
#line 1770 "Exif.c"
		char* _tmp1_;
#line 402 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1774 "Exif.c"
	} else {
		char* _tmp2_;
#line 402 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1779 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 402 "Exif.vala"
	return result;
#line 1785 "Exif.c"
}


#line 405 "Exif.vala"
char* exif_get_copyright (ExifData* exif) {
#line 1791 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 405 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 406 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_COPYRIGHT, EXIF_FORMAT_ASCII, 1);
#line 1799 "Exif.c"
	_tmp0_ = NULL;
#line 408 "Exif.vala"
	if (entry != NULL) {
#line 1803 "Exif.c"
		char* _tmp1_;
#line 408 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1807 "Exif.c"
	} else {
		char* _tmp2_;
#line 408 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1812 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 408 "Exif.vala"
	return result;
#line 1818 "Exif.c"
}


#line 411 "Exif.vala"
char* exif_get_software (ExifData* exif) {
#line 1824 "Exif.c"
	char* result = NULL;
	ExifEntry* entry;
	char* _tmp0_;
#line 411 "Exif.vala"
	g_return_val_if_fail (exif != NULL, NULL);
#line 412 "Exif.vala"
	entry = exif_find_first_entry (exif, EXIF_TAG_SOFTWARE, EXIF_FORMAT_ASCII, 1);
#line 1832 "Exif.c"
	_tmp0_ = NULL;
#line 414 "Exif.vala"
	if (entry != NULL) {
#line 1836 "Exif.c"
		char* _tmp1_;
#line 414 "Exif.vala"
		_tmp0_ = (_tmp1_ = exif_entry_get_string (entry), _g_free0 (_tmp0_), _tmp1_);
#line 1840 "Exif.c"
	} else {
		char* _tmp2_;
#line 414 "Exif.vala"
		_tmp0_ = (_tmp2_ = g_strdup (""), _g_free0 (_tmp0_), _tmp2_);
#line 1845 "Exif.c"
	}
	result = _tmp0_;
	_exif_entry_unref0 (entry);
#line 414 "Exif.vala"
	return result;
#line 1851 "Exif.c"
}


GQuark exif_error_quark (void) {
	return g_quark_from_static_string ("exif_error-quark");
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 426 "Exif.vala"
PhotoExif* photo_exif_construct (GType object_type, GFile* file) {
#line 1867 "Exif.c"
	PhotoExif* self;
	GFile* _tmp0_;
#line 426 "Exif.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1872 "Exif.c"
	self = (PhotoExif*) g_type_create_instance (object_type);
#line 427 "Exif.vala"
	self->priv->file = (_tmp0_ = _g_object_ref0 (file), _g_object_unref0 (self->priv->file), _tmp0_);
#line 431 "Exif.vala"
	exif_data_set_data_type (self->priv->exif, EXIF_DATA_TYPE_COMPRESSED);
#line 1878 "Exif.c"
	return self;
}


#line 426 "Exif.vala"
PhotoExif* photo_exif_new (GFile* file) {
#line 426 "Exif.vala"
	return photo_exif_construct (TYPE_PHOTO_EXIF, file);
#line 1887 "Exif.c"
}


#line 434 "Exif.vala"
void photo_exif_load (PhotoExif* self, GError** error) {
#line 1893 "Exif.c"
	GError * _inner_error_;
	gsize raw_length = 0UL;
	guint8* _tmp1_;
	gint _raw_size_;
	gint raw_length1;
	gint _tmp0_;
	guint8* raw;
	ExifData* _tmp4_;
#line 434 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 1904 "Exif.c"
	_inner_error_ = NULL;
	raw = (_tmp1_ = photo_exif_get_raw_exif (self, &raw_length, &_tmp0_, &_inner_error_), raw_length1 = _tmp0_, _raw_size_ = raw_length1, _tmp1_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 437 "Exif.vala"
	if (raw == NULL) {
#line 1913 "Exif.c"
		char* _tmp2_;
		GError* _tmp3_;
		_inner_error_ = (_tmp3_ = g_error_new (EXIF_ERROR, EXIF_ERROR_FILE_FORMAT, "EXIF not found in %s", _tmp2_ = g_file_get_path (self->priv->file)), _g_free0 (_tmp2_), _tmp3_);
		{
			g_propagate_error (error, _inner_error_);
			raw = (g_free (raw), NULL);
			return;
		}
	}
#line 440 "Exif.vala"
	self->priv->exif = (_tmp4_ = exif_data_new_from_data (raw, raw_length), _exif_data_unref0 (self->priv->exif), _tmp4_);
#line 444 "Exif.vala"
	exif_data_set_data_type (self->priv->exif, EXIF_DATA_TYPE_COMPRESSED);
#line 447 "Exif.vala"
	exif_data_fix (self->priv->exif);
#line 1929 "Exif.c"
	raw = (g_free (raw), NULL);
}


#line 450 "Exif.vala"
gboolean photo_exif_query_has_exif (PhotoExif* self) {
#line 1936 "Exif.c"
	gboolean result = FALSE;
	GError * _inner_error_;
#line 450 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), FALSE);
#line 1941 "Exif.c"
	_inner_error_ = NULL;
	{
		gsize raw_length = 0UL;
		guint8* _tmp2_;
		gint __tmp1__size_;
		gint _tmp1__length1;
		gint _tmp0_;
		guint8* _tmp1_;
		gint _tmp3__length1;
		guint8* _tmp3_;
		gboolean _tmp4_;
		_tmp1_ = (_tmp2_ = photo_exif_get_raw_exif (self, &raw_length, &_tmp0_, &_inner_error_), _tmp1__length1 = _tmp0_, __tmp1__size_ = _tmp1__length1, _tmp2_);
		if (_inner_error_ != NULL) {
			goto __catch30_g_error;
		}
		result = (_tmp4_ = (_tmp3_ = _tmp1_, _tmp3__length1 = _tmp1__length1, _tmp3_) != NULL, _tmp3_ = (g_free (_tmp3_), NULL), _tmp4_);
#line 455 "Exif.vala"
		return result;
#line 1960 "Exif.c"
	}
	goto __finally30;
	__catch30_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp5_;
#line 457 "Exif.vala"
			g_warning ("Exif.vala:457: Unable to load EXIF from %s: %s", _tmp5_ = g_file_get_path (self->priv->file), err->message);
#line 1972 "Exif.c"
			_g_free0 (_tmp5_);
			result = FALSE;
			_g_error_free0 (err);
#line 459 "Exif.vala"
			return result;
#line 1978 "Exif.c"
		}
	}
	__finally30:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


#line 464 "Exif.vala"
guint8* photo_exif_get_raw_exif (PhotoExif* self, gsize* raw_length, int* result_length1, GError** error) {
#line 1992 "Exif.c"
	guint8* result = NULL;
	GError * _inner_error_;
	GFileInputStream* fins;
	JpegMarker marker = 0;
	gint segment_length = 0;
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	guint8* _tmp4_;
	gint _raw_size_;
	gint raw_length1;
	guint8* raw;
	gboolean _tmp13_ = FALSE;
	guint8* _tmp16_;
#line 464 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 2008 "Exif.c"
	_inner_error_ = NULL;
#line 465 "Exif.vala"
	fins = g_file_read (self->priv->file, NULL, &_inner_error_);
#line 2012 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
#line 471 "Exif.vala"
	_tmp0_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 2019 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fins);
		return NULL;
	}
#line 471 "Exif.vala"
	segment_length = _tmp0_;
#line 472 "Exif.vala"
	if (marker != JPEG_MARKER_SOI) {
#line 472 "Exif.vala"
		_tmp1_ = TRUE;
#line 2031 "Exif.c"
	} else {
#line 472 "Exif.vala"
		_tmp1_ = segment_length != 0;
#line 2035 "Exif.c"
	}
#line 472 "Exif.vala"
	if (_tmp1_) {
#line 2039 "Exif.c"
		char* _tmp2_;
		gpointer _tmp3_;
#line 473 "Exif.vala"
		g_warning ("Exif.vala:473: No SOI marker found in %s", _tmp2_ = g_file_get_path (self->priv->file));
#line 2044 "Exif.c"
		_g_free0 (_tmp2_);
		result = (_tmp3_ = NULL, *result_length1 = 0, _tmp3_);
		_g_object_unref0 (fins);
#line 475 "Exif.vala"
		return result;
#line 2050 "Exif.c"
	}
	raw = (_tmp4_ = NULL, raw_length1 = 0, _raw_size_ = raw_length1, _tmp4_);
	{
		gboolean _tmp5_;
#line 480 "Exif.vala"
		_tmp5_ = TRUE;
#line 480 "Exif.vala"
		while (TRUE) {
#line 2059 "Exif.c"
			gint _tmp6_;
			gboolean _tmp8_ = FALSE;
			guint8* _tmp9_;
			gsize bytes_read = 0UL;
#line 480 "Exif.vala"
			if (!_tmp5_) {
#line 2066 "Exif.c"
			}
#line 480 "Exif.vala"
			_tmp5_ = FALSE;
#line 481 "Exif.vala"
			_tmp6_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 2072 "Exif.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (fins);
				raw = (g_free (raw), NULL);
				return NULL;
			}
#line 481 "Exif.vala"
			segment_length = _tmp6_;
#line 482 "Exif.vala"
			if (segment_length == (-1)) {
#line 2083 "Exif.c"
				gpointer _tmp7_;
				result = (_tmp7_ = NULL, *result_length1 = 0, _tmp7_);
				_g_object_unref0 (fins);
				raw = (g_free (raw), NULL);
#line 484 "Exif.vala"
				return result;
#line 2090 "Exif.c"
			}
#line 487 "Exif.vala"
			if (marker != JPEG_MARKER_APP1) {
#line 487 "Exif.vala"
				_tmp8_ = TRUE;
#line 2096 "Exif.c"
			} else {
#line 487 "Exif.vala"
				_tmp8_ = segment_length < G_N_ELEMENTS (EXIF_SIGNATURE);
#line 2100 "Exif.c"
			}
#line 487 "Exif.vala"
			if (_tmp8_) {
#line 488 "Exif.vala"
				if (segment_length > 0) {
#line 489 "Exif.vala"
					g_input_stream_skip (G_INPUT_STREAM (fins), (gsize) segment_length, NULL, &_inner_error_);
#line 2108 "Exif.c"
					if (_inner_error_ != NULL) {
						g_propagate_error (error, _inner_error_);
						_g_object_unref0 (fins);
						raw = (g_free (raw), NULL);
						return NULL;
					}
				}
#line 491 "Exif.vala"
				continue;
#line 2118 "Exif.c"
			}
#line 495 "Exif.vala"
			raw = (_tmp9_ = g_new0 (guint8, segment_length), raw = (g_free (raw), NULL), raw_length1 = segment_length, _raw_size_ = raw_length1, _tmp9_);
#line 498 "Exif.vala"
			g_input_stream_read_all (G_INPUT_STREAM (fins), raw, (gsize) raw_length1, &bytes_read, NULL, &_inner_error_);
#line 2124 "Exif.c"
			if (_inner_error_ != NULL) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (fins);
				raw = (g_free (raw), NULL);
				return NULL;
			}
#line 499 "Exif.vala"
			if (bytes_read != raw_length1) {
#line 2133 "Exif.c"
				char* _tmp10_;
#line 500 "Exif.vala"
				g_warning ("Exif.vala:500: Unable to read full segment in %s", _tmp10_ = g_file_get_path (self->priv->file));
#line 2137 "Exif.c"
				_g_free0 (_tmp10_);
#line 504 "Exif.vala"
				continue;
#line 2141 "Exif.c"
			}
#line 508 "Exif.vala"
			if (memcmp (raw, EXIF_SIGNATURE, (gsize) G_N_ELEMENTS (EXIF_SIGNATURE)) != 0) {
#line 2145 "Exif.c"
				char* _tmp11_;
#line 509 "Exif.vala"
				g_warning ("Exif.vala:509: Invalid EXIF signature in APP1 segment of %s", _tmp11_ = g_file_get_path (self->priv->file));
#line 2149 "Exif.c"
				_g_free0 (_tmp11_);
#line 511 "Exif.vala"
				continue;
#line 2153 "Exif.c"
			}
#line 518 "Exif.vala"
			if (raw[segment_length - 2] == JPEG_MARKER_PREFIX) {
#line 519 "Exif.vala"
				segment_length = segment_length - 2;
#line 520 "Exif.vala"
				if (segment_length <= 0) {
#line 2161 "Exif.c"
					char* _tmp12_;
#line 521 "Exif.vala"
					g_warning ("Exif.vala:521: Detected invalid length field in too-short EXIF segment" \
" in %s", _tmp12_ = g_file_get_path (self->priv->file));
#line 2165 "Exif.c"
					_g_free0 (_tmp12_);
#line 524 "Exif.vala"
					continue;
#line 2169 "Exif.c"
				}
			}
#line 529 "Exif.vala"
			*raw_length = (gsize) segment_length;
#line 532 "Exif.vala"
			break;
#line 2176 "Exif.c"
		}
	}
#line 535 "Exif.vala"
	if (marker != JPEG_MARKER_APP1) {
#line 535 "Exif.vala"
		_tmp13_ = TRUE;
#line 2183 "Exif.c"
	} else {
#line 535 "Exif.vala"
		_tmp13_ = raw == NULL;
#line 2187 "Exif.c"
	}
#line 535 "Exif.vala"
	if (_tmp13_) {
#line 2191 "Exif.c"
		char* _tmp14_;
		gpointer _tmp15_;
#line 536 "Exif.vala"
		g_warning ("Exif.vala:536: No APP1 marker found in %s", _tmp14_ = g_file_get_path (self->priv->file));
#line 2196 "Exif.c"
		_g_free0 (_tmp14_);
		result = (_tmp15_ = NULL, *result_length1 = 0, _tmp15_);
		_g_object_unref0 (fins);
		raw = (g_free (raw), NULL);
#line 538 "Exif.vala"
		return result;
#line 2203 "Exif.c"
	}
	result = (_tmp16_ = raw, *result_length1 = raw_length1, _tmp16_);
	_g_object_unref0 (fins);
#line 541 "Exif.vala"
	return result;
#line 2209 "Exif.c"
	_g_object_unref0 (fins);
	raw = (g_free (raw), NULL);
}


#line 545 "Exif.vala"
char* photo_exif_get_md5 (PhotoExif* self) {
#line 2217 "Exif.c"
	char* result = NULL;
	gint flattened_size = 0;
	guchar* flattened;
	char* md5;
	ExifMem* _tmp0_;
#line 545 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 547 "Exif.vala"
	flattened = photo_exif_flatten_sans_thumbnail (self, &flattened_size);
#line 548 "Exif.vala"
	if (flattened == NULL) {
#line 2229 "Exif.c"
		result = NULL;
#line 549 "Exif.vala"
		return result;
#line 2233 "Exif.c"
	}
#line 551 "Exif.vala"
	md5 = md5_binary (flattened, (gsize) flattened_size);
#line 553 "Exif.vala"
	exif_mem_free (_tmp0_ = exif_mem_new_default (), flattened);
#line 2239 "Exif.c"
	_exif_mem_unref0 (_tmp0_);
	result = md5;
#line 555 "Exif.vala"
	return result;
#line 2244 "Exif.c"
}


#line 559 "Exif.vala"
char* photo_exif_get_thumbnail_md5 (PhotoExif* self) {
#line 2250 "Exif.c"
	char* result = NULL;
	char* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 559 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 2256 "Exif.c"
	_tmp0_ = NULL;
#line 560 "Exif.vala"
	if (self->priv->exif->data != NULL) {
#line 560 "Exif.vala"
		_tmp1_ = self->priv->exif->size > 0;
#line 2262 "Exif.c"
	} else {
#line 560 "Exif.vala"
		_tmp1_ = FALSE;
#line 2266 "Exif.c"
	}
#line 560 "Exif.vala"
	if (_tmp1_) {
#line 2270 "Exif.c"
		char* _tmp2_;
#line 560 "Exif.vala"
		_tmp0_ = (_tmp2_ = md5_binary (self->priv->exif->data, (gsize) self->priv->exif->size), _g_free0 (_tmp0_), _tmp2_);
#line 2274 "Exif.c"
	} else {
		char* _tmp3_;
#line 560 "Exif.vala"
		_tmp0_ = (_tmp3_ = NULL, _g_free0 (_tmp0_), _tmp3_);
#line 2279 "Exif.c"
	}
	result = _tmp0_;
#line 560 "Exif.vala"
	return result;
#line 2284 "Exif.c"
}


#line 563 "Exif.vala"
ExifData* photo_exif_get_exif (PhotoExif* self) {
#line 2290 "Exif.c"
	ExifData* result = NULL;
	ExifData* _tmp0_;
#line 563 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 2295 "Exif.c"
	result = (_tmp0_ = self->priv->exif, (_tmp0_ == NULL) ? NULL : exif_data_ref (_tmp0_), _tmp0_);
#line 564 "Exif.vala"
	return result;
#line 2299 "Exif.c"
}


#line 567 "Exif.vala"
void photo_exif_set_exif (PhotoExif* self, ExifData* exif) {
#line 2305 "Exif.c"
	ExifData* _tmp1_;
	ExifData* _tmp0_;
#line 567 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 567 "Exif.vala"
	g_return_if_fail (exif != NULL);
#line 568 "Exif.vala"
	self->priv->exif = (_tmp1_ = (_tmp0_ = exif, (_tmp0_ == NULL) ? NULL : exif_data_ref (_tmp0_), _tmp0_), _exif_data_unref0 (self->priv->exif), _tmp1_);
#line 2314 "Exif.c"
}


#line 571 "Exif.vala"
Orientation photo_exif_get_orientation (PhotoExif* self) {
#line 2320 "Exif.c"
	Orientation result = 0;
#line 571 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), 0);
#line 2324 "Exif.c"
	result = exif_get_orientation (self->priv->exif);
#line 572 "Exif.vala"
	return result;
#line 2328 "Exif.c"
}


#line 575 "Exif.vala"
void photo_exif_set_orientation (PhotoExif* self, Orientation orientation) {
#line 575 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 576 "Exif.vala"
	exif_set_orientation (&self->priv->exif, orientation);
#line 2338 "Exif.c"
}


#line 579 "Exif.vala"
gboolean photo_exif_get_dimensions (PhotoExif* self, Dimensions* dim) {
#line 2344 "Exif.c"
	gboolean result = FALSE;
#line 579 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), FALSE);
#line 2348 "Exif.c"
	result = exif_get_dimensions (self->priv->exif, dim);
#line 580 "Exif.vala"
	return result;
#line 2352 "Exif.c"
}


#line 583 "Exif.vala"
void photo_exif_set_dimensions (PhotoExif* self, Dimensions* dim) {
#line 583 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 584 "Exif.vala"
	exif_set_dimensions (&self->priv->exif, dim);
#line 2362 "Exif.c"
}


#line 587 "Exif.vala"
char* photo_exif_get_datetime (PhotoExif* self) {
#line 2368 "Exif.c"
	char* result = NULL;
#line 587 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 2372 "Exif.c"
	result = exif_get_datetime (self->priv->exif);
#line 588 "Exif.vala"
	return result;
#line 2376 "Exif.c"
}


#line 591 "Exif.vala"
void photo_exif_set_datetime (PhotoExif* self, const char* datetime) {
#line 591 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 591 "Exif.vala"
	g_return_if_fail (datetime != NULL);
#line 592 "Exif.vala"
	exif_set_datetime (self->priv->exif, datetime);
#line 2388 "Exif.c"
}


#line 595 "Exif.vala"
gboolean photo_exif_get_timestamp (PhotoExif* self, time_t* timestamp) {
#line 2394 "Exif.c"
	gboolean result = FALSE;
#line 595 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), FALSE);
#line 2398 "Exif.c"
	result = exif_get_timestamp (self->priv->exif, timestamp);
#line 596 "Exif.vala"
	return result;
#line 2402 "Exif.c"
}


#line 599 "Exif.vala"
void photo_exif_set_timestamp (PhotoExif* self, time_t timestamp) {
#line 599 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 600 "Exif.vala"
	exif_set_timestamp (self->priv->exif, timestamp);
#line 2412 "Exif.c"
}


#line 603 "Exif.vala"
gint photo_exif_remove_all_tags (PhotoExif* self, ExifTag tag) {
#line 2418 "Exif.c"
	gint result = 0;
#line 603 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), 0);
#line 2422 "Exif.c"
	result = exif_remove_all_tags (self->priv->exif, tag);
#line 604 "Exif.vala"
	return result;
#line 2426 "Exif.c"
}


#line 607 "Exif.vala"
gboolean photo_exif_remove_thumbnail (PhotoExif* self) {
#line 2432 "Exif.c"
	gboolean result = FALSE;
	ExifMem* _tmp0_;
#line 607 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), FALSE);
#line 608 "Exif.vala"
	if (self->priv->exif->data == NULL) {
#line 2439 "Exif.c"
		result = FALSE;
#line 609 "Exif.vala"
		return result;
#line 2443 "Exif.c"
	}
#line 611 "Exif.vala"
	exif_mem_free (_tmp0_ = exif_mem_new_default (), self->priv->exif->data);
#line 2447 "Exif.c"
	_exif_mem_unref0 (_tmp0_);
#line 612 "Exif.vala"
	self->priv->exif->data = NULL;
#line 613 "Exif.vala"
	self->priv->exif->size = (guint) 0;
#line 2453 "Exif.c"
	result = TRUE;
#line 615 "Exif.vala"
	return result;
#line 2457 "Exif.c"
}


#line 619 "Exif.vala"
static guchar* photo_exif_flatten (PhotoExif* self, gint* size) {
#line 2463 "Exif.c"
	guchar* result = NULL;
	guchar* flattened;
	gint flattened_size;
#line 619 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 620 "Exif.vala"
	flattened = NULL;
#line 621 "Exif.vala"
	flattened_size = 0;
#line 622 "Exif.vala"
	exif_data_save_data (self->priv->exif, &flattened, &flattened_size);
#line 624 "Exif.vala"
	*size = flattened_size;
#line 2477 "Exif.c"
	result = flattened;
#line 626 "Exif.vala"
	return result;
#line 2481 "Exif.c"
}


#line 630 "Exif.vala"
static guchar* photo_exif_flatten_sans_thumbnail (PhotoExif* self, gint* size) {
#line 2487 "Exif.c"
	guchar* result = NULL;
	guchar* thumbnail;
	guint thumbnail_size;
	guchar* flattened;
	gint flattened_size;
#line 630 "Exif.vala"
	g_return_val_if_fail (IS_PHOTO_EXIF (self), NULL);
#line 632 "Exif.vala"
	thumbnail = self->priv->exif->data;
#line 633 "Exif.vala"
	thumbnail_size = self->priv->exif->size;
#line 635 "Exif.vala"
	self->priv->exif->data = NULL;
#line 636 "Exif.vala"
	self->priv->exif->size = (guint) 0;
#line 638 "Exif.vala"
	flattened = NULL;
#line 639 "Exif.vala"
	flattened_size = 0;
#line 640 "Exif.vala"
	exif_data_save_data (self->priv->exif, &flattened, &flattened_size);
#line 642 "Exif.vala"
	*size = flattened_size;
#line 645 "Exif.vala"
	self->priv->exif->data = thumbnail;
#line 646 "Exif.vala"
	self->priv->exif->size = thumbnail_size;
#line 2515 "Exif.c"
	result = flattened;
#line 648 "Exif.vala"
	return result;
#line 2519 "Exif.c"
}


#line 651 "Exif.vala"
void photo_exif_commit (PhotoExif* self, GError** error) {
#line 2525 "Exif.c"
	GError * _inner_error_;
	GFileInputStream* fins;
	JpegMarker marker = 0;
	gint segment_length = 0;
	gboolean original_has_exif;
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp5_;
	gint flattened_size;
	guchar* flattened;
#line 651 "Exif.vala"
	g_return_if_fail (IS_PHOTO_EXIF (self));
#line 2538 "Exif.c"
	_inner_error_ = NULL;
#line 652 "Exif.vala"
	fins = g_file_read (self->priv->file, NULL, &_inner_error_);
#line 2542 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
#line 656 "Exif.vala"
	original_has_exif = FALSE;
#line 659 "Exif.vala"
	_tmp0_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 2551 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fins);
		return;
	}
#line 659 "Exif.vala"
	segment_length = _tmp0_;
#line 660 "Exif.vala"
	if (marker != JPEG_MARKER_SOI) {
#line 660 "Exif.vala"
		_tmp1_ = TRUE;
#line 2563 "Exif.c"
	} else {
#line 660 "Exif.vala"
		_tmp1_ = segment_length != 0;
#line 2567 "Exif.c"
	}
#line 660 "Exif.vala"
	if (_tmp1_) {
#line 2571 "Exif.c"
		char* _tmp3_;
		char* _tmp2_;
		GError* _tmp4_;
		_inner_error_ = (_tmp4_ = g_error_new_literal (EXIF_ERROR, EXIF_ERROR_FILE_FORMAT, _tmp3_ = g_strdup_printf ("SOI not found in %s", _tmp2_ = g_file_get_path (self->priv->file))), _g_free0 (_tmp3_), _g_free0 (_tmp2_), _tmp4_);
		{
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (fins);
			return;
		}
	}
#line 663 "Exif.vala"
	_tmp5_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 2584 "Exif.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fins);
		return;
	}
#line 663 "Exif.vala"
	segment_length = _tmp5_;
#line 666 "Exif.vala"
	if (marker == JPEG_MARKER_APP0) {
#line 2594 "Exif.c"
		gint _tmp6_;
#line 667 "Exif.vala"
		g_input_stream_skip (G_INPUT_STREAM (fins), (gsize) segment_length, NULL, &_inner_error_);
#line 2598 "Exif.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (fins);
			return;
		}
#line 668 "Exif.vala"
		_tmp6_ = jpeg_read_marker (fins, &marker, &_inner_error_);
#line 2606 "Exif.c"
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (fins);
			return;
		}
#line 668 "Exif.vala"
		segment_length = _tmp6_;
#line 2614 "Exif.c"
	}
#line 671 "Exif.vala"
	if (marker == JPEG_MARKER_APP1) {
#line 672 "Exif.vala"
		original_has_exif = TRUE;
#line 2620 "Exif.c"
	}
#line 675 "Exif.vala"
	flattened_size = 0;
#line 676 "Exif.vala"
	flattened = photo_exif_flatten (self, &flattened_size);
#line 677 "Exif.vala"
	g_assert (flattened != NULL);
#line 678 "Exif.vala"
	g_assert (flattened_size > 0);
#line 2630 "Exif.c"
	{
		gboolean _tmp8_ = FALSE;
#line 681 "Exif.vala"
		if (flattened_size == segment_length) {
#line 681 "Exif.vala"
			_tmp8_ = original_has_exif;
#line 2637 "Exif.c"
		} else {
#line 681 "Exif.vala"
			_tmp8_ = FALSE;
#line 2641 "Exif.c"
		}
#line 681 "Exif.vala"
		if (_tmp8_) {
#line 2645 "Exif.c"
			char* _tmp9_;
			GFileInputStream* _tmp10_;
			char* _tmp11_;
			FILE* _tmp12_;
			FILE* fs;
			gsize count_written;
#line 685 "Exif.vala"
			g_debug ("Exif.vala:685: Writing EXIF in-place of %d bytes to %s", flattened_size, _tmp9_ = g_file_get_path (self->priv->file));
#line 2654 "Exif.c"
			_g_free0 (_tmp9_);
#line 688 "Exif.vala"
			g_input_stream_close (G_INPUT_STREAM (fins), NULL, &_inner_error_);
#line 2658 "Exif.c"
			if (_inner_error_ != NULL) {
				goto __finally31;
			}
#line 689 "Exif.vala"
			fins = (_tmp10_ = NULL, _g_object_unref0 (fins), _tmp10_);
#line 693 "Exif.vala"
			fs = (_tmp12_ = fopen (_tmp11_ = g_file_get_path (self->priv->file), "r+"), _g_free0 (_tmp11_), _tmp12_);
#line 694 "Exif.vala"
			if (fs == NULL) {
#line 2668 "Exif.c"
				char* _tmp14_;
				char* _tmp13_;
				GError* _tmp15_;
				_inner_error_ = (_tmp15_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, _tmp14_ = g_strdup_printf ("%s: fopen() error", _tmp13_ = g_file_get_path (self->priv->file))), _g_free0 (_tmp14_), _g_free0 (_tmp13_), _tmp15_);
				{
					_fclose0 (fs);
					goto __finally31;
				}
			}
#line 698 "Exif.vala"
			if (fseek (fs, (glong) ((2 + 2) + 2), SEEK_SET) < 0) {
#line 2680 "Exif.c"
				char* _tmp16_;
				GError* _tmp17_;
				_inner_error_ = (_tmp17_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "%s: fseek() error %d", _tmp16_ = g_file_get_path (self->priv->file), ferror (fs)), _g_free0 (_tmp16_), _tmp17_);
				{
					_fclose0 (fs);
					goto __finally31;
				}
			}
#line 702 "Exif.vala"
			count_written = fwrite (flattened, (gsize) flattened_size, (gsize) 1, fs);
#line 703 "Exif.vala"
			if (count_written != 1) {
#line 2693 "Exif.c"
				char* _tmp18_;
				GError* _tmp19_;
				_inner_error_ = (_tmp19_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "%s: fwrite() error %d", _tmp18_ = g_file_get_path (self->priv->file), errno), _g_free0 (_tmp18_), _tmp19_);
				{
					_fclose0 (fs);
					goto __finally31;
				}
			}
			_fclose0 (fs);
		} else {
			GFile* temp;
			GFile* _tmp22_;
			GFileOutputStream* _tmp21_;
			GFile* _tmp20_ = NULL;
			GFileOutputStream* fouts;
			gsize bytes_written;
			char* _tmp24_;
			char* _tmp23_;
			guint8* _tmp25_;
			gint _copy_buffer_size_;
			gint copy_buffer_length1;
			guint8* copy_buffer;
#line 707 "Exif.vala"
			temp = NULL;
#line 708 "Exif.vala"
			fouts = (_tmp21_ = photo_exif_create_temp (self->priv->file, &_tmp20_, &_inner_error_), temp = (_tmp22_ = _tmp20_, _g_object_unref0 (temp), _tmp22_), _tmp21_);
#line 2720 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				goto __finally31;
			}
#line 709 "Exif.vala"
			bytes_written = (gsize) 0;
#line 711 "Exif.vala"
			g_debug ("Exif.vala:711: Building new file at %s with %d bytes EXIF, overwriting" \
" %s", _tmp23_ = g_file_get_path (temp), flattened_size, _tmp24_ = g_file_get_path (self->priv->file));
#line 2729 "Exif.c"
			_g_free0 (_tmp24_);
			_g_free0 (_tmp23_);
#line 715 "Exif.vala"
			jpeg_write_marker (fouts, JPEG_MARKER_SOI, 0, &_inner_error_);
#line 2734 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				goto __finally31;
			}
#line 718 "Exif.vala"
			if (original_has_exif) {
#line 719 "Exif.vala"
				g_input_stream_skip (G_INPUT_STREAM (fins), (gsize) segment_length, NULL, &_inner_error_);
#line 2744 "Exif.c"
				if (_inner_error_ != NULL) {
					_g_object_unref0 (temp);
					_g_object_unref0 (fouts);
					goto __finally31;
				}
			}
#line 722 "Exif.vala"
			jpeg_write_marker (fouts, JPEG_MARKER_APP1, flattened_size, &_inner_error_);
#line 2753 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				goto __finally31;
			}
#line 723 "Exif.vala"
			g_output_stream_write_all (G_OUTPUT_STREAM (fouts), flattened, (gsize) flattened_size, &bytes_written, NULL, &_inner_error_);
#line 2761 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				goto __finally31;
			}
#line 724 "Exif.vala"
			g_assert (bytes_written == flattened_size);
#line 727 "Exif.vala"
			if (!original_has_exif) {
#line 728 "Exif.vala"
				jpeg_write_marker (fouts, marker, segment_length, &_inner_error_);
#line 2773 "Exif.c"
				if (_inner_error_ != NULL) {
					_g_object_unref0 (temp);
					_g_object_unref0 (fouts);
					goto __finally31;
				}
			}
			copy_buffer = (_tmp25_ = g_new0 (guint8, 64 * 1024), copy_buffer_length1 = 64 * 1024, _copy_buffer_size_ = copy_buffer_length1, _tmp25_);
			{
				gboolean _tmp26_;
#line 732 "Exif.vala"
				_tmp26_ = TRUE;
#line 732 "Exif.vala"
				while (TRUE) {
#line 2787 "Exif.c"
					gssize bytes_read;
#line 732 "Exif.vala"
					if (!_tmp26_) {
#line 2791 "Exif.c"
					}
#line 732 "Exif.vala"
					_tmp26_ = FALSE;
#line 733 "Exif.vala"
					bytes_read = g_input_stream_read (G_INPUT_STREAM (fins), copy_buffer, (gsize) copy_buffer_length1, NULL, &_inner_error_);
#line 2797 "Exif.c"
					if (_inner_error_ != NULL) {
						_g_object_unref0 (temp);
						_g_object_unref0 (fouts);
						copy_buffer = (g_free (copy_buffer), NULL);
						goto __finally31;
					}
#line 734 "Exif.vala"
					if (bytes_read == 0) {
#line 735 "Exif.vala"
						break;
#line 2808 "Exif.c"
					}
#line 737 "Exif.vala"
					g_assert (bytes_read > 0);
#line 739 "Exif.vala"
					g_output_stream_write_all (G_OUTPUT_STREAM (fouts), copy_buffer, (gsize) bytes_read, &bytes_written, NULL, &_inner_error_);
#line 2814 "Exif.c"
					if (_inner_error_ != NULL) {
						_g_object_unref0 (temp);
						_g_object_unref0 (fouts);
						copy_buffer = (g_free (copy_buffer), NULL);
						goto __finally31;
					}
#line 740 "Exif.vala"
					g_assert (bytes_written == bytes_read);
#line 2823 "Exif.c"
				}
			}
#line 744 "Exif.vala"
			g_output_stream_close (G_OUTPUT_STREAM (fouts), NULL, &_inner_error_);
#line 2828 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				copy_buffer = (g_free (copy_buffer), NULL);
				goto __finally31;
			}
#line 745 "Exif.vala"
			g_input_stream_close (G_INPUT_STREAM (fins), NULL, &_inner_error_);
#line 2837 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				copy_buffer = (g_free (copy_buffer), NULL);
				goto __finally31;
			}
#line 747 "Exif.vala"
			g_file_move (temp, self->priv->file, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 2846 "Exif.c"
			if (_inner_error_ != NULL) {
				_g_object_unref0 (temp);
				_g_object_unref0 (fouts);
				copy_buffer = (g_free (copy_buffer), NULL);
				goto __finally31;
			}
			_g_object_unref0 (temp);
			_g_object_unref0 (fouts);
			copy_buffer = (g_free (copy_buffer), NULL);
		}
	}
	__finally31:
	{
		ExifMem* _tmp7_;
#line 750 "Exif.vala"
		exif_mem_free (_tmp7_ = exif_mem_new_default (), flattened);
#line 2863 "Exif.c"
		_exif_mem_unref0 (_tmp7_);
	}
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fins);
		return;
	}
	_g_object_unref0 (fins);
}


#line 754 "Exif.vala"
static GFileOutputStream* photo_exif_create_temp (GFile* original, GFile** temp, GError** error) {
#line 2877 "Exif.c"
	GFileOutputStream* result = NULL;
	GError * _inner_error_;
	GFile* parent;
#line 754 "Exif.vala"
	g_return_val_if_fail (G_IS_FILE (original), NULL);
#line 2883 "Exif.c"
	if (temp != NULL) {
		*temp = NULL;
	}
	_inner_error_ = NULL;
#line 755 "Exif.vala"
	parent = g_file_get_parent (original);
#line 756 "Exif.vala"
	g_assert (parent != NULL);
#line 2892 "Exif.c"
	{
		gint ctr;
#line 758 "Exif.vala"
		ctr = 0;
#line 2897 "Exif.c"
		{
			gboolean _tmp0_;
#line 758 "Exif.vala"
			_tmp0_ = TRUE;
#line 758 "Exif.vala"
			while (TRUE) {
#line 2904 "Exif.c"
				char* _tmp1_;
				GFile* _tmp2_;
				GFile* t;
				GFileOutputStream* fouts;
#line 758 "Exif.vala"
				if (!_tmp0_) {
#line 758 "Exif.vala"
					ctr++;
#line 2913 "Exif.c"
				}
#line 758 "Exif.vala"
				_tmp0_ = FALSE;
#line 758 "Exif.vala"
				if (!(ctr < G_MAXINT)) {
#line 758 "Exif.vala"
					break;
#line 2921 "Exif.c"
				}
#line 759 "Exif.vala"
				t = (_tmp2_ = g_file_get_child (parent, _tmp1_ = g_strdup_printf ("shotwell.%08X.tmp", (guint) ctr)), _g_free0 (_tmp1_), _tmp2_);
#line 760 "Exif.vala"
				fouts = g_file_create (t, G_FILE_CREATE_PRIVATE, NULL, &_inner_error_);
#line 2927 "Exif.c"
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (t);
					_g_object_unref0 (parent);
					return NULL;
				}
#line 761 "Exif.vala"
				if (fouts != NULL) {
#line 2936 "Exif.c"
					GFile* _tmp3_;
#line 762 "Exif.vala"
					*temp = (_tmp3_ = _g_object_ref0 (t), _g_object_unref0 (*temp), _tmp3_);
#line 2940 "Exif.c"
					result = fouts;
					_g_object_unref0 (t);
					_g_object_unref0 (parent);
#line 764 "Exif.vala"
					return result;
#line 2946 "Exif.c"
				}
				_g_object_unref0 (t);
				_g_object_unref0 (fouts);
			}
		}
	}
	result = NULL;
	_g_object_unref0 (parent);
#line 768 "Exif.vala"
	return result;
#line 2957 "Exif.c"
}


static void value_photo_exif_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_photo_exif_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_exif_unref (value->data[0].v_pointer);
	}
}


static void value_photo_exif_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_exif_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_photo_exif_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_photo_exif_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoExif* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_exif_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_photo_exif_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoExif** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_exif_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_photo_exif (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoExif* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_EXIF), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_photo_exif (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_EXIF), NULL);
	return value->data[0].v_pointer;
}


void value_set_photo_exif (GValue* value, gpointer v_object) {
	PhotoExif* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_EXIF));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_EXIF));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_exif_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_exif_unref (old);
	}
}


void value_take_photo_exif (GValue* value, gpointer v_object) {
	PhotoExif* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_EXIF));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_EXIF));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_exif_unref (old);
	}
}


static void photo_exif_class_init (PhotoExifClass * klass) {
	photo_exif_parent_class = g_type_class_peek_parent (klass);
	PHOTO_EXIF_CLASS (klass)->finalize = photo_exif_finalize;
	g_type_class_add_private (klass, sizeof (PhotoExifPrivate));
}


static void photo_exif_instance_init (PhotoExif * self) {
	self->priv = PHOTO_EXIF_GET_PRIVATE (self);
	self->priv->exif = exif_data_new ();
	self->ref_count = 1;
}


static void photo_exif_finalize (PhotoExif* obj) {
	PhotoExif * self;
	self = PHOTO_EXIF (obj);
	_g_object_unref0 (self->priv->file);
	_exif_data_unref0 (self->priv->exif);
}


GType photo_exif_get_type (void) {
	static volatile gsize photo_exif_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exif_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_exif_init, value_photo_exif_free_value, value_photo_exif_copy_value, value_photo_exif_peek_pointer, "p", value_photo_exif_collect_value, "p", value_photo_exif_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoExifClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_exif_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoExif), 0, (GInstanceInitFunc) photo_exif_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_exif_type_id;
		photo_exif_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoExif", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_exif_type_id__volatile, photo_exif_type_id);
	}
	return photo_exif_type_id__volatile;
}


gpointer photo_exif_ref (gpointer instance) {
	PhotoExif* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_exif_unref (gpointer instance) {
	PhotoExif* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_EXIF_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}




