/* LibraryFiles.c generated by valac, the Vala compiler
 * generated from LibraryFiles.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <time.h>
#include <libexif/exif-data.h>
#include <stdlib.h>
#include <string.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_PHOTO_EXIF (photo_exif_get_type ())
#define PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_EXIF, PhotoExif))
#define PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_EXIF, PhotoExifClass))
#define IS_PHOTO_EXIF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_EXIF))
#define IS_PHOTO_EXIF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_EXIF))
#define PHOTO_EXIF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_EXIF, PhotoExifClass))

typedef struct _PhotoExif PhotoExif;
typedef struct _PhotoExifClass PhotoExifClass;
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
#define _photo_exif_unref0(var) ((var == NULL) ? NULL : (var = (photo_exif_unref (var), NULL)))

typedef enum  {
	EXIF_ERROR_FILE_FORMAT
} ExifError;
#define EXIF_ERROR exif_error_quark ()


#define LIBRARY_FILES_DIRECTORY_DEPTH 3
gboolean library_files_claim_file (GFile* file, GError** error);
GFile* app_dirs_get_photos_dir (void);
gboolean exif_get_timestamp (ExifData* exif, time_t* timestamp);
void disassemble_filename (const char* basename, char** name, char** ext);
GFile* library_files_generate_unique_file (const char* basename, ExifData* exif, time_t ts, gboolean* collision, GError** error);
time_t query_file_modified (GFile* file, GError** error);
PhotoExif* photo_exif_new (GFile* file);
PhotoExif* photo_exif_construct (GType object_type, GFile* file);
gpointer photo_exif_ref (gpointer instance);
void photo_exif_unref (gpointer instance);
GParamSpec* param_spec_photo_exif (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_exif (GValue* value, gpointer v_object);
void value_take_photo_exif (GValue* value, gpointer v_object);
gpointer value_get_photo_exif (const GValue* value);
GType photo_exif_get_type (void);
GQuark exif_error_quark (void);
void photo_exif_load (PhotoExif* self, GError** error);
ExifData* photo_exif_get_exif (PhotoExif* self);
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, GError** error);



static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


#line 11 "LibraryFiles.vala"
gboolean library_files_claim_file (GFile* file, GError** error) {
#line 71 "LibraryFiles.c"
	gboolean result = FALSE;
	GError * _inner_error_;
#line 11 "LibraryFiles.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 76 "LibraryFiles.c"
	_inner_error_ = NULL;
	{
		GFileOutputStream* _tmp0_;
#line 13 "LibraryFiles.vala"
		_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
#line 82 "LibraryFiles.c"
		_g_object_unref0 (_tmp0_);
		if (_inner_error_ != NULL) {
			goto __catch157_g_error;
		}
		result = TRUE;
#line 16 "LibraryFiles.vala"
		return result;
#line 90 "LibraryFiles.c"
	}
	goto __finally157;
	__catch157_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 19 "LibraryFiles.vala"
			if (!g_error_matches (err, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 101 "LibraryFiles.c"
				char* _tmp1_;
#line 20 "LibraryFiles.vala"
				g_debug ("LibraryFiles.vala:20: claim_file %s: %s", _tmp1_ = g_file_get_path (file), err->message);
#line 105 "LibraryFiles.c"
				_g_free0 (_tmp1_);
				_inner_error_ = _g_error_copy0 (err);
				{
					_g_error_free0 (err);
					goto __finally157;
				}
			}
			result = FALSE;
			_g_error_free0 (err);
#line 25 "LibraryFiles.vala"
			return result;
#line 117 "LibraryFiles.c"
		}
	}
	__finally157:
	{
		g_propagate_error (error, _inner_error_);
		return FALSE;
	}
}


#line 2053 "glib-2.0.vapi"
static void g_time_local (time_t time, struct tm* result) {
#line 130 "LibraryFiles.c"
	struct tm _result_ = {0};
#line 2055 "glib-2.0.vapi"
	localtime_r (&time, &_result_);
#line 134 "LibraryFiles.c"
	*result = _result_;
#line 2056 "glib-2.0.vapi"
	return;
#line 138 "LibraryFiles.c"
}


#line 33 "LibraryFiles.vala"
GFile* library_files_generate_unique_file (const char* basename, ExifData* exif, time_t ts, gboolean* collision, GError** error) {
#line 144 "LibraryFiles.c"
	GFile* result = NULL;
	GError * _inner_error_;
	GFile* dir;
	time_t timestamp;
	gboolean _tmp0_ = FALSE;
	struct tm _tmp1_ = {0};
	struct tm tm;
	GFile* _tmp3_;
	char* _tmp2_;
	GFile* _tmp5_;
	char* _tmp4_;
	GFile* _tmp7_;
	char* _tmp6_;
	GFile* file;
	gboolean _tmp8_;
	char* name;
	char* ext;
	char* _tmp12_;
	char* _tmp11_ = NULL;
	char* _tmp10_;
	char* _tmp9_ = NULL;
#line 33 "LibraryFiles.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 168 "LibraryFiles.c"
	_inner_error_ = NULL;
#line 35 "LibraryFiles.vala"
	dir = app_dirs_get_photos_dir ();
#line 36 "LibraryFiles.vala"
	timestamp = ts;
#line 40 "LibraryFiles.vala"
	if (exif != NULL) {
#line 40 "LibraryFiles.vala"
		_tmp0_ = !exif_get_timestamp (exif, &timestamp);
#line 178 "LibraryFiles.c"
	} else {
#line 40 "LibraryFiles.vala"
		_tmp0_ = FALSE;
#line 182 "LibraryFiles.c"
	}
#line 40 "LibraryFiles.vala"
	if (_tmp0_) {
#line 42 "LibraryFiles.vala"
		if (ts == 0) {
#line 43 "LibraryFiles.vala"
			timestamp = time (NULL);
#line 190 "LibraryFiles.c"
		}
	}
#line 46 "LibraryFiles.vala"
	tm = (g_time_local (timestamp, &_tmp1_), _tmp1_);
#line 50 "LibraryFiles.vala"
	dir = (_tmp3_ = g_file_get_child (dir, _tmp2_ = g_strdup_printf ("%04u", (guint) (tm.tm_year + 1900))), _g_object_unref0 (dir), _tmp3_);
#line 197 "LibraryFiles.c"
	_g_free0 (_tmp2_);
#line 51 "LibraryFiles.vala"
	dir = (_tmp5_ = g_file_get_child (dir, _tmp4_ = g_strdup_printf ("%02u", (guint) (tm.tm_mon + 1))), _g_object_unref0 (dir), _tmp5_);
#line 201 "LibraryFiles.c"
	_g_free0 (_tmp4_);
#line 52 "LibraryFiles.vala"
	dir = (_tmp7_ = g_file_get_child (dir, _tmp6_ = g_strdup_printf ("%02u", (guint) tm.tm_mday)), _g_object_unref0 (dir), _tmp7_);
#line 205 "LibraryFiles.c"
	_g_free0 (_tmp6_);
	{
#line 55 "LibraryFiles.vala"
		g_file_make_directory_with_parents (dir, NULL, &_inner_error_);
#line 210 "LibraryFiles.c"
		if (_inner_error_ != NULL) {
			goto __catch158_g_error;
		}
	}
	goto __finally158;
	__catch158_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 57 "LibraryFiles.vala"
			if (!g_error_matches (err, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 224 "LibraryFiles.c"
				_inner_error_ = _g_error_copy0 (err);
				{
					_g_error_free0 (err);
					_g_object_unref0 (dir);
					goto __finally158;
				}
			}
			_g_error_free0 (err);
		}
	}
	__finally158:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (dir);
		return NULL;
	}
#line 64 "LibraryFiles.vala"
	file = g_file_get_child (dir, basename);
#line 65 "LibraryFiles.vala"
	_tmp8_ = library_files_claim_file (file, &_inner_error_);
#line 245 "LibraryFiles.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (dir);
		_g_object_unref0 (file);
		return NULL;
	}
#line 65 "LibraryFiles.vala"
	if (_tmp8_) {
#line 66 "LibraryFiles.vala"
		*collision = FALSE;
#line 256 "LibraryFiles.c"
		result = file;
		_g_object_unref0 (dir);
#line 68 "LibraryFiles.vala"
		return result;
#line 261 "LibraryFiles.c"
	}
#line 72 "LibraryFiles.vala"
	*collision = TRUE;
#line 265 "LibraryFiles.c"
	name = NULL;
	ext = NULL;
#line 75 "LibraryFiles.vala"
	(disassemble_filename (basename, &_tmp9_, &_tmp11_), name = (_tmp10_ = _tmp9_, _g_free0 (name), _tmp10_));
#line 75 "LibraryFiles.vala"
	ext = (_tmp12_ = _tmp11_, _g_free0 (ext), _tmp12_);
#line 272 "LibraryFiles.c"
	{
		gint ctr;
#line 78 "LibraryFiles.vala"
		ctr = 1;
#line 277 "LibraryFiles.c"
		{
			gboolean _tmp13_;
#line 78 "LibraryFiles.vala"
			_tmp13_ = TRUE;
#line 78 "LibraryFiles.vala"
			while (TRUE) {
#line 284 "LibraryFiles.c"
				char* _tmp14_;
				char* new_name;
				GFile* _tmp17_;
				gboolean _tmp18_;
#line 78 "LibraryFiles.vala"
				if (!_tmp13_) {
#line 78 "LibraryFiles.vala"
					ctr++;
#line 293 "LibraryFiles.c"
				}
#line 78 "LibraryFiles.vala"
				_tmp13_ = FALSE;
#line 78 "LibraryFiles.vala"
				if (!(ctr < G_MAXINT)) {
#line 78 "LibraryFiles.vala"
					break;
#line 301 "LibraryFiles.c"
				}
				_tmp14_ = NULL;
#line 79 "LibraryFiles.vala"
				if (ext != NULL) {
#line 306 "LibraryFiles.c"
					char* _tmp15_;
#line 79 "LibraryFiles.vala"
					_tmp14_ = (_tmp15_ = g_strdup_printf ("%s_%d.%s", name, ctr, ext), _g_free0 (_tmp14_), _tmp15_);
#line 310 "LibraryFiles.c"
				} else {
					char* _tmp16_;
#line 79 "LibraryFiles.vala"
					_tmp14_ = (_tmp16_ = g_strdup_printf ("%s_%d", name, ctr), _g_free0 (_tmp14_), _tmp16_);
#line 315 "LibraryFiles.c"
				}
#line 79 "LibraryFiles.vala"
				new_name = g_strdup (_tmp14_);
#line 81 "LibraryFiles.vala"
				file = (_tmp17_ = g_file_get_child (dir, new_name), _g_object_unref0 (file), _tmp17_);
#line 82 "LibraryFiles.vala"
				_tmp18_ = library_files_claim_file (file, &_inner_error_);
#line 323 "LibraryFiles.c"
				if (_inner_error_ != NULL) {
					g_propagate_error (error, _inner_error_);
					_g_free0 (_tmp14_);
					_g_free0 (new_name);
					_g_object_unref0 (dir);
					_g_object_unref0 (file);
					_g_free0 (name);
					_g_free0 (ext);
					return NULL;
				}
#line 82 "LibraryFiles.vala"
				if (_tmp18_) {
#line 336 "LibraryFiles.c"
					result = file;
					_g_free0 (_tmp14_);
					_g_free0 (new_name);
					_g_object_unref0 (dir);
					_g_free0 (name);
					_g_free0 (ext);
#line 83 "LibraryFiles.vala"
					return result;
#line 345 "LibraryFiles.c"
				}
				_g_free0 (_tmp14_);
				_g_free0 (new_name);
			}
		}
	}
#line 86 "LibraryFiles.vala"
	g_debug ("LibraryFiles.vala:86: generate_unique_filename for %s: unable to claim" \
" file", basename);
#line 354 "LibraryFiles.c"
	result = NULL;
	_g_object_unref0 (dir);
	_g_object_unref0 (file);
	_g_free0 (name);
	_g_free0 (ext);
#line 88 "LibraryFiles.vala"
	return result;
#line 362 "LibraryFiles.c"
}


#line 92 "LibraryFiles.vala"
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, GError** error) {
#line 368 "LibraryFiles.c"
	GFile* result = NULL;
	GError * _inner_error_;
	time_t timestamp;
	PhotoExif* exif;
	ExifData* data;
	gboolean collision = FALSE;
	char* _tmp4_;
	GFile* _tmp5_;
	GFile* dest;
#line 92 "LibraryFiles.vala"
	g_return_val_if_fail (G_IS_FILE (src), NULL);
#line 380 "LibraryFiles.c"
	_inner_error_ = NULL;
#line 93 "LibraryFiles.vala"
	timestamp = (time_t) 0;
#line 384 "LibraryFiles.c"
	{
		time_t _tmp0_;
#line 95 "LibraryFiles.vala"
		_tmp0_ = query_file_modified (src, &_inner_error_);
#line 389 "LibraryFiles.c"
		if (_inner_error_ != NULL) {
			goto __catch159_g_error;
		}
#line 95 "LibraryFiles.vala"
		timestamp = _tmp0_;
#line 395 "LibraryFiles.c"
	}
	goto __finally159;
	__catch159_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp1_;
#line 97 "LibraryFiles.vala"
			g_critical ("LibraryFiles.vala:97: Unable to access file modification for %s: %s", _tmp1_ = g_file_get_path (src), err->message);
#line 407 "LibraryFiles.c"
			_g_free0 (_tmp1_);
			_g_error_free0 (err);
		}
	}
	__finally159:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
#line 100 "LibraryFiles.vala"
	exif = photo_exif_new (src);
#line 419 "LibraryFiles.c"
	data = NULL;
	{
		ExifData* _tmp2_;
#line 103 "LibraryFiles.vala"
		photo_exif_load (exif, &_inner_error_);
#line 425 "LibraryFiles.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == EXIF_ERROR) {
				goto __catch160_exif_error;
			}
			goto __finally160;
		}
#line 104 "LibraryFiles.vala"
		data = (_tmp2_ = photo_exif_get_exif (exif), _exif_data_unref0 (data), _tmp2_);
#line 434 "LibraryFiles.c"
	}
	goto __finally160;
	__catch160_exif_error:
	{
		GError * exif_err;
		exif_err = _inner_error_;
		_inner_error_ = NULL;
		{
			ExifData* _tmp3_;
#line 106 "LibraryFiles.vala"
			data = (_tmp3_ = NULL, _exif_data_unref0 (data), _tmp3_);
#line 446 "LibraryFiles.c"
			_g_error_free0 (exif_err);
		}
	}
	__finally160:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_exif_unref0 (exif);
		_exif_data_unref0 (data);
		return NULL;
	}
#line 110 "LibraryFiles.vala"
	dest = (_tmp5_ = library_files_generate_unique_file (_tmp4_ = g_file_get_basename (src), data, timestamp, &collision, &_inner_error_), _g_free0 (_tmp4_), _tmp5_);
#line 459 "LibraryFiles.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_exif_unref0 (exif);
		_exif_data_unref0 (data);
		return NULL;
	}
#line 111 "LibraryFiles.vala"
	if (dest == NULL) {
#line 468 "LibraryFiles.c"
		_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Unable to generate unique pathname for destination");
		{
			g_propagate_error (error, _inner_error_);
			_photo_exif_unref0 (exif);
			_exif_data_unref0 (data);
			_g_object_unref0 (dest);
			return NULL;
		}
	}
#line 114 "LibraryFiles.vala"
	g_file_copy (src, dest, G_FILE_COPY_ALL_METADATA | G_FILE_COPY_OVERWRITE, NULL, progress_callback, progress_callback_target, &_inner_error_);
#line 480 "LibraryFiles.c"
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_photo_exif_unref0 (exif);
		_exif_data_unref0 (data);
		_g_object_unref0 (dest);
		return NULL;
	}
	result = dest;
	_photo_exif_unref0 (exif);
	_exif_data_unref0 (data);
#line 116 "LibraryFiles.vala"
	return result;
#line 493 "LibraryFiles.c"
}




