/* Orientation.c generated by valac, the Vala compiler
 * generated from Orientation.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>


#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



GType orientation_get_type (void);
char* orientation_to_string (Orientation self);
Orientation orientation_rotate_clockwise (Orientation self);
Orientation orientation_rotate_counterclockwise (Orientation self);
Orientation orientation_flip_top_to_bottom (Orientation self);
Orientation orientation_flip_left_to_right (Orientation self);
GType rotation_get_type (void);
Orientation orientation_perform (Orientation self, Rotation rotation);
GType dimensions_get_type (void);
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
gboolean dimensions_has_area (Dimensions *self);
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
GType box_get_type (void);
Box* box_dup (const Box* self);
void box_free (Box* self);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);



#line 19 "Orientation.vala"
char* orientation_to_string (Orientation self) {
#line 94 "Orientation.c"
	char* result = NULL;
#line 20 "Orientation.vala"
	switch (self) {
#line 98 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = g_strdup ("top-left");
#line 22 "Orientation.vala"
			return result;
#line 104 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = g_strdup ("top-right");
#line 25 "Orientation.vala"
			return result;
#line 111 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = g_strdup ("bottom-right");
#line 28 "Orientation.vala"
			return result;
#line 118 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = g_strdup ("bottom-left");
#line 31 "Orientation.vala"
			return result;
#line 125 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = g_strdup ("left-top");
#line 34 "Orientation.vala"
			return result;
#line 132 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = g_strdup ("right-top");
#line 37 "Orientation.vala"
			return result;
#line 139 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = g_strdup ("right-bottom");
#line 40 "Orientation.vala"
			return result;
#line 146 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = g_strdup ("left-bottom");
#line 43 "Orientation.vala"
			return result;
#line 153 "Orientation.c"
		}
		default:
		{
			result = g_strdup_printf ("unknown orientation %d", (gint) self);
#line 46 "Orientation.vala"
			return result;
#line 160 "Orientation.c"
		}
	}
}


#line 50 "Orientation.vala"
Orientation orientation_rotate_clockwise (Orientation self) {
#line 168 "Orientation.c"
	Orientation result = 0;
#line 51 "Orientation.vala"
	switch (self) {
#line 172 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 53 "Orientation.vala"
			return result;
#line 178 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 56 "Orientation.vala"
			return result;
#line 185 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 59 "Orientation.vala"
			return result;
#line 192 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_LEFT_TOP;
#line 62 "Orientation.vala"
			return result;
#line 199 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 65 "Orientation.vala"
			return result;
#line 206 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 68 "Orientation.vala"
			return result;
#line 213 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 71 "Orientation.vala"
			return result;
#line 220 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_TOP_LEFT;
#line 74 "Orientation.vala"
			return result;
#line 227 "Orientation.c"
		}
		default:
		{
			{
#line 77 "Orientation.vala"
				g_error ("Orientation.vala:77: rotate_clockwise: %d", (gint) self);
#line 234 "Orientation.c"
				result = self;
#line 79 "Orientation.vala"
				return result;
#line 238 "Orientation.c"
			}
		}
	}
}


#line 84 "Orientation.vala"
Orientation orientation_rotate_counterclockwise (Orientation self) {
#line 247 "Orientation.c"
	Orientation result = 0;
#line 85 "Orientation.vala"
	switch (self) {
#line 251 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 87 "Orientation.vala"
			return result;
#line 257 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_LEFT_TOP;
#line 90 "Orientation.vala"
			return result;
#line 264 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 93 "Orientation.vala"
			return result;
#line 271 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 96 "Orientation.vala"
			return result;
#line 278 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 99 "Orientation.vala"
			return result;
#line 285 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_TOP_LEFT;
#line 102 "Orientation.vala"
			return result;
#line 292 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 105 "Orientation.vala"
			return result;
#line 299 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 108 "Orientation.vala"
			return result;
#line 306 "Orientation.c"
		}
		default:
		{
			{
#line 111 "Orientation.vala"
				g_error ("Orientation.vala:111: rotate_counterclockwise: %d", (gint) self);
#line 313 "Orientation.c"
				result = self;
#line 113 "Orientation.vala"
				return result;
#line 317 "Orientation.c"
			}
		}
	}
}


#line 118 "Orientation.vala"
Orientation orientation_flip_top_to_bottom (Orientation self) {
#line 326 "Orientation.c"
	Orientation result = 0;
#line 119 "Orientation.vala"
	switch (self) {
#line 330 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 121 "Orientation.vala"
			return result;
#line 336 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 124 "Orientation.vala"
			return result;
#line 343 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 127 "Orientation.vala"
			return result;
#line 350 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_TOP_LEFT;
#line 130 "Orientation.vala"
			return result;
#line 357 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 133 "Orientation.vala"
			return result;
#line 364 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_LEFT_TOP;
#line 136 "Orientation.vala"
			return result;
#line 371 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 139 "Orientation.vala"
			return result;
#line 378 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 142 "Orientation.vala"
			return result;
#line 385 "Orientation.c"
		}
		default:
		{
			{
#line 145 "Orientation.vala"
				g_error ("Orientation.vala:145: flip_top_to_bottom: %d", (gint) self);
#line 392 "Orientation.c"
				result = self;
#line 147 "Orientation.vala"
				return result;
#line 396 "Orientation.c"
			}
		}
	}
}


#line 152 "Orientation.vala"
Orientation orientation_flip_left_to_right (Orientation self) {
#line 405 "Orientation.c"
	Orientation result = 0;
#line 153 "Orientation.vala"
	switch (self) {
#line 409 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
			result = ORIENTATION_TOP_RIGHT;
#line 155 "Orientation.vala"
			return result;
#line 415 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			result = ORIENTATION_TOP_LEFT;
#line 158 "Orientation.vala"
			return result;
#line 422 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			result = ORIENTATION_BOTTOM_LEFT;
#line 161 "Orientation.vala"
			return result;
#line 429 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			result = ORIENTATION_BOTTOM_RIGHT;
#line 164 "Orientation.vala"
			return result;
#line 436 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			result = ORIENTATION_RIGHT_TOP;
#line 167 "Orientation.vala"
			return result;
#line 443 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			result = ORIENTATION_LEFT_TOP;
#line 170 "Orientation.vala"
			return result;
#line 450 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			result = ORIENTATION_LEFT_BOTTOM;
#line 173 "Orientation.vala"
			return result;
#line 457 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			result = ORIENTATION_RIGHT_BOTTOM;
#line 176 "Orientation.vala"
			return result;
#line 464 "Orientation.c"
		}
		default:
		{
			{
#line 179 "Orientation.vala"
				g_error ("Orientation.vala:179: flip_left_to_right: %d", (gint) self);
#line 471 "Orientation.c"
				result = self;
#line 181 "Orientation.vala"
				return result;
#line 475 "Orientation.c"
			}
		}
	}
}


#line 186 "Orientation.vala"
Orientation orientation_perform (Orientation self, Rotation rotation) {
#line 484 "Orientation.c"
	Orientation result = 0;
#line 187 "Orientation.vala"
	switch (rotation) {
#line 488 "Orientation.c"
		case ROTATION_CLOCKWISE:
		{
			result = orientation_rotate_clockwise (self);
#line 189 "Orientation.vala"
			return result;
#line 494 "Orientation.c"
		}
		case ROTATION_COUNTERCLOCKWISE:
		{
			result = orientation_rotate_counterclockwise (self);
#line 192 "Orientation.vala"
			return result;
#line 501 "Orientation.c"
		}
		case ROTATION_MIRROR:
		{
			result = orientation_flip_left_to_right (self);
#line 195 "Orientation.vala"
			return result;
#line 508 "Orientation.c"
		}
		case ROTATION_UPSIDE_DOWN:
		{
			result = orientation_flip_top_to_bottom (self);
#line 198 "Orientation.vala"
			return result;
#line 515 "Orientation.c"
		}
		default:
		{
#line 201 "Orientation.vala"
			g_error ("Orientation.vala:201: perform: %d", (gint) rotation);
#line 521 "Orientation.c"
			result = self;
#line 203 "Orientation.vala"
			return result;
#line 525 "Orientation.c"
		}
	}
}


#line 207 "Orientation.vala"
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
#line 208 "Orientation.vala"
	switch (self) {
#line 535 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		case ORIENTATION_TOP_RIGHT:
		case ORIENTATION_BOTTOM_RIGHT:
		case ORIENTATION_BOTTOM_LEFT:
		{
			*result = *dim;
#line 214 "Orientation.vala"
			return;
#line 544 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		case ORIENTATION_RIGHT_TOP:
		case ORIENTATION_RIGHT_BOTTOM:
		case ORIENTATION_LEFT_BOTTOM:
		{
			Dimensions _tmp0_ = {0};
			*result = (dimensions_init (&_tmp0_, (*dim).height, (*dim).width), _tmp0_);
#line 221 "Orientation.vala"
			return;
#line 555 "Orientation.c"
		}
		default:
		{
#line 224 "Orientation.vala"
			g_error ("Orientation.vala:224: rotate_dimensions: %d", (gint) self);
#line 561 "Orientation.c"
			*result = *dim;
#line 226 "Orientation.vala"
			return;
#line 565 "Orientation.c"
		}
	}
}


#line 230 "Orientation.vala"
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result) {
#line 573 "Orientation.c"
	Dimensions _tmp0_ = {0};
	*result = (orientation_rotate_dimensions (self, dim, &_tmp0_), _tmp0_);
#line 231 "Orientation.vala"
	return;
#line 578 "Orientation.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 234 "Orientation.vala"
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf) {
#line 589 "Orientation.c"
	GdkPixbuf* result = NULL;
#line 234 "Orientation.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 235 "Orientation.vala"
	switch (self) {
#line 595 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 238 "Orientation.vala"
			break;
#line 600 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
			GdkPixbuf* _tmp0_;
#line 242 "Orientation.vala"
			pixbuf = (_tmp0_ = gdk_pixbuf_flip (pixbuf, TRUE), _g_object_unref0 (pixbuf), _tmp0_);
#line 243 "Orientation.vala"
			break;
#line 609 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
			GdkPixbuf* _tmp1_;
#line 246 "Orientation.vala"
			pixbuf = (_tmp1_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_UPSIDEDOWN), _g_object_unref0 (pixbuf), _tmp1_);
#line 247 "Orientation.vala"
			break;
#line 618 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
			GdkPixbuf* _tmp2_;
#line 251 "Orientation.vala"
			pixbuf = (_tmp2_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp2_);
#line 252 "Orientation.vala"
			break;
#line 627 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
			GdkPixbuf* _tmp3_;
			GdkPixbuf* _tmp4_;
#line 255 "Orientation.vala"
			pixbuf = (_tmp3_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE), _g_object_unref0 (pixbuf), _tmp3_);
#line 256 "Orientation.vala"
			pixbuf = (_tmp4_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp4_);
#line 257 "Orientation.vala"
			break;
#line 639 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
			GdkPixbuf* _tmp5_;
#line 260 "Orientation.vala"
			pixbuf = (_tmp5_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE), _g_object_unref0 (pixbuf), _tmp5_);
#line 261 "Orientation.vala"
			break;
#line 648 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 264 "Orientation.vala"
			pixbuf = (_tmp6_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_CLOCKWISE), _g_object_unref0 (pixbuf), _tmp6_);
#line 265 "Orientation.vala"
			pixbuf = (_tmp7_ = gdk_pixbuf_flip (pixbuf, FALSE), _g_object_unref0 (pixbuf), _tmp7_);
#line 266 "Orientation.vala"
			break;
#line 660 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
			GdkPixbuf* _tmp8_;
#line 269 "Orientation.vala"
			pixbuf = (_tmp8_ = gdk_pixbuf_rotate_simple (pixbuf, GDK_PIXBUF_ROTATE_COUNTERCLOCKWISE), _g_object_unref0 (pixbuf), _tmp8_);
#line 270 "Orientation.vala"
			break;
#line 669 "Orientation.c"
		}
		default:
		{
#line 273 "Orientation.vala"
			g_error ("Orientation.vala:273: rotate_pixbuf: %d", (gint) self);
#line 274 "Orientation.vala"
			break;
#line 677 "Orientation.c"
		}
	}
	result = _g_object_ref0 (pixbuf);
	_g_object_unref0 (pixbuf);
#line 277 "Orientation.vala"
	return result;
#line 684 "Orientation.c"
}


#line 281 "Orientation.vala"
void orientation_rotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
#line 690 "Orientation.c"
	GdkPoint rotated = {0};
#line 282 "Orientation.vala"
	g_assert (dimensions_has_area (space));
#line 283 "Orientation.vala"
	g_assert ((*point).x >= 0);
#line 284 "Orientation.vala"
	g_assert ((*point).x < (*space).width);
#line 285 "Orientation.vala"
	g_assert ((*point).y >= 0);
#line 286 "Orientation.vala"
	g_assert ((*point).y < (*space).height);
#line 702 "Orientation.c"
	memset (&rotated, 0, sizeof (GdkPoint));
#line 290 "Orientation.vala"
	switch (self) {
#line 706 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 293 "Orientation.vala"
			rotated = *point;
#line 294 "Orientation.vala"
			break;
#line 713 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
#line 298 "Orientation.vala"
			rotated.x = ((*space).width - (*point).x) - 1;
#line 299 "Orientation.vala"
			rotated.y = (*point).y;
#line 300 "Orientation.vala"
			break;
#line 723 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
#line 304 "Orientation.vala"
			rotated.x = ((*space).width - (*point).x) - 1;
#line 305 "Orientation.vala"
			rotated.y = ((*space).height - (*point).y) - 1;
#line 306 "Orientation.vala"
			break;
#line 733 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
#line 310 "Orientation.vala"
			rotated.x = (*point).x;
#line 311 "Orientation.vala"
			rotated.y = ((*space).height - (*point).y) - 1;
#line 312 "Orientation.vala"
			break;
#line 743 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
#line 316 "Orientation.vala"
			rotated.x = (*point).y;
#line 317 "Orientation.vala"
			rotated.y = (*point).x;
#line 318 "Orientation.vala"
			break;
#line 753 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
#line 322 "Orientation.vala"
			rotated.x = ((*space).height - (*point).y) - 1;
#line 323 "Orientation.vala"
			rotated.y = (*point).x;
#line 324 "Orientation.vala"
			break;
#line 763 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
#line 328 "Orientation.vala"
			rotated.x = ((*space).height - (*point).y) - 1;
#line 329 "Orientation.vala"
			rotated.y = ((*space).width - (*point).x) - 1;
#line 330 "Orientation.vala"
			break;
#line 773 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
#line 334 "Orientation.vala"
			rotated.x = (*point).y;
#line 335 "Orientation.vala"
			rotated.y = ((*space).width - (*point).x) - 1;
#line 336 "Orientation.vala"
			break;
#line 783 "Orientation.c"
		}
		default:
		{
#line 339 "Orientation.vala"
			g_error ("Orientation.vala:339: rotate_point: %d", (gint) self);
#line 340 "Orientation.vala"
			break;
#line 791 "Orientation.c"
		}
	}
	*result = rotated;
#line 343 "Orientation.vala"
	return;
#line 797 "Orientation.c"
}


#line 347 "Orientation.vala"
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result) {
#line 803 "Orientation.c"
	GdkPoint derotated = {0};
#line 348 "Orientation.vala"
	g_assert (dimensions_has_area (space));
#line 807 "Orientation.c"
	memset (&derotated, 0, sizeof (GdkPoint));
#line 352 "Orientation.vala"
	switch (self) {
#line 811 "Orientation.c"
		case ORIENTATION_TOP_LEFT:
		{
#line 355 "Orientation.vala"
			derotated = *point;
#line 356 "Orientation.vala"
			break;
#line 818 "Orientation.c"
		}
		case ORIENTATION_TOP_RIGHT:
		{
#line 360 "Orientation.vala"
			derotated.x = ((*space).width - (*point).x) - 1;
#line 361 "Orientation.vala"
			derotated.y = (*point).y;
#line 362 "Orientation.vala"
			break;
#line 828 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_RIGHT:
		{
#line 366 "Orientation.vala"
			derotated.x = ((*space).width - (*point).x) - 1;
#line 367 "Orientation.vala"
			derotated.y = ((*space).height - (*point).y) - 1;
#line 368 "Orientation.vala"
			break;
#line 838 "Orientation.c"
		}
		case ORIENTATION_BOTTOM_LEFT:
		{
#line 372 "Orientation.vala"
			derotated.x = (*point).x;
#line 373 "Orientation.vala"
			derotated.y = ((*space).height - (*point).y) - 1;
#line 374 "Orientation.vala"
			break;
#line 848 "Orientation.c"
		}
		case ORIENTATION_LEFT_TOP:
		{
#line 378 "Orientation.vala"
			derotated.x = (*point).y;
#line 379 "Orientation.vala"
			derotated.y = (*point).x;
#line 380 "Orientation.vala"
			break;
#line 858 "Orientation.c"
		}
		case ORIENTATION_RIGHT_TOP:
		{
#line 384 "Orientation.vala"
			derotated.x = (*point).y;
#line 385 "Orientation.vala"
			derotated.y = ((*space).height - (*point).x) - 1;
#line 386 "Orientation.vala"
			break;
#line 868 "Orientation.c"
		}
		case ORIENTATION_RIGHT_BOTTOM:
		{
#line 390 "Orientation.vala"
			derotated.x = ((*space).width - (*point).y) - 1;
#line 391 "Orientation.vala"
			derotated.y = ((*space).height - (*point).x) - 1;
#line 392 "Orientation.vala"
			break;
#line 878 "Orientation.c"
		}
		case ORIENTATION_LEFT_BOTTOM:
		{
#line 396 "Orientation.vala"
			derotated.x = ((*space).width - (*point).y) - 1;
#line 397 "Orientation.vala"
			derotated.y = (*point).x;
#line 398 "Orientation.vala"
			break;
#line 888 "Orientation.c"
		}
		default:
		{
#line 401 "Orientation.vala"
			g_error ("Orientation.vala:401: rotate_point: %d", (gint) self);
#line 402 "Orientation.vala"
			break;
#line 896 "Orientation.c"
		}
	}
	*result = derotated;
#line 405 "Orientation.vala"
	return;
#line 902 "Orientation.c"
}


#line 409 "Orientation.vala"
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
#line 908 "Orientation.c"
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Box _tmp2_ = {0};
#line 411 "Orientation.vala"
	box_get_points (box, &top_left, &bottom_right);
#line 413 "Orientation.vala"
	top_left = (orientation_rotate_point (self, space, &top_left, &_tmp0_), _tmp0_);
#line 414 "Orientation.vala"
	bottom_right = (orientation_rotate_point (self, space, &bottom_right, &_tmp1_), _tmp1_);
#line 920 "Orientation.c"
	*result = (box_from_points (&top_left, &bottom_right, &_tmp2_), _tmp2_);
#line 416 "Orientation.vala"
	return;
#line 924 "Orientation.c"
}


#line 420 "Orientation.vala"
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result) {
#line 930 "Orientation.c"
	GdkPoint top_left = {0};
	GdkPoint bottom_right = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	Box _tmp2_ = {0};
#line 422 "Orientation.vala"
	box_get_points (box, &top_left, &bottom_right);
#line 424 "Orientation.vala"
	top_left = (orientation_derotate_point (self, space, &top_left, &_tmp0_), _tmp0_);
#line 425 "Orientation.vala"
	bottom_right = (orientation_derotate_point (self, space, &bottom_right, &_tmp1_), _tmp1_);
#line 942 "Orientation.c"
	*result = (box_from_points (&top_left, &bottom_right, &_tmp2_), _tmp2_);
#line 427 "Orientation.vala"
	return;
#line 946 "Orientation.c"
}


GType orientation_get_type (void) {
	static volatile gsize orientation_type_id__volatile = 0;
	if (g_once_init_enter (&orientation_type_id__volatile)) {
		static const GEnumValue values[] = {{ORIENTATION_MIN, "ORIENTATION_MIN", "min"}, {ORIENTATION_TOP_LEFT, "ORIENTATION_TOP_LEFT", "top-left"}, {ORIENTATION_TOP_RIGHT, "ORIENTATION_TOP_RIGHT", "top-right"}, {ORIENTATION_BOTTOM_RIGHT, "ORIENTATION_BOTTOM_RIGHT", "bottom-right"}, {ORIENTATION_BOTTOM_LEFT, "ORIENTATION_BOTTOM_LEFT", "bottom-left"}, {ORIENTATION_LEFT_TOP, "ORIENTATION_LEFT_TOP", "left-top"}, {ORIENTATION_RIGHT_TOP, "ORIENTATION_RIGHT_TOP", "right-top"}, {ORIENTATION_RIGHT_BOTTOM, "ORIENTATION_RIGHT_BOTTOM", "right-bottom"}, {ORIENTATION_LEFT_BOTTOM, "ORIENTATION_LEFT_BOTTOM", "left-bottom"}, {ORIENTATION_MAX, "ORIENTATION_MAX", "max"}, {0, NULL, NULL}};
		GType orientation_type_id;
		orientation_type_id = g_enum_register_static ("Orientation", values);
		g_once_init_leave (&orientation_type_id__volatile, orientation_type_id);
	}
	return orientation_type_id__volatile;
}




