/* SortedList.c generated by valac, the Vala compiler
 * generated from SortedList.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
typedef struct _SortedListPrivate SortedListPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _SortedList {
	GObject parent_instance;
	SortedListPrivate * priv;
};

struct _SortedListClass {
	GObjectClass parent_class;
};

struct _SortedListPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeArrayList* list;
	Comparator cmp;
	gpointer cmp_target;
	GDestroyNotify cmp_target_destroy_notify;
};


static gpointer sorted_list_parent_class = NULL;
static GeeIterableIface* sorted_list_gee_iterable_parent_iface = NULL;

gint64 file_comparator (void* a, void* b);
GType sorted_list_get_type (void);
#define SORTED_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SORTED_LIST, SortedListPrivate))
enum  {
	SORTED_LIST_DUMMY_PROPERTY,
	SORTED_LIST_ELEMENT_TYPE,
	SORTED_LIST_SIZE,
	SORTED_LIST_G_TYPE,
	SORTED_LIST_G_DUP_FUNC,
	SORTED_LIST_G_DESTROY_FUNC
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
static GeeIterator* sorted_list_real_iterator (GeeIterable* base);
static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item);
gboolean sorted_list_add (SortedList* self, gconstpointer item);
static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add);
gboolean sorted_list_add_many (SortedList* self, GeeList* items);
void sorted_list_clear (SortedList* self);
gboolean sorted_list_contains (SortedList* self, gconstpointer item);
gboolean sorted_list_remove (SortedList* self, gconstpointer item);
gboolean sorted_list_remove_many (SortedList* self, GeeCollection* items);
gpointer sorted_list_get_at (SortedList* self, gint index);
gint sorted_list_locate (SortedList* self, gconstpointer search, GEqualFunc equal_func);
gint sorted_list_index_of (SortedList* self, gconstpointer search);
void sorted_list_remove_at (SortedList* self, gint index);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
SortedList* sorted_list_copy (SortedList* self);
static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index);
static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index);
gint sorted_list_get_size (SortedList* self);
static void sorted_list_finalize (GObject* obj);
static void sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);



#line 9 "SortedList.vala"
gint64 file_comparator (void* a, void* b) {
#line 96 "SortedList.c"
	gint64 result = 0LL;
	char* _tmp1_;
	char* _tmp0_;
	gint64 _tmp2_;
	result = (_tmp2_ = (gint64) strcmp (_tmp0_ = g_file_get_path (G_FILE ((GFile*) a)), _tmp1_ = g_file_get_path (G_FILE ((GFile*) b))), _g_free0 (_tmp1_), _g_free0 (_tmp0_), _tmp2_);
#line 10 "SortedList.vala"
	return result;
#line 104 "SortedList.c"
}


#line 17 "SortedList.vala"
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
#line 110 "SortedList.c"
	SortedList * self;
	GeeArrayList* _tmp0_;
	Comparator _tmp1_;
#line 17 "SortedList.vala"
	self = (SortedList*) g_object_new (object_type, NULL);
#line 17 "SortedList.vala"
	self->priv->g_type = g_type;
#line 17 "SortedList.vala"
	self->priv->g_dup_func = g_dup_func;
#line 17 "SortedList.vala"
	self->priv->g_destroy_func = g_destroy_func;
#line 18 "SortedList.vala"
	self->priv->list = (_tmp0_ = gee_array_list_new (g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func, NULL), _g_object_unref0 (self->priv->list), _tmp0_);
#line 19 "SortedList.vala"
	self->priv->cmp = (_tmp1_ = cmp, ((self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL), self->priv->cmp = NULL, self->priv->cmp_target = NULL, self->priv->cmp_target_destroy_notify = NULL), self->priv->cmp_target = cmp_target, self->priv->cmp_target_destroy_notify = NULL, _tmp1_);
#line 126 "SortedList.c"
	return self;
}


#line 17 "SortedList.vala"
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target) {
#line 17 "SortedList.vala"
	return sorted_list_construct (TYPE_SORTED_LIST, g_type, g_dup_func, g_destroy_func, cmp, cmp_target);
#line 135 "SortedList.c"
}


#line 26 "SortedList.vala"
static GeeIterator* sorted_list_real_iterator (GeeIterable* base) {
#line 141 "SortedList.c"
	SortedList * self;
	GeeIterator* result = NULL;
	self = SORTED_LIST (base);
	result = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->list));
#line 27 "SortedList.vala"
	return result;
#line 148 "SortedList.c"
}


#line 30 "SortedList.vala"
gboolean sorted_list_add (SortedList* self, gconstpointer item) {
#line 154 "SortedList.c"
	gboolean result = FALSE;
#line 30 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 31 "SortedList.vala"
	if (self->priv->cmp == NULL) {
#line 32 "SortedList.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
#line 162 "SortedList.c"
	} else {
#line 34 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), sorted_list_get_sorted_insert_pos (self, item), item);
#line 166 "SortedList.c"
	}
	result = TRUE;
#line 40 "SortedList.vala"
	return result;
#line 171 "SortedList.c"
}


#line 43 "SortedList.vala"
gboolean sorted_list_add_many (SortedList* self, GeeList* items) {
#line 177 "SortedList.c"
	gboolean result = FALSE;
	gboolean added;
#line 43 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 43 "SortedList.vala"
	g_return_val_if_fail (GEE_IS_LIST (items), FALSE);
#line 44 "SortedList.vala"
	added = FALSE;
#line 45 "SortedList.vala"
	if (gee_collection_get_size (GEE_COLLECTION (items)) == 0) {
#line 188 "SortedList.c"
	} else {
#line 47 "SortedList.vala"
		if (self->priv->cmp != NULL) {
#line 50 "SortedList.vala"
			if (gee_collection_get_size (GEE_COLLECTION (items)) == 1) {
#line 194 "SortedList.c"
				gpointer _tmp1_;
				gpointer _tmp0_;
#line 51 "SortedList.vala"
				gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), sorted_list_get_sorted_insert_pos (self, _tmp0_ = gee_list_get (items, 0)), _tmp1_ = gee_list_get (items, 0));
#line 199 "SortedList.c"
				((_tmp1_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp1_ = (self->priv->g_destroy_func (_tmp1_), NULL));
				((_tmp0_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp0_ = (self->priv->g_destroy_func (_tmp0_), NULL));
#line 52 "SortedList.vala"
				added = TRUE;
#line 204 "SortedList.c"
			} else {
#line 54 "SortedList.vala"
				added = sorted_list_merge_sort (self, items);
#line 208 "SortedList.c"
			}
		} else {
#line 57 "SortedList.vala"
			added = gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->list), GEE_COLLECTION (items));
#line 213 "SortedList.c"
		}
	}
	result = added;
#line 64 "SortedList.vala"
	return result;
#line 219 "SortedList.c"
}


#line 67 "SortedList.vala"
void sorted_list_clear (SortedList* self) {
#line 67 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 68 "SortedList.vala"
	gee_abstract_collection_clear (GEE_ABSTRACT_COLLECTION (self->priv->list));
#line 229 "SortedList.c"
}


#line 71 "SortedList.vala"
gboolean sorted_list_contains (SortedList* self, gconstpointer item) {
#line 235 "SortedList.c"
	gboolean result = FALSE;
#line 71 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 239 "SortedList.c"
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
#line 72 "SortedList.vala"
	return result;
#line 243 "SortedList.c"
}


#line 75 "SortedList.vala"
gboolean sorted_list_remove (SortedList* self, gconstpointer item) {
#line 249 "SortedList.c"
	gboolean result = FALSE;
#line 75 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 253 "SortedList.c"
	result = gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->list), item);
#line 76 "SortedList.vala"
	return result;
#line 257 "SortedList.c"
}


#line 79 "SortedList.vala"
gboolean sorted_list_remove_many (SortedList* self, GeeCollection* items) {
#line 263 "SortedList.c"
	gboolean result = FALSE;
#line 79 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 79 "SortedList.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (items), FALSE);
#line 269 "SortedList.c"
	result = gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->list), items);
#line 80 "SortedList.vala"
	return result;
#line 273 "SortedList.c"
}


#line 87 "SortedList.vala"
gpointer sorted_list_get_at (SortedList* self, gint index) {
#line 279 "SortedList.c"
	gpointer result = NULL;
#line 87 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
#line 283 "SortedList.c"
	result = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), index);
#line 88 "SortedList.vala"
	return result;
#line 287 "SortedList.c"
}


#line 95 "SortedList.vala"
gint sorted_list_index_of (SortedList* self, gconstpointer search) {
#line 293 "SortedList.c"
	gint result = 0;
	gint count;
#line 95 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 97 "SortedList.vala"
	if (self->priv->cmp == NULL) {
#line 300 "SortedList.c"
		result = sorted_list_locate (self, search, g_direct_equal);
#line 98 "SortedList.vala"
		return result;
#line 304 "SortedList.c"
	}
#line 103 "SortedList.vala"
	count = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 308 "SortedList.c"
	{
		gint ctr;
#line 104 "SortedList.vala"
		ctr = 0;
#line 313 "SortedList.c"
		{
			gboolean _tmp0_;
#line 104 "SortedList.vala"
			_tmp0_ = TRUE;
#line 104 "SortedList.vala"
			while (TRUE) {
#line 320 "SortedList.c"
				gpointer _tmp1_;
				gboolean _tmp2_;
#line 104 "SortedList.vala"
				if (!_tmp0_) {
#line 104 "SortedList.vala"
					ctr++;
#line 327 "SortedList.c"
				}
#line 104 "SortedList.vala"
				_tmp0_ = FALSE;
#line 104 "SortedList.vala"
				if (!(ctr < count)) {
#line 104 "SortedList.vala"
					break;
#line 335 "SortedList.c"
				}
#line 105 "SortedList.vala"
				if ((_tmp2_ = self->priv->cmp (_tmp1_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), ctr), search, self->priv->cmp_target) == 0, ((_tmp1_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp1_ = (self->priv->g_destroy_func (_tmp1_), NULL)), _tmp2_)) {
#line 339 "SortedList.c"
					result = ctr;
#line 106 "SortedList.vala"
					return result;
#line 343 "SortedList.c"
				}
			}
		}
	}
	result = -1;
#line 109 "SortedList.vala"
	return result;
#line 351 "SortedList.c"
}


#line 113 "SortedList.vala"
gint sorted_list_locate (SortedList* self, gconstpointer search, GEqualFunc equal_func) {
#line 357 "SortedList.c"
	gint result = 0;
	gint count;
#line 113 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 114 "SortedList.vala"
	count = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 364 "SortedList.c"
	{
		gint ctr;
#line 115 "SortedList.vala"
		ctr = 0;
#line 369 "SortedList.c"
		{
			gboolean _tmp0_;
#line 115 "SortedList.vala"
			_tmp0_ = TRUE;
#line 115 "SortedList.vala"
			while (TRUE) {
#line 376 "SortedList.c"
				gpointer _tmp1_;
				gboolean _tmp2_;
#line 115 "SortedList.vala"
				if (!_tmp0_) {
#line 115 "SortedList.vala"
					ctr++;
#line 383 "SortedList.c"
				}
#line 115 "SortedList.vala"
				_tmp0_ = FALSE;
#line 115 "SortedList.vala"
				if (!(ctr < count)) {
#line 115 "SortedList.vala"
					break;
#line 391 "SortedList.c"
				}
#line 116 "SortedList.vala"
				if ((_tmp2_ = equal_func (_tmp1_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), ctr), search), ((_tmp1_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp1_ = (self->priv->g_destroy_func (_tmp1_), NULL)), _tmp2_)) {
#line 395 "SortedList.c"
					result = ctr;
#line 117 "SortedList.vala"
					return result;
#line 399 "SortedList.c"
				}
			}
		}
	}
	result = -1;
#line 120 "SortedList.vala"
	return result;
#line 407 "SortedList.c"
}


#line 123 "SortedList.vala"
void sorted_list_remove_at (SortedList* self, gint index) {
#line 413 "SortedList.c"
	gpointer _tmp0_;
#line 123 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 124 "SortedList.vala"
	_tmp0_ = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
#line 419 "SortedList.c"
	((_tmp0_ == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (_tmp0_ = (self->priv->g_destroy_func (_tmp0_), NULL));
}


#line 127 "SortedList.vala"
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target) {
#line 426 "SortedList.c"
	Comparator _tmp0_;
#line 127 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 128 "SortedList.vala"
	self->priv->cmp = (_tmp0_ = new_cmp, ((self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL), self->priv->cmp = NULL, self->priv->cmp_target = NULL, self->priv->cmp_target_destroy_notify = NULL), self->priv->cmp_target = new_cmp_target, self->priv->cmp_target_destroy_notify = NULL, _tmp0_);
#line 130 "SortedList.vala"
	sorted_list_merge_sort (self, NULL);
#line 434 "SortedList.c"
}


#line 138 "SortedList.vala"
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item) {
#line 440 "SortedList.c"
	gboolean result = FALSE;
	gint index;
	gint new_index;
#line 138 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 139 "SortedList.vala"
	index = sorted_list_locate (self, item, g_direct_equal);
#line 140 "SortedList.vala"
	g_assert (index >= 0);
#line 142 "SortedList.vala"
	new_index = sorted_list_get_sorted_insert_pos (self, item);
#line 144 "SortedList.vala"
	if (index == new_index) {
#line 454 "SortedList.c"
		result = FALSE;
#line 145 "SortedList.vala"
		return result;
#line 458 "SortedList.c"
	}
#line 149 "SortedList.vala"
	if (new_index > index) {
#line 462 "SortedList.c"
		gpointer removed_item;
#line 150 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), new_index, item);
#line 151 "SortedList.vala"
		removed_item = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
#line 152 "SortedList.vala"
		g_assert (item == removed_item);
#line 470 "SortedList.c"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
	} else {
		gpointer removed_item;
#line 154 "SortedList.vala"
		removed_item = gee_abstract_list_remove_at (GEE_ABSTRACT_LIST (self->priv->list), index);
#line 155 "SortedList.vala"
		g_assert (item == removed_item);
#line 156 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), new_index, item);
#line 480 "SortedList.c"
		((removed_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (removed_item = (self->priv->g_destroy_func (removed_item), NULL));
	}
	result = TRUE;
#line 163 "SortedList.vala"
	return result;
#line 486 "SortedList.c"
}


#line 166 "SortedList.vala"
static gint sorted_list_get_sorted_insert_pos (SortedList* self, gconstpointer item) {
#line 492 "SortedList.c"
	gint result = 0;
	gint low;
	gint high;
#line 166 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
#line 167 "SortedList.vala"
	low = 0;
#line 168 "SortedList.vala"
	high = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 502 "SortedList.c"
	{
		gboolean _tmp0_;
#line 169 "SortedList.vala"
		_tmp0_ = TRUE;
#line 169 "SortedList.vala"
		while (TRUE) {
#line 509 "SortedList.c"
			gint mid;
			gpointer cmp_item;
			gint64 _result_;
#line 169 "SortedList.vala"
			if (!_tmp0_) {
#line 515 "SortedList.c"
			}
#line 169 "SortedList.vala"
			_tmp0_ = FALSE;
#line 170 "SortedList.vala"
			if (low == high) {
#line 521 "SortedList.c"
				result = low;
#line 171 "SortedList.vala"
				return result;
#line 525 "SortedList.c"
			}
#line 173 "SortedList.vala"
			mid = low + ((high - low) / 2);
#line 177 "SortedList.vala"
			cmp_item = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), mid);
#line 178 "SortedList.vala"
			if (item == cmp_item) {
#line 533 "SortedList.c"
				gpointer _tmp1_;
#line 180 "SortedList.vala"
				if (mid >= (gee_collection_get_size (GEE_COLLECTION (self->priv->list)) - 1)) {
#line 537 "SortedList.c"
					result = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 181 "SortedList.vala"
					return result;
#line 542 "SortedList.c"
				}
#line 183 "SortedList.vala"
				cmp_item = (_tmp1_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), mid + 1), ((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL)), _tmp1_);
#line 546 "SortedList.c"
			}
#line 186 "SortedList.vala"
			_result_ = self->priv->cmp (item, cmp_item, self->priv->cmp_target);
#line 187 "SortedList.vala"
			if (_result_ < 0) {
#line 188 "SortedList.vala"
				high = mid;
#line 554 "SortedList.c"
			} else {
#line 189 "SortedList.vala"
				if (_result_ > 0) {
#line 190 "SortedList.vala"
					low = mid + 1;
#line 560 "SortedList.c"
				} else {
					result = mid;
					((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
#line 192 "SortedList.vala"
					return result;
#line 566 "SortedList.c"
				}
			}
			((cmp_item == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (cmp_item = (self->priv->g_destroy_func (cmp_item), NULL));
		}
	}
}


#line 196 "SortedList.vala"
SortedList* sorted_list_copy (SortedList* self) {
#line 577 "SortedList.c"
	SortedList* result = NULL;
	SortedList* copy;
#line 196 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), NULL);
#line 197 "SortedList.vala"
	copy = sorted_list_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, self->priv->cmp, self->priv->cmp_target);
#line 199 "SortedList.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (copy->priv->list), GEE_COLLECTION (self->priv->list));
#line 586 "SortedList.c"
	result = copy;
#line 201 "SortedList.vala"
	return result;
#line 590 "SortedList.c"
}


#line 222 "SortedList.vala"
static gboolean sorted_list_merge_sort (SortedList* self, GeeList* add) {
#line 596 "SortedList.c"
	gboolean result = FALSE;
	gint list_count;
	gint _tmp0_ = 0;
	gint add_count;
	gint count;
	gpointer* _tmp1_;
	gint _array_size_;
	gint array_length1;
	gpointer* array;
	gint offset;
	gint _tmp4__length1;
	gpointer* _tmp4_;
#line 222 "SortedList.vala"
	g_return_val_if_fail (IS_SORTED_LIST (self), FALSE);
#line 222 "SortedList.vala"
	g_return_val_if_fail ((add == NULL) || GEE_IS_LIST (add), FALSE);
#line 223 "SortedList.vala"
	g_assert (self->priv->cmp != NULL);
#line 225 "SortedList.vala"
	list_count = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 226 "SortedList.vala"
	if (add != NULL) {
#line 226 "SortedList.vala"
		_tmp0_ = gee_collection_get_size (GEE_COLLECTION (add));
#line 621 "SortedList.c"
	} else {
#line 226 "SortedList.vala"
		_tmp0_ = 0;
#line 625 "SortedList.c"
	}
#line 226 "SortedList.vala"
	add_count = _tmp0_;
#line 228 "SortedList.vala"
	count = list_count + add_count;
#line 229 "SortedList.vala"
	if (count == 0) {
#line 633 "SortedList.c"
		result = FALSE;
#line 230 "SortedList.vala"
		return result;
#line 637 "SortedList.c"
	}
	array = (_tmp1_ = g_new0 (gpointer, count), array_length1 = count, _array_size_ = array_length1, _tmp1_);
#line 235 "SortedList.vala"
	offset = 0;
#line 237 "SortedList.vala"
	while (TRUE) {
#line 644 "SortedList.c"
		gpointer _tmp2_;
#line 237 "SortedList.vala"
		if (!(offset < list_count)) {
#line 237 "SortedList.vala"
			break;
#line 650 "SortedList.c"
		}
#line 238 "SortedList.vala"
		array[offset] = (_tmp2_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (self->priv->list), offset), ((array[offset] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[offset] = (self->priv->g_destroy_func (array[offset]), NULL)), _tmp2_);
#line 239 "SortedList.vala"
		offset++;
#line 656 "SortedList.c"
	}
#line 242 "SortedList.vala"
	if (add != NULL) {
#line 660 "SortedList.c"
		gint add_ctr;
#line 243 "SortedList.vala"
		add_ctr = 0;
#line 244 "SortedList.vala"
		while (TRUE) {
#line 666 "SortedList.c"
			gpointer _tmp3_;
#line 244 "SortedList.vala"
			if (!(offset < count)) {
#line 244 "SortedList.vala"
				break;
#line 672 "SortedList.c"
			}
#line 245 "SortedList.vala"
			array[offset] = (_tmp3_ = gee_list_get (add, add_ctr++), ((array[offset] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[offset] = (self->priv->g_destroy_func (array[offset]), NULL)), _tmp3_);
#line 246 "SortedList.vala"
			offset++;
#line 678 "SortedList.c"
		}
	}
#line 250 "SortedList.vala"
	g_assert (offset == count);
#line 252 "SortedList.vala"
	_sorted_list_merge_sort (self, array, array_length1, (_tmp4_ = g_new0 (gpointer, count), _tmp4__length1 = count, _tmp4_), count, 0, count - 1);
#line 685 "SortedList.c"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 254 "SortedList.vala"
	offset = 0;
#line 255 "SortedList.vala"
	while (TRUE) {
#line 255 "SortedList.vala"
		if (!(offset < list_count)) {
#line 255 "SortedList.vala"
			break;
#line 695 "SortedList.c"
		}
#line 256 "SortedList.vala"
		gee_abstract_list_set (GEE_ABSTRACT_LIST (self->priv->list), offset, array[offset]);
#line 257 "SortedList.vala"
		offset++;
#line 701 "SortedList.c"
	}
#line 260 "SortedList.vala"
	while (TRUE) {
#line 260 "SortedList.vala"
		if (!(offset < count)) {
#line 260 "SortedList.vala"
			break;
#line 709 "SortedList.c"
		}
#line 261 "SortedList.vala"
		gee_abstract_list_insert (GEE_ABSTRACT_LIST (self->priv->list), offset, array[offset]);
#line 262 "SortedList.vala"
		offset++;
#line 715 "SortedList.c"
	}
	result = TRUE;
	array = (_vala_array_free (array, array_length1, (GDestroyNotify) self->priv->g_destroy_func), NULL);
#line 265 "SortedList.vala"
	return result;
#line 721 "SortedList.c"
}


#line 268 "SortedList.vala"
static void _sorted_list_merge_sort (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint end_index) {
#line 727 "SortedList.c"
	gint count;
	gint middle_index;
#line 268 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 269 "SortedList.vala"
	g_assert (start_index <= end_index);
#line 271 "SortedList.vala"
	count = (end_index - start_index) + 1;
#line 272 "SortedList.vala"
	if (count <= 1) {
#line 273 "SortedList.vala"
		return;
#line 740 "SortedList.c"
	}
#line 275 "SortedList.vala"
	middle_index = start_index + (count / 2);
#line 277 "SortedList.vala"
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, start_index, middle_index - 1);
#line 278 "SortedList.vala"
	_sorted_list_merge_sort (self, array, array_length1, scratch, scratch_length1, middle_index, end_index);
#line 280 "SortedList.vala"
	if (self->priv->cmp (array[middle_index - 1], array[middle_index], self->priv->cmp_target) > 0) {
#line 281 "SortedList.vala"
		sorted_list_merge (self, array, array_length1, scratch, scratch_length1, start_index, middle_index, end_index);
#line 752 "SortedList.c"
	}
}


#line 284 "SortedList.vala"
static void sorted_list_merge (SortedList* self, gpointer* array, int array_length1, gpointer* scratch, int scratch_length1, gint start_index, gint middle_index, gint end_index) {
#line 759 "SortedList.c"
	gint count;
	gint left_start;
	gint left_end;
	gint right_start;
	gint right_end;
	gint scratch_index;
#line 284 "SortedList.vala"
	g_return_if_fail (IS_SORTED_LIST (self));
#line 285 "SortedList.vala"
	g_assert (start_index < end_index);
#line 287 "SortedList.vala"
	count = (end_index - start_index) + 1;
#line 288 "SortedList.vala"
	left_start = start_index;
#line 289 "SortedList.vala"
	left_end = middle_index - 1;
#line 290 "SortedList.vala"
	right_start = middle_index;
#line 291 "SortedList.vala"
	right_end = end_index;
#line 293 "SortedList.vala"
	g_assert (scratch_length1 >= count);
#line 294 "SortedList.vala"
	scratch_index = 0;
#line 296 "SortedList.vala"
	while (TRUE) {
#line 786 "SortedList.c"
		gboolean _tmp0_ = FALSE;
		gconstpointer _tmp1_;
		gpointer left;
		gconstpointer _tmp2_;
		gpointer right;
#line 296 "SortedList.vala"
		if (left_start <= left_end) {
#line 296 "SortedList.vala"
			_tmp0_ = right_start <= right_end;
#line 796 "SortedList.c"
		} else {
#line 296 "SortedList.vala"
			_tmp0_ = FALSE;
#line 800 "SortedList.c"
		}
#line 296 "SortedList.vala"
		if (!_tmp0_) {
#line 296 "SortedList.vala"
			break;
#line 806 "SortedList.c"
		}
#line 297 "SortedList.vala"
		left = (_tmp1_ = array[left_start], ((_tmp1_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp1_) : self->priv->g_dup_func ((gpointer) _tmp1_));
#line 298 "SortedList.vala"
		right = (_tmp2_ = array[right_start], ((_tmp2_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp2_) : self->priv->g_dup_func ((gpointer) _tmp2_));
#line 300 "SortedList.vala"
		if (self->priv->cmp (left, right, self->priv->cmp_target) <= 0) {
#line 814 "SortedList.c"
			gpointer _tmp5_;
			gpointer *_tmp4_;
			gconstpointer _tmp3_;
#line 301 "SortedList.vala"
			_tmp4_ = &scratch[scratch_index++];
#line 301 "SortedList.vala"
			(*_tmp4_) = (_tmp5_ = (_tmp3_ = left, ((_tmp3_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp3_) : self->priv->g_dup_func ((gpointer) _tmp3_)), (((*_tmp4_) == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : ((*_tmp4_) = (self->priv->g_destroy_func ((*_tmp4_)), NULL)), _tmp5_);
#line 302 "SortedList.vala"
			left_start++;
#line 824 "SortedList.c"
		} else {
			gpointer _tmp8_;
			gpointer *_tmp7_;
			gconstpointer _tmp6_;
#line 304 "SortedList.vala"
			_tmp7_ = &scratch[scratch_index++];
#line 304 "SortedList.vala"
			(*_tmp7_) = (_tmp8_ = (_tmp6_ = right, ((_tmp6_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp6_) : self->priv->g_dup_func ((gpointer) _tmp6_)), (((*_tmp7_) == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : ((*_tmp7_) = (self->priv->g_destroy_func ((*_tmp7_)), NULL)), _tmp8_);
#line 305 "SortedList.vala"
			right_start++;
#line 835 "SortedList.c"
		}
		((left == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (left = (self->priv->g_destroy_func (left), NULL));
		((right == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (right = (self->priv->g_destroy_func (right), NULL));
	}
#line 309 "SortedList.vala"
	while (TRUE) {
#line 842 "SortedList.c"
		gpointer _tmp11_;
		gpointer *_tmp10_;
		gconstpointer _tmp9_;
#line 309 "SortedList.vala"
		if (!(left_start <= left_end)) {
#line 309 "SortedList.vala"
			break;
#line 850 "SortedList.c"
		}
#line 310 "SortedList.vala"
		_tmp10_ = &scratch[scratch_index++];
#line 310 "SortedList.vala"
		(*_tmp10_) = (_tmp11_ = (_tmp9_ = array[left_start++], ((_tmp9_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp9_) : self->priv->g_dup_func ((gpointer) _tmp9_)), (((*_tmp10_) == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : ((*_tmp10_) = (self->priv->g_destroy_func ((*_tmp10_)), NULL)), _tmp11_);
#line 856 "SortedList.c"
	}
#line 312 "SortedList.vala"
	while (TRUE) {
#line 860 "SortedList.c"
		gpointer _tmp14_;
		gpointer *_tmp13_;
		gconstpointer _tmp12_;
#line 312 "SortedList.vala"
		if (!(right_start <= right_end)) {
#line 312 "SortedList.vala"
			break;
#line 868 "SortedList.c"
		}
#line 313 "SortedList.vala"
		_tmp13_ = &scratch[scratch_index++];
#line 313 "SortedList.vala"
		(*_tmp13_) = (_tmp14_ = (_tmp12_ = array[right_start++], ((_tmp12_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp12_) : self->priv->g_dup_func ((gpointer) _tmp12_)), (((*_tmp13_) == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : ((*_tmp13_) = (self->priv->g_destroy_func ((*_tmp13_)), NULL)), _tmp14_);
#line 874 "SortedList.c"
	}
#line 315 "SortedList.vala"
	g_assert (scratch_index == count);
#line 317 "SortedList.vala"
	scratch_index = 0;
#line 880 "SortedList.c"
	{
		gint list_index;
#line 318 "SortedList.vala"
		list_index = start_index;
#line 885 "SortedList.c"
		{
			gboolean _tmp15_;
#line 318 "SortedList.vala"
			_tmp15_ = TRUE;
#line 318 "SortedList.vala"
			while (TRUE) {
#line 892 "SortedList.c"
				gpointer _tmp17_;
				gconstpointer _tmp16_;
#line 318 "SortedList.vala"
				if (!_tmp15_) {
#line 318 "SortedList.vala"
					list_index++;
#line 899 "SortedList.c"
				}
#line 318 "SortedList.vala"
				_tmp15_ = FALSE;
#line 318 "SortedList.vala"
				if (!(list_index <= end_index)) {
#line 318 "SortedList.vala"
					break;
#line 907 "SortedList.c"
				}
#line 319 "SortedList.vala"
				array[list_index] = (_tmp17_ = (_tmp16_ = scratch[scratch_index++], ((_tmp16_ == NULL) || (self->priv->g_dup_func == NULL)) ? ((gpointer) _tmp16_) : self->priv->g_dup_func ((gpointer) _tmp16_)), ((array[list_index] == NULL) || (self->priv->g_destroy_func == NULL)) ? NULL : (array[list_index] = (self->priv->g_destroy_func (array[list_index]), NULL)), _tmp17_);
#line 911 "SortedList.c"
			}
		}
	}
}


static GType sorted_list_real_get_element_type (GeeIterable* base) {
	GType result;
	SortedList* self;
	self = SORTED_LIST (base);
	result = self->priv->g_type;
#line 23 "SortedList.vala"
	return result;
#line 925 "SortedList.c"
}


gint sorted_list_get_size (SortedList* self) {
	gint result;
	g_return_val_if_fail (IS_SORTED_LIST (self), 0);
	result = gee_collection_get_size (GEE_COLLECTION (self->priv->list));
#line 84 "SortedList.vala"
	return result;
#line 935 "SortedList.c"
}


static void sorted_list_class_init (SortedListClass * klass) {
	sorted_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SortedListPrivate));
	G_OBJECT_CLASS (klass)->get_property = sorted_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = sorted_list_set_property;
	G_OBJECT_CLASS (klass)->finalize = sorted_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), SORTED_LIST_ELEMENT_TYPE, "element-type");
	g_object_class_install_property (G_OBJECT_CLASS (klass), SORTED_LIST_SIZE, g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void sorted_list_gee_iterable_interface_init (GeeIterableIface * iface) {
	sorted_list_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
	iface->iterator = sorted_list_real_iterator;
	iface->get_element_type = sorted_list_real_get_element_type;
}


static void sorted_list_instance_init (SortedList * self) {
	self->priv = SORTED_LIST_GET_PRIVATE (self);
}


static void sorted_list_finalize (GObject* obj) {
	SortedList * self;
	self = SORTED_LIST (obj);
	_g_object_unref0 (self->priv->list);
	(self->priv->cmp_target_destroy_notify == NULL) ? NULL : (self->priv->cmp_target_destroy_notify (self->priv->cmp_target), NULL);
	self->priv->cmp = NULL;
	self->priv->cmp_target = NULL;
	self->priv->cmp_target_destroy_notify = NULL;
	G_OBJECT_CLASS (sorted_list_parent_class)->finalize (obj);
}


GType sorted_list_get_type (void) {
	static volatile gsize sorted_list_type_id__volatile = 0;
	if (g_once_init_enter (&sorted_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SortedListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sorted_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SortedList), 0, (GInstanceInitFunc) sorted_list_instance_init, NULL };
		static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) sorted_list_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType sorted_list_type_id;
		sorted_list_type_id = g_type_register_static (G_TYPE_OBJECT, "SortedList", &g_define_type_info, 0);
		g_type_add_interface_static (sorted_list_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
		g_once_init_leave (&sorted_list_type_id__volatile, sorted_list_type_id);
	}
	return sorted_list_type_id__volatile;
}


static void sorted_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = SORTED_LIST (object);
	switch (property_id) {
		case SORTED_LIST_ELEMENT_TYPE:
		g_value_set_gtype (value, gee_iterable_get_element_type (GEE_ITERABLE (self)));
		break;
		case SORTED_LIST_SIZE:
		g_value_set_int (value, sorted_list_get_size (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void sorted_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SortedList * self;
	self = SORTED_LIST (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case SORTED_LIST_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case SORTED_LIST_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case SORTED_LIST_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}




