/* DataCollection.c generated by valac, the Vala compiler
 * generated from DataCollection.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataSet*/
/**/
/* A DataSet is a collection class used for internal implementations of DataCollection*/
/* and its children.  It may be of use to other classes, however.*/
/**/
/* The general purpose of DataSet is to provide low-cost implementations of various collection*/
/* operations at a cost of internally maintaining its objects in more than one simple collection.*/
/* contains(), for example, can return a result with hash-table performance while notions of*/
/* ordering are maintained by a SortedList.  The cost is in adding and removing objects (in general,*/
/* there are others).*/
/**/
/* Because this class has no signalling mechanisms and does not manipulate DataObjects in ways*/
/* they expect to be manipulated (these features are performed by DataCollection), it's probably*/
/* best not to use this class.  Even in cases of building a list of DataObjects for some quick*/
/* operation is probably best done by a Gee.ArrayList.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
typedef struct _DataSetPrivate DataSetPrivate;

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
typedef struct _ParamSpecDataSet ParamSpecDataSet;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_UNKNOWN_TOTAL_MONITOR (unknown_total_monitor_get_type ())
#define UNKNOWN_TOTAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitor))
#define UNKNOWN_TOTAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorClass))
#define IS_UNKNOWN_TOTAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNKNOWN_TOTAL_MONITOR))
#define IS_UNKNOWN_TOTAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNKNOWN_TOTAL_MONITOR))
#define UNKNOWN_TOTAL_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorClass))

typedef struct _UnknownTotalMonitor UnknownTotalMonitor;
typedef struct _UnknownTotalMonitorClass UnknownTotalMonitorClass;
typedef struct _UnknownTotalMonitorPrivate UnknownTotalMonitorPrivate;
typedef struct _ParamSpecUnknownTotalMonitor ParamSpecUnknownTotalMonitor;

#define TYPE_AGGREGATE_PROGRESS_MONITOR (aggregate_progress_monitor_get_type ())
#define AGGREGATE_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitor))
#define AGGREGATE_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorClass))
#define IS_AGGREGATE_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR))
#define IS_AGGREGATE_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_AGGREGATE_PROGRESS_MONITOR))
#define AGGREGATE_PROGRESS_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorClass))

typedef struct _AggregateProgressMonitor AggregateProgressMonitor;
typedef struct _AggregateProgressMonitorClass AggregateProgressMonitorClass;
typedef struct _AggregateProgressMonitorPrivate AggregateProgressMonitorPrivate;
typedef struct _ParamSpecAggregateProgressMonitor ParamSpecAggregateProgressMonitor;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define DATA_COLLECTION_TYPE_MARKER_IMPL (data_collection_marker_impl_get_type ())
#define DATA_COLLECTION_MARKER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImpl))
#define DATA_COLLECTION_MARKER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImplClass))
#define DATA_COLLECTION_IS_MARKER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL))
#define DATA_COLLECTION_IS_MARKER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DATA_COLLECTION_TYPE_MARKER_IMPL))
#define DATA_COLLECTION_MARKER_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DATA_COLLECTION_TYPE_MARKER_IMPL, DataCollectionMarkerImplClass))

typedef struct _DataCollectionMarkerImpl DataCollectionMarkerImpl;
typedef struct _DataCollectionMarkerImplClass DataCollectionMarkerImplClass;
typedef struct _DataCollectionMarkerImplPrivate DataCollectionMarkerImplPrivate;
typedef struct _ParamSpecDataCollection ParamSpecDataCollection;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define SOURCE_COLLECTION_TYPE_DESTROY_COUNTER (source_collection_destroy_counter_get_type ())
#define SOURCE_COLLECTION_DESTROY_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounter))
#define SOURCE_COLLECTION_DESTROY_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounterClass))
#define SOURCE_COLLECTION_IS_DESTROY_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER))
#define SOURCE_COLLECTION_IS_DESTROY_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER))
#define SOURCE_COLLECTION_DESTROY_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, SourceCollectionDestroyCounterClass))

typedef struct _SourceCollectionDestroyCounter SourceCollectionDestroyCounter;
typedef struct _SourceCollectionDestroyCounterClass SourceCollectionDestroyCounterClass;
typedef struct _SourceCollectionDestroyCounterPrivate SourceCollectionDestroyCounterPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
typedef struct _ViewManagerPrivate ViewManagerPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;
typedef struct _ParamSpecViewManager ParamSpecViewManager;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;

struct _DataSet {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataSetPrivate * priv;
};

struct _DataSetClass {
	GTypeClass parent_class;
	void (*finalize) (DataSet *self);
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
struct _DataSetPrivate {
	SortedList* list;
	GeeHashSet* hash_set;
	Comparator user_comparator;
	gpointer user_comparator_target;
	GDestroyNotify user_comparator_target_destroy_notify;
};

struct _ParamSpecDataSet {
	GParamSpec parent_instance;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeIterable* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
};

typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _UnknownTotalMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UnknownTotalMonitorPrivate * priv;
};

struct _UnknownTotalMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (UnknownTotalMonitor *self);
};

struct _UnknownTotalMonitorPrivate {
	guint64 total;
	ProgressMonitor wrapped_monitor;
	gpointer wrapped_monitor_target;
	GDestroyNotify wrapped_monitor_target_destroy_notify;
};

struct _ParamSpecUnknownTotalMonitor {
	GParamSpec parent_instance;
};

struct _AggregateProgressMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AggregateProgressMonitorPrivate * priv;
};

struct _AggregateProgressMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (AggregateProgressMonitor *self);
};

struct _AggregateProgressMonitorPrivate {
	guint64 grand_total;
	ProgressMonitor wrapped_monitor;
	gpointer wrapped_monitor_target;
	GDestroyNotify wrapped_monitor_target_destroy_notify;
	guint64 aggregate_count;
	guint64 last_count;
};

struct _ParamSpecAggregateProgressMonitor {
	GParamSpec parent_instance;
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	char* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_item_altered) (DataCollection* self, DataObject* item);
	void (*notify_items_altered) (DataCollection* self, GeeCollection* items);
	void (*notify_item_metadata_altered) (DataCollection* self, DataObject* item);
	void (*notify_items_metadata_altered) (DataCollection* self, GeeCollection* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const char* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const char* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target);
	void (*reset_comparator) (DataCollection* self);
	GeeIterable* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	void (*close) (DataCollection* self);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*item_altered) (DataCollection* self, DataObject* item);
	void (*items_altered) (DataCollection* self, GeeCollection* items);
	void (*item_metadata_altered) (DataCollection* self, DataObject* object);
	void (*items_metadata_altered) (DataCollection* self, GeeCollection* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const char* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const char* name);
};

struct _DataCollectionPrivate {
	char* name;
	DataSet* dataset;
	GeeHashMap* properties;
	gint64 object_ordinal_generator;
	gint notifies_frozen;
	GeeHashSet* frozen_items_altered;
	GeeHashSet* frozen_items_metadata_altered;
	gboolean fire_ordering_changed;
};

struct _DataCollectionMarkerImpl {
	GObject parent_instance;
	DataCollectionMarkerImplPrivate * priv;
	DataCollection* owner;
	GeeHashSet* marked;
};

struct _DataCollectionMarkerImplClass {
	GObjectClass parent_class;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);
struct _ParamSpecDataCollection {
	GParamSpec parent_instance;
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
};

struct _SourceCollectionDestroyCounter {
	GObject parent_instance;
	SourceCollectionDestroyCounterPrivate * priv;
	Marker* remove_marker;
	gint delete_failed;
};

struct _SourceCollectionDestroyCounterClass {
	GObjectClass parent_class;
};

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _DatabaseSourceCollectionPrivate {
	GetSourceDatabaseKey source_key_func;
	gpointer source_key_func_target;
	GDestroyNotify source_key_func_target_destroy_notify;
	GeeHashMap* map;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

typedef DataView* (*CreateView) (DataSource* source, void* user_data);
typedef gboolean (*ViewFilter) (DataView* view, void* user_data);
struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*items_shown) (ViewCollection* self, GeeIterable* visible);
	void (*items_hidden) (ViewCollection* self, GeeIterable* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeIterable* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
};

struct _ViewCollectionPrivate {
	SourceCollection* sources;
	ViewManager* manager;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	GDestroyNotify mirroring_ctor_target_destroy_notify;
	ViewFilter filter;
	gpointer filter_target;
	GDestroyNotify filter_target_destroy_notify;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	GeeHashMap* source_map;
};

struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};


static gpointer data_set_parent_class = NULL;
static gpointer unknown_total_monitor_parent_class = NULL;
static gpointer aggregate_progress_monitor_parent_class = NULL;
static gpointer data_collection_marker_impl_parent_class = NULL;
static MarkerIface* data_collection_marker_impl_marker_parent_iface = NULL;
static gpointer data_collection_parent_class = NULL;
static gpointer source_collection_destroy_counter_parent_class = NULL;
static gpointer source_collection_parent_class = NULL;
static gpointer database_source_collection_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_collection_parent_class = NULL;

gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void);
GType sorted_list_get_type (void);
GType data_object_get_type (void);
#define DATA_SET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_SET, DataSetPrivate))
enum  {
	DATA_SET_DUMMY_PROPERTY
};
SortedList* sorted_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
SortedList* sorted_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, Comparator cmp, void* cmp_target);
void data_set_reset_comparator (DataSet* self);
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
gint64 data_object_internal_get_ordinal (DataObject* self);
static gint64 data_set_order_added_comparator (DataSet* self, void* a, void* b);
static gint64 data_set_comparator_wrapper (DataSet* self, void* a, void* b);
gboolean data_set_contains (DataSet* self, DataObject* object);
gint sorted_list_get_size (SortedList* self);
gint data_set_get_count (DataSet* self);
void sorted_list_resort (SortedList* self, Comparator new_cmp, void* new_cmp_target);
static gint64 _data_set_order_added_comparator_comparator (void* a, void* b, gpointer self);
static gint64 _data_set_comparator_wrapper_comparator (void* a, void* b, gpointer self);
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target);
SortedList* sorted_list_copy (SortedList* self);
GeeIterable* data_set_get_all (DataSet* self);
DataSet* data_set_copy (DataSet* self);
gpointer sorted_list_get_at (SortedList* self, gint index);
DataObject* data_set_get_at (DataSet* self, gint index);
gint sorted_list_locate (SortedList* self, gconstpointer search, GEqualFunc equal_func);
gint data_set_index_of (DataSet* self, DataObject* object);
gboolean sorted_list_add (SortedList* self, gconstpointer item);
gboolean sorted_list_remove (SortedList* self, gconstpointer item);
gboolean data_set_add (DataSet* self, DataObject* object);
gboolean sorted_list_add_many (SortedList* self, GeeList* items);
gboolean sorted_list_remove_many (SortedList* self, GeeCollection* items);
gboolean data_set_add_many (DataSet* self, GeeList* objects);
gboolean data_set_remove (DataSet* self, DataObject* object);
gboolean data_set_remove_many (DataSet* self, GeeList* objects);
gboolean sorted_list_resort_item (SortedList* self, gconstpointer item);
gboolean data_set_resort_object (DataSet* self, DataObject* object);
static void data_set_finalize (DataSet* obj);
GType marker_get_type (void);
void marker_mark (Marker* self, DataObject* object);
void marker_mark_many (Marker* self, GeeIterable* list);
void marker_mark_all (Marker* self);
gint marker_get_count (Marker* self);
gpointer unknown_total_monitor_ref (gpointer instance);
void unknown_total_monitor_unref (gpointer instance);
GParamSpec* param_spec_unknown_total_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_unknown_total_monitor (GValue* value, gpointer v_object);
void value_take_unknown_total_monitor (GValue* value, gpointer v_object);
gpointer value_get_unknown_total_monitor (const GValue* value);
GType unknown_total_monitor_get_type (void);
#define UNKNOWN_TOTAL_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_UNKNOWN_TOTAL_MONITOR, UnknownTotalMonitorPrivate))
enum  {
	UNKNOWN_TOTAL_MONITOR_DUMMY_PROPERTY
};
UnknownTotalMonitor* unknown_total_monitor_new (guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
UnknownTotalMonitor* unknown_total_monitor_construct (GType object_type, guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
gboolean unknown_total_monitor_monitor (UnknownTotalMonitor* self, guint64 count, guint64 total);
static void unknown_total_monitor_finalize (UnknownTotalMonitor* obj);
gpointer aggregate_progress_monitor_ref (gpointer instance);
void aggregate_progress_monitor_unref (gpointer instance);
GParamSpec* param_spec_aggregate_progress_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_aggregate_progress_monitor (GValue* value, gpointer v_object);
void value_take_aggregate_progress_monitor (GValue* value, gpointer v_object);
gpointer value_get_aggregate_progress_monitor (const GValue* value);
GType aggregate_progress_monitor_get_type (void);
#define AGGREGATE_PROGRESS_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_AGGREGATE_PROGRESS_MONITOR, AggregateProgressMonitorPrivate))
enum  {
	AGGREGATE_PROGRESS_MONITOR_DUMMY_PROPERTY
};
AggregateProgressMonitor* aggregate_progress_monitor_new (guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
AggregateProgressMonitor* aggregate_progress_monitor_construct (GType object_type, guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target);
void aggregate_progress_monitor_next_step (AggregateProgressMonitor* self, const char* name);
gboolean aggregate_progress_monitor_monitor (AggregateProgressMonitor* self, guint64 count, guint64 total);
static void aggregate_progress_monitor_finalize (AggregateProgressMonitor* obj);
gboolean null_progress_monitor (guint64 count, guint64 total);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void);
#define DATA_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_COLLECTION, DataCollectionPrivate))
enum  {
	DATA_COLLECTION_DUMMY_PROPERTY
};
static GValue* _g_value_dup (GValue* self);
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataCollection* data_collection_new (const char* name);
DataCollection* data_collection_construct (GType object_type, const char* name);
gint data_collection_get_count (DataCollection* self);
char* data_collection_to_string (DataCollection* self);
static char* data_collection_real_to_string (DataCollection* self);
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added);
static void data_collection_real_notify_items_added (DataCollection* self, GeeIterable* added);
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed);
static void data_collection_real_notify_items_removed (DataCollection* self, GeeIterable* removed);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void data_collection_real_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
void data_collection_notify_item_altered (DataCollection* self, DataObject* item);
static void data_collection_real_notify_item_altered (DataCollection* self, DataObject* item);
void data_collection_notify_items_altered (DataCollection* self, GeeCollection* items);
static void data_collection_real_notify_items_altered (DataCollection* self, GeeCollection* items);
void data_collection_notify_item_metadata_altered (DataCollection* self, DataObject* item);
static void data_collection_real_notify_item_metadata_altered (DataCollection* self, DataObject* item);
void data_collection_notify_items_metadata_altered (DataCollection* self, GeeCollection* items);
static void data_collection_real_notify_items_metadata_altered (DataCollection* self, GeeCollection* items);
void data_collection_notify_ordering_changed (DataCollection* self);
static void data_collection_real_notify_ordering_changed (DataCollection* self);
void data_collection_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
static void data_collection_real_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
void data_collection_notify_property_cleared (DataCollection* self, const char* name);
static void data_collection_real_notify_property_cleared (DataCollection* self, const char* name);
GeeArrayList* data_collection_get_singleton (DataObject* object);
gboolean data_collection_valid_type (DataCollection* self, DataObject* object);
static gboolean data_collection_real_valid_type (DataCollection* self, DataObject* object);
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target);
static void data_collection_real_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target);
void data_collection_reset_comparator (DataCollection* self);
static void data_collection_real_reset_comparator (DataCollection* self);
GeeIterable* data_collection_get_all (DataCollection* self);
static GeeIterable* data_collection_real_get_all (DataCollection* self);
DataSet* data_collection_get_dataset_copy (DataCollection* self);
static gint data_collection_real_get_count (DataCollection* self);
DataObject* data_collection_get_at (DataCollection* self, gint index);
static DataObject* data_collection_real_get_at (DataCollection* self, gint index);
gint data_collection_index_of (DataCollection* self, DataObject* object);
static gint data_collection_real_index_of (DataCollection* self, DataObject* object);
static gboolean data_collection_internal_contains (DataCollection* self, DataObject* object);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
static gboolean data_collection_real_contains (DataCollection* self, DataObject* object);
DataCollection* data_object_get_membership (DataObject* self);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
static void data_collection_internal_add (DataCollection* self, DataObject* object);
static void data_collection_internal_add_many (DataCollection* self, GeeList* objects, ProgressMonitor monitor, void* monitor_target);
void data_object_internal_clear_membership (DataObject* self);
static void data_collection_internal_remove (DataCollection* self, DataObject* object);
char* data_object_to_string (DataObject* self);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
gboolean data_collection_add (DataCollection* self, DataObject* object);
gint data_collection_add_many (DataCollection* self, GeeIterable* objects, ProgressMonitor monitor, void* monitor_target);
static DataCollectionMarkerImpl* data_collection_marker_impl_new (DataCollection* owner);
static DataCollectionMarkerImpl* data_collection_marker_impl_construct (GType object_type, DataCollection* owner);
static GType data_collection_marker_impl_get_type (void) G_GNUC_UNUSED;
Marker* data_collection_start_marking (DataCollection* self);
Marker* data_collection_mark (DataCollection* self, DataObject* object);
static gboolean data_collection_marker_impl_is_valid (DataCollectionMarkerImpl* self, DataCollection* collection);
static void data_collection_marker_impl_freeze (DataCollectionMarkerImpl* self);
static void data_collection_marker_impl_finished (DataCollectionMarkerImpl* self);
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user);
void data_collection_remove_marked (DataCollection* self, Marker* m);
void data_collection_clear (DataCollection* self);
void data_collection_close (DataCollection* self);
static void data_collection_real_close (DataCollection* self);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object);
void data_collection_internal_notify_metadata_altered (DataCollection* self, DataObject* object);
GValue* data_collection_get_property (DataCollection* self, const char* name);
gboolean bool_value_equals (GValue* a, GValue* b);
static gboolean _bool_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self);
gboolean int_value_equals (GValue* a, GValue* b);
static gboolean _int_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self);
void data_object_notify_collection_property_set (DataObject* self, const char* name, GValue* old, GValue* val);
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_object_notify_collection_property_cleared (DataObject* self, const char* name);
void data_collection_clear_property (DataCollection* self, const char* name);
void data_collection_frozen (DataCollection* self);
void data_collection_freeze_notifications (DataCollection* self);
void data_collection_thawed (DataCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
static void data_collection_real_frozen (DataCollection* self);
static void data_collection_real_thawed (DataCollection* self);
void data_collection_items_added (DataCollection* self, GeeIterable* added);
static void data_collection_real_items_added (DataCollection* self, GeeIterable* added);
void data_collection_items_removed (DataCollection* self, GeeIterable* removed);
static void data_collection_real_items_removed (DataCollection* self, GeeIterable* removed);
void data_collection_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void data_collection_real_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
void data_collection_item_altered (DataCollection* self, DataObject* item);
static void data_collection_real_item_altered (DataCollection* self, DataObject* item);
void data_collection_items_altered (DataCollection* self, GeeCollection* items);
static void data_collection_real_items_altered (DataCollection* self, GeeCollection* items);
void data_collection_item_metadata_altered (DataCollection* self, DataObject* object);
static void data_collection_real_item_metadata_altered (DataCollection* self, DataObject* object);
void data_collection_items_metadata_altered (DataCollection* self, GeeCollection* items);
static void data_collection_real_items_metadata_altered (DataCollection* self, GeeCollection* items);
void data_collection_ordering_changed (DataCollection* self);
static void data_collection_real_ordering_changed (DataCollection* self);
void data_collection_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
static void data_collection_real_property_set (DataCollection* self, const char* name, GValue* old, GValue* val);
void data_collection_property_cleared (DataCollection* self, const char* name);
static void data_collection_real_property_cleared (DataCollection* self, const char* name);
enum  {
	DATA_COLLECTION_MARKER_IMPL_DUMMY_PROPERTY
};
static void data_collection_marker_impl_on_items_removed (DataCollectionMarkerImpl* self, GeeIterable* removed);
static void _data_collection_marker_impl_on_items_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void data_collection_marker_impl_real_mark (Marker* base, DataObject* object);
static void data_collection_marker_impl_real_mark_many (Marker* base, GeeIterable* list);
static void data_collection_marker_impl_real_mark_all (Marker* base);
static gint data_collection_marker_impl_real_get_count (Marker* base);
static void data_collection_marker_impl_finalize (GObject* obj);
static void data_collection_finalize (DataCollection* obj);
GType source_collection_get_type (void);
GType data_source_get_type (void);
enum  {
	SOURCE_COLLECTION_DUMMY_PROPERTY
};
SourceCollection* source_collection_new (const char* name);
SourceCollection* source_collection_construct (GType object_type, const char* name);
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_notify_item_destroyed (SourceCollection* self, DataSource* source);
static gboolean source_collection_real_valid_type (DataCollection* base, DataObject* object);
static SourceCollectionDestroyCounter* source_collection_destroy_counter_new (Marker* remove_marker);
static SourceCollectionDestroyCounter* source_collection_destroy_counter_construct (GType object_type, Marker* remove_marker);
static GType source_collection_destroy_counter_get_type (void) G_GNUC_UNUSED;
static gboolean source_collection_destroy_and_delete_source (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_destroy_and_delete_source_marked_action (DataObject* object, GObject* user, gpointer self);
static gboolean source_collection_destroy_source (SourceCollection* self, DataObject* object, GObject* user);
static gboolean _source_collection_destroy_source_marked_action (DataObject* object, GObject* user, gpointer self);
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
void data_source_internal_mark_for_destroy (DataSource* self);
void data_source_destroy (DataSource* self);
void source_collection_item_destroyed (SourceCollection* self, DataSource* source);
static void source_collection_real_item_destroyed (SourceCollection* self, DataSource* source);
enum  {
	SOURCE_COLLECTION_DESTROY_COUNTER_DUMMY_PROPERTY
};
static void source_collection_destroy_counter_finalize (GObject* obj);
GType database_source_collection_get_type (void);
#define DATABASE_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionPrivate))
enum  {
	DATABASE_SOURCE_COLLECTION_DUMMY_PROPERTY
};
guint int64_hash (void* p);
static guint _int64_hash_ghash_func (void* key);
gboolean int64_equal (void* a, void* b);
static gboolean _int64_equal_gequal_func (void* a, void* b);
static gint64* _int64_dup (gint64* self);
DatabaseSourceCollection* database_source_collection_new (const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
static void database_source_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
static void database_source_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
static void database_source_collection_finalize (DataCollection* obj);
gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_manager (GValue* value, gpointer v_object);
void value_take_view_manager (GValue* value, gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void);
GType data_view_get_type (void);
enum  {
	VIEW_MANAGER_DUMMY_PROPERTY
};
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source);
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source);
DataView* view_manager_create_view (ViewManager* self, DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager* obj);
GType view_collection_get_type (void);
#define VIEW_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIEW_COLLECTION, ViewCollectionPrivate))
enum  {
	VIEW_COLLECTION_DUMMY_PROPERTY
};
ViewCollection* view_collection_new (const char* name);
ViewCollection* view_collection_construct (GType object_type, const char* name);
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
void view_collection_halt_monitoring (ViewCollection* self);
void view_collection_halt_mirroring (ViewCollection* self);
static void view_collection_real_close (DataCollection* base);
static void view_collection_add_sources (ViewCollection* self, GeeIterable* added, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_sources_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_sources_added_data_collection_items_added (SourceCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_sources_removed_data_collection_items_removed (SourceCollection* _sender, GeeIterable* removed, gpointer self);
static void view_collection_on_source_altered (ViewCollection* self, DataObject* object);
static void _view_collection_on_source_altered_data_collection_item_altered (SourceCollection* _sender, DataObject* item, gpointer self);
static void _view_collection_on_source_altered_data_collection_item_metadata_altered (SourceCollection* _sender, DataObject* object, gpointer self);
void view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, GeeIterable* initial, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (ViewCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (ViewCollection* _sender, GeeIterable* removed, gpointer self);
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target);
void view_collection_reapply_view_filter (ViewCollection* self);
void view_collection_install_view_filter (ViewCollection* self, ViewFilter filter, void* filter_target);
gboolean data_view_is_visible (DataView* self);
static void view_collection_show_items (ViewCollection* self, GeeList* to_show);
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide);
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view);
void view_collection_reset_view_filter (ViewCollection* self);
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object);
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source);
DataSource* data_view_get_source (DataView* self);
gboolean data_view_is_selected (DataView* self);
void data_view_internal_set_visible (DataView* self, gboolean visible);
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeList* many);
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
static void view_collection_remove_selected (ViewCollection* self, DataView* view);
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
static void view_collection_filter_altered_item (ViewCollection* self, DataObject* object);
static void view_collection_real_item_altered (DataCollection* base, DataObject* object);
static void view_collection_real_item_metadata_altered (DataCollection* base, DataObject* object);
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target);
static void view_collection_real_reset_comparator (DataCollection* base);
static GeeIterable* view_collection_real_get_all (DataCollection* base);
GeeIterable* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base, gint index);
static gint view_collection_real_index_of (DataCollection* base, DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object);
DataView* view_collection_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first (ViewCollection* self);
DataView* view_collection_get_last (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
DataView* view_collection_get_next (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view);
DataView* view_collection_get_previous (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view);
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev);
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home);
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_select_marked (ViewCollection* self, Marker* marker);
static void view_collection_add_selected (ViewCollection* self, DataView* view);
void view_collection_select_all (ViewCollection* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_unselect_marked (ViewCollection* self, Marker* marker);
void view_collection_unselect_all (ViewCollection* self);
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception);
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_UNUSED;
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_toggle_marked (ViewCollection* self, Marker* marker);
gboolean data_view_internal_toggle (DataView* self);
gint view_collection_get_selected_count (ViewCollection* self);
GeeIterable* view_collection_get_selected (ViewCollection* self);
DataView* view_collection_get_selected_at (ViewCollection* self, gint index);
GeeCollection* view_collection_get_sources (ViewCollection* self);
GeeCollection* view_collection_get_selected_sources (ViewCollection* self);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_thawed (DataCollection* base);
void view_collection_items_selected (ViewCollection* self, GeeIterable* selected);
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected);
void view_collection_items_unselected (ViewCollection* self, GeeIterable* unselected);
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected);
void view_collection_items_state_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed);
void view_collection_items_shown (ViewCollection* self, GeeIterable* visible);
static void view_collection_real_items_shown (ViewCollection* self, GeeIterable* visible);
void view_collection_items_hidden (ViewCollection* self, GeeIterable* hidden);
static void view_collection_real_items_hidden (ViewCollection* self, GeeIterable* hidden);
void view_collection_items_visibility_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeIterable* changed);
void view_collection_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views);
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_DUMMY_PROPERTY
};
static void view_collection_toggle_lists_finalize (GObject* obj);
static void view_collection_finalize (DataCollection* obj);


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

#line 30 "DataCollection.vala"
DataSet* data_set_construct (GType object_type) {
#line 893 "DataCollection.c"
	DataSet* self;
	self = (DataSet*) g_type_create_instance (object_type);
#line 31 "DataCollection.vala"
	data_set_reset_comparator (self);
#line 898 "DataCollection.c"
	return self;
}


#line 30 "DataCollection.vala"
DataSet* data_set_new (void) {
#line 30 "DataCollection.vala"
	return data_set_construct (TYPE_DATA_SET);
#line 907 "DataCollection.c"
}


#line 34 "DataCollection.vala"
static gint64 data_set_order_added_comparator (DataSet* self, void* a, void* b) {
#line 913 "DataCollection.c"
	gint64 result = 0LL;
#line 34 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0LL);
#line 917 "DataCollection.c"
	result = data_object_internal_get_ordinal (DATA_OBJECT ((DataObject*) a)) - data_object_internal_get_ordinal (DATA_OBJECT ((DataObject*) b));
#line 35 "DataCollection.vala"
	return result;
#line 921 "DataCollection.c"
}


#line 38 "DataCollection.vala"
static gint64 data_set_comparator_wrapper (DataSet* self, void* a, void* b) {
#line 927 "DataCollection.c"
	gint64 result = 0LL;
	gint64 _result_;
#line 38 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0LL);
#line 39 "DataCollection.vala"
	if (a == b) {
#line 934 "DataCollection.c"
		result = (gint64) 0;
#line 40 "DataCollection.vala"
		return result;
#line 938 "DataCollection.c"
	}
#line 44 "DataCollection.vala"
	_result_ = self->priv->user_comparator (a, b, self->priv->user_comparator_target);
#line 45 "DataCollection.vala"
	if (_result_ == 0) {
#line 46 "DataCollection.vala"
		_result_ = data_set_order_added_comparator (self, a, b);
#line 946 "DataCollection.c"
	}
#line 48 "DataCollection.vala"
	g_assert (_result_ != 0);
#line 950 "DataCollection.c"
	result = _result_;
#line 50 "DataCollection.vala"
	return result;
#line 954 "DataCollection.c"
}


#line 53 "DataCollection.vala"
gboolean data_set_contains (DataSet* self, DataObject* object) {
#line 960 "DataCollection.c"
	gboolean result = FALSE;
#line 53 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 53 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 966 "DataCollection.c"
	result = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object);
#line 54 "DataCollection.vala"
	return result;
#line 970 "DataCollection.c"
}


#line 57 "DataCollection.vala"
gint data_set_get_count (DataSet* self) {
#line 976 "DataCollection.c"
	gint result = 0;
#line 57 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0);
#line 980 "DataCollection.c"
	result = sorted_list_get_size (self->priv->list);
#line 58 "DataCollection.vala"
	return result;
#line 984 "DataCollection.c"
}


#line 34 "DataCollection.vala"
static gint64 _data_set_order_added_comparator_comparator (void* a, void* b, gpointer self) {
#line 990 "DataCollection.c"
	return data_set_order_added_comparator (self, a, b);
}


#line 61 "DataCollection.vala"
void data_set_reset_comparator (DataSet* self) {
#line 997 "DataCollection.c"
	Comparator _tmp0_;
#line 61 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SET (self));
#line 62 "DataCollection.vala"
	self->priv->user_comparator = (_tmp0_ = NULL, ((self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL), self->priv->user_comparator = NULL, self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL), self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL, _tmp0_);
#line 63 "DataCollection.vala"
	sorted_list_resort (self->priv->list, _data_set_order_added_comparator_comparator, self);
#line 1005 "DataCollection.c"
}


#line 38 "DataCollection.vala"
static gint64 _data_set_comparator_wrapper_comparator (void* a, void* b, gpointer self) {
#line 1011 "DataCollection.c"
	return data_set_comparator_wrapper (self, a, b);
}


#line 66 "DataCollection.vala"
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target) {
#line 1018 "DataCollection.c"
	Comparator _tmp0_;
#line 66 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SET (self));
#line 67 "DataCollection.vala"
	self->priv->user_comparator = (_tmp0_ = user_comparator, ((self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL), self->priv->user_comparator = NULL, self->priv->user_comparator_target = NULL, self->priv->user_comparator_target_destroy_notify = NULL), self->priv->user_comparator_target = user_comparator_target, self->priv->user_comparator_target_destroy_notify = NULL, _tmp0_);
#line 68 "DataCollection.vala"
	sorted_list_resort (self->priv->list, _data_set_comparator_wrapper_comparator, self);
#line 1026 "DataCollection.c"
}


#line 71 "DataCollection.vala"
GeeIterable* data_set_get_all (DataSet* self) {
#line 1032 "DataCollection.c"
	GeeIterable* result = NULL;
#line 71 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 1036 "DataCollection.c"
	result = GEE_ITERABLE (sorted_list_copy (self->priv->list));
#line 74 "DataCollection.vala"
	return result;
#line 1040 "DataCollection.c"
}


#line 77 "DataCollection.vala"
DataSet* data_set_copy (DataSet* self) {
#line 1046 "DataCollection.c"
	DataSet* result = NULL;
	DataSet* clone;
	SortedList* _tmp0_;
#line 77 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 78 "DataCollection.vala"
	clone = data_set_new ();
#line 79 "DataCollection.vala"
	clone->priv->list = (_tmp0_ = sorted_list_copy (self->priv->list), _g_object_unref0 (clone->priv->list), _tmp0_);
#line 80 "DataCollection.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (clone->priv->hash_set), GEE_COLLECTION (self->priv->hash_set));
#line 1058 "DataCollection.c"
	result = clone;
#line 82 "DataCollection.vala"
	return result;
#line 1062 "DataCollection.c"
}


#line 85 "DataCollection.vala"
DataObject* data_set_get_at (DataSet* self, gint index) {
#line 1068 "DataCollection.c"
	DataObject* result = NULL;
#line 85 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), NULL);
#line 1072 "DataCollection.c"
	result = (DataObject*) sorted_list_get_at (self->priv->list, index);
#line 86 "DataCollection.vala"
	return result;
#line 1076 "DataCollection.c"
}


#line 89 "DataCollection.vala"
gint data_set_index_of (DataSet* self, DataObject* object) {
#line 1082 "DataCollection.c"
	gint result = 0;
#line 89 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), 0);
#line 89 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 1088 "DataCollection.c"
	result = sorted_list_locate (self->priv->list, object, g_direct_equal);
#line 90 "DataCollection.vala"
	return result;
#line 1092 "DataCollection.c"
}


#line 93 "DataCollection.vala"
gboolean data_set_add (DataSet* self, DataObject* object) {
#line 1098 "DataCollection.c"
	gboolean result = FALSE;
#line 93 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 93 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 94 "DataCollection.vala"
	if (!sorted_list_add (self->priv->list, object)) {
#line 1106 "DataCollection.c"
		result = FALSE;
#line 95 "DataCollection.vala"
		return result;
#line 1110 "DataCollection.c"
	}
#line 97 "DataCollection.vala"
	if (!gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object)) {
#line 99 "DataCollection.vala"
		sorted_list_remove (self->priv->list, object);
#line 1116 "DataCollection.c"
		result = FALSE;
#line 101 "DataCollection.vala"
		return result;
#line 1120 "DataCollection.c"
	}
	result = TRUE;
#line 104 "DataCollection.vala"
	return result;
#line 1125 "DataCollection.c"
}


#line 107 "DataCollection.vala"
gboolean data_set_add_many (DataSet* self, GeeList* objects) {
#line 1131 "DataCollection.c"
	gboolean result = FALSE;
	gint count;
#line 107 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 107 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_LIST (objects), FALSE);
#line 108 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (objects));
#line 109 "DataCollection.vala"
	if (count == 0) {
#line 1142 "DataCollection.c"
		result = TRUE;
#line 110 "DataCollection.vala"
		return result;
#line 1146 "DataCollection.c"
	}
#line 112 "DataCollection.vala"
	if (!sorted_list_add_many (self->priv->list, objects)) {
#line 1150 "DataCollection.c"
		result = FALSE;
#line 113 "DataCollection.vala"
		return result;
#line 1154 "DataCollection.c"
	}
#line 115 "DataCollection.vala"
	if (!gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), GEE_COLLECTION (objects))) {
#line 117 "DataCollection.vala"
		sorted_list_remove_many (self->priv->list, GEE_COLLECTION (objects));
#line 1160 "DataCollection.c"
		result = FALSE;
#line 119 "DataCollection.vala"
		return result;
#line 1164 "DataCollection.c"
	}
	result = TRUE;
#line 122 "DataCollection.vala"
	return result;
#line 1169 "DataCollection.c"
}


#line 125 "DataCollection.vala"
gboolean data_set_remove (DataSet* self, DataObject* object) {
#line 1175 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
#line 125 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 125 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 126 "DataCollection.vala"
	success = TRUE;
#line 128 "DataCollection.vala"
	if (!sorted_list_remove (self->priv->list, object)) {
#line 129 "DataCollection.vala"
		success = FALSE;
#line 1188 "DataCollection.c"
	}
#line 131 "DataCollection.vala"
	if (!gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), object)) {
#line 132 "DataCollection.vala"
		success = FALSE;
#line 1194 "DataCollection.c"
	}
	result = success;
#line 134 "DataCollection.vala"
	return result;
#line 1199 "DataCollection.c"
}


#line 137 "DataCollection.vala"
gboolean data_set_remove_many (DataSet* self, GeeList* objects) {
#line 1205 "DataCollection.c"
	gboolean result = FALSE;
	gboolean success;
#line 137 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 137 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_LIST (objects), FALSE);
#line 138 "DataCollection.vala"
	success = TRUE;
#line 140 "DataCollection.vala"
	if (!sorted_list_remove_many (self->priv->list, GEE_COLLECTION (objects))) {
#line 141 "DataCollection.vala"
		success = FALSE;
#line 1218 "DataCollection.c"
	}
#line 143 "DataCollection.vala"
	if (!gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->hash_set), GEE_COLLECTION (objects))) {
#line 144 "DataCollection.vala"
		success = FALSE;
#line 1224 "DataCollection.c"
	}
	result = success;
#line 146 "DataCollection.vala"
	return result;
#line 1229 "DataCollection.c"
}


#line 150 "DataCollection.vala"
gboolean data_set_resort_object (DataSet* self, DataObject* object) {
#line 1235 "DataCollection.c"
	gboolean result = FALSE;
#line 150 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SET (self), FALSE);
#line 150 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1241 "DataCollection.c"
	result = sorted_list_resort_item (self->priv->list, object);
#line 151 "DataCollection.vala"
	return result;
#line 1245 "DataCollection.c"
}


static void value_data_set_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_data_set_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		data_set_unref (value->data[0].v_pointer);
	}
}


static void value_data_set_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = data_set_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_data_set_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_data_set_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DataSet* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = data_set_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_data_set_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DataSet** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = data_set_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDataSet* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATA_SET), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_data_set (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET), NULL);
	return value->data[0].v_pointer;
}


void value_set_data_set (GValue* value, gpointer v_object) {
	DataSet* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_SET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		data_set_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_set_unref (old);
	}
}


void value_take_data_set (GValue* value, gpointer v_object) {
	DataSet* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_SET));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_SET));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_set_unref (old);
	}
}


static void data_set_class_init (DataSetClass * klass) {
	data_set_parent_class = g_type_class_peek_parent (klass);
	DATA_SET_CLASS (klass)->finalize = data_set_finalize;
	g_type_class_add_private (klass, sizeof (DataSetPrivate));
}


static void data_set_instance_init (DataSet * self) {
	self->priv = DATA_SET_GET_PRIVATE (self);
	self->priv->list = sorted_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->hash_set = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->user_comparator = NULL;
	self->ref_count = 1;
}


static void data_set_finalize (DataSet* obj) {
	DataSet * self;
	self = DATA_SET (obj);
	_g_object_unref0 (self->priv->list);
	_g_object_unref0 (self->priv->hash_set);
	(self->priv->user_comparator_target_destroy_notify == NULL) ? NULL : (self->priv->user_comparator_target_destroy_notify (self->priv->user_comparator_target), NULL);
	self->priv->user_comparator = NULL;
	self->priv->user_comparator_target = NULL;
	self->priv->user_comparator_target_destroy_notify = NULL;
}


GType data_set_get_type (void) {
	static volatile gsize data_set_type_id__volatile = 0;
	if (g_once_init_enter (&data_set_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_data_set_init, value_data_set_free_value, value_data_set_copy_value, value_data_set_peek_pointer, "p", value_data_set_collect_value, "p", value_data_set_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DataSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataSet), 0, (GInstanceInitFunc) data_set_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType data_set_type_id;
		data_set_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DataSet", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&data_set_type_id__volatile, data_set_type_id);
	}
	return data_set_type_id__volatile;
}


gpointer data_set_ref (gpointer instance) {
	DataSet* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void data_set_unref (gpointer instance) {
	DataSet* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATA_SET_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 164 "DataCollection.vala"
void marker_mark (Marker* self, DataObject* object) {
#line 164 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark (self, object);
#line 1423 "DataCollection.c"
}


#line 166 "DataCollection.vala"
void marker_mark_many (Marker* self, GeeIterable* list) {
#line 166 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark_many (self, list);
#line 1431 "DataCollection.c"
}


#line 168 "DataCollection.vala"
void marker_mark_all (Marker* self) {
#line 168 "DataCollection.vala"
	MARKER_GET_INTERFACE (self)->mark_all (self);
#line 1439 "DataCollection.c"
}


#line 170 "DataCollection.vala"
gint marker_get_count (Marker* self) {
#line 170 "DataCollection.vala"
	return MARKER_GET_INTERFACE (self)->get_count (self);
#line 1447 "DataCollection.c"
}


static void marker_base_init (MarkerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType marker_get_type (void) {
	static volatile gsize marker_type_id__volatile = 0;
	if (g_once_init_enter (&marker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MarkerIface), (GBaseInitFunc) marker_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType marker_type_id;
		marker_type_id = g_type_register_static (G_TYPE_INTERFACE, "Marker", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (marker_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&marker_type_id__volatile, marker_type_id);
	}
	return marker_type_id__volatile;
}


#line 187 "DataCollection.vala"
UnknownTotalMonitor* unknown_total_monitor_construct (GType object_type, guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 1474 "DataCollection.c"
	UnknownTotalMonitor* self;
	ProgressMonitor _tmp0_;
	self = (UnknownTotalMonitor*) g_type_create_instance (object_type);
#line 188 "DataCollection.vala"
	self->priv->total = total;
#line 189 "DataCollection.vala"
	self->priv->wrapped_monitor = (_tmp0_ = wrapped_monitor, ((self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL), self->priv->wrapped_monitor = NULL, self->priv->wrapped_monitor_target = NULL, self->priv->wrapped_monitor_target_destroy_notify = NULL), self->priv->wrapped_monitor_target = wrapped_monitor_target, self->priv->wrapped_monitor_target_destroy_notify = NULL, _tmp0_);
#line 1482 "DataCollection.c"
	return self;
}


#line 187 "DataCollection.vala"
UnknownTotalMonitor* unknown_total_monitor_new (guint64 total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 187 "DataCollection.vala"
	return unknown_total_monitor_construct (TYPE_UNKNOWN_TOTAL_MONITOR, total, wrapped_monitor, wrapped_monitor_target);
#line 1491 "DataCollection.c"
}


#line 192 "DataCollection.vala"
gboolean unknown_total_monitor_monitor (UnknownTotalMonitor* self, guint64 count, guint64 total) {
#line 1497 "DataCollection.c"
	gboolean result = FALSE;
#line 192 "DataCollection.vala"
	g_return_val_if_fail (IS_UNKNOWN_TOTAL_MONITOR (self), FALSE);
#line 1501 "DataCollection.c"
	result = self->priv->wrapped_monitor (count, self->priv->total, self->priv->wrapped_monitor_target);
#line 193 "DataCollection.vala"
	return result;
#line 1505 "DataCollection.c"
}


static void value_unknown_total_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_unknown_total_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		unknown_total_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_unknown_total_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = unknown_total_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_unknown_total_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_unknown_total_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		UnknownTotalMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = unknown_total_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_unknown_total_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	UnknownTotalMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = unknown_total_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_unknown_total_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecUnknownTotalMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_UNKNOWN_TOTAL_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_unknown_total_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_unknown_total_monitor (GValue* value, gpointer v_object) {
	UnknownTotalMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UNKNOWN_TOTAL_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		unknown_total_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		unknown_total_monitor_unref (old);
	}
}


void value_take_unknown_total_monitor (GValue* value, gpointer v_object) {
	UnknownTotalMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UNKNOWN_TOTAL_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UNKNOWN_TOTAL_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		unknown_total_monitor_unref (old);
	}
}


static void unknown_total_monitor_class_init (UnknownTotalMonitorClass * klass) {
	unknown_total_monitor_parent_class = g_type_class_peek_parent (klass);
	UNKNOWN_TOTAL_MONITOR_CLASS (klass)->finalize = unknown_total_monitor_finalize;
	g_type_class_add_private (klass, sizeof (UnknownTotalMonitorPrivate));
}


static void unknown_total_monitor_instance_init (UnknownTotalMonitor * self) {
	self->priv = UNKNOWN_TOTAL_MONITOR_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void unknown_total_monitor_finalize (UnknownTotalMonitor* obj) {
	UnknownTotalMonitor * self;
	self = UNKNOWN_TOTAL_MONITOR (obj);
	(self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL);
	self->priv->wrapped_monitor = NULL;
	self->priv->wrapped_monitor_target = NULL;
	self->priv->wrapped_monitor_target_destroy_notify = NULL;
}


GType unknown_total_monitor_get_type (void) {
	static volatile gsize unknown_total_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&unknown_total_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_unknown_total_monitor_init, value_unknown_total_monitor_free_value, value_unknown_total_monitor_copy_value, value_unknown_total_monitor_peek_pointer, "p", value_unknown_total_monitor_collect_value, "p", value_unknown_total_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UnknownTotalMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) unknown_total_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UnknownTotalMonitor), 0, (GInstanceInitFunc) unknown_total_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType unknown_total_monitor_type_id;
		unknown_total_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UnknownTotalMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&unknown_total_monitor_type_id__volatile, unknown_total_monitor_type_id);
	}
	return unknown_total_monitor_type_id__volatile;
}


gpointer unknown_total_monitor_ref (gpointer instance) {
	UnknownTotalMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void unknown_total_monitor_unref (gpointer instance) {
	UnknownTotalMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		UNKNOWN_TOTAL_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 205 "DataCollection.vala"
AggregateProgressMonitor* aggregate_progress_monitor_construct (GType object_type, guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 1676 "DataCollection.c"
	AggregateProgressMonitor* self;
	ProgressMonitor _tmp0_;
	self = (AggregateProgressMonitor*) g_type_create_instance (object_type);
#line 206 "DataCollection.vala"
	self->priv->grand_total = grand_total;
#line 207 "DataCollection.vala"
	self->priv->wrapped_monitor = (_tmp0_ = wrapped_monitor, ((self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL), self->priv->wrapped_monitor = NULL, self->priv->wrapped_monitor_target = NULL, self->priv->wrapped_monitor_target_destroy_notify = NULL), self->priv->wrapped_monitor_target = wrapped_monitor_target, self->priv->wrapped_monitor_target_destroy_notify = NULL, _tmp0_);
#line 1684 "DataCollection.c"
	return self;
}


#line 205 "DataCollection.vala"
AggregateProgressMonitor* aggregate_progress_monitor_new (guint64 grand_total, ProgressMonitor wrapped_monitor, void* wrapped_monitor_target) {
#line 205 "DataCollection.vala"
	return aggregate_progress_monitor_construct (TYPE_AGGREGATE_PROGRESS_MONITOR, grand_total, wrapped_monitor, wrapped_monitor_target);
#line 1693 "DataCollection.c"
}


#line 210 "DataCollection.vala"
void aggregate_progress_monitor_next_step (AggregateProgressMonitor* self, const char* name) {
#line 210 "DataCollection.vala"
	g_return_if_fail (IS_AGGREGATE_PROGRESS_MONITOR (self));
#line 210 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 211 "DataCollection.vala"
	g_debug ("DataCollection.vala:211: next step: %s (%lld/%lld)", name, self->priv->aggregate_count, self->priv->grand_total);
#line 212 "DataCollection.vala"
	self->priv->last_count = G_MAXUINT64;
#line 1707 "DataCollection.c"
}


#line 215 "DataCollection.vala"
gboolean aggregate_progress_monitor_monitor (AggregateProgressMonitor* self, guint64 count, guint64 total) {
#line 1713 "DataCollection.c"
	gboolean result = FALSE;
	guint64 _tmp0_ = 0ULL;
#line 215 "DataCollection.vala"
	g_return_val_if_fail (IS_AGGREGATE_PROGRESS_MONITOR (self), FALSE);
#line 217 "DataCollection.vala"
	if (self->priv->last_count != G_MAXUINT64) {
#line 217 "DataCollection.vala"
		_tmp0_ = count - self->priv->last_count;
#line 1722 "DataCollection.c"
	} else {
#line 217 "DataCollection.vala"
		_tmp0_ = count;
#line 1726 "DataCollection.c"
	}
#line 217 "DataCollection.vala"
	self->priv->aggregate_count = self->priv->aggregate_count + _tmp0_;
#line 218 "DataCollection.vala"
	if (self->priv->aggregate_count > self->priv->grand_total) {
#line 219 "DataCollection.vala"
		self->priv->aggregate_count = self->priv->grand_total;
#line 1734 "DataCollection.c"
	}
#line 222 "DataCollection.vala"
	self->priv->last_count = count;
#line 1738 "DataCollection.c"
	result = self->priv->wrapped_monitor (self->priv->aggregate_count, self->priv->grand_total, self->priv->wrapped_monitor_target);
#line 224 "DataCollection.vala"
	return result;
#line 1742 "DataCollection.c"
}


static void value_aggregate_progress_monitor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_aggregate_progress_monitor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		aggregate_progress_monitor_unref (value->data[0].v_pointer);
	}
}


static void value_aggregate_progress_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = aggregate_progress_monitor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_aggregate_progress_monitor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_aggregate_progress_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		AggregateProgressMonitor* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = aggregate_progress_monitor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_aggregate_progress_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	AggregateProgressMonitor** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = aggregate_progress_monitor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_aggregate_progress_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecAggregateProgressMonitor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_AGGREGATE_PROGRESS_MONITOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_aggregate_progress_monitor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR), NULL);
	return value->data[0].v_pointer;
}


void value_set_aggregate_progress_monitor (GValue* value, gpointer v_object) {
	AggregateProgressMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AGGREGATE_PROGRESS_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		aggregate_progress_monitor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		aggregate_progress_monitor_unref (old);
	}
}


void value_take_aggregate_progress_monitor (GValue* value, gpointer v_object) {
	AggregateProgressMonitor* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_AGGREGATE_PROGRESS_MONITOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_AGGREGATE_PROGRESS_MONITOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		aggregate_progress_monitor_unref (old);
	}
}


static void aggregate_progress_monitor_class_init (AggregateProgressMonitorClass * klass) {
	aggregate_progress_monitor_parent_class = g_type_class_peek_parent (klass);
	AGGREGATE_PROGRESS_MONITOR_CLASS (klass)->finalize = aggregate_progress_monitor_finalize;
	g_type_class_add_private (klass, sizeof (AggregateProgressMonitorPrivate));
}


static void aggregate_progress_monitor_instance_init (AggregateProgressMonitor * self) {
	self->priv = AGGREGATE_PROGRESS_MONITOR_GET_PRIVATE (self);
	self->priv->aggregate_count = (guint64) 0;
	self->priv->last_count = G_MAXUINT64;
	self->ref_count = 1;
}


static void aggregate_progress_monitor_finalize (AggregateProgressMonitor* obj) {
	AggregateProgressMonitor * self;
	self = AGGREGATE_PROGRESS_MONITOR (obj);
	(self->priv->wrapped_monitor_target_destroy_notify == NULL) ? NULL : (self->priv->wrapped_monitor_target_destroy_notify (self->priv->wrapped_monitor_target), NULL);
	self->priv->wrapped_monitor = NULL;
	self->priv->wrapped_monitor_target = NULL;
	self->priv->wrapped_monitor_target_destroy_notify = NULL;
}


GType aggregate_progress_monitor_get_type (void) {
	static volatile gsize aggregate_progress_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&aggregate_progress_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_aggregate_progress_monitor_init, value_aggregate_progress_monitor_free_value, value_aggregate_progress_monitor_copy_value, value_aggregate_progress_monitor_peek_pointer, "p", value_aggregate_progress_monitor_collect_value, "p", value_aggregate_progress_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AggregateProgressMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) aggregate_progress_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AggregateProgressMonitor), 0, (GInstanceInitFunc) aggregate_progress_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType aggregate_progress_monitor_type_id;
		aggregate_progress_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AggregateProgressMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&aggregate_progress_monitor_type_id__volatile, aggregate_progress_monitor_type_id);
	}
	return aggregate_progress_monitor_type_id__volatile;
}


gpointer aggregate_progress_monitor_ref (gpointer instance) {
	AggregateProgressMonitor* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void aggregate_progress_monitor_unref (gpointer instance) {
	AggregateProgressMonitor* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		AGGREGATE_PROGRESS_MONITOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 229 "DataCollection.vala"
gboolean null_progress_monitor (guint64 count, guint64 total) {
#line 1915 "DataCollection.c"
	gboolean result = FALSE;
	result = TRUE;
#line 230 "DataCollection.vala"
	return result;
#line 1920 "DataCollection.c"
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


#line 356 "DataCollection.vala"
DataCollection* data_collection_construct (GType object_type, const char* name) {
#line 1931 "DataCollection.c"
	DataCollection* self;
	char* _tmp0_;
#line 356 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1936 "DataCollection.c"
	self = (DataCollection*) g_type_create_instance (object_type);
#line 357 "DataCollection.vala"
	self->priv->name = (_tmp0_ = g_strdup (name), _g_free0 (self->priv->name), _tmp0_);
#line 1940 "DataCollection.c"
	return self;
}


#line 356 "DataCollection.vala"
DataCollection* data_collection_new (const char* name) {
#line 356 "DataCollection.vala"
	return data_collection_construct (TYPE_DATA_COLLECTION, name);
#line 1949 "DataCollection.c"
}


#line 366 "DataCollection.vala"
static char* data_collection_real_to_string (DataCollection* self) {
#line 1955 "DataCollection.c"
	char* result = NULL;
#line 366 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 1959 "DataCollection.c"
	result = g_strdup_printf ("%s (%d)", self->priv->name, data_collection_get_count (self));
#line 367 "DataCollection.vala"
	return result;
#line 1963 "DataCollection.c"
}


#line 366 "DataCollection.vala"
char* data_collection_to_string (DataCollection* self) {
#line 366 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->to_string (self);
#line 1971 "DataCollection.c"
}


#line 371 "DataCollection.vala"
static void data_collection_real_notify_items_added (DataCollection* self, GeeIterable* added) {
#line 371 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 371 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 372 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-added", added);
#line 1983 "DataCollection.c"
}


#line 371 "DataCollection.vala"
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added) {
#line 371 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_added (self, added);
#line 1991 "DataCollection.c"
}


#line 375 "DataCollection.vala"
static void data_collection_real_notify_items_removed (DataCollection* self, GeeIterable* removed) {
#line 375 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 375 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 376 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-removed", removed);
#line 2003 "DataCollection.c"
}


#line 375 "DataCollection.vala"
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed) {
#line 375 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_removed (self, removed);
#line 2011 "DataCollection.c"
}


#line 379 "DataCollection.vala"
static void data_collection_real_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 379 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 379 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 379 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 381 "DataCollection.vala"
	g_signal_emit_by_name (self, "contents-altered", added, removed);
#line 2025 "DataCollection.c"
}


#line 379 "DataCollection.vala"
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 379 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_contents_altered (self, added, removed);
#line 2033 "DataCollection.c"
}


#line 384 "DataCollection.vala"
static void data_collection_real_notify_item_altered (DataCollection* self, DataObject* item) {
#line 384 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 384 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (item));
#line 385 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-altered", item);
#line 2045 "DataCollection.c"
}


#line 384 "DataCollection.vala"
void data_collection_notify_item_altered (DataCollection* self, DataObject* item) {
#line 384 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_item_altered (self, item);
#line 2053 "DataCollection.c"
}


#line 388 "DataCollection.vala"
static void data_collection_real_notify_items_altered (DataCollection* self, GeeCollection* items) {
#line 388 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 388 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (items));
#line 389 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-altered", items);
#line 2065 "DataCollection.c"
}


#line 388 "DataCollection.vala"
void data_collection_notify_items_altered (DataCollection* self, GeeCollection* items) {
#line 388 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_altered (self, items);
#line 2073 "DataCollection.c"
}


#line 392 "DataCollection.vala"
static void data_collection_real_notify_item_metadata_altered (DataCollection* self, DataObject* item) {
#line 392 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 392 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (item));
#line 393 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-metadata-altered", item);
#line 2085 "DataCollection.c"
}


#line 392 "DataCollection.vala"
void data_collection_notify_item_metadata_altered (DataCollection* self, DataObject* item) {
#line 392 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_item_metadata_altered (self, item);
#line 2093 "DataCollection.c"
}


#line 396 "DataCollection.vala"
static void data_collection_real_notify_items_metadata_altered (DataCollection* self, GeeCollection* items) {
#line 396 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 396 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (items));
#line 397 "DataCollection.vala"
	g_signal_emit_by_name (self, "items-metadata-altered", items);
#line 2105 "DataCollection.c"
}


#line 396 "DataCollection.vala"
void data_collection_notify_items_metadata_altered (DataCollection* self, GeeCollection* items) {
#line 396 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_items_metadata_altered (self, items);
#line 2113 "DataCollection.c"
}


#line 400 "DataCollection.vala"
static void data_collection_real_notify_ordering_changed (DataCollection* self) {
#line 400 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 401 "DataCollection.vala"
	g_signal_emit_by_name (self, "ordering-changed");
#line 2123 "DataCollection.c"
}


#line 400 "DataCollection.vala"
void data_collection_notify_ordering_changed (DataCollection* self) {
#line 400 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_ordering_changed (self);
#line 2131 "DataCollection.c"
}


#line 404 "DataCollection.vala"
static void data_collection_real_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 404 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 404 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 405 "DataCollection.vala"
	g_signal_emit_by_name (self, "property-set", name, old, val);
#line 2143 "DataCollection.c"
}


#line 404 "DataCollection.vala"
void data_collection_notify_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 404 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_property_set (self, name, old, val);
#line 2151 "DataCollection.c"
}


#line 408 "DataCollection.vala"
static void data_collection_real_notify_property_cleared (DataCollection* self, const char* name) {
#line 408 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 408 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 409 "DataCollection.vala"
	g_signal_emit_by_name (self, "property-cleared", name);
#line 2163 "DataCollection.c"
}


#line 408 "DataCollection.vala"
void data_collection_notify_property_cleared (DataCollection* self, const char* name) {
#line 408 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->notify_property_cleared (self, name);
#line 2171 "DataCollection.c"
}


#line 417 "DataCollection.vala"
GeeArrayList* data_collection_get_singleton (DataObject* object) {
#line 2177 "DataCollection.c"
	GeeArrayList* result = NULL;
	GeeArrayList* singleton;
#line 417 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 418 "DataCollection.vala"
	singleton = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 419 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (singleton), object);
#line 2186 "DataCollection.c"
	result = singleton;
#line 421 "DataCollection.vala"
	return result;
#line 2190 "DataCollection.c"
}


#line 424 "DataCollection.vala"
static gboolean data_collection_real_valid_type (DataCollection* self, DataObject* object) {
#line 2196 "DataCollection.c"
	gboolean result = FALSE;
#line 424 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 424 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2202 "DataCollection.c"
	result = TRUE;
#line 425 "DataCollection.vala"
	return result;
#line 2206 "DataCollection.c"
}


#line 424 "DataCollection.vala"
gboolean data_collection_valid_type (DataCollection* self, DataObject* object) {
#line 424 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->valid_type (self, object);
#line 2214 "DataCollection.c"
}


#line 428 "DataCollection.vala"
static void data_collection_real_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target) {
#line 428 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 429 "DataCollection.vala"
	data_set_set_comparator (self->priv->dataset, comparator, comparator_target);
#line 430 "DataCollection.vala"
	data_collection_notify_ordering_changed (self);
#line 2226 "DataCollection.c"
}


#line 428 "DataCollection.vala"
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target) {
#line 428 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->set_comparator (self, comparator, comparator_target);
#line 2234 "DataCollection.c"
}


#line 434 "DataCollection.vala"
static void data_collection_real_reset_comparator (DataCollection* self) {
#line 434 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 435 "DataCollection.vala"
	data_set_reset_comparator (self->priv->dataset);
#line 436 "DataCollection.vala"
	data_collection_notify_ordering_changed (self);
#line 2246 "DataCollection.c"
}


#line 434 "DataCollection.vala"
void data_collection_reset_comparator (DataCollection* self) {
#line 434 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->reset_comparator (self);
#line 2254 "DataCollection.c"
}


#line 439 "DataCollection.vala"
static GeeIterable* data_collection_real_get_all (DataCollection* self) {
#line 2260 "DataCollection.c"
	GeeIterable* result = NULL;
#line 439 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 2264 "DataCollection.c"
	result = data_set_get_all (self->priv->dataset);
#line 440 "DataCollection.vala"
	return result;
#line 2268 "DataCollection.c"
}


#line 439 "DataCollection.vala"
GeeIterable* data_collection_get_all (DataCollection* self) {
#line 439 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_all (self);
#line 2276 "DataCollection.c"
}


#line 443 "DataCollection.vala"
DataSet* data_collection_get_dataset_copy (DataCollection* self) {
#line 2282 "DataCollection.c"
	DataSet* result = NULL;
#line 443 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 2286 "DataCollection.c"
	result = data_set_copy (self->priv->dataset);
#line 444 "DataCollection.vala"
	return result;
#line 2290 "DataCollection.c"
}


#line 447 "DataCollection.vala"
static gint data_collection_real_get_count (DataCollection* self) {
#line 2296 "DataCollection.c"
	gint result = 0;
#line 447 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 2300 "DataCollection.c"
	result = data_set_get_count (self->priv->dataset);
#line 448 "DataCollection.vala"
	return result;
#line 2304 "DataCollection.c"
}


#line 447 "DataCollection.vala"
gint data_collection_get_count (DataCollection* self) {
#line 447 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_count (self);
#line 2312 "DataCollection.c"
}


#line 451 "DataCollection.vala"
static DataObject* data_collection_real_get_at (DataCollection* self, gint index) {
#line 2318 "DataCollection.c"
	DataObject* result = NULL;
#line 451 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 2322 "DataCollection.c"
	result = data_set_get_at (self->priv->dataset, index);
#line 452 "DataCollection.vala"
	return result;
#line 2326 "DataCollection.c"
}


#line 451 "DataCollection.vala"
DataObject* data_collection_get_at (DataCollection* self, gint index) {
#line 451 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->get_at (self, index);
#line 2334 "DataCollection.c"
}


#line 455 "DataCollection.vala"
static gint data_collection_real_index_of (DataCollection* self, DataObject* object) {
#line 2340 "DataCollection.c"
	gint result = 0;
#line 455 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 455 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 2346 "DataCollection.c"
	result = data_set_index_of (self->priv->dataset, object);
#line 456 "DataCollection.vala"
	return result;
#line 2350 "DataCollection.c"
}


#line 455 "DataCollection.vala"
gint data_collection_index_of (DataCollection* self, DataObject* object) {
#line 455 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->index_of (self, object);
#line 2358 "DataCollection.c"
}


#line 459 "DataCollection.vala"
static gboolean data_collection_real_contains (DataCollection* self, DataObject* object) {
#line 2364 "DataCollection.c"
	gboolean result = FALSE;
#line 459 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 459 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 2370 "DataCollection.c"
	result = data_collection_internal_contains (self, object);
#line 460 "DataCollection.vala"
	return result;
#line 2374 "DataCollection.c"
}


#line 459 "DataCollection.vala"
gboolean data_collection_contains (DataCollection* self, DataObject* object) {
#line 459 "DataCollection.vala"
	return DATA_COLLECTION_GET_CLASS (self)->contains (self, object);
#line 2382 "DataCollection.c"
}


#line 465 "DataCollection.vala"
static gboolean data_collection_internal_contains (DataCollection* self, DataObject* object) {
#line 2388 "DataCollection.c"
	gboolean result = FALSE;
	DataCollection* _tmp0_;
#line 465 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 465 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 466 "DataCollection.vala"
	if (!data_set_contains (self->priv->dataset, object)) {
#line 2397 "DataCollection.c"
		result = FALSE;
#line 467 "DataCollection.vala"
		return result;
#line 2401 "DataCollection.c"
	}
#line 469 "DataCollection.vala"
	g_assert ((_tmp0_ = data_object_get_membership (object)) == self);
#line 2405 "DataCollection.c"
	_data_collection_unref0 (_tmp0_);
	result = TRUE;
#line 471 "DataCollection.vala"
	return result;
#line 2410 "DataCollection.c"
}


#line 474 "DataCollection.vala"
static void data_collection_internal_add (DataCollection* self, DataObject* object) {
#line 2416 "DataCollection.c"
	gboolean added;
#line 474 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 474 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 475 "DataCollection.vala"
	g_assert (data_collection_valid_type (self, object));
#line 477 "DataCollection.vala"
	data_object_internal_set_membership (object, self, self->priv->object_ordinal_generator++);
#line 479 "DataCollection.vala"
	added = data_set_add (self->priv->dataset, object);
#line 480 "DataCollection.vala"
	g_assert (added);
#line 2430 "DataCollection.c"
}


#line 483 "DataCollection.vala"
static void data_collection_internal_add_many (DataCollection* self, GeeList* objects, ProgressMonitor monitor, void* monitor_target) {
#line 2436 "DataCollection.c"
	gint count;
	gboolean added;
#line 483 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 483 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (objects));
#line 484 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (objects));
#line 2445 "DataCollection.c"
	{
		gint ctr;
#line 485 "DataCollection.vala"
		ctr = 0;
#line 2450 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 485 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 485 "DataCollection.vala"
			while (TRUE) {
#line 2457 "DataCollection.c"
				DataObject* object;
#line 485 "DataCollection.vala"
				if (!_tmp0_) {
#line 485 "DataCollection.vala"
					ctr++;
#line 2463 "DataCollection.c"
				}
#line 485 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 485 "DataCollection.vala"
				if (!(ctr < count)) {
#line 485 "DataCollection.vala"
					break;
#line 2471 "DataCollection.c"
				}
#line 486 "DataCollection.vala"
				object = (DataObject*) gee_list_get (objects, ctr);
#line 487 "DataCollection.vala"
				g_assert (data_collection_valid_type (self, object));
#line 489 "DataCollection.vala"
				data_object_internal_set_membership (object, self, self->priv->object_ordinal_generator++);
#line 491 "DataCollection.vala"
				if (monitor != NULL) {
#line 492 "DataCollection.vala"
					monitor ((guint64) ctr, (guint64) count, monitor_target);
#line 2483 "DataCollection.c"
				}
				_g_object_unref0 (object);
			}
		}
	}
#line 495 "DataCollection.vala"
	added = data_set_add_many (self->priv->dataset, objects);
#line 496 "DataCollection.vala"
	g_assert (added);
#line 2493 "DataCollection.c"
}


#line 499 "DataCollection.vala"
static void data_collection_internal_remove (DataCollection* self, DataObject* object) {
#line 2499 "DataCollection.c"
	gboolean removed;
#line 499 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 499 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 500 "DataCollection.vala"
	removed = data_set_remove (self->priv->dataset, object);
#line 501 "DataCollection.vala"
	g_assert (removed);
#line 503 "DataCollection.vala"
	data_object_internal_clear_membership (object);
#line 2511 "DataCollection.c"
}


#line 507 "DataCollection.vala"
gboolean data_collection_add (DataCollection* self, DataObject* object) {
#line 2517 "DataCollection.c"
	gboolean result = FALSE;
	GeeList* added;
#line 507 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 507 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 508 "DataCollection.vala"
	if (data_collection_internal_contains (self, object)) {
#line 2526 "DataCollection.c"
		char* _tmp1_;
		char* _tmp0_;
#line 509 "DataCollection.vala"
		g_debug ("DataCollection.vala:509: %s cannot add %s: already present", _tmp0_ = data_collection_to_string (self), _tmp1_ = data_object_to_string (object));
#line 2531 "DataCollection.c"
		_g_free0 (_tmp1_);
		_g_free0 (_tmp0_);
		result = FALSE;
#line 511 "DataCollection.vala"
		return result;
#line 2537 "DataCollection.c"
	}
#line 514 "DataCollection.vala"
	data_collection_internal_add (self, object);
#line 517 "DataCollection.vala"
	added = GEE_LIST (data_collection_get_singleton (object));
#line 518 "DataCollection.vala"
	data_collection_notify_items_added (self, GEE_ITERABLE (added));
#line 519 "DataCollection.vala"
	data_collection_notify_contents_altered (self, GEE_ITERABLE (added), NULL);
#line 522 "DataCollection.vala"
	data_object_notify_membership_changed (object, self);
#line 2549 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (added);
#line 524 "DataCollection.vala"
	return result;
#line 2554 "DataCollection.c"
}


#line 528 "DataCollection.vala"
gint data_collection_add_many (DataCollection* self, GeeIterable* objects, ProgressMonitor monitor, void* monitor_target) {
#line 2560 "DataCollection.c"
	gint result = 0;
	GeeArrayList* added;
	gint count;
#line 528 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), 0);
#line 528 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_ITERABLE (objects), 0);
#line 529 "DataCollection.vala"
	added = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2570 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (objects);
#line 530 "DataCollection.vala"
		while (TRUE) {
#line 2576 "DataCollection.c"
			DataObject* object;
#line 530 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 530 "DataCollection.vala"
				break;
#line 2582 "DataCollection.c"
			}
#line 530 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 531 "DataCollection.vala"
			if (data_collection_internal_contains (self, object)) {
#line 2588 "DataCollection.c"
				char* _tmp1_;
				char* _tmp0_;
#line 532 "DataCollection.vala"
				g_debug ("DataCollection.vala:532: %s cannot add %s: already present", _tmp0_ = data_collection_to_string (self), _tmp1_ = data_object_to_string (object));
#line 2593 "DataCollection.c"
				_g_free0 (_tmp1_);
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 534 "DataCollection.vala"
				continue;
#line 2599 "DataCollection.c"
			}
#line 537 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added), object);
#line 2603 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 540 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (added));
#line 541 "DataCollection.vala"
	if (count == 0) {
#line 2612 "DataCollection.c"
		result = 0;
		_g_object_unref0 (added);
#line 542 "DataCollection.vala"
		return result;
#line 2617 "DataCollection.c"
	}
#line 544 "DataCollection.vala"
	data_collection_internal_add_many (self, GEE_LIST (added), monitor, monitor_target);
#line 547 "DataCollection.vala"
	data_collection_notify_items_added (self, GEE_ITERABLE (added));
#line 548 "DataCollection.vala"
	data_collection_notify_contents_altered (self, GEE_ITERABLE (added), NULL);
#line 2625 "DataCollection.c"
	{
		gint ctr;
#line 551 "DataCollection.vala"
		ctr = 0;
#line 2630 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 551 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 551 "DataCollection.vala"
			while (TRUE) {
#line 2637 "DataCollection.c"
				DataObject* _tmp3_;
#line 551 "DataCollection.vala"
				if (!_tmp2_) {
#line 551 "DataCollection.vala"
					ctr++;
#line 2643 "DataCollection.c"
				}
#line 551 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 551 "DataCollection.vala"
				if (!(ctr < count)) {
#line 551 "DataCollection.vala"
					break;
#line 2651 "DataCollection.c"
				}
#line 552 "DataCollection.vala"
				data_object_notify_membership_changed (_tmp3_ = (DataObject*) gee_abstract_list_get (GEE_ABSTRACT_LIST (added), ctr), self);
#line 2655 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
			}
		}
	}
	result = count;
	_g_object_unref0 (added);
#line 554 "DataCollection.vala"
	return result;
#line 2664 "DataCollection.c"
}


#line 558 "DataCollection.vala"
Marker* data_collection_start_marking (DataCollection* self) {
#line 2670 "DataCollection.c"
	Marker* result = NULL;
#line 558 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 2674 "DataCollection.c"
	result = MARKER (data_collection_marker_impl_new (self));
#line 559 "DataCollection.vala"
	return result;
#line 2678 "DataCollection.c"
}


#line 563 "DataCollection.vala"
Marker* data_collection_mark (DataCollection* self, DataObject* object) {
#line 2684 "DataCollection.c"
	Marker* result = NULL;
	Marker* marker;
#line 563 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 563 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), NULL);
#line 564 "DataCollection.vala"
	marker = MARKER (data_collection_marker_impl_new (self));
#line 565 "DataCollection.vala"
	marker_mark (marker, object);
#line 2695 "DataCollection.c"
	result = marker;
#line 567 "DataCollection.vala"
	return result;
#line 2699 "DataCollection.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 572 "DataCollection.vala"
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user) {
#line 2710 "DataCollection.c"
	DataCollectionMarkerImpl* marker;
	guint64 count;
	guint64 total;
#line 572 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 572 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (m));
#line 572 "DataCollection.vala"
	g_return_if_fail ((user == NULL) || G_IS_OBJECT (user));
#line 574 "DataCollection.vala"
	marker = _g_object_ref0 (DATA_COLLECTION_MARKER_IMPL (m));
#line 576 "DataCollection.vala"
	g_assert (data_collection_marker_impl_is_valid (marker, self));
#line 579 "DataCollection.vala"
	data_collection_marker_impl_freeze (marker);
#line 581 "DataCollection.vala"
	count = (guint64) 0;
#line 582 "DataCollection.vala"
	total = (guint64) gee_collection_get_size (GEE_COLLECTION (marker->marked));
#line 2730 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 585 "DataCollection.vala"
		while (TRUE) {
#line 2736 "DataCollection.c"
			DataObject* object;
#line 585 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 585 "DataCollection.vala"
				break;
#line 2742 "DataCollection.c"
			}
#line 585 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 587 "DataCollection.vala"
			if (!data_collection_internal_contains (self, object)) {
#line 2748 "DataCollection.c"
				char* _tmp0_;
#line 588 "DataCollection.vala"
				g_warning ("DataCollection.vala:588: act_on_marked: marker holding ref to unknown " \
"%s", _tmp0_ = data_object_to_string (object));
#line 2752 "DataCollection.c"
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 590 "DataCollection.vala"
				continue;
#line 2757 "DataCollection.c"
			}
#line 593 "DataCollection.vala"
			if (!action (object, user, action_target)) {
#line 2761 "DataCollection.c"
				_g_object_unref0 (object);
#line 594 "DataCollection.vala"
				break;
#line 2765 "DataCollection.c"
			}
#line 596 "DataCollection.vala"
			if (monitor != NULL) {
#line 597 "DataCollection.vala"
				if (!monitor (count = count + 1, total, monitor_target)) {
#line 2771 "DataCollection.c"
					_g_object_unref0 (object);
#line 598 "DataCollection.vala"
					break;
#line 2775 "DataCollection.c"
				}
			}
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 603 "DataCollection.vala"
	data_collection_marker_impl_finished (marker);
#line 2784 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 608 "DataCollection.vala"
void data_collection_remove_marked (DataCollection* self, Marker* m) {
#line 2791 "DataCollection.c"
	DataCollectionMarkerImpl* marker;
#line 608 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 608 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (m));
#line 609 "DataCollection.vala"
	marker = _g_object_ref0 (DATA_COLLECTION_MARKER_IMPL (m));
#line 611 "DataCollection.vala"
	g_assert (data_collection_marker_impl_is_valid (marker, self));
#line 614 "DataCollection.vala"
	data_collection_marker_impl_freeze (marker);
#line 2803 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 617 "DataCollection.vala"
		while (TRUE) {
#line 2809 "DataCollection.c"
			DataObject* object;
#line 617 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 617 "DataCollection.vala"
				break;
#line 2815 "DataCollection.c"
			}
#line 617 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 619 "DataCollection.vala"
			if (!data_collection_internal_contains (self, object)) {
#line 2821 "DataCollection.c"
				char* _tmp0_;
#line 620 "DataCollection.vala"
				g_warning ("DataCollection.vala:620: remove_marked: marker holding ref to unknown " \
"%s", _tmp0_ = data_object_to_string (object));
#line 2825 "DataCollection.c"
				_g_free0 (_tmp0_);
				_g_object_unref0 (object);
#line 622 "DataCollection.vala"
				continue;
#line 2830 "DataCollection.c"
			}
#line 625 "DataCollection.vala"
			data_collection_internal_remove (self, object);
#line 2834 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 629 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (marker->marked)) > 0) {
#line 630 "DataCollection.vala"
		data_collection_notify_items_removed (self, GEE_ITERABLE (marker->marked));
#line 631 "DataCollection.vala"
		data_collection_notify_contents_altered (self, NULL, GEE_ITERABLE (marker->marked));
#line 2845 "DataCollection.c"
		{
			GeeIterator* _object_it;
			_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (marker->marked));
#line 634 "DataCollection.vala"
			while (TRUE) {
#line 2851 "DataCollection.c"
				DataObject* object;
#line 634 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 634 "DataCollection.vala"
					break;
#line 2857 "DataCollection.c"
				}
#line 634 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 635 "DataCollection.vala"
				data_object_notify_membership_changed (object, NULL);
#line 2863 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
#line 639 "DataCollection.vala"
	data_collection_marker_impl_finished (marker);
#line 2871 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 642 "DataCollection.vala"
void data_collection_clear (DataCollection* self) {
#line 2878 "DataCollection.c"
	GeeArrayList* removed;
#line 642 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 643 "DataCollection.vala"
	if (data_set_get_count (self->priv->dataset) == 0) {
#line 644 "DataCollection.vala"
		return;
#line 2886 "DataCollection.c"
	}
#line 648 "DataCollection.vala"
	removed = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 2890 "DataCollection.c"
	{
		gboolean _tmp0_;
#line 649 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 649 "DataCollection.vala"
		while (TRUE) {
#line 2897 "DataCollection.c"
			DataObject* object;
#line 649 "DataCollection.vala"
			if (!_tmp0_) {
#line 655 "DataCollection.vala"
				if (!(data_set_get_count (self->priv->dataset) > 0)) {
#line 655 "DataCollection.vala"
					break;
#line 2905 "DataCollection.c"
				}
			}
#line 649 "DataCollection.vala"
			_tmp0_ = FALSE;
#line 650 "DataCollection.vala"
			object = data_set_get_at (self->priv->dataset, 0);
#line 651 "DataCollection.vala"
			g_assert (object != NULL);
#line 653 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (removed), object);
#line 654 "DataCollection.vala"
			data_collection_internal_remove (self, object);
#line 2918 "DataCollection.c"
			_g_object_unref0 (object);
		}
	}
#line 658 "DataCollection.vala"
	data_collection_notify_items_removed (self, GEE_ITERABLE (removed));
#line 659 "DataCollection.vala"
	data_collection_notify_contents_altered (self, NULL, GEE_ITERABLE (removed));
#line 2926 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (removed));
#line 662 "DataCollection.vala"
		while (TRUE) {
#line 2932 "DataCollection.c"
			DataObject* object;
#line 662 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 662 "DataCollection.vala"
				break;
#line 2938 "DataCollection.c"
			}
#line 662 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 663 "DataCollection.vala"
			data_object_notify_membership_changed (object, NULL);
#line 2944 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	_g_object_unref0 (removed);
}


#line 672 "DataCollection.vala"
static void data_collection_real_close (DataCollection* self) {
#line 672 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 673 "DataCollection.vala"
	data_collection_clear (self);
#line 2959 "DataCollection.c"
}


#line 672 "DataCollection.vala"
void data_collection_close (DataCollection* self) {
#line 672 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->close (self);
#line 2967 "DataCollection.c"
}


#line 678 "DataCollection.vala"
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object) {
#line 2973 "DataCollection.c"
	gboolean resort_occurred;
	GeeArrayList* _tmp2_;
#line 678 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 678 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 679 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self, object));
#line 681 "DataCollection.vala"
	resort_occurred = data_set_resort_object (self->priv->dataset, object);
#line 683 "DataCollection.vala"
	if (data_collection_are_notifications_frozen (self)) {
#line 2986 "DataCollection.c"
		gboolean _tmp1_ = FALSE;
#line 684 "DataCollection.vala"
		if (self->priv->frozen_items_altered == NULL) {
#line 2990 "DataCollection.c"
			GeeHashSet* _tmp0_;
#line 685 "DataCollection.vala"
			self->priv->frozen_items_altered = (_tmp0_ = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_items_altered), _tmp0_);
#line 2994 "DataCollection.c"
		}
#line 686 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_items_altered), object);
#line 688 "DataCollection.vala"
		if (self->priv->fire_ordering_changed) {
#line 688 "DataCollection.vala"
			_tmp1_ = TRUE;
#line 3002 "DataCollection.c"
		} else {
#line 688 "DataCollection.vala"
			_tmp1_ = resort_occurred;
#line 3006 "DataCollection.c"
		}
#line 688 "DataCollection.vala"
		self->priv->fire_ordering_changed = _tmp1_;
#line 690 "DataCollection.vala"
		return;
#line 3012 "DataCollection.c"
	}
#line 693 "DataCollection.vala"
	if (resort_occurred) {
#line 694 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 3018 "DataCollection.c"
	}
#line 696 "DataCollection.vala"
	data_collection_notify_item_altered (self, object);
#line 697 "DataCollection.vala"
	data_collection_notify_items_altered (self, GEE_COLLECTION (_tmp2_ = data_collection_get_singleton (object)));
#line 3024 "DataCollection.c"
	_g_object_unref0 (_tmp2_);
}


#line 702 "DataCollection.vala"
void data_collection_internal_notify_metadata_altered (DataCollection* self, DataObject* object) {
#line 3031 "DataCollection.c"
	gboolean resort_occurred;
	GeeArrayList* _tmp3_;
#line 702 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 702 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 703 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self, object));
#line 705 "DataCollection.vala"
	resort_occurred = data_set_resort_object (self->priv->dataset, object);
#line 707 "DataCollection.vala"
	if (data_collection_are_notifications_frozen (self)) {
#line 3044 "DataCollection.c"
		GeeHashSet* _tmp1_;
		gboolean _tmp2_ = FALSE;
#line 708 "DataCollection.vala"
		if (self->priv->frozen_items_metadata_altered == NULL) {
#line 3049 "DataCollection.c"
			GeeHashSet* _tmp0_;
#line 709 "DataCollection.vala"
			self->priv->frozen_items_metadata_altered = (_tmp0_ = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_items_metadata_altered), _tmp0_);
#line 3053 "DataCollection.c"
		}
#line 710 "DataCollection.vala"
		self->priv->frozen_items_metadata_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_items_metadata_altered), _tmp1_);
#line 712 "DataCollection.vala"
		if (self->priv->fire_ordering_changed) {
#line 712 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 3061 "DataCollection.c"
		} else {
#line 712 "DataCollection.vala"
			_tmp2_ = resort_occurred;
#line 3065 "DataCollection.c"
		}
#line 712 "DataCollection.vala"
		self->priv->fire_ordering_changed = _tmp2_;
#line 714 "DataCollection.vala"
		return;
#line 3071 "DataCollection.c"
	}
#line 717 "DataCollection.vala"
	if (resort_occurred) {
#line 718 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 3077 "DataCollection.c"
	}
#line 720 "DataCollection.vala"
	data_collection_notify_item_metadata_altered (self, object);
#line 721 "DataCollection.vala"
	data_collection_notify_items_metadata_altered (self, GEE_COLLECTION (_tmp3_ = data_collection_get_singleton (object)));
#line 3083 "DataCollection.c"
	_g_object_unref0 (_tmp3_);
}


#line 724 "DataCollection.vala"
GValue* data_collection_get_property (DataCollection* self, const char* name) {
#line 3090 "DataCollection.c"
	GValue* result = NULL;
#line 724 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), NULL);
#line 724 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 3096 "DataCollection.c"
	result = (GValue*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->properties), name);
#line 725 "DataCollection.vala"
	return result;
#line 3100 "DataCollection.c"
}


#line 40 "util.vala"
static gboolean _bool_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self) {
#line 3106 "DataCollection.c"
	return bool_value_equals (a, b);
}


#line 44 "util.vala"
static gboolean _int_value_equals_value_equal_func (GValue* a, GValue* b, gpointer self) {
#line 3113 "DataCollection.c"
	return int_value_equals (a, b);
}


#line 728 "DataCollection.vala"
void data_collection_set_property (DataCollection* self, const char* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
#line 3120 "DataCollection.c"
	GValue* old;
	gint count;
#line 728 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 728 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 729 "DataCollection.vala"
	if (value_equals == NULL) {
#line 730 "DataCollection.vala"
		if (G_VALUE_HOLDS (val, G_TYPE_BOOLEAN)) {
#line 3131 "DataCollection.c"
			ValueEqualFunc _tmp0_;
#line 731 "DataCollection.vala"
			value_equals = (_tmp0_ = _bool_value_equals_value_equal_func, value_equals_target = NULL, _tmp0_);
#line 3135 "DataCollection.c"
		} else {
#line 732 "DataCollection.vala"
			if (G_VALUE_HOLDS (val, G_TYPE_INT)) {
#line 3139 "DataCollection.c"
				ValueEqualFunc _tmp1_;
#line 733 "DataCollection.vala"
				value_equals = (_tmp1_ = _int_value_equals_value_equal_func, value_equals_target = NULL, _tmp1_);
#line 3143 "DataCollection.c"
			} else {
#line 735 "DataCollection.vala"
				g_error ("DataCollection.vala:735: value_equals must be specified for this type");
#line 3147 "DataCollection.c"
			}
		}
	}
#line 738 "DataCollection.vala"
	old = (GValue*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->properties), name);
#line 739 "DataCollection.vala"
	if (old != NULL) {
#line 740 "DataCollection.vala"
		if (value_equals (old, val, value_equals_target)) {
#line 3157 "DataCollection.c"
			_g_free0 (old);
#line 741 "DataCollection.vala"
			return;
#line 3161 "DataCollection.c"
		}
	}
#line 744 "DataCollection.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->properties), name, val);
#line 746 "DataCollection.vala"
	data_collection_notify_property_set (self, name, old, val);
#line 749 "DataCollection.vala"
	count = data_set_get_count (self->priv->dataset);
#line 3170 "DataCollection.c"
	{
		gint ctr;
#line 750 "DataCollection.vala"
		ctr = 0;
#line 3175 "DataCollection.c"
		{
			gboolean _tmp2_;
#line 750 "DataCollection.vala"
			_tmp2_ = TRUE;
#line 750 "DataCollection.vala"
			while (TRUE) {
#line 3182 "DataCollection.c"
				DataObject* _tmp3_;
#line 750 "DataCollection.vala"
				if (!_tmp2_) {
#line 750 "DataCollection.vala"
					ctr++;
#line 3188 "DataCollection.c"
				}
#line 750 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 750 "DataCollection.vala"
				if (!(ctr < count)) {
#line 750 "DataCollection.vala"
					break;
#line 3196 "DataCollection.c"
				}
#line 751 "DataCollection.vala"
				data_object_notify_collection_property_set (_tmp3_ = data_set_get_at (self->priv->dataset, ctr), name, old, val);
#line 3200 "DataCollection.c"
				_g_object_unref0 (_tmp3_);
			}
		}
	}
	_g_free0 (old);
}


#line 754 "DataCollection.vala"
void data_collection_clear_property (DataCollection* self, const char* name) {
#line 3211 "DataCollection.c"
	gint count;
#line 754 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 754 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 755 "DataCollection.vala"
	if (!gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->properties), name, NULL)) {
#line 756 "DataCollection.vala"
		return;
#line 3221 "DataCollection.c"
	}
#line 759 "DataCollection.vala"
	data_collection_notify_property_cleared (self, name);
#line 762 "DataCollection.vala"
	count = data_set_get_count (self->priv->dataset);
#line 3227 "DataCollection.c"
	{
		gint ctr;
#line 763 "DataCollection.vala"
		ctr = 0;
#line 3232 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 763 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 763 "DataCollection.vala"
			while (TRUE) {
#line 3239 "DataCollection.c"
				DataObject* _tmp1_;
#line 763 "DataCollection.vala"
				if (!_tmp0_) {
#line 763 "DataCollection.vala"
					ctr++;
#line 3245 "DataCollection.c"
				}
#line 763 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 763 "DataCollection.vala"
				if (!(ctr < count)) {
#line 763 "DataCollection.vala"
					break;
#line 3253 "DataCollection.c"
				}
#line 764 "DataCollection.vala"
				data_object_notify_collection_property_cleared (_tmp1_ = data_set_get_at (self->priv->dataset, ctr), name);
#line 3257 "DataCollection.c"
				_g_object_unref0 (_tmp1_);
			}
		}
	}
}


#line 781 "DataCollection.vala"
void data_collection_freeze_notifications (DataCollection* self) {
#line 781 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 782 "DataCollection.vala"
	if ((self->priv->notifies_frozen++) == 0) {
#line 783 "DataCollection.vala"
		data_collection_frozen (self);
#line 3273 "DataCollection.c"
	}
}


#line 786 "DataCollection.vala"
void data_collection_thaw_notifications (DataCollection* self) {
#line 786 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 787 "DataCollection.vala"
	if (self->priv->notifies_frozen == 0) {
#line 788 "DataCollection.vala"
		return;
#line 3286 "DataCollection.c"
	}
#line 790 "DataCollection.vala"
	if ((self->priv->notifies_frozen = self->priv->notifies_frozen - 1) == 0) {
#line 791 "DataCollection.vala"
		data_collection_thawed (self);
#line 3292 "DataCollection.c"
	}
}


#line 794 "DataCollection.vala"
gboolean data_collection_are_notifications_frozen (DataCollection* self) {
#line 3299 "DataCollection.c"
	gboolean result = FALSE;
#line 794 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (self), FALSE);
#line 3303 "DataCollection.c"
	result = self->priv->notifies_frozen > 0;
#line 795 "DataCollection.vala"
	return result;
#line 3307 "DataCollection.c"
}


#line 800 "DataCollection.vala"
static void data_collection_real_frozen (DataCollection* self) {
#line 800 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 3315 "DataCollection.c"
}


#line 800 "DataCollection.vala"
void data_collection_frozen (DataCollection* self) {
#line 800 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->frozen (self);
#line 3323 "DataCollection.c"
}


#line 805 "DataCollection.vala"
static void data_collection_real_thawed (DataCollection* self) {
#line 805 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 806 "DataCollection.vala"
	if (self->priv->frozen_items_altered != NULL) {
#line 3333 "DataCollection.c"
		GeeHashSet* _tmp0_;
		{
			GeeIterator* _object_it;
			_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_items_altered));
#line 807 "DataCollection.vala"
			while (TRUE) {
#line 3340 "DataCollection.c"
				DataObject* object;
#line 807 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 807 "DataCollection.vala"
					break;
#line 3346 "DataCollection.c"
				}
#line 807 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 808 "DataCollection.vala"
				data_collection_notify_item_altered (self, object);
#line 3352 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
#line 809 "DataCollection.vala"
		data_collection_notify_items_altered (self, GEE_COLLECTION (self->priv->frozen_items_altered));
#line 810 "DataCollection.vala"
		self->priv->frozen_items_altered = (_tmp0_ = NULL, _g_object_unref0 (self->priv->frozen_items_altered), _tmp0_);
#line 3361 "DataCollection.c"
	}
#line 813 "DataCollection.vala"
	if (self->priv->frozen_items_metadata_altered != NULL) {
#line 3365 "DataCollection.c"
		GeeHashSet* _tmp1_;
		{
			GeeIterator* _object_it;
			_object_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_items_metadata_altered));
#line 814 "DataCollection.vala"
			while (TRUE) {
#line 3372 "DataCollection.c"
				DataObject* object;
#line 814 "DataCollection.vala"
				if (!gee_iterator_next (_object_it)) {
#line 814 "DataCollection.vala"
					break;
#line 3378 "DataCollection.c"
				}
#line 814 "DataCollection.vala"
				object = (DataObject*) gee_iterator_get (_object_it);
#line 815 "DataCollection.vala"
				data_collection_notify_item_metadata_altered (self, object);
#line 3384 "DataCollection.c"
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
#line 816 "DataCollection.vala"
		data_collection_notify_items_metadata_altered (self, GEE_COLLECTION (self->priv->frozen_items_metadata_altered));
#line 817 "DataCollection.vala"
		self->priv->frozen_items_metadata_altered = (_tmp1_ = NULL, _g_object_unref0 (self->priv->frozen_items_metadata_altered), _tmp1_);
#line 3393 "DataCollection.c"
	}
#line 820 "DataCollection.vala"
	if (self->priv->fire_ordering_changed) {
#line 821 "DataCollection.vala"
		self->priv->fire_ordering_changed = FALSE;
#line 822 "DataCollection.vala"
		data_collection_notify_ordering_changed (self);
#line 3401 "DataCollection.c"
	}
}


#line 805 "DataCollection.vala"
void data_collection_thawed (DataCollection* self) {
#line 805 "DataCollection.vala"
	DATA_COLLECTION_GET_CLASS (self)->thawed (self);
#line 3410 "DataCollection.c"
}


#line 306 "DataCollection.vala"
static void data_collection_real_items_added (DataCollection* self, GeeIterable* added) {
#line 306 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 306 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 3420 "DataCollection.c"
}


#line 310 "DataCollection.vala"
static void data_collection_real_items_removed (DataCollection* self, GeeIterable* removed) {
#line 310 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 310 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 3430 "DataCollection.c"
}


#line 314 "DataCollection.vala"
static void data_collection_real_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed) {
#line 314 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 314 "DataCollection.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 314 "DataCollection.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 3442 "DataCollection.c"
}


#line 321 "DataCollection.vala"
static void data_collection_real_item_altered (DataCollection* self, DataObject* item) {
#line 321 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 321 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (item));
#line 3452 "DataCollection.c"
}


#line 327 "DataCollection.vala"
static void data_collection_real_items_altered (DataCollection* self, GeeCollection* items) {
#line 327 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 327 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (items));
#line 3462 "DataCollection.c"
}


#line 333 "DataCollection.vala"
static void data_collection_real_item_metadata_altered (DataCollection* self, DataObject* object) {
#line 333 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 333 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 3472 "DataCollection.c"
}


#line 339 "DataCollection.vala"
static void data_collection_real_items_metadata_altered (DataCollection* self, GeeCollection* items) {
#line 339 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 339 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (items));
#line 3482 "DataCollection.c"
}


#line 344 "DataCollection.vala"
static void data_collection_real_ordering_changed (DataCollection* self) {
#line 344 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 3490 "DataCollection.c"
}


#line 349 "DataCollection.vala"
static void data_collection_real_property_set (DataCollection* self, const char* name, GValue* old, GValue* val) {
#line 349 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 349 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 3500 "DataCollection.c"
}


#line 353 "DataCollection.vala"
static void data_collection_real_property_cleared (DataCollection* self, const char* name) {
#line 353 "DataCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (self));
#line 353 "DataCollection.vala"
	g_return_if_fail (name != NULL);
#line 3510 "DataCollection.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


#line 275 "DataCollection.vala"
static void _data_collection_marker_impl_on_items_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 3521 "DataCollection.c"
	data_collection_marker_impl_on_items_removed (self, removed);
}


#line 240 "DataCollection.vala"
static DataCollectionMarkerImpl* data_collection_marker_impl_construct (GType object_type, DataCollection* owner) {
#line 3528 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	DataCollection* _tmp0_;
#line 240 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (owner), NULL);
#line 240 "DataCollection.vala"
	self = (DataCollectionMarkerImpl*) g_object_new (object_type, NULL);
#line 241 "DataCollection.vala"
	self->owner = (_tmp0_ = _data_collection_ref0 (owner), _data_collection_unref0 (self->owner), _tmp0_);
#line 245 "DataCollection.vala"
	g_signal_connect_object (owner, "items-removed", (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self, 0);
#line 3539 "DataCollection.c"
	return self;
}


#line 240 "DataCollection.vala"
static DataCollectionMarkerImpl* data_collection_marker_impl_new (DataCollection* owner) {
#line 240 "DataCollection.vala"
	return data_collection_marker_impl_construct (DATA_COLLECTION_TYPE_MARKER_IMPL, owner);
#line 3548 "DataCollection.c"
}


#line 252 "DataCollection.vala"
static void data_collection_marker_impl_real_mark (Marker* base, DataObject* object) {
#line 3554 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 252 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 253 "DataCollection.vala"
	g_assert (data_collection_internal_contains (self->owner, object));
#line 255 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 3563 "DataCollection.c"
}


#line 258 "DataCollection.vala"
static void data_collection_marker_impl_real_mark_many (Marker* base, GeeIterable* list) {
#line 3569 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
#line 258 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (list));
#line 3574 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (list);
#line 259 "DataCollection.vala"
		while (TRUE) {
#line 3580 "DataCollection.c"
			DataObject* object;
#line 259 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 259 "DataCollection.vala"
				break;
#line 3586 "DataCollection.c"
			}
#line 259 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 260 "DataCollection.vala"
			g_assert (data_collection_internal_contains (self->owner, object));
#line 262 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 3594 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 266 "DataCollection.vala"
static void data_collection_marker_impl_real_mark_all (Marker* base) {
#line 3604 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (base);
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
		_object_it = (_tmp1_ = gee_iterable_iterator (_tmp0_ = data_collection_get_all (self->owner)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 267 "DataCollection.vala"
		while (TRUE) {
#line 3614 "DataCollection.c"
			DataObject* object;
#line 267 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 267 "DataCollection.vala"
				break;
#line 3620 "DataCollection.c"
			}
#line 267 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 268 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 3626 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 271 "DataCollection.vala"
static gint data_collection_marker_impl_real_get_count (Marker* base) {
#line 3636 "DataCollection.c"
	DataCollectionMarkerImpl * self;
	gint result = 0;
	self = DATA_COLLECTION_MARKER_IMPL (base);
	result = gee_collection_get_size (GEE_COLLECTION (self->marked));
#line 272 "DataCollection.vala"
	return result;
#line 3643 "DataCollection.c"
}


#line 275 "DataCollection.vala"
static void data_collection_marker_impl_on_items_removed (DataCollectionMarkerImpl* self, GeeIterable* removed) {
#line 275 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 275 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 3653 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (removed);
#line 276 "DataCollection.vala"
		while (TRUE) {
#line 3659 "DataCollection.c"
			DataObject* object;
#line 276 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 276 "DataCollection.vala"
				break;
#line 3665 "DataCollection.c"
			}
#line 276 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 277 "DataCollection.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (self->marked), object);
#line 3671 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
}


#line 283 "DataCollection.vala"
static void data_collection_marker_impl_freeze (DataCollectionMarkerImpl* self) {
#line 3681 "DataCollection.c"
	guint _tmp0_;
#line 283 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 284 "DataCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 284 "DataCollection.vala"
	g_signal_handlers_disconnect_matched (self->owner, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self);
#line 3689 "DataCollection.c"
}


#line 287 "DataCollection.vala"
static void data_collection_marker_impl_finished (DataCollectionMarkerImpl* self) {
#line 3695 "DataCollection.c"
	GeeHashSet* _tmp0_;
#line 287 "DataCollection.vala"
	g_return_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self));
#line 288 "DataCollection.vala"
	self->marked = (_tmp0_ = NULL, _g_object_unref0 (self->marked), _tmp0_);
#line 3701 "DataCollection.c"
}


#line 291 "DataCollection.vala"
static gboolean data_collection_marker_impl_is_valid (DataCollectionMarkerImpl* self, DataCollection* collection) {
#line 3707 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 291 "DataCollection.vala"
	g_return_val_if_fail (DATA_COLLECTION_IS_MARKER_IMPL (self), FALSE);
#line 291 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_COLLECTION (collection), FALSE);
#line 292 "DataCollection.vala"
	if (collection == self->owner) {
#line 292 "DataCollection.vala"
		_tmp0_ = self->marked != NULL;
#line 3718 "DataCollection.c"
	} else {
#line 292 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 3722 "DataCollection.c"
	}
	result = _tmp0_;
#line 292 "DataCollection.vala"
	return result;
#line 3727 "DataCollection.c"
}


static void data_collection_marker_impl_class_init (DataCollectionMarkerImplClass * klass) {
	data_collection_marker_impl_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = data_collection_marker_impl_finalize;
}


static void data_collection_marker_impl_marker_interface_init (MarkerIface * iface) {
	data_collection_marker_impl_marker_parent_iface = g_type_interface_peek_parent (iface);
	iface->mark = data_collection_marker_impl_real_mark;
	iface->mark_many = data_collection_marker_impl_real_mark_many;
	iface->mark_all = data_collection_marker_impl_real_mark_all;
	iface->get_count = data_collection_marker_impl_real_get_count;
}


static void data_collection_marker_impl_instance_init (DataCollectionMarkerImpl * self) {
	self->marked = gee_hash_set_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
}


static void data_collection_marker_impl_finalize (GObject* obj) {
	DataCollectionMarkerImpl * self;
	self = DATA_COLLECTION_MARKER_IMPL (obj);
	{
		guint _tmp0_;
#line 249 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 249 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (self->owner, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _data_collection_marker_impl_on_items_removed_data_collection_items_removed, self);
#line 3760 "DataCollection.c"
	}
	_data_collection_unref0 (self->owner);
	_g_object_unref0 (self->marked);
	G_OBJECT_CLASS (data_collection_marker_impl_parent_class)->finalize (obj);
}


static GType data_collection_marker_impl_get_type (void) {
	static volatile gsize data_collection_marker_impl_type_id__volatile = 0;
	if (g_once_init_enter (&data_collection_marker_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataCollectionMarkerImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_collection_marker_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataCollectionMarkerImpl), 0, (GInstanceInitFunc) data_collection_marker_impl_instance_init, NULL };
		static const GInterfaceInfo marker_info = { (GInterfaceInitFunc) data_collection_marker_impl_marker_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType data_collection_marker_impl_type_id;
		data_collection_marker_impl_type_id = g_type_register_static (G_TYPE_OBJECT, "DataCollectionMarkerImpl", &g_define_type_info, 0);
		g_type_add_interface_static (data_collection_marker_impl_type_id, TYPE_MARKER, &marker_info);
		g_once_init_leave (&data_collection_marker_impl_type_id__volatile, data_collection_marker_impl_type_id);
	}
	return data_collection_marker_impl_type_id__volatile;
}


static void value_data_collection_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_data_collection_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		data_collection_unref (value->data[0].v_pointer);
	}
}


static void value_data_collection_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = data_collection_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_data_collection_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_data_collection_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DataCollection* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = data_collection_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_data_collection_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DataCollection** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = data_collection_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecDataCollection* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATA_COLLECTION), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_data_collection (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION), NULL);
	return value->data[0].v_pointer;
}


void value_set_data_collection (GValue* value, gpointer v_object) {
	DataCollection* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		data_collection_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_collection_unref (old);
	}
}


void value_take_data_collection (GValue* value, gpointer v_object) {
	DataCollection* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATA_COLLECTION));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATA_COLLECTION));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		data_collection_unref (old);
	}
}


static void data_collection_class_init (DataCollectionClass * klass) {
	data_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = data_collection_finalize;
	g_type_class_add_private (klass, sizeof (DataCollectionPrivate));
	DATA_COLLECTION_CLASS (klass)->to_string = data_collection_real_to_string;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = data_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = data_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->notify_contents_altered = data_collection_real_notify_contents_altered;
	DATA_COLLECTION_CLASS (klass)->notify_item_altered = data_collection_real_notify_item_altered;
	DATA_COLLECTION_CLASS (klass)->notify_items_altered = data_collection_real_notify_items_altered;
	DATA_COLLECTION_CLASS (klass)->notify_item_metadata_altered = data_collection_real_notify_item_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->notify_items_metadata_altered = data_collection_real_notify_items_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->notify_ordering_changed = data_collection_real_notify_ordering_changed;
	DATA_COLLECTION_CLASS (klass)->notify_property_set = data_collection_real_notify_property_set;
	DATA_COLLECTION_CLASS (klass)->notify_property_cleared = data_collection_real_notify_property_cleared;
	DATA_COLLECTION_CLASS (klass)->valid_type = data_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->set_comparator = data_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = data_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = data_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = data_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = data_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = data_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = data_collection_real_contains;
	DATA_COLLECTION_CLASS (klass)->close = data_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->frozen = data_collection_real_frozen;
	DATA_COLLECTION_CLASS (klass)->thawed = data_collection_real_thawed;
	DATA_COLLECTION_CLASS (klass)->items_added = data_collection_real_items_added;
	DATA_COLLECTION_CLASS (klass)->items_removed = data_collection_real_items_removed;
	DATA_COLLECTION_CLASS (klass)->contents_altered = data_collection_real_contents_altered;
	DATA_COLLECTION_CLASS (klass)->item_altered = data_collection_real_item_altered;
	DATA_COLLECTION_CLASS (klass)->items_altered = data_collection_real_items_altered;
	DATA_COLLECTION_CLASS (klass)->item_metadata_altered = data_collection_real_item_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->items_metadata_altered = data_collection_real_items_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->ordering_changed = data_collection_real_ordering_changed;
	DATA_COLLECTION_CLASS (klass)->property_set = data_collection_real_property_set;
	DATA_COLLECTION_CLASS (klass)->property_cleared = data_collection_real_property_cleared;
	g_signal_new ("items_added", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_added), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_removed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_removed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("contents_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_ITERABLE, GEE_TYPE_ITERABLE);
	g_signal_new ("item_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, item_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_OBJECT);
	g_signal_new ("items_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("item_metadata_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, item_metadata_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_OBJECT);
	g_signal_new ("items_metadata_altered", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, items_metadata_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("ordering_changed", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, ordering_changed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("property_set", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, property_set), NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_VALUE, G_TYPE_VALUE);
	g_signal_new ("property_cleared", TYPE_DATA_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DataCollectionClass, property_cleared), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void data_collection_instance_init (DataCollection * self) {
	self->priv = DATA_COLLECTION_GET_PRIVATE (self);
	self->priv->dataset = data_set_new ();
	self->priv->properties = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_VALUE, (GBoxedCopyFunc) _g_value_dup, g_free, NULL, NULL, NULL);
	self->priv->object_ordinal_generator = (gint64) 0;
	self->priv->notifies_frozen = 0;
	self->priv->frozen_items_altered = NULL;
	self->priv->frozen_items_metadata_altered = NULL;
	self->priv->fire_ordering_changed = FALSE;
	self->ref_count = 1;
}


static void data_collection_finalize (DataCollection* obj) {
	DataCollection * self;
	self = DATA_COLLECTION (obj);
	{
	}
	_g_free0 (self->priv->name);
	_data_set_unref0 (self->priv->dataset);
	_g_object_unref0 (self->priv->properties);
	_g_object_unref0 (self->priv->frozen_items_altered);
	_g_object_unref0 (self->priv->frozen_items_metadata_altered);
}


GType data_collection_get_type (void) {
	static volatile gsize data_collection_type_id__volatile = 0;
	if (g_once_init_enter (&data_collection_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_data_collection_init, value_data_collection_free_value, value_data_collection_copy_value, value_data_collection_peek_pointer, "p", value_data_collection_collect_value, "p", value_data_collection_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DataCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataCollection), 0, (GInstanceInitFunc) data_collection_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType data_collection_type_id;
		data_collection_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DataCollection", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&data_collection_type_id__volatile, data_collection_type_id);
	}
	return data_collection_type_id__volatile;
}


gpointer data_collection_ref (gpointer instance) {
	DataCollection* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void data_collection_unref (gpointer instance) {
	DataCollection* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DATA_COLLECTION_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 846 "DataCollection.vala"
SourceCollection* source_collection_construct (GType object_type, const char* name) {
#line 4001 "DataCollection.c"
	SourceCollection* self;
#line 846 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 847 "DataCollection.vala"
	self = (SourceCollection*) data_collection_construct (object_type, name);
#line 4007 "DataCollection.c"
	return self;
}


#line 846 "DataCollection.vala"
SourceCollection* source_collection_new (const char* name) {
#line 846 "DataCollection.vala"
	return source_collection_construct (TYPE_SOURCE_COLLECTION, name);
#line 4016 "DataCollection.c"
}


#line 850 "DataCollection.vala"
static void source_collection_real_notify_item_destroyed (SourceCollection* self, DataSource* source) {
#line 850 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 850 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 851 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-destroyed", source);
#line 4028 "DataCollection.c"
}


#line 850 "DataCollection.vala"
void source_collection_notify_item_destroyed (SourceCollection* self, DataSource* source) {
#line 850 "DataCollection.vala"
	SOURCE_COLLECTION_GET_CLASS (self)->notify_item_destroyed (self, source);
#line 4036 "DataCollection.c"
}


#line 854 "DataCollection.vala"
static gboolean source_collection_real_valid_type (DataCollection* base, DataObject* object) {
#line 4042 "DataCollection.c"
	SourceCollection * self;
	gboolean result = FALSE;
	self = SOURCE_COLLECTION (base);
#line 854 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 4048 "DataCollection.c"
	result = IS_DATA_SOURCE (object);
#line 855 "DataCollection.vala"
	return result;
#line 4052 "DataCollection.c"
}


#line 874 "DataCollection.vala"
static gboolean _source_collection_destroy_and_delete_source_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 4058 "DataCollection.c"
	return source_collection_destroy_and_delete_source (self, object, user);
}


#line 888 "DataCollection.vala"
static gboolean _source_collection_destroy_source_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 4065 "DataCollection.c"
	return source_collection_destroy_source (self, object, user);
}


#line 860 "DataCollection.vala"
gint source_collection_destroy_marked (SourceCollection* self, Marker* marker, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target) {
#line 4072 "DataCollection.c"
	gint result = 0;
	Marker* _tmp0_;
	SourceCollectionDestroyCounter* _tmp1_;
	SourceCollectionDestroyCounter* counter;
#line 860 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), 0);
#line 860 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (marker), 0);
#line 861 "DataCollection.vala"
	counter = (_tmp1_ = source_collection_destroy_counter_new (_tmp0_ = data_collection_start_marking (DATA_COLLECTION (self))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 863 "DataCollection.vala"
	if (delete_backing) {
#line 864 "DataCollection.vala"
		data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_destroy_and_delete_source_marked_action, self, monitor, monitor_target, G_OBJECT (counter));
#line 4087 "DataCollection.c"
	} else {
#line 866 "DataCollection.vala"
		data_collection_act_on_marked (DATA_COLLECTION (self), marker, _source_collection_destroy_source_marked_action, self, monitor, monitor_target, G_OBJECT (counter));
#line 4091 "DataCollection.c"
	}
#line 869 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), counter->remove_marker);
#line 4095 "DataCollection.c"
	result = counter->delete_failed;
	_g_object_unref0 (counter);
#line 871 "DataCollection.vala"
	return result;
#line 4100 "DataCollection.c"
}


#line 874 "DataCollection.vala"
static gboolean source_collection_destroy_and_delete_source (SourceCollection* self, DataObject* object, GObject* user) {
#line 4106 "DataCollection.c"
	gboolean result = FALSE;
	GError * _inner_error_;
	gboolean success;
#line 874 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 874 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 874 "DataCollection.vala"
	g_return_val_if_fail (G_IS_OBJECT (user), FALSE);
#line 4116 "DataCollection.c"
	_inner_error_ = NULL;
#line 875 "DataCollection.vala"
	success = FALSE;
#line 4120 "DataCollection.c"
	{
		gboolean _tmp0_;
#line 877 "DataCollection.vala"
		_tmp0_ = data_source_internal_delete_backing (DATA_SOURCE (object), &_inner_error_);
#line 4125 "DataCollection.c"
		if (_inner_error_ != NULL) {
			goto __catch117_g_error;
		}
#line 877 "DataCollection.vala"
		success = _tmp0_;
#line 4131 "DataCollection.c"
	}
	goto __finally117;
	__catch117_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 879 "DataCollection.vala"
			success = FALSE;
#line 4142 "DataCollection.c"
			_g_error_free0 (err);
		}
	}
	__finally117:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
#line 882 "DataCollection.vala"
	if (!success) {
#line 883 "DataCollection.vala"
		SOURCE_COLLECTION_DESTROY_COUNTER (user)->delete_failed++;
#line 4156 "DataCollection.c"
	}
	result = source_collection_destroy_source (self, object, user);
#line 885 "DataCollection.vala"
	return result;
#line 4161 "DataCollection.c"
}


#line 888 "DataCollection.vala"
static gboolean source_collection_destroy_source (SourceCollection* self, DataObject* object, GObject* user) {
#line 4167 "DataCollection.c"
	gboolean result = FALSE;
	DataSource* source;
#line 888 "DataCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (self), FALSE);
#line 888 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 888 "DataCollection.vala"
	g_return_val_if_fail (G_IS_OBJECT (user), FALSE);
#line 889 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 891 "DataCollection.vala"
	data_source_internal_mark_for_destroy (source);
#line 892 "DataCollection.vala"
	data_source_destroy (source);
#line 893 "DataCollection.vala"
	source_collection_notify_item_destroyed (self, source);
#line 895 "DataCollection.vala"
	marker_mark (SOURCE_COLLECTION_DESTROY_COUNTER (user)->remove_marker, DATA_OBJECT (source));
#line 4186 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (source);
#line 897 "DataCollection.vala"
	return result;
#line 4191 "DataCollection.c"
}


#line 843 "DataCollection.vala"
static void source_collection_real_item_destroyed (SourceCollection* self, DataSource* source) {
#line 843 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (self));
#line 843 "DataCollection.vala"
	g_return_if_fail (IS_DATA_SOURCE (source));
#line 4201 "DataCollection.c"
}


#line 836 "DataCollection.vala"
static SourceCollectionDestroyCounter* source_collection_destroy_counter_construct (GType object_type, Marker* remove_marker) {
#line 4207 "DataCollection.c"
	SourceCollectionDestroyCounter * self;
	Marker* _tmp0_;
#line 836 "DataCollection.vala"
	g_return_val_if_fail (IS_MARKER (remove_marker), NULL);
#line 836 "DataCollection.vala"
	self = (SourceCollectionDestroyCounter*) g_object_new (object_type, NULL);
#line 837 "DataCollection.vala"
	self->remove_marker = (_tmp0_ = _g_object_ref0 (remove_marker), _g_object_unref0 (self->remove_marker), _tmp0_);
#line 4216 "DataCollection.c"
	return self;
}


#line 836 "DataCollection.vala"
static SourceCollectionDestroyCounter* source_collection_destroy_counter_new (Marker* remove_marker) {
#line 836 "DataCollection.vala"
	return source_collection_destroy_counter_construct (SOURCE_COLLECTION_TYPE_DESTROY_COUNTER, remove_marker);
#line 4225 "DataCollection.c"
}


static void source_collection_destroy_counter_class_init (SourceCollectionDestroyCounterClass * klass) {
	source_collection_destroy_counter_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = source_collection_destroy_counter_finalize;
}


static void source_collection_destroy_counter_instance_init (SourceCollectionDestroyCounter * self) {
	self->delete_failed = 0;
}


static void source_collection_destroy_counter_finalize (GObject* obj) {
	SourceCollectionDestroyCounter * self;
	self = SOURCE_COLLECTION_DESTROY_COUNTER (obj);
	_g_object_unref0 (self->remove_marker);
	G_OBJECT_CLASS (source_collection_destroy_counter_parent_class)->finalize (obj);
}


static GType source_collection_destroy_counter_get_type (void) {
	static volatile gsize source_collection_destroy_counter_type_id__volatile = 0;
	if (g_once_init_enter (&source_collection_destroy_counter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceCollectionDestroyCounterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_collection_destroy_counter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceCollectionDestroyCounter), 0, (GInstanceInitFunc) source_collection_destroy_counter_instance_init, NULL };
		GType source_collection_destroy_counter_type_id;
		source_collection_destroy_counter_type_id = g_type_register_static (G_TYPE_OBJECT, "SourceCollectionDestroyCounter", &g_define_type_info, 0);
		g_once_init_leave (&source_collection_destroy_counter_type_id__volatile, source_collection_destroy_counter_type_id);
	}
	return source_collection_destroy_counter_type_id__volatile;
}


static void source_collection_class_init (SourceCollectionClass * klass) {
	source_collection_parent_class = g_type_class_peek_parent (klass);
	SOURCE_COLLECTION_CLASS (klass)->notify_item_destroyed = source_collection_real_notify_item_destroyed;
	DATA_COLLECTION_CLASS (klass)->valid_type = source_collection_real_valid_type;
	SOURCE_COLLECTION_CLASS (klass)->item_destroyed = source_collection_real_item_destroyed;
	g_signal_new ("item_destroyed", TYPE_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceCollectionClass, item_destroyed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_SOURCE);
}


static void source_collection_instance_init (SourceCollection * self) {
}


GType source_collection_get_type (void) {
	static volatile gsize source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceCollection), 0, (GInstanceInitFunc) source_collection_instance_init, NULL };
		GType source_collection_type_id;
		source_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "SourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&source_collection_type_id__volatile, source_collection_type_id);
	}
	return source_collection_type_id__volatile;
}


#line 7 "util.vala"
static guint _int64_hash_ghash_func (void* key) {
#line 4287 "DataCollection.c"
	return int64_hash (key);
}


#line 18 "util.vala"
static gboolean _int64_equal_gequal_func (void* a, void* b) {
#line 4294 "DataCollection.c"
	return int64_equal (a, b);
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}


#line 911 "DataCollection.vala"
DatabaseSourceCollection* database_source_collection_construct (GType object_type, const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
#line 4309 "DataCollection.c"
	DatabaseSourceCollection* self;
	GetSourceDatabaseKey _tmp0_;
#line 911 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 912 "DataCollection.vala"
	self = (DatabaseSourceCollection*) source_collection_construct (object_type, name);
#line 914 "DataCollection.vala"
	self->priv->source_key_func = (_tmp0_ = source_key_func, ((self->priv->source_key_func_target_destroy_notify == NULL) ? NULL : (self->priv->source_key_func_target_destroy_notify (self->priv->source_key_func_target), NULL), self->priv->source_key_func = NULL, self->priv->source_key_func_target = NULL, self->priv->source_key_func_target_destroy_notify = NULL), self->priv->source_key_func_target = source_key_func_target, self->priv->source_key_func_target_destroy_notify = NULL, _tmp0_);
#line 4318 "DataCollection.c"
	return self;
}


#line 911 "DataCollection.vala"
DatabaseSourceCollection* database_source_collection_new (const char* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target) {
#line 911 "DataCollection.vala"
	return database_source_collection_construct (TYPE_DATABASE_SOURCE_COLLECTION, name, source_key_func, source_key_func_target);
#line 4327 "DataCollection.c"
}


#line 917 "DataCollection.vala"
static void database_source_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
#line 4333 "DataCollection.c"
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (base);
#line 917 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 4338 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (added);
#line 918 "DataCollection.vala"
		while (TRUE) {
#line 4344 "DataCollection.c"
			DataObject* object;
			DataSource* source;
			gint64 key;
#line 918 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 918 "DataCollection.vala"
				break;
#line 4352 "DataCollection.c"
			}
#line 918 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 919 "DataCollection.vala"
			source = _g_object_ref0 (DATA_SOURCE (object));
#line 920 "DataCollection.vala"
			key = self->priv->source_key_func (source, self->priv->source_key_func_target);
#line 922 "DataCollection.vala"
			g_assert (!gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->map), &key));
#line 924 "DataCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), &key, source);
#line 4364 "DataCollection.c"
			_g_object_unref0 (object);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_object_it);
	}
#line 927 "DataCollection.vala"
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->notify_items_added (DATA_COLLECTION (SOURCE_COLLECTION (self)), added);
#line 4372 "DataCollection.c"
}


#line 930 "DataCollection.vala"
static void database_source_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
#line 4378 "DataCollection.c"
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (base);
#line 930 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 4383 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (removed);
#line 931 "DataCollection.vala"
		while (TRUE) {
#line 4389 "DataCollection.c"
			DataObject* object;
			gint64 key;
			gboolean is_removed;
#line 931 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 931 "DataCollection.vala"
				break;
#line 4397 "DataCollection.c"
			}
#line 931 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 932 "DataCollection.vala"
			key = self->priv->source_key_func (DATA_SOURCE (object), self->priv->source_key_func_target);
#line 934 "DataCollection.vala"
			is_removed = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), &key, NULL);
#line 935 "DataCollection.vala"
			g_assert (is_removed);
#line 4407 "DataCollection.c"
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
#line 938 "DataCollection.vala"
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->notify_items_removed (DATA_COLLECTION (SOURCE_COLLECTION (self)), removed);
#line 4414 "DataCollection.c"
}


#line 941 "DataCollection.vala"
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key) {
#line 4420 "DataCollection.c"
	DataSource* result = NULL;
#line 941 "DataCollection.vala"
	g_return_val_if_fail (IS_DATABASE_SOURCE_COLLECTION (self), NULL);
#line 4424 "DataCollection.c"
	result = (DataSource*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), &key);
#line 942 "DataCollection.vala"
	return result;
#line 4428 "DataCollection.c"
}


static void database_source_collection_class_init (DatabaseSourceCollectionClass * klass) {
	database_source_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = database_source_collection_finalize;
	g_type_class_add_private (klass, sizeof (DatabaseSourceCollectionPrivate));
	DATA_COLLECTION_CLASS (klass)->notify_items_added = database_source_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = database_source_collection_real_notify_items_removed;
}


static void database_source_collection_instance_init (DatabaseSourceCollection * self) {
	self->priv = DATABASE_SOURCE_COLLECTION_GET_PRIVATE (self);
	self->priv->map = gee_hash_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_hash_ghash_func, _int64_equal_gequal_func, g_direct_equal);
}


static void database_source_collection_finalize (DataCollection* obj) {
	DatabaseSourceCollection * self;
	self = DATABASE_SOURCE_COLLECTION (obj);
	(self->priv->source_key_func_target_destroy_notify == NULL) ? NULL : (self->priv->source_key_func_target_destroy_notify (self->priv->source_key_func_target), NULL);
	self->priv->source_key_func = NULL;
	self->priv->source_key_func_target = NULL;
	self->priv->source_key_func_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->map);
	DATA_COLLECTION_CLASS (database_source_collection_parent_class)->finalize (obj);
}


GType database_source_collection_get_type (void) {
	static volatile gsize database_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&database_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseSourceCollection), 0, (GInstanceInitFunc) database_source_collection_instance_init, NULL };
		GType database_source_collection_type_id;
		database_source_collection_type_id = g_type_register_static (TYPE_SOURCE_COLLECTION, "DatabaseSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&database_source_collection_type_id__volatile, database_source_collection_type_id);
	}
	return database_source_collection_type_id__volatile;
}


#line 956 "DataCollection.vala"
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source) {
#line 4473 "DataCollection.c"
	gboolean result = FALSE;
#line 956 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), FALSE);
#line 956 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 4479 "DataCollection.c"
	result = TRUE;
#line 957 "DataCollection.vala"
	return result;
#line 4483 "DataCollection.c"
}


#line 956 "DataCollection.vala"
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source) {
#line 956 "DataCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
#line 4491 "DataCollection.c"
}


#line 962 "DataCollection.vala"
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source) {
#line 4497 "DataCollection.c"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 962 "DataCollection.vala"
DataView* view_manager_create_view (ViewManager* self, DataSource* source) {
#line 962 "DataCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
#line 4508 "DataCollection.c"
}


#line 952 "DataCollection.vala"
ViewManager* view_manager_construct (GType object_type) {
#line 4514 "DataCollection.c"
	ViewManager* self;
	self = (ViewManager*) g_type_create_instance (object_type);
	return self;
}


static void value_view_manager_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_view_manager_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		view_manager_unref (value->data[0].v_pointer);
	}
}


static void value_view_manager_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_view_manager_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_view_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ViewManager* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = view_manager_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_view_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewManager** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = view_manager_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewManager* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_view_manager (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
	return value->data[0].v_pointer;
}


void value_set_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		view_manager_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


void value_take_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		view_manager_unref (old);
	}
}


static void view_manager_class_init (ViewManagerClass * klass) {
	view_manager_parent_class = g_type_class_peek_parent (klass);
	VIEW_MANAGER_CLASS (klass)->finalize = view_manager_finalize;
	VIEW_MANAGER_CLASS (klass)->include_in_view = view_manager_real_include_in_view;
	VIEW_MANAGER_CLASS (klass)->create_view = view_manager_real_create_view;
}


static void view_manager_instance_init (ViewManager * self) {
	self->ref_count = 1;
}


static void view_manager_finalize (ViewManager* obj) {
	ViewManager * self;
	self = VIEW_MANAGER (obj);
}


GType view_manager_get_type (void) {
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}


gpointer view_manager_ref (gpointer instance) {
	ViewManager* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void view_manager_unref (gpointer instance) {
	ViewManager* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


#line 1045 "DataCollection.vala"
ViewCollection* view_collection_construct (GType object_type, const char* name) {
#line 4684 "DataCollection.c"
	ViewCollection* self;
#line 1045 "DataCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1046 "DataCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, name);
#line 4690 "DataCollection.c"
	return self;
}


#line 1045 "DataCollection.vala"
ViewCollection* view_collection_new (const char* name) {
#line 1045 "DataCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 4699 "DataCollection.c"
}


#line 1049 "DataCollection.vala"
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 1049 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1049 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1050 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-view-altered", view);
#line 4711 "DataCollection.c"
}


#line 1049 "DataCollection.vala"
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 1049 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_view_altered (self, view);
#line 4719 "DataCollection.c"
}


#line 1053 "DataCollection.vala"
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1053 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1053 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 1054 "DataCollection.vala"
	g_signal_emit_by_name (self, "views-altered", views);
#line 4731 "DataCollection.c"
}


#line 1053 "DataCollection.vala"
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1053 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_views_altered (self, views);
#line 4739 "DataCollection.c"
}


#line 1057 "DataCollection.vala"
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1057 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1057 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1058 "DataCollection.vala"
	g_signal_emit_by_name (self, "item-geometry-altered", view);
#line 4751 "DataCollection.c"
}


#line 1057 "DataCollection.vala"
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1057 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_geometry_altered (self, view);
#line 4759 "DataCollection.c"
}


#line 1061 "DataCollection.vala"
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1061 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1061 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 1062 "DataCollection.vala"
	g_signal_emit_by_name (self, "geometries-altered", views);
#line 4771 "DataCollection.c"
}


#line 1061 "DataCollection.vala"
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1061 "DataCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_geometries_altered (self, views);
#line 4779 "DataCollection.c"
}


#line 1065 "DataCollection.vala"
static void view_collection_real_close (DataCollection* base) {
#line 4785 "DataCollection.c"
	ViewCollection * self;
	ViewFilter _tmp0_;
	self = VIEW_COLLECTION (base);
#line 1066 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1067 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1068 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = NULL, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1070 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (DATA_COLLECTION (self));
#line 4797 "DataCollection.c"
}


static gpointer _view_manager_ref0 (gpointer self) {
	return self ? view_manager_ref (self) : NULL;
}


#line 1205 "DataCollection.vala"
static void _view_collection_on_sources_added_data_collection_items_added (SourceCollection* _sender, GeeIterable* added, gpointer self) {
#line 4808 "DataCollection.c"
	view_collection_on_sources_added (self, added);
}


#line 1222 "DataCollection.vala"
static void _view_collection_on_sources_removed_data_collection_items_removed (SourceCollection* _sender, GeeIterable* removed, gpointer self) {
#line 4815 "DataCollection.c"
	view_collection_on_sources_removed (self, removed);
}


#line 1236 "DataCollection.vala"
static void _view_collection_on_source_altered_data_collection_item_altered (SourceCollection* _sender, DataObject* item, gpointer self) {
#line 4822 "DataCollection.c"
	view_collection_on_source_altered (self, item);
}


#line 1236 "DataCollection.vala"
static void _view_collection_on_source_altered_data_collection_item_metadata_altered (SourceCollection* _sender, DataObject* object, gpointer self) {
#line 4829 "DataCollection.c"
	view_collection_on_source_altered (self, object);
}


#line 1073 "DataCollection.vala"
void view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, GeeIterable* initial, ProgressMonitor monitor, void* monitor_target) {
#line 4836 "DataCollection.c"
	SourceCollection* _tmp0_;
	ViewManager* _tmp1_;
#line 1073 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1073 "DataCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 1073 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_MANAGER (manager));
#line 1073 "DataCollection.vala"
	g_return_if_fail ((initial == NULL) || GEE_IS_ITERABLE (initial));
#line 1075 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1076 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1077 "DataCollection.vala"
	data_collection_clear (DATA_COLLECTION (self));
#line 1079 "DataCollection.vala"
	self->priv->sources = (_tmp0_ = _data_collection_ref0 (sources), _data_collection_unref0 (self->priv->sources), _tmp0_);
#line 1080 "DataCollection.vala"
	self->priv->manager = (_tmp1_ = _view_manager_ref0 (manager), _view_manager_unref0 (self->priv->manager), _tmp1_);
#line 1082 "DataCollection.vala"
	if (initial != NULL) {
#line 4859 "DataCollection.c"
		GeeArrayList* created_views;
#line 1084 "DataCollection.vala"
		created_views = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 4863 "DataCollection.c"
		{
			GeeIterator* _source_it;
			_source_it = gee_iterable_iterator (initial);
#line 1085 "DataCollection.vala"
			while (TRUE) {
#line 4869 "DataCollection.c"
				DataSource* source;
				DataView* _tmp2_;
#line 1085 "DataCollection.vala"
				if (!gee_iterator_next (_source_it)) {
#line 1085 "DataCollection.vala"
					break;
#line 4876 "DataCollection.c"
				}
#line 1085 "DataCollection.vala"
				source = (DataSource*) gee_iterator_get (_source_it);
#line 1086 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), _tmp2_ = view_manager_create_view (manager, source));
#line 4882 "DataCollection.c"
				_g_object_unref0 (_tmp2_);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
#line 1088 "DataCollection.vala"
		data_collection_add_many (DATA_COLLECTION (self), GEE_ITERABLE (created_views), monitor, monitor_target);
#line 4890 "DataCollection.c"
		_g_object_unref0 (created_views);
	} else {
		GeeIterable* _tmp3_;
#line 1091 "DataCollection.vala"
		view_collection_add_sources (self, _tmp3_ = GEE_ITERABLE (data_collection_get_all (DATA_COLLECTION (sources))), monitor, monitor_target);
#line 4896 "DataCollection.c"
		_g_object_unref0 (_tmp3_);
	}
#line 1096 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, self);
#line 1097 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, self);
#line 1098 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "item-altered", (GCallback) _view_collection_on_source_altered_data_collection_item_altered, self);
#line 1099 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (sources), "item-metadata-altered", (GCallback) _view_collection_on_source_altered_data_collection_item_metadata_altered, self);
#line 4907 "DataCollection.c"
}


#line 1102 "DataCollection.vala"
void view_collection_halt_monitoring (ViewCollection* self) {
#line 4913 "DataCollection.c"
	SourceCollection* _tmp4_;
	ViewManager* _tmp5_;
#line 1102 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1103 "DataCollection.vala"
	if (self->priv->sources != NULL) {
#line 4920 "DataCollection.c"
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 1104 "DataCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1104 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, self);
#line 1105 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1105 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, self);
#line 1106 "DataCollection.vala"
		g_signal_parse_name ("item-altered", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 1106 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_source_altered_data_collection_item_altered, self);
#line 1107 "DataCollection.vala"
		g_signal_parse_name ("item-metadata-altered", TYPE_DATA_COLLECTION, &_tmp3_, NULL, FALSE);
#line 1107 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _view_collection_on_source_altered_data_collection_item_metadata_altered, self);
#line 4941 "DataCollection.c"
	}
#line 1110 "DataCollection.vala"
	self->priv->sources = (_tmp4_ = NULL, _data_collection_unref0 (self->priv->sources), _tmp4_);
#line 1111 "DataCollection.vala"
	self->priv->manager = (_tmp5_ = NULL, _view_manager_unref0 (self->priv->manager), _tmp5_);
#line 4947 "DataCollection.c"
}


#line 1260 "DataCollection.vala"
static void _view_collection_on_mirror_contents_added_data_collection_items_added (ViewCollection* _sender, GeeIterable* added, gpointer self) {
#line 4953 "DataCollection.c"
	view_collection_on_mirror_contents_added (self, added);
}


#line 1272 "DataCollection.vala"
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (ViewCollection* _sender, GeeIterable* removed, gpointer self) {
#line 4960 "DataCollection.c"
	view_collection_on_mirror_contents_removed (self, removed);
}


#line 1114 "DataCollection.vala"
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target) {
#line 4967 "DataCollection.c"
	ViewCollection* _tmp0_;
	CreateView _tmp1_;
	GeeIterable* _tmp2_;
#line 1114 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1114 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_mirror));
#line 1115 "DataCollection.vala"
	view_collection_halt_mirroring (self);
#line 1116 "DataCollection.vala"
	view_collection_halt_monitoring (self);
#line 1117 "DataCollection.vala"
	data_collection_clear (DATA_COLLECTION (self));
#line 1119 "DataCollection.vala"
	self->priv->mirroring = (_tmp0_ = _data_collection_ref0 (to_mirror), _data_collection_unref0 (self->priv->mirroring), _tmp0_);
#line 1120 "DataCollection.vala"
	self->priv->mirroring_ctor = (_tmp1_ = mirroring_ctor, ((self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL), self->priv->mirroring_ctor = NULL, self->priv->mirroring_ctor_target = NULL, self->priv->mirroring_ctor_target_destroy_notify = NULL), self->priv->mirroring_ctor_target = mirroring_ctor_target, self->priv->mirroring_ctor_target_destroy_notify = NULL, _tmp1_);
#line 1123 "DataCollection.vala"
	view_collection_on_mirror_contents_added (self, _tmp2_ = data_collection_get_all (DATA_COLLECTION (self->priv->mirroring)));
#line 4987 "DataCollection.c"
	_g_object_unref0 (_tmp2_);
#line 1125 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 1126 "DataCollection.vala"
	g_signal_connect (DATA_COLLECTION (self->priv->mirroring), "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 4993 "DataCollection.c"
}


#line 1129 "DataCollection.vala"
void view_collection_halt_mirroring (ViewCollection* self) {
#line 4999 "DataCollection.c"
	ViewCollection* _tmp2_;
#line 1129 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1130 "DataCollection.vala"
	if (self->priv->mirroring != NULL) {
#line 5005 "DataCollection.c"
		guint _tmp0_;
		guint _tmp1_;
#line 1131 "DataCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp0_, NULL, FALSE);
#line 1131 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 1132 "DataCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
#line 1132 "DataCollection.vala"
		g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->mirroring), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 5016 "DataCollection.c"
	}
#line 1135 "DataCollection.vala"
	self->priv->mirroring = (_tmp2_ = NULL, _data_collection_unref0 (self->priv->mirroring), _tmp2_);
#line 5020 "DataCollection.c"
}


#line 1138 "DataCollection.vala"
void view_collection_install_view_filter (ViewCollection* self, ViewFilter filter, void* filter_target) {
#line 5026 "DataCollection.c"
	ViewFilter _tmp0_;
#line 1138 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1139 "DataCollection.vala"
	if (self->priv->filter == filter) {
#line 1140 "DataCollection.vala"
		return;
#line 5034 "DataCollection.c"
	}
#line 1143 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = filter, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = filter_target, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1146 "DataCollection.vala"
	view_collection_reapply_view_filter (self);
#line 5040 "DataCollection.c"
}


#line 1151 "DataCollection.vala"
void view_collection_reapply_view_filter (ViewCollection* self) {
#line 5046 "DataCollection.c"
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
#line 1151 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1152 "DataCollection.vala"
	if (self->priv->filter == NULL) {
#line 1153 "DataCollection.vala"
		return;
#line 5055 "DataCollection.c"
	}
#line 1158 "DataCollection.vala"
	to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1159 "DataCollection.vala"
	to_hide = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 5061 "DataCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
		_object_it = (_tmp1_ = gee_iterable_iterator (_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1162 "DataCollection.vala"
		while (TRUE) {
#line 5069 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 1162 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1162 "DataCollection.vala"
				break;
#line 5076 "DataCollection.c"
			}
#line 1162 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1163 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1165 "DataCollection.vala"
			if (self->priv->filter (view, self->priv->filter_target)) {
#line 1166 "DataCollection.vala"
				if (!data_view_is_visible (view)) {
#line 1167 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), DATA_VIEW (object));
#line 5088 "DataCollection.c"
				}
			} else {
#line 1169 "DataCollection.vala"
				if (data_view_is_visible (view)) {
#line 1170 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), DATA_VIEW (object));
#line 5095 "DataCollection.c"
				}
			}
			_g_object_unref0 (object);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_object_it);
	}
#line 1174 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_show)) > 0) {
#line 1175 "DataCollection.vala"
		view_collection_show_items (self, GEE_LIST (to_show));
#line 5107 "DataCollection.c"
	}
#line 1177 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_hide)) > 0) {
#line 1178 "DataCollection.vala"
		view_collection_hide_items (self, GEE_LIST (to_hide));
#line 5113 "DataCollection.c"
	}
	_g_object_unref0 (to_show);
	_g_object_unref0 (to_hide);
}


#line 1181 "DataCollection.vala"
void view_collection_reset_view_filter (ViewCollection* self) {
#line 5122 "DataCollection.c"
	ViewFilter _tmp0_;
	GeeArrayList* to_show;
#line 1181 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1182 "DataCollection.vala"
	self->priv->filter = (_tmp0_ = NULL, ((self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL), self->priv->filter = NULL, self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL), self->priv->filter_target = NULL, self->priv->filter_target_destroy_notify = NULL, _tmp0_);
#line 1186 "DataCollection.vala"
	to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 5131 "DataCollection.c"
	{
		GeeIterable* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _object_it;
		_object_it = (_tmp2_ = gee_iterable_iterator (_tmp1_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self))), _g_object_unref0 (_tmp1_), _tmp2_);
#line 1187 "DataCollection.vala"
		while (TRUE) {
#line 5139 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 1187 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1187 "DataCollection.vala"
				break;
#line 5146 "DataCollection.c"
			}
#line 1187 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1188 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1189 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 1190 "DataCollection.vala"
				g_assert (view_collection_is_visible (self, view));
#line 5156 "DataCollection.c"
				_g_object_unref0 (object);
				_g_object_unref0 (view);
#line 1192 "DataCollection.vala"
				continue;
#line 5161 "DataCollection.c"
			}
#line 1195 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
#line 5165 "DataCollection.c"
			_g_object_unref0 (object);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_object_it);
	}
#line 1198 "DataCollection.vala"
	view_collection_show_items (self, GEE_LIST (to_show));
#line 5173 "DataCollection.c"
	_g_object_unref0 (to_show);
}


#line 1201 "DataCollection.vala"
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object) {
#line 5180 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
#line 1201 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 5186 "DataCollection.c"
	result = IS_DATA_VIEW (object);
#line 1202 "DataCollection.vala"
	return result;
#line 5190 "DataCollection.c"
}


#line 1205 "DataCollection.vala"
static void view_collection_on_sources_added (ViewCollection* self, GeeIterable* added) {
#line 1205 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1205 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1206 "DataCollection.vala"
	view_collection_add_sources (self, added, NULL, NULL);
#line 5202 "DataCollection.c"
}


#line 1209 "DataCollection.vala"
static void view_collection_add_sources (ViewCollection* self, GeeIterable* added, ProgressMonitor monitor, void* monitor_target) {
#line 5208 "DataCollection.c"
	GeeArrayList* created_views;
#line 1209 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1209 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1212 "DataCollection.vala"
	created_views = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 5216 "DataCollection.c"
	{
		GeeIterator* _source_it;
		_source_it = gee_iterable_iterator (added);
#line 1213 "DataCollection.vala"
		while (TRUE) {
#line 5222 "DataCollection.c"
			DataSource* source;
#line 1213 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1213 "DataCollection.vala"
				break;
#line 5228 "DataCollection.c"
			}
#line 1213 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1214 "DataCollection.vala"
			if (view_manager_include_in_view (self->priv->manager, source)) {
#line 5234 "DataCollection.c"
				DataView* _tmp0_;
#line 1215 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (created_views), _tmp0_ = view_manager_create_view (self->priv->manager, source));
#line 5238 "DataCollection.c"
				_g_object_unref0 (_tmp0_);
			}
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
#line 1218 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (created_views)) > 0) {
#line 1219 "DataCollection.vala"
		data_collection_add_many (DATA_COLLECTION (self), GEE_ITERABLE (created_views), monitor, monitor_target);
#line 5249 "DataCollection.c"
	}
	_g_object_unref0 (created_views);
}


#line 1222 "DataCollection.vala"
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed) {
#line 5257 "DataCollection.c"
	Marker* marker;
#line 1222 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1222 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 1224 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 5265 "DataCollection.c"
	{
		GeeIterator* _source_it;
		_source_it = gee_iterable_iterator (removed);
#line 1225 "DataCollection.vala"
		while (TRUE) {
#line 5271 "DataCollection.c"
			DataSource* source;
			DataView* view;
#line 1225 "DataCollection.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1225 "DataCollection.vala"
				break;
#line 5278 "DataCollection.c"
			}
#line 1225 "DataCollection.vala"
			source = (DataSource*) gee_iterator_get (_source_it);
#line 1226 "DataCollection.vala"
			view = (DataView*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 1229 "DataCollection.vala"
			if (view != NULL) {
#line 1230 "DataCollection.vala"
				marker_mark (marker, DATA_OBJECT (view));
#line 5288 "DataCollection.c"
			}
			_g_object_unref0 (source);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_source_it);
	}
#line 1233 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 5297 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 1236 "DataCollection.vala"
static void view_collection_on_source_altered (ViewCollection* self, DataObject* object) {
#line 5304 "DataCollection.c"
	DataSource* source;
	gboolean include;
	gboolean _tmp0_ = FALSE;
#line 1236 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1236 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1237 "DataCollection.vala"
	source = _g_object_ref0 (DATA_SOURCE (object));
#line 1241 "DataCollection.vala"
	include = view_manager_include_in_view (self->priv->manager, source);
#line 1242 "DataCollection.vala"
	if (include) {
#line 1242 "DataCollection.vala"
		_tmp0_ = !view_collection_has_view_for_source (self, source);
#line 5320 "DataCollection.c"
	} else {
#line 1242 "DataCollection.vala"
		_tmp0_ = FALSE;
#line 5324 "DataCollection.c"
	}
#line 1242 "DataCollection.vala"
	if (_tmp0_) {
#line 5328 "DataCollection.c"
		DataView* _tmp1_;
#line 1243 "DataCollection.vala"
		data_collection_add (DATA_COLLECTION (self), DATA_OBJECT (_tmp1_ = view_manager_create_view (self->priv->manager, source)));
#line 5332 "DataCollection.c"
		_g_object_unref0 (_tmp1_);
	} else {
		gboolean _tmp2_ = FALSE;
#line 1244 "DataCollection.vala"
		if (!include) {
#line 1244 "DataCollection.vala"
			_tmp2_ = view_collection_has_view_for_source (self, source);
#line 5340 "DataCollection.c"
		} else {
#line 1244 "DataCollection.vala"
			_tmp2_ = FALSE;
#line 5344 "DataCollection.c"
		}
#line 1244 "DataCollection.vala"
		if (_tmp2_) {
#line 5348 "DataCollection.c"
			DataView* _tmp3_;
			Marker* _tmp4_;
			Marker* marker;
#line 1245 "DataCollection.vala"
			marker = (_tmp4_ = data_collection_mark (DATA_COLLECTION (self), DATA_OBJECT (_tmp3_ = view_collection_get_view_for_source (self, source))), _g_object_unref0 (_tmp3_), _tmp4_);
#line 1246 "DataCollection.vala"
			data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 5356 "DataCollection.c"
			_g_object_unref0 (marker);
		} else {
			gboolean _tmp5_ = FALSE;
#line 1247 "DataCollection.vala"
			if (include) {
#line 1247 "DataCollection.vala"
				_tmp5_ = view_collection_has_view_for_source (self, source);
#line 5364 "DataCollection.c"
			} else {
#line 1247 "DataCollection.vala"
				_tmp5_ = FALSE;
#line 5368 "DataCollection.c"
			}
#line 1247 "DataCollection.vala"
			if (_tmp5_) {
#line 5372 "DataCollection.c"
				DataView* view;
				gboolean _tmp6_ = FALSE;
#line 1248 "DataCollection.vala"
				view = view_collection_get_view_for_source (self, source);
#line 1250 "DataCollection.vala"
				if (data_set_contains (self->priv->selected, DATA_OBJECT (view))) {
#line 1251 "DataCollection.vala"
					data_set_resort_object (self->priv->selected, DATA_OBJECT (view));
#line 5381 "DataCollection.c"
				}
#line 1253 "DataCollection.vala"
				if (self->priv->visible != NULL) {
#line 1253 "DataCollection.vala"
					_tmp6_ = view_collection_is_visible (self, view);
#line 5387 "DataCollection.c"
				} else {
#line 1253 "DataCollection.vala"
					_tmp6_ = FALSE;
#line 5391 "DataCollection.c"
				}
#line 1253 "DataCollection.vala"
				if (_tmp6_) {
#line 1254 "DataCollection.vala"
					if (data_set_resort_object (self->priv->visible, DATA_OBJECT (view))) {
#line 1255 "DataCollection.vala"
						data_collection_notify_ordering_changed (DATA_COLLECTION (self));
#line 5399 "DataCollection.c"
					}
				}
				_g_object_unref0 (view);
			}
		}
	}
	_g_object_unref0 (source);
}


#line 1260 "DataCollection.vala"
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added) {
#line 5412 "DataCollection.c"
	GeeArrayList* to_add;
#line 1260 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1260 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1261 "DataCollection.vala"
	to_add = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 5420 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (added);
#line 1262 "DataCollection.vala"
		while (TRUE) {
#line 5426 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataView* _tmp1_;
			DataSource* _tmp0_;
#line 1262 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1262 "DataCollection.vala"
				break;
#line 5435 "DataCollection.c"
			}
#line 1262 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1263 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1265 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_add), _tmp1_ = self->priv->mirroring_ctor (_tmp0_ = data_view_get_source (view), self->priv->mirroring_ctor_target));
#line 5443 "DataCollection.c"
			_g_object_unref0 (_tmp1_);
			_g_object_unref0 (_tmp0_);
			_g_object_unref0 (object);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_object_it);
	}
#line 1268 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_add)) > 0) {
#line 1269 "DataCollection.vala"
		data_collection_add_many (DATA_COLLECTION (self), GEE_ITERABLE (to_add), NULL, NULL);
#line 5455 "DataCollection.c"
	}
	_g_object_unref0 (to_add);
}


#line 1272 "DataCollection.vala"
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed) {
#line 5463 "DataCollection.c"
	Marker* marker;
#line 1272 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1272 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 1273 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 5471 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (removed);
#line 1274 "DataCollection.vala"
		while (TRUE) {
#line 5477 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			DataView* _tmp1_;
			DataView* our_view;
#line 1274 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1274 "DataCollection.vala"
				break;
#line 5487 "DataCollection.c"
			}
#line 1274 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1275 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1277 "DataCollection.vala"
			our_view = (_tmp1_ = view_collection_get_view_for_source (self, _tmp0_ = data_view_get_source (view)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1278 "DataCollection.vala"
			marker_mark (marker, DATA_OBJECT (our_view));
#line 5497 "DataCollection.c"
			_g_object_unref0 (object);
			_g_object_unref0 (view);
			_g_object_unref0 (our_view);
		}
		_g_object_unref0 (_object_it);
	}
#line 1281 "DataCollection.vala"
	data_collection_remove_marked (DATA_COLLECTION (self), marker);
#line 5506 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 1285 "DataCollection.vala"
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
#line 5513 "DataCollection.c"
	ViewCollection * self;
	GeeArrayList* added_visible;
	GeeArrayList* added_selected;
	gboolean is_added;
	self = VIEW_COLLECTION (base);
#line 1285 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 1286 "DataCollection.vala"
	added_visible = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1287 "DataCollection.vala"
	added_selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 5525 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (added);
#line 1289 "DataCollection.vala"
		while (TRUE) {
#line 5531 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
#line 1289 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1289 "DataCollection.vala"
				break;
#line 5539 "DataCollection.c"
			}
#line 1289 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1290 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1291 "DataCollection.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp0_ = data_view_get_source (view), view);
#line 5547 "DataCollection.c"
			_g_object_unref0 (_tmp0_);
#line 1293 "DataCollection.vala"
			if (data_view_is_selected (view)) {
#line 1294 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
#line 5553 "DataCollection.c"
			}
#line 1296 "DataCollection.vala"
			if (self->priv->filter != NULL) {
#line 1297 "DataCollection.vala"
				data_view_internal_set_visible (view, self->priv->filter (view, self->priv->filter_target));
#line 5559 "DataCollection.c"
			}
#line 1299 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 1300 "DataCollection.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_visible), view);
#line 5565 "DataCollection.c"
			}
			_g_object_unref0 (object);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_object_it);
	}
#line 1303 "DataCollection.vala"
	is_added = view_collection_add_many_visible (self, GEE_LIST (added_visible));
#line 1304 "DataCollection.vala"
	g_assert (is_added);
#line 1305 "DataCollection.vala"
	is_added = data_set_add_many (self->priv->selected, GEE_LIST (added_selected));
#line 1306 "DataCollection.vala"
	g_assert (is_added);
#line 1308 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (DATA_COLLECTION (self), added);
#line 5582 "DataCollection.c"
	_g_object_unref0 (added_visible);
	_g_object_unref0 (added_selected);
}


#line 1312 "DataCollection.vala"
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
#line 5590 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1312 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 5595 "DataCollection.c"
	{
		GeeIterator* _object_it;
		_object_it = gee_iterable_iterator (removed);
#line 1313 "DataCollection.vala"
		while (TRUE) {
#line 5601 "DataCollection.c"
			DataObject* object;
			DataView* view;
			DataSource* _tmp0_;
			gboolean _tmp1_;
			gboolean is_removed;
			gboolean _tmp2_ = FALSE;
#line 1313 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1313 "DataCollection.vala"
				break;
#line 5612 "DataCollection.c"
			}
#line 1313 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1314 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1316 "DataCollection.vala"
			is_removed = (_tmp1_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->source_map), _tmp0_ = data_view_get_source (view), NULL), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1317 "DataCollection.vala"
			g_assert (is_removed);
#line 1319 "DataCollection.vala"
			if (data_view_is_selected (view)) {
#line 1320 "DataCollection.vala"
				view_collection_remove_selected (self, view);
#line 5626 "DataCollection.c"
			}
#line 1322 "DataCollection.vala"
			if (data_view_is_visible (view)) {
#line 1322 "DataCollection.vala"
				_tmp2_ = self->priv->visible != NULL;
#line 5632 "DataCollection.c"
			} else {
#line 1322 "DataCollection.vala"
				_tmp2_ = FALSE;
#line 5636 "DataCollection.c"
			}
#line 1322 "DataCollection.vala"
			if (_tmp2_) {
#line 1323 "DataCollection.vala"
				is_removed = data_set_remove (self->priv->visible, DATA_OBJECT (view));
#line 1324 "DataCollection.vala"
				g_assert (is_removed);
#line 5644 "DataCollection.c"
			}
			_g_object_unref0 (object);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_object_it);
	}
#line 1328 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (DATA_COLLECTION (self), removed);
#line 5653 "DataCollection.c"
}


#line 1331 "DataCollection.vala"
static void view_collection_filter_altered_item (ViewCollection* self, DataObject* object) {
#line 5659 "DataCollection.c"
	DataView* view;
#line 1331 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1331 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1332 "DataCollection.vala"
	if (self->priv->filter == NULL) {
#line 1333 "DataCollection.vala"
		return;
#line 5669 "DataCollection.c"
	}
#line 1335 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 1339 "DataCollection.vala"
	if (self->priv->filter (view, self->priv->filter_target)) {
#line 1340 "DataCollection.vala"
		if (!data_view_is_visible (view)) {
#line 5677 "DataCollection.c"
			GeeArrayList* to_show;
#line 1341 "DataCollection.vala"
			to_show = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1342 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_show), view);
#line 1343 "DataCollection.vala"
			view_collection_show_items (self, GEE_LIST (to_show));
#line 5685 "DataCollection.c"
			_g_object_unref0 (to_show);
		}
	} else {
#line 1346 "DataCollection.vala"
		if (data_view_is_visible (view)) {
#line 5691 "DataCollection.c"
			GeeArrayList* to_hide;
#line 1347 "DataCollection.vala"
			to_hide = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1348 "DataCollection.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (to_hide), view);
#line 1349 "DataCollection.vala"
			view_collection_hide_items (self, GEE_LIST (to_hide));
#line 5699 "DataCollection.c"
			_g_object_unref0 (to_hide);
		}
	}
	_g_object_unref0 (view);
}


#line 1354 "DataCollection.vala"
static void view_collection_real_item_altered (DataCollection* base, DataObject* object) {
#line 5709 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1354 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1355 "DataCollection.vala"
	view_collection_filter_altered_item (self, object);
#line 1357 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->item_altered (DATA_COLLECTION (self), object);
#line 5718 "DataCollection.c"
}


#line 1360 "DataCollection.vala"
static void view_collection_real_item_metadata_altered (DataCollection* base, DataObject* object) {
#line 5724 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1360 "DataCollection.vala"
	g_return_if_fail (IS_DATA_OBJECT (object));
#line 1361 "DataCollection.vala"
	view_collection_filter_altered_item (self, object);
#line 1363 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->item_metadata_altered (DATA_COLLECTION (self), object);
#line 5733 "DataCollection.c"
}


#line 1366 "DataCollection.vala"
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target) {
#line 5739 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1367 "DataCollection.vala"
	data_set_set_comparator (self->priv->selected, comparator, comparator_target);
#line 1368 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1369 "DataCollection.vala"
		data_set_set_comparator (self->priv->visible, comparator, comparator_target);
#line 5748 "DataCollection.c"
	}
#line 1371 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (DATA_COLLECTION (self), comparator, comparator_target);
#line 5752 "DataCollection.c"
}


#line 1374 "DataCollection.vala"
static void view_collection_real_reset_comparator (DataCollection* base) {
#line 5758 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1375 "DataCollection.vala"
	data_set_reset_comparator (self->priv->selected);
#line 1376 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1377 "DataCollection.vala"
		data_set_reset_comparator (self->priv->visible);
#line 5767 "DataCollection.c"
	}
#line 1379 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (DATA_COLLECTION (self));
#line 5771 "DataCollection.c"
}


#line 1382 "DataCollection.vala"
static GeeIterable* view_collection_real_get_all (DataCollection* base) {
#line 5777 "DataCollection.c"
	ViewCollection * self;
	GeeIterable* result = NULL;
	GeeIterable* _tmp0_;
	self = VIEW_COLLECTION (base);
	_tmp0_ = NULL;
#line 1383 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 5785 "DataCollection.c"
		GeeIterable* _tmp1_;
#line 1383 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_set_get_all (self->priv->visible), _g_object_unref0 (_tmp0_), _tmp1_);
#line 5789 "DataCollection.c"
	} else {
		GeeIterable* _tmp2_;
#line 1383 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self)), _g_object_unref0 (_tmp0_), _tmp2_);
#line 5794 "DataCollection.c"
	}
	result = _tmp0_;
#line 1383 "DataCollection.vala"
	return result;
#line 5799 "DataCollection.c"
}


#line 1386 "DataCollection.vala"
GeeIterable* view_collection_get_all_unfiltered (ViewCollection* self) {
#line 5805 "DataCollection.c"
	GeeIterable* result = NULL;
#line 1386 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 5809 "DataCollection.c"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (DATA_COLLECTION (self));
#line 1387 "DataCollection.vala"
	return result;
#line 5813 "DataCollection.c"
}


#line 1390 "DataCollection.vala"
static gint view_collection_real_get_count (DataCollection* base) {
#line 5819 "DataCollection.c"
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
#line 1391 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1391 "DataCollection.vala"
		_tmp0_ = data_set_get_count (self->priv->visible);
#line 5828 "DataCollection.c"
	} else {
#line 1391 "DataCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 5832 "DataCollection.c"
	}
	result = _tmp0_;
#line 1391 "DataCollection.vala"
	return result;
#line 5837 "DataCollection.c"
}


#line 1394 "DataCollection.vala"
gint view_collection_get_unfiltered_count (ViewCollection* self) {
#line 5843 "DataCollection.c"
	gint result = 0;
#line 1394 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 5847 "DataCollection.c"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self));
#line 1395 "DataCollection.vala"
	return result;
#line 5851 "DataCollection.c"
}


#line 1398 "DataCollection.vala"
static DataObject* view_collection_real_get_at (DataCollection* base, gint index) {
#line 5857 "DataCollection.c"
	ViewCollection * self;
	DataObject* result = NULL;
	DataObject* _tmp0_;
	self = VIEW_COLLECTION (base);
	_tmp0_ = NULL;
#line 1399 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 5865 "DataCollection.c"
		DataObject* _tmp1_;
#line 1399 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_set_get_at (self->priv->visible, index), _g_object_unref0 (_tmp0_), _tmp1_);
#line 5869 "DataCollection.c"
	} else {
		DataObject* _tmp2_;
#line 1399 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (DATA_COLLECTION (self), index), _g_object_unref0 (_tmp0_), _tmp2_);
#line 5874 "DataCollection.c"
	}
	result = _tmp0_;
#line 1399 "DataCollection.vala"
	return result;
#line 5879 "DataCollection.c"
}


#line 1402 "DataCollection.vala"
static gint view_collection_real_index_of (DataCollection* base, DataObject* object) {
#line 5885 "DataCollection.c"
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	self = VIEW_COLLECTION (base);
#line 1402 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 1403 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1403 "DataCollection.vala"
		_tmp0_ = data_set_index_of (self->priv->visible, object);
#line 5896 "DataCollection.c"
	} else {
#line 1403 "DataCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (DATA_COLLECTION (self), object);
#line 5900 "DataCollection.c"
	}
	result = _tmp0_;
#line 1403 "DataCollection.vala"
	return result;
#line 5905 "DataCollection.c"
}


#line 1406 "DataCollection.vala"
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object) {
#line 5911 "DataCollection.c"
	ViewCollection * self;
	gboolean result = FALSE;
	self = VIEW_COLLECTION (base);
#line 1406 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1409 "DataCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (DATA_COLLECTION (self), object)) {
#line 5919 "DataCollection.c"
		result = FALSE;
#line 1410 "DataCollection.vala"
		return result;
#line 5923 "DataCollection.c"
	}
	result = view_collection_is_visible (self, DATA_VIEW (object));
#line 1413 "DataCollection.vala"
	return result;
#line 5928 "DataCollection.c"
}


#line 1416 "DataCollection.vala"
static DataView* view_collection_real_get_first (ViewCollection* self) {
#line 5934 "DataCollection.c"
	DataView* result = NULL;
	DataView* _tmp0_;
#line 1416 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 5939 "DataCollection.c"
	_tmp0_ = NULL;
#line 1417 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) > 0) {
#line 5943 "DataCollection.c"
		DataView* _tmp1_;
#line 1417 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), 0)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 5947 "DataCollection.c"
	} else {
		DataView* _tmp2_;
#line 1417 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 5952 "DataCollection.c"
	}
	result = _tmp0_;
#line 1417 "DataCollection.vala"
	return result;
#line 5957 "DataCollection.c"
}


#line 1416 "DataCollection.vala"
DataView* view_collection_get_first (ViewCollection* self) {
#line 1416 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first (self);
#line 5965 "DataCollection.c"
}


#line 1420 "DataCollection.vala"
static DataView* view_collection_real_get_last (ViewCollection* self) {
#line 5971 "DataCollection.c"
	DataView* result = NULL;
	DataView* _tmp0_;
#line 1420 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 5976 "DataCollection.c"
	_tmp0_ = NULL;
#line 1421 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) > 0) {
#line 5980 "DataCollection.c"
		DataView* _tmp1_;
#line 1421 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), data_collection_get_count (DATA_COLLECTION (self)) - 1)), _g_object_unref0 (_tmp0_), _tmp1_);
#line 5984 "DataCollection.c"
	} else {
		DataView* _tmp2_;
#line 1421 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 5989 "DataCollection.c"
	}
	result = _tmp0_;
#line 1421 "DataCollection.vala"
	return result;
#line 5994 "DataCollection.c"
}


#line 1420 "DataCollection.vala"
DataView* view_collection_get_last (ViewCollection* self) {
#line 1420 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_last (self);
#line 6002 "DataCollection.c"
}


#line 1424 "DataCollection.vala"
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view) {
#line 6008 "DataCollection.c"
	DataView* result = NULL;
	gint index;
#line 1424 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1424 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 1425 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) == 0) {
#line 6017 "DataCollection.c"
		result = NULL;
#line 1426 "DataCollection.vala"
		return result;
#line 6021 "DataCollection.c"
	}
#line 1428 "DataCollection.vala"
	index = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
#line 1429 "DataCollection.vala"
	if (index < 0) {
#line 6027 "DataCollection.c"
		result = NULL;
#line 1430 "DataCollection.vala"
		return result;
#line 6031 "DataCollection.c"
	}
#line 1432 "DataCollection.vala"
	index++;
#line 1433 "DataCollection.vala"
	if (index >= data_collection_get_count (DATA_COLLECTION (self))) {
#line 1434 "DataCollection.vala"
		index = 0;
#line 6039 "DataCollection.c"
	}
	result = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), index));
#line 1436 "DataCollection.vala"
	return result;
#line 6044 "DataCollection.c"
}


#line 1424 "DataCollection.vala"
DataView* view_collection_get_next (ViewCollection* self, DataView* view) {
#line 1424 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_next (self, view);
#line 6052 "DataCollection.c"
}


#line 1439 "DataCollection.vala"
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view) {
#line 6058 "DataCollection.c"
	DataView* result = NULL;
	gint index;
#line 1439 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1439 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 1440 "DataCollection.vala"
	if (data_collection_get_count (DATA_COLLECTION (self)) == 0) {
#line 6067 "DataCollection.c"
		result = NULL;
#line 1441 "DataCollection.vala"
		return result;
#line 6071 "DataCollection.c"
	}
#line 1443 "DataCollection.vala"
	index = data_collection_index_of (DATA_COLLECTION (self), DATA_OBJECT (view));
#line 1444 "DataCollection.vala"
	if (index < 0) {
#line 6077 "DataCollection.c"
		result = NULL;
#line 1445 "DataCollection.vala"
		return result;
#line 6081 "DataCollection.c"
	}
#line 1447 "DataCollection.vala"
	index--;
#line 1448 "DataCollection.vala"
	if (index < 0) {
#line 1449 "DataCollection.vala"
		index = data_collection_get_count (DATA_COLLECTION (self)) - 1;
#line 6089 "DataCollection.c"
	}
	result = DATA_VIEW (data_collection_get_at (DATA_COLLECTION (self), index));
#line 1451 "DataCollection.vala"
	return result;
#line 6094 "DataCollection.c"
}


#line 1439 "DataCollection.vala"
DataView* view_collection_get_previous (ViewCollection* self, DataView* view) {
#line 1439 "DataCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_previous (self, view);
#line 6102 "DataCollection.c"
}


#line 1454 "DataCollection.vala"
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev) {
#line 6108 "DataCollection.c"
	gboolean result = FALSE;
	DataView* home_view;
	DataView* next_view;
	DataSource* _tmp0_;
	DataSource* _tmp3_;
	DataView* prev_view;
	DataSource* _tmp4_;
	DataSource* _tmp7_;
#line 1454 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1454 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), FALSE);
#line 6121 "DataCollection.c"
	if (next != NULL) {
		*next = NULL;
	}
	if (prev != NULL) {
		*prev = NULL;
	}
#line 1455 "DataCollection.vala"
	home_view = view_collection_get_view_for_source (self, home);
#line 1456 "DataCollection.vala"
	if (home_view == NULL) {
#line 6132 "DataCollection.c"
		result = FALSE;
		_g_object_unref0 (home_view);
#line 1457 "DataCollection.vala"
		return result;
#line 6137 "DataCollection.c"
	}
#line 1459 "DataCollection.vala"
	next_view = view_collection_get_next (self, home_view);
#line 6141 "DataCollection.c"
	_tmp0_ = NULL;
#line 1460 "DataCollection.vala"
	if (next_view != NULL) {
#line 6145 "DataCollection.c"
		DataSource* _tmp1_;
#line 1460 "DataCollection.vala"
		_tmp0_ = (_tmp1_ = data_view_get_source (next_view), _g_object_unref0 (_tmp0_), _tmp1_);
#line 6149 "DataCollection.c"
	} else {
		DataSource* _tmp2_;
#line 1460 "DataCollection.vala"
		_tmp0_ = (_tmp2_ = NULL, _g_object_unref0 (_tmp0_), _tmp2_);
#line 6154 "DataCollection.c"
	}
#line 1460 "DataCollection.vala"
	*next = (_tmp3_ = _g_object_ref0 (_tmp0_), _g_object_unref0 (*next), _tmp3_);
#line 1462 "DataCollection.vala"
	prev_view = view_collection_get_previous (self, home_view);
#line 6160 "DataCollection.c"
	_tmp4_ = NULL;
#line 1463 "DataCollection.vala"
	if (prev_view != NULL) {
#line 6164 "DataCollection.c"
		DataSource* _tmp5_;
#line 1463 "DataCollection.vala"
		_tmp4_ = (_tmp5_ = data_view_get_source (prev_view), _g_object_unref0 (_tmp4_), _tmp5_);
#line 6168 "DataCollection.c"
	} else {
		DataSource* _tmp6_;
#line 1463 "DataCollection.vala"
		_tmp4_ = (_tmp6_ = NULL, _g_object_unref0 (_tmp4_), _tmp6_);
#line 6173 "DataCollection.c"
	}
#line 1463 "DataCollection.vala"
	*prev = (_tmp7_ = _g_object_ref0 (_tmp4_), _g_object_unref0 (*prev), _tmp7_);
#line 6177 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (home_view);
	_g_object_unref0 (next_view);
	_g_object_unref0 (_tmp0_);
	_g_object_unref0 (prev_view);
	_g_object_unref0 (_tmp4_);
#line 1465 "DataCollection.vala"
	return result;
#line 6186 "DataCollection.c"
}


#line 1469 "DataCollection.vala"
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home) {
#line 6192 "DataCollection.c"
	GeeSet* result = NULL;
	GeeSet* neighbors;
	DataSource* next;
	DataSource* prev;
	DataSource* _tmp5_;
	gboolean _tmp4_;
	DataSource* _tmp3_ = NULL;
	DataSource* _tmp2_;
	gboolean _tmp1_;
	DataSource* _tmp0_ = NULL;
#line 1469 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1469 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), NULL);
#line 1471 "DataCollection.vala"
	neighbors = GEE_SET (gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL));
#line 6209 "DataCollection.c"
	next = NULL;
	prev = NULL;
#line 1475 "DataCollection.vala"
	if (!(_tmp4_ = (_tmp1_ = view_collection_get_immediate_neighbors (self, home, &_tmp0_, &_tmp3_), next = (_tmp2_ = _tmp0_, _g_object_unref0 (next), _tmp2_), _tmp1_), prev = (_tmp5_ = _tmp3_, _g_object_unref0 (prev), _tmp5_), _tmp4_)) {
#line 6214 "DataCollection.c"
		result = neighbors;
		_g_object_unref0 (next);
		_g_object_unref0 (prev);
#line 1476 "DataCollection.vala"
		return result;
#line 6220 "DataCollection.c"
	}
#line 1479 "DataCollection.vala"
	if (next != NULL) {
#line 6224 "DataCollection.c"
		DataSource* next_next;
		DataSource* next_prev;
		DataSource* _tmp9_;
		DataSource* _tmp8_ = NULL;
		DataSource* _tmp7_;
		DataSource* _tmp6_ = NULL;
#line 1480 "DataCollection.vala"
		gee_collection_add (GEE_COLLECTION (neighbors), next);
#line 6233 "DataCollection.c"
		next_next = NULL;
		next_prev = NULL;
#line 1483 "DataCollection.vala"
		(view_collection_get_immediate_neighbors (self, next, &_tmp6_, &_tmp8_), next_next = (_tmp7_ = _tmp6_, _g_object_unref0 (next_next), _tmp7_));
#line 1483 "DataCollection.vala"
		next_prev = (_tmp9_ = _tmp8_, _g_object_unref0 (next_prev), _tmp9_);
#line 1486 "DataCollection.vala"
		if (next_next != NULL) {
#line 1487 "DataCollection.vala"
			gee_collection_add (GEE_COLLECTION (neighbors), next_next);
#line 6244 "DataCollection.c"
		}
		_g_object_unref0 (next_next);
		_g_object_unref0 (next_prev);
	}
#line 1491 "DataCollection.vala"
	if (prev != NULL) {
#line 6251 "DataCollection.c"
		DataSource* next_prev;
		DataSource* prev_prev;
		DataSource* _tmp13_;
		DataSource* _tmp12_ = NULL;
		DataSource* _tmp11_;
		DataSource* _tmp10_ = NULL;
#line 1492 "DataCollection.vala"
		gee_collection_add (GEE_COLLECTION (neighbors), prev);
#line 6260 "DataCollection.c"
		next_prev = NULL;
		prev_prev = NULL;
#line 1495 "DataCollection.vala"
		(view_collection_get_immediate_neighbors (self, prev, &_tmp10_, &_tmp12_), next_prev = (_tmp11_ = _tmp10_, _g_object_unref0 (next_prev), _tmp11_));
#line 1495 "DataCollection.vala"
		prev_prev = (_tmp13_ = _tmp12_, _g_object_unref0 (prev_prev), _tmp13_);
#line 1498 "DataCollection.vala"
		if (prev_prev != NULL) {
#line 1499 "DataCollection.vala"
			gee_collection_add (GEE_COLLECTION (neighbors), prev_prev);
#line 6271 "DataCollection.c"
		}
		_g_object_unref0 (next_prev);
		_g_object_unref0 (prev_prev);
	}
#line 1503 "DataCollection.vala"
	gee_collection_remove (GEE_COLLECTION (neighbors), home);
#line 6278 "DataCollection.c"
	result = neighbors;
	_g_object_unref0 (next);
	_g_object_unref0 (prev);
#line 1505 "DataCollection.vala"
	return result;
#line 6284 "DataCollection.c"
}


#line 1536 "DataCollection.vala"
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 6290 "DataCollection.c"
	return view_collection_select_item (self, object, user);
}


#line 1509 "DataCollection.vala"
void view_collection_select_marked (ViewCollection* self, Marker* marker) {
#line 6297 "DataCollection.c"
	GeeArrayList* selected;
#line 1509 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1509 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 1510 "DataCollection.vala"
	selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1511 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_select_item_marked_action, self, NULL, NULL, G_OBJECT (selected));
#line 1513 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (selected)) > 0) {
#line 1514 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-selected", GEE_ITERABLE (selected));
#line 1515 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-state-changed", GEE_ITERABLE (selected));
#line 6313 "DataCollection.c"
	}
	_g_object_unref0 (selected);
}


#line 1519 "DataCollection.vala"
static void view_collection_add_selected (ViewCollection* self, DataView* view) {
#line 6321 "DataCollection.c"
	gboolean added;
#line 1519 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1519 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1520 "DataCollection.vala"
	added = data_set_add (self->priv->selected, DATA_OBJECT (view));
#line 1521 "DataCollection.vala"
	g_assert (added);
#line 6331 "DataCollection.c"
}


#line 1524 "DataCollection.vala"
static void view_collection_remove_selected (ViewCollection* self, DataView* view) {
#line 6337 "DataCollection.c"
	gboolean removed;
#line 1524 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1524 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1525 "DataCollection.vala"
	removed = data_set_remove (self->priv->selected, DATA_OBJECT (view));
#line 1526 "DataCollection.vala"
	g_assert (removed);
#line 6347 "DataCollection.c"
}


#line 1530 "DataCollection.vala"
void view_collection_select_all (ViewCollection* self) {
#line 6353 "DataCollection.c"
	Marker* marker;
#line 1530 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1531 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 1532 "DataCollection.vala"
	marker_mark_all (marker);
#line 1533 "DataCollection.vala"
	view_collection_select_marked (self, marker);
#line 6363 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 1536 "DataCollection.vala"
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 6370 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
#line 1536 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1536 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1536 "DataCollection.vala"
	g_return_val_if_fail (G_IS_OBJECT (user), FALSE);
#line 1537 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 1538 "DataCollection.vala"
	if (data_view_is_selected (view)) {
#line 1539 "DataCollection.vala"
		g_assert (data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 6385 "DataCollection.c"
		result = TRUE;
		_g_object_unref0 (view);
#line 1541 "DataCollection.vala"
		return result;
#line 6390 "DataCollection.c"
	}
#line 1544 "DataCollection.vala"
	data_view_internal_set_selected (view, TRUE);
#line 1545 "DataCollection.vala"
	view_collection_add_selected (self, view);
#line 1547 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
#line 6398 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (view);
#line 1549 "DataCollection.vala"
	return result;
#line 6403 "DataCollection.c"
}


#line 1585 "DataCollection.vala"
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 6409 "DataCollection.c"
	return view_collection_unselect_item (self, object, user);
}


#line 1553 "DataCollection.vala"
void view_collection_unselect_marked (ViewCollection* self, Marker* marker) {
#line 6416 "DataCollection.c"
	GeeArrayList* unselected;
#line 1553 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1553 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 1554 "DataCollection.vala"
	unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1555 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_OBJECT (unselected));
#line 1557 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (unselected)) > 0) {
#line 1558 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-unselected", GEE_ITERABLE (unselected));
#line 1559 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-state-changed", GEE_ITERABLE (unselected));
#line 6432 "DataCollection.c"
	}
	_g_object_unref0 (unselected);
}


#line 1564 "DataCollection.vala"
void view_collection_unselect_all (ViewCollection* self) {
#line 6440 "DataCollection.c"
	Marker* marker;
#line 1564 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1565 "DataCollection.vala"
	if (data_set_get_count (self->priv->selected) == 0) {
#line 1566 "DataCollection.vala"
		return;
#line 6448 "DataCollection.c"
	}
#line 1568 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 1569 "DataCollection.vala"
	marker_mark_all (marker);
#line 1570 "DataCollection.vala"
	view_collection_unselect_marked (self, marker);
#line 6456 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 1574 "DataCollection.vala"
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception) {
#line 6463 "DataCollection.c"
	Marker* marker;
#line 1574 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1574 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (exception));
#line 1575 "DataCollection.vala"
	marker = data_collection_start_marking (DATA_COLLECTION (self));
#line 6471 "DataCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _object_it;
		_object_it = (_tmp1_ = gee_iterable_iterator (_tmp0_ = data_collection_get_all (DATA_COLLECTION (self))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1576 "DataCollection.vala"
		while (TRUE) {
#line 6479 "DataCollection.c"
			DataObject* object;
			DataView* view;
#line 1576 "DataCollection.vala"
			if (!gee_iterator_next (_object_it)) {
#line 1576 "DataCollection.vala"
				break;
#line 6486 "DataCollection.c"
			}
#line 1576 "DataCollection.vala"
			object = (DataObject*) gee_iterator_get (_object_it);
#line 1577 "DataCollection.vala"
			view = _g_object_ref0 (DATA_VIEW (object));
#line 1578 "DataCollection.vala"
			if (view != exception) {
#line 1579 "DataCollection.vala"
				marker_mark (marker, DATA_OBJECT (view));
#line 6496 "DataCollection.c"
			}
			_g_object_unref0 (object);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_object_it);
	}
#line 1582 "DataCollection.vala"
	view_collection_unselect_marked (self, marker);
#line 6505 "DataCollection.c"
	_g_object_unref0 (marker);
}


#line 1585 "DataCollection.vala"
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 6512 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
#line 1585 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1585 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1585 "DataCollection.vala"
	g_return_val_if_fail (G_IS_OBJECT (user), FALSE);
#line 1586 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 1587 "DataCollection.vala"
	if (!data_view_is_selected (view)) {
#line 1588 "DataCollection.vala"
		g_assert (!data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 6527 "DataCollection.c"
		result = TRUE;
		_g_object_unref0 (view);
#line 1590 "DataCollection.vala"
		return result;
#line 6532 "DataCollection.c"
	}
#line 1593 "DataCollection.vala"
	data_view_internal_set_selected (view, FALSE);
#line 1594 "DataCollection.vala"
	view_collection_remove_selected (self, view);
#line 1596 "DataCollection.vala"
	gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (GEE_ARRAY_LIST (user)), view);
#line 6540 "DataCollection.c"
	result = TRUE;
	_g_object_unref0 (view);
#line 1598 "DataCollection.vala"
	return result;
#line 6545 "DataCollection.c"
}


#line 1618 "DataCollection.vala"
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self) {
#line 6551 "DataCollection.c"
	return view_collection_toggle_item (self, object, user);
}


#line 1603 "DataCollection.vala"
void view_collection_toggle_marked (ViewCollection* self, Marker* marker) {
#line 6558 "DataCollection.c"
	ViewCollectionToggleLists* lists;
#line 1603 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1603 "DataCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 1604 "DataCollection.vala"
	lists = view_collection_toggle_lists_new ();
#line 1605 "DataCollection.vala"
	data_collection_act_on_marked (DATA_COLLECTION (self), marker, _view_collection_toggle_item_marked_action, self, NULL, NULL, G_OBJECT (lists));
#line 1607 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (lists->selected)) > 0) {
#line 1608 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-selected", GEE_ITERABLE (lists->selected));
#line 1609 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-state-changed", GEE_ITERABLE (lists->selected));
#line 6574 "DataCollection.c"
	}
#line 1612 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (lists->unselected)) > 0) {
#line 1613 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-unselected", GEE_ITERABLE (lists->unselected));
#line 1614 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-state-changed", GEE_ITERABLE (lists->unselected));
#line 6582 "DataCollection.c"
	}
	_g_object_unref0 (lists);
}


#line 1618 "DataCollection.vala"
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user) {
#line 6590 "DataCollection.c"
	gboolean result = FALSE;
	DataView* view;
	ViewCollectionToggleLists* lists;
#line 1618 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1618 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1618 "DataCollection.vala"
	g_return_val_if_fail (G_IS_OBJECT (user), FALSE);
#line 1619 "DataCollection.vala"
	view = _g_object_ref0 (DATA_VIEW (object));
#line 1620 "DataCollection.vala"
	lists = _g_object_ref0 (VIEW_COLLECTION_TOGGLE_LISTS (user));
#line 1624 "DataCollection.vala"
	if (data_view_internal_toggle (view)) {
#line 1625 "DataCollection.vala"
		view_collection_add_selected (self, view);
#line 1627 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->selected), view);
#line 6610 "DataCollection.c"
	} else {
#line 1629 "DataCollection.vala"
		view_collection_remove_selected (self, view);
#line 1631 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (lists->unselected), view);
#line 6616 "DataCollection.c"
	}
	result = TRUE;
	_g_object_unref0 (view);
	_g_object_unref0 (lists);
#line 1634 "DataCollection.vala"
	return result;
#line 6623 "DataCollection.c"
}


#line 1637 "DataCollection.vala"
gint view_collection_get_selected_count (ViewCollection* self) {
#line 6629 "DataCollection.c"
	gint result = 0;
#line 1637 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 6633 "DataCollection.c"
	result = data_set_get_count (self->priv->selected);
#line 1638 "DataCollection.vala"
	return result;
#line 6637 "DataCollection.c"
}


#line 1641 "DataCollection.vala"
GeeIterable* view_collection_get_selected (ViewCollection* self) {
#line 6643 "DataCollection.c"
	GeeIterable* result = NULL;
#line 1641 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 6647 "DataCollection.c"
	result = GEE_ITERABLE (data_set_get_all (self->priv->selected));
#line 1642 "DataCollection.vala"
	return result;
#line 6651 "DataCollection.c"
}


#line 1645 "DataCollection.vala"
DataView* view_collection_get_selected_at (ViewCollection* self, gint index) {
#line 6657 "DataCollection.c"
	DataView* result = NULL;
#line 1645 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 6661 "DataCollection.c"
	result = DATA_VIEW (data_set_get_at (self->priv->selected, index));
#line 1646 "DataCollection.vala"
	return result;
#line 6665 "DataCollection.c"
}


#line 1649 "DataCollection.vala"
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view) {
#line 6671 "DataCollection.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1649 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1649 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 1650 "DataCollection.vala"
	if (self->priv->visible != NULL) {
#line 1650 "DataCollection.vala"
		_tmp0_ = data_set_contains (self->priv->visible, DATA_OBJECT (view));
#line 6682 "DataCollection.c"
	} else {
#line 1650 "DataCollection.vala"
		_tmp0_ = TRUE;
#line 6686 "DataCollection.c"
	}
	result = _tmp0_;
#line 1650 "DataCollection.vala"
	return result;
#line 6691 "DataCollection.c"
}


#line 1653 "DataCollection.vala"
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeList* many) {
#line 6697 "DataCollection.c"
	gboolean result = FALSE;
#line 1653 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1653 "DataCollection.vala"
	g_return_val_if_fail (GEE_IS_LIST (many), FALSE);
#line 1654 "DataCollection.vala"
	if (self->priv->visible == NULL) {
#line 6705 "DataCollection.c"
		result = TRUE;
#line 1655 "DataCollection.vala"
		return result;
#line 6709 "DataCollection.c"
	}
#line 1657 "DataCollection.vala"
	if (!data_set_add_many (self->priv->visible, many)) {
#line 6713 "DataCollection.c"
		result = FALSE;
#line 1658 "DataCollection.vala"
		return result;
#line 6717 "DataCollection.c"
	}
#line 1661 "DataCollection.vala"
	if (data_set_get_count (self->priv->visible) == DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (DATA_COLLECTION (self))) {
#line 6721 "DataCollection.c"
		DataSet* _tmp0_;
#line 1662 "DataCollection.vala"
		self->priv->visible = (_tmp0_ = NULL, _data_set_unref0 (self->priv->visible), _tmp0_);
#line 6725 "DataCollection.c"
	}
	result = TRUE;
#line 1664 "DataCollection.vala"
	return result;
#line 6730 "DataCollection.c"
}


#line 1668 "DataCollection.vala"
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide) {
#line 6736 "DataCollection.c"
	GeeArrayList* unselected;
	gint count;
	gboolean removed;
#line 1668 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1668 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_hide));
#line 1669 "DataCollection.vala"
	unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1671 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (to_hide));
#line 6748 "DataCollection.c"
	{
		gint ctr;
#line 1672 "DataCollection.vala"
		ctr = 0;
#line 6753 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1672 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1672 "DataCollection.vala"
			while (TRUE) {
#line 6760 "DataCollection.c"
				DataView* view;
#line 1672 "DataCollection.vala"
				if (!_tmp0_) {
#line 1672 "DataCollection.vala"
					ctr++;
#line 6766 "DataCollection.c"
				}
#line 1672 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1672 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1672 "DataCollection.vala"
					break;
#line 6774 "DataCollection.c"
				}
#line 1673 "DataCollection.vala"
				view = (DataView*) gee_list_get (to_hide, ctr);
#line 1674 "DataCollection.vala"
				g_assert (data_view_is_visible (view));
#line 1676 "DataCollection.vala"
				if (data_view_is_selected (view)) {
#line 1677 "DataCollection.vala"
					data_view_internal_set_selected (view, FALSE);
#line 1678 "DataCollection.vala"
					view_collection_remove_selected (self, view);
#line 1679 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (unselected), view);
#line 6788 "DataCollection.c"
				}
#line 1682 "DataCollection.vala"
				data_view_internal_set_visible (view, FALSE);
#line 6792 "DataCollection.c"
				_g_object_unref0 (view);
			}
		}
	}
#line 1685 "DataCollection.vala"
	if (self->priv->visible == NULL) {
#line 6799 "DataCollection.c"
		DataSet* _tmp1_;
#line 1687 "DataCollection.vala"
		self->priv->visible = (_tmp1_ = data_collection_get_dataset_copy (DATA_COLLECTION (self)), _data_set_unref0 (self->priv->visible), _tmp1_);
#line 6803 "DataCollection.c"
	}
#line 1690 "DataCollection.vala"
	removed = data_set_remove_many (self->priv->visible, to_hide);
#line 1691 "DataCollection.vala"
	g_assert (removed);
#line 1693 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (unselected)) > 0) {
#line 1694 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-state-changed", GEE_ITERABLE (unselected));
#line 1695 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-unselected", GEE_ITERABLE (unselected));
#line 6815 "DataCollection.c"
	}
#line 1698 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_hide)) > 0) {
#line 1699 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-hidden", GEE_ITERABLE (to_hide));
#line 1700 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-visibility-changed", GEE_ITERABLE (to_hide));
#line 6823 "DataCollection.c"
	}
	_g_object_unref0 (unselected);
}


#line 1705 "DataCollection.vala"
static void view_collection_show_items (ViewCollection* self, GeeList* to_show) {
#line 6831 "DataCollection.c"
	GeeArrayList* added_selected;
	gint count;
	gboolean added;
#line 1705 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1705 "DataCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_show));
#line 1706 "DataCollection.vala"
	added_selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1708 "DataCollection.vala"
	count = gee_collection_get_size (GEE_COLLECTION (to_show));
#line 6843 "DataCollection.c"
	{
		gint ctr;
#line 1709 "DataCollection.vala"
		ctr = 0;
#line 6848 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1709 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1709 "DataCollection.vala"
			while (TRUE) {
#line 6855 "DataCollection.c"
				DataView* view;
#line 1709 "DataCollection.vala"
				if (!_tmp0_) {
#line 1709 "DataCollection.vala"
					ctr++;
#line 6861 "DataCollection.c"
				}
#line 1709 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1709 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1709 "DataCollection.vala"
					break;
#line 6869 "DataCollection.c"
				}
#line 1710 "DataCollection.vala"
				view = (DataView*) gee_list_get (to_show, ctr);
#line 1711 "DataCollection.vala"
				g_assert (!data_view_is_visible (view));
#line 1713 "DataCollection.vala"
				data_view_internal_set_visible (view, TRUE);
#line 1716 "DataCollection.vala"
				if (data_view_is_selected (view)) {
#line 1717 "DataCollection.vala"
					g_assert (!data_set_contains (self->priv->selected, DATA_OBJECT (view)));
#line 1718 "DataCollection.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (added_selected), view);
#line 6883 "DataCollection.c"
				}
				_g_object_unref0 (view);
			}
		}
	}
#line 1722 "DataCollection.vala"
	added = view_collection_add_many_visible (self, to_show);
#line 1723 "DataCollection.vala"
	g_assert (added);
#line 1724 "DataCollection.vala"
	added = data_set_add_many (self->priv->selected, GEE_LIST (added_selected));
#line 1725 "DataCollection.vala"
	g_assert (added);
#line 1727 "DataCollection.vala"
	if (gee_collection_get_size (GEE_COLLECTION (to_show)) > 0) {
#line 1728 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-shown", GEE_ITERABLE (to_show));
#line 1729 "DataCollection.vala"
		g_signal_emit_by_name (self, "items-visibility-changed", GEE_ITERABLE (to_show));
#line 6903 "DataCollection.c"
	}
	_g_object_unref0 (added_selected);
}


#line 1733 "DataCollection.vala"
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source) {
#line 6911 "DataCollection.c"
	gboolean result = FALSE;
#line 1733 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1733 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 6917 "DataCollection.c"
	result = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 1734 "DataCollection.vala"
	return result;
#line 6921 "DataCollection.c"
}


#line 1737 "DataCollection.vala"
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source) {
#line 6927 "DataCollection.c"
	DataView* result = NULL;
#line 1737 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1737 "DataCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 6933 "DataCollection.c"
	result = (DataView*) gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->source_map), source);
#line 1738 "DataCollection.vala"
	return result;
#line 6937 "DataCollection.c"
}


#line 1741 "DataCollection.vala"
GeeCollection* view_collection_get_sources (ViewCollection* self) {
#line 6943 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeSet* _tmp0_;
	GeeCollection* _tmp1_;
#line 1741 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 6949 "DataCollection.c"
	result = (_tmp1_ = GEE_COLLECTION (gee_set_get_read_only_view (_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->source_map)))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 1742 "DataCollection.vala"
	return result;
#line 6953 "DataCollection.c"
}


#line 1745 "DataCollection.vala"
GeeCollection* view_collection_get_selected_sources (ViewCollection* self) {
#line 6959 "DataCollection.c"
	GeeCollection* result = NULL;
	GeeCollection* sources;
	gint count;
#line 1745 "DataCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1746 "DataCollection.vala"
	sources = GEE_COLLECTION (gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL));
#line 1748 "DataCollection.vala"
	count = data_set_get_count (self->priv->selected);
#line 6969 "DataCollection.c"
	{
		gint ctr;
#line 1749 "DataCollection.vala"
		ctr = 0;
#line 6974 "DataCollection.c"
		{
			gboolean _tmp0_;
#line 1749 "DataCollection.vala"
			_tmp0_ = TRUE;
#line 1749 "DataCollection.vala"
			while (TRUE) {
#line 6981 "DataCollection.c"
				DataSource* _tmp2_;
				DataView* _tmp1_;
#line 1749 "DataCollection.vala"
				if (!_tmp0_) {
#line 1749 "DataCollection.vala"
					ctr++;
#line 6988 "DataCollection.c"
				}
#line 1749 "DataCollection.vala"
				_tmp0_ = FALSE;
#line 1749 "DataCollection.vala"
				if (!(ctr < count)) {
#line 1749 "DataCollection.vala"
					break;
#line 6996 "DataCollection.c"
				}
#line 1750 "DataCollection.vala"
				gee_collection_add (sources, _tmp2_ = data_view_get_source (_tmp1_ = DATA_VIEW (data_set_get_at (self->priv->selected, ctr))));
#line 7000 "DataCollection.c"
				_g_object_unref0 (_tmp2_);
				_g_object_unref0 (_tmp1_);
			}
		}
	}
	result = sources;
#line 1752 "DataCollection.vala"
	return result;
#line 7009 "DataCollection.c"
}


#line 1756 "DataCollection.vala"
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view) {
#line 1756 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1756 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1757 "DataCollection.vala"
	if (!data_collection_are_notifications_frozen (DATA_COLLECTION (self))) {
#line 7021 "DataCollection.c"
		GeeArrayList* _tmp0_;
#line 1758 "DataCollection.vala"
		view_collection_notify_item_view_altered (self, view);
#line 1759 "DataCollection.vala"
		view_collection_notify_views_altered (self, GEE_COLLECTION (_tmp0_ = data_collection_get_singleton (DATA_OBJECT (view))));
#line 7027 "DataCollection.c"
		_g_object_unref0 (_tmp0_);
	} else {
#line 1761 "DataCollection.vala"
		if (self->priv->frozen_views_altered == NULL) {
#line 7032 "DataCollection.c"
			GeeHashSet* _tmp1_;
#line 1762 "DataCollection.vala"
			self->priv->frozen_views_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_views_altered), _tmp1_);
#line 7036 "DataCollection.c"
		}
#line 1763 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered), view);
#line 7040 "DataCollection.c"
	}
}


#line 1768 "DataCollection.vala"
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view) {
#line 1768 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1768 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1769 "DataCollection.vala"
	if (!data_collection_are_notifications_frozen (DATA_COLLECTION (self))) {
#line 7053 "DataCollection.c"
		GeeArrayList* _tmp0_;
#line 1770 "DataCollection.vala"
		view_collection_notify_item_geometry_altered (self, view);
#line 1771 "DataCollection.vala"
		view_collection_notify_geometries_altered (self, GEE_COLLECTION (_tmp0_ = data_collection_get_singleton (DATA_OBJECT (view))));
#line 7059 "DataCollection.c"
		_g_object_unref0 (_tmp0_);
	} else {
#line 1773 "DataCollection.vala"
		if (self->priv->frozen_geometries_altered == NULL) {
#line 7064 "DataCollection.c"
			GeeHashSet* _tmp1_;
#line 1774 "DataCollection.vala"
			self->priv->frozen_geometries_altered = (_tmp1_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL), _g_object_unref0 (self->priv->frozen_geometries_altered), _tmp1_);
#line 7068 "DataCollection.c"
		}
#line 1775 "DataCollection.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered), view);
#line 7072 "DataCollection.c"
	}
}


#line 1779 "DataCollection.vala"
static void view_collection_real_thawed (DataCollection* base) {
#line 7079 "DataCollection.c"
	ViewCollection * self;
	self = VIEW_COLLECTION (base);
#line 1780 "DataCollection.vala"
	if (self->priv->frozen_views_altered != NULL) {
#line 7084 "DataCollection.c"
		GeeHashSet* _tmp0_;
		{
			GeeIterator* _view_it;
			_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_views_altered));
#line 1781 "DataCollection.vala"
			while (TRUE) {
#line 7091 "DataCollection.c"
				DataView* view;
#line 1781 "DataCollection.vala"
				if (!gee_iterator_next (_view_it)) {
#line 1781 "DataCollection.vala"
					break;
#line 7097 "DataCollection.c"
				}
#line 1781 "DataCollection.vala"
				view = (DataView*) gee_iterator_get (_view_it);
#line 1782 "DataCollection.vala"
				view_collection_notify_item_view_altered (self, view);
#line 7103 "DataCollection.c"
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
#line 1783 "DataCollection.vala"
		view_collection_notify_views_altered (self, GEE_COLLECTION (self->priv->frozen_views_altered));
#line 1784 "DataCollection.vala"
		self->priv->frozen_views_altered = (_tmp0_ = NULL, _g_object_unref0 (self->priv->frozen_views_altered), _tmp0_);
#line 7112 "DataCollection.c"
	}
#line 1787 "DataCollection.vala"
	if (self->priv->frozen_geometries_altered != NULL) {
#line 7116 "DataCollection.c"
		GeeHashSet* _tmp1_;
		{
			GeeIterator* _view_it;
			_view_it = gee_abstract_collection_iterator (GEE_ABSTRACT_COLLECTION (self->priv->frozen_geometries_altered));
#line 1788 "DataCollection.vala"
			while (TRUE) {
#line 7123 "DataCollection.c"
				DataView* view;
#line 1788 "DataCollection.vala"
				if (!gee_iterator_next (_view_it)) {
#line 1788 "DataCollection.vala"
					break;
#line 7129 "DataCollection.c"
				}
#line 1788 "DataCollection.vala"
				view = (DataView*) gee_iterator_get (_view_it);
#line 1789 "DataCollection.vala"
				view_collection_notify_item_geometry_altered (self, view);
#line 7135 "DataCollection.c"
				_g_object_unref0 (view);
			}
			_g_object_unref0 (_view_it);
		}
#line 1790 "DataCollection.vala"
		view_collection_notify_geometries_altered (self, GEE_COLLECTION (self->priv->frozen_geometries_altered));
#line 1791 "DataCollection.vala"
		self->priv->frozen_geometries_altered = (_tmp1_ = NULL, _g_object_unref0 (self->priv->frozen_geometries_altered), _tmp1_);
#line 7144 "DataCollection.c"
	}
#line 1794 "DataCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->thawed (DATA_COLLECTION (self));
#line 7148 "DataCollection.c"
}


#line 1008 "DataCollection.vala"
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected) {
#line 1008 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1008 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (selected));
#line 7158 "DataCollection.c"
}


#line 1012 "DataCollection.vala"
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected) {
#line 1012 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1012 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (unselected));
#line 7168 "DataCollection.c"
}


#line 1016 "DataCollection.vala"
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed) {
#line 1016 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1016 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (changed));
#line 7178 "DataCollection.c"
}


#line 1020 "DataCollection.vala"
static void view_collection_real_items_shown (ViewCollection* self, GeeIterable* visible) {
#line 1020 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1020 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (visible));
#line 7188 "DataCollection.c"
}


#line 1024 "DataCollection.vala"
static void view_collection_real_items_hidden (ViewCollection* self, GeeIterable* hidden) {
#line 1024 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1024 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (hidden));
#line 7198 "DataCollection.c"
}


#line 1028 "DataCollection.vala"
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeIterable* changed) {
#line 1028 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1028 "DataCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (changed));
#line 7208 "DataCollection.c"
}


#line 1032 "DataCollection.vala"
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view) {
#line 1032 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1032 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 7218 "DataCollection.c"
}


#line 1036 "DataCollection.vala"
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 1036 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1036 "DataCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 7228 "DataCollection.c"
}


#line 1039 "DataCollection.vala"
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views) {
#line 1039 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1039 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 7238 "DataCollection.c"
}


#line 1042 "DataCollection.vala"
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 1042 "DataCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1042 "DataCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 7248 "DataCollection.c"
}


#line 987 "DataCollection.vala"
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type) {
#line 7254 "DataCollection.c"
	ViewCollectionToggleLists * self;
#line 987 "DataCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 7258 "DataCollection.c"
	return self;
}


#line 987 "DataCollection.vala"
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void) {
#line 987 "DataCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 7267 "DataCollection.c"
}


static void view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass) {
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
}


static void view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self) {
	self->selected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	self->unselected = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
}


static void view_collection_toggle_lists_finalize (GObject* obj) {
	ViewCollectionToggleLists * self;
	self = VIEW_COLLECTION_TOGGLE_LISTS (obj);
	_g_object_unref0 (self->selected);
	_g_object_unref0 (self->unselected);
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
}


static GType view_collection_toggle_lists_get_type (void) {
	static volatile gsize view_collection_toggle_lists_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_toggle_lists_type_id__volatile, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__volatile;
}


static void view_collection_class_init (ViewCollectionClass * klass) {
	view_collection_parent_class = g_type_class_peek_parent (klass);
	DATA_COLLECTION_CLASS (klass)->finalize = view_collection_finalize;
	g_type_class_add_private (klass, sizeof (ViewCollectionPrivate));
	VIEW_COLLECTION_CLASS (klass)->notify_item_view_altered = view_collection_real_notify_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_views_altered = view_collection_real_notify_views_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_item_geometry_altered = view_collection_real_notify_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->notify_geometries_altered = view_collection_real_notify_geometries_altered;
	DATA_COLLECTION_CLASS (klass)->close = view_collection_real_close;
	DATA_COLLECTION_CLASS (klass)->valid_type = view_collection_real_valid_type;
	DATA_COLLECTION_CLASS (klass)->notify_items_added = view_collection_real_notify_items_added;
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = view_collection_real_notify_items_removed;
	DATA_COLLECTION_CLASS (klass)->item_altered = view_collection_real_item_altered;
	DATA_COLLECTION_CLASS (klass)->item_metadata_altered = view_collection_real_item_metadata_altered;
	DATA_COLLECTION_CLASS (klass)->set_comparator = view_collection_real_set_comparator;
	DATA_COLLECTION_CLASS (klass)->reset_comparator = view_collection_real_reset_comparator;
	DATA_COLLECTION_CLASS (klass)->get_all = view_collection_real_get_all;
	DATA_COLLECTION_CLASS (klass)->get_count = view_collection_real_get_count;
	DATA_COLLECTION_CLASS (klass)->get_at = view_collection_real_get_at;
	DATA_COLLECTION_CLASS (klass)->index_of = view_collection_real_index_of;
	DATA_COLLECTION_CLASS (klass)->contains = view_collection_real_contains;
	VIEW_COLLECTION_CLASS (klass)->get_first = view_collection_real_get_first;
	VIEW_COLLECTION_CLASS (klass)->get_last = view_collection_real_get_last;
	VIEW_COLLECTION_CLASS (klass)->get_next = view_collection_real_get_next;
	VIEW_COLLECTION_CLASS (klass)->get_previous = view_collection_real_get_previous;
	DATA_COLLECTION_CLASS (klass)->thawed = view_collection_real_thawed;
	VIEW_COLLECTION_CLASS (klass)->items_selected = view_collection_real_items_selected;
	VIEW_COLLECTION_CLASS (klass)->items_unselected = view_collection_real_items_unselected;
	VIEW_COLLECTION_CLASS (klass)->items_state_changed = view_collection_real_items_state_changed;
	VIEW_COLLECTION_CLASS (klass)->items_shown = view_collection_real_items_shown;
	VIEW_COLLECTION_CLASS (klass)->items_hidden = view_collection_real_items_hidden;
	VIEW_COLLECTION_CLASS (klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
	VIEW_COLLECTION_CLASS (klass)->item_view_altered = view_collection_real_item_view_altered;
	VIEW_COLLECTION_CLASS (klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
	VIEW_COLLECTION_CLASS (klass)->views_altered = view_collection_real_views_altered;
	VIEW_COLLECTION_CLASS (klass)->geometries_altered = view_collection_real_geometries_altered;
	g_signal_new ("items_selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_state_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("items_visibility_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
	g_signal_new ("item_view_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("item_geometry_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
	g_signal_new ("views_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	g_signal_new ("geometries_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
}


static void view_collection_instance_init (ViewCollection * self) {
	self->priv = VIEW_COLLECTION_GET_PRIVATE (self);
	self->priv->sources = NULL;
	self->priv->manager = NULL;
	self->priv->mirroring = NULL;
	self->priv->mirroring_ctor = NULL;
	self->priv->filter = NULL;
	self->priv->selected = data_set_new ();
	self->priv->visible = NULL;
	self->priv->frozen_views_altered = NULL;
	self->priv->frozen_geometries_altered = NULL;
	self->priv->source_map = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_hash, g_direct_equal, g_direct_equal);
}


static void view_collection_finalize (DataCollection* obj) {
	ViewCollection * self;
	self = VIEW_COLLECTION (obj);
	_data_collection_unref0 (self->priv->sources);
	_view_manager_unref0 (self->priv->manager);
	_data_collection_unref0 (self->priv->mirroring);
	(self->priv->mirroring_ctor_target_destroy_notify == NULL) ? NULL : (self->priv->mirroring_ctor_target_destroy_notify (self->priv->mirroring_ctor_target), NULL);
	self->priv->mirroring_ctor = NULL;
	self->priv->mirroring_ctor_target = NULL;
	self->priv->mirroring_ctor_target_destroy_notify = NULL;
	(self->priv->filter_target_destroy_notify == NULL) ? NULL : (self->priv->filter_target_destroy_notify (self->priv->filter_target), NULL);
	self->priv->filter = NULL;
	self->priv->filter_target = NULL;
	self->priv->filter_target_destroy_notify = NULL;
	_data_set_unref0 (self->priv->selected);
	_data_set_unref0 (self->priv->visible);
	_g_object_unref0 (self->priv->frozen_views_altered);
	_g_object_unref0 (self->priv->frozen_geometries_altered);
	_g_object_unref0 (self->priv->source_map);
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
}


GType view_collection_get_type (void) {
	static volatile gsize view_collection_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
		GType view_collection_type_id;
		view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_type_id__volatile, view_collection_type_id);
	}
	return view_collection_type_id__volatile;
}



static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__STRING_BOXED_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_BOXED_BOXED) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_boxed (param_values + 3), data2);
}



